	PROGRAM SUMADD
C
C	Simply summarizes header information in RunidR.GDT files
C	Test side, Base Side, TestVOC, amount added
C
C	USE: SUMADD [InputFile] [OutputFile]
C	Defaults: Input=i:\tmp.lis, output=i:\tmp.csv
C	Input file is list of test runs.  If they are appended by "A" or "B"
C	Location of R.GDT files taken from GDT= parameter in modeling.prm
C
	CHARACTER INFILE*40,OUTFIL*40,RUNID*8,INFO*12,INLIN*80
	CHARACTER OUTSTR*80,RUNUIC*60
C
	CALL GETARG (1,INFILE)
	LINFIL=LNBLNK(INFILE)
	CALL GETARG (2,OUTFIL)
	LOUTFL=LNBLNK(OUTFIL)
	IF (INFILE(1:1).EQ.'?') THEN
		WRITE (6,*) 'Simply summarizes header information'//
     &		 ' in RunidR.GDT files'
		WRITE (6,*) 'USE: SUMADD InputFile OutputFile'
		WRITE (6,*) 'Defaults: Input=i:\tmp.lis, output='//
     &		 'i:\tmp.csv'
		CALL EXIT (2)
	ELSEIF (INFILE(1:1).EQ.' ') THEN
		INFILE='I:\TMP.LIS'
		LINFIL=10
	ENDIF
	IF (OUTFIL(1:1).EQ.' ') THEN
		OUTFIL='I:\TMP.CSV'
		LOUTFL=10
	ENDIF
C
	RUNUIC='.\'
	LRUNUC=2
	OPEN (UNIT=1,FILE='MODELING.PRM',STATUS='UNKNOWN')
   70	READ (1,1,END=71) INLIN
    1	FORMAT (A)
	IF (INLIN(1:4).EQ.'GDT=') THEN
		RUNUIC=INLIN(5:)
		LRUNUC=LNBLNK(RUNUIC)
	ENDIF
	GOTO 70
   71	CLOSE (UNIT=1)
C
C	OPEN INPUT FILE
C
	OPEN (UNIT=3,FILE=INFILE,STATUS='OLD',ACTION='READ',ERR=2)
	GOTO 3
    2	WRITE (6,*) 'FILE = '//INFILE(1:LINFIL)//' does not exist.'
	CALL EXIT (2)
    3	CONTINUE
C
C	OPEN OUTPUT FILE
C
	OPEN (UNIT=2,FILE=OUTFIL,STATUS='UNKNOWN')
	WRITE (2,*) 'RunID,Msg,RctFile,TestRun,BaseRun,TestVOC,Added'
C
    5	READ (3,1,END=990) RUNID
	IF (RUNID(1:1).EQ.' ') THEN
		WRITE (2,*)
		GOTO 5
	ELSEIF (RUNID(1:1).EQ.'!') THEN
		GOTO 5
	ENDIF
	LRUNID=LNBLNK(RUNID)
	IF (RUNID(LRUNID:LRUNID).EQ.'A'.OR.
     &	 RUNID(LRUNID:LRUNID).EQ.'B'.OR.
     &	 RUNID(LRUNID:LRUNID).EQ.'R') THEN
		L1=LRUNID-1
	ELSE
		L1=LRUNID
	ENDIF
 	INLIN=RUNUIC(1:LRUNUC)//RUNID(1:L1)//'R.GDT'
	OPEN (UNIT=1,FILE=INLIN,STATUS='OLD',ACTION='READ',ERR=4)
	GOTO 10
    4	WRITE (6,*) 'FILE = ',INLIN(1:LNBLNK(INLIN)),' does not exist.'
	WRITE (2,*) RUNID(1:LNBLNK(RUNID)),',No file.'
	GOTO 5
C
C	
   10	READ (1,1,END=101) INLIN
	IF (INLIN(1:6).NE.'3 0 IR') THEN
		WRITE (2,*) RUNID(1:LNBLNK(RUNID)),',Wrong type.'
		GOTO 5
	ENDIF
C
	READ (1,1,END=101) INLIN
	CLOSE (UNIT=1)
	OUTSTR=RUNID(1:LRUNID)//','
	L1=LRUNID+1
	CALL PARSE0 (5,INLIN,80)
	DO 110 I=1,5
		CALL PARSE1 (I,INFO,LINFO,12,INLIN)
		IF (LINFO.EQ.0) THEN
			OUTSTR=OUTSTR(1:L1)//','
			L1=L1+1
		ELSE
			OUTSTR=OUTSTR(1:L1)//','//INFO(1:LINFO)
			L1=L1+LINFO+1
		ENDIF
  110	CONTINUE
	WRITE (2,*) OUTSTR(1:L1)
	GOTO 5
C
  101	WRITE (2,*) RUNID(1:LNBLNK(RUNID)),'No headers'
	GOTO 5
C
C	DONE
C
  990	CLOSE (UNIT=2)
	CLOSE (UNIT=3)
	WRITE (6,*) 'File = '//OUTFIL(1:LOUTFL)//' created.'
	CALL EXIT(0)
	END