C --- INTINI.FOR  --- INITIALIZE INT. 
C
C --- CALLED BY INTMAIN
C --- CALLS INITIN, FILNAM
C --- UNITS USED:  OUT:  OPENS, LEAVES OPEN.  INTEND CLOSES IT.
C
C	READS COMMAND LINE:
C
C	  P1   =.INT FILE NAME
C	[ P2 ] = SAVE SUBDIRECTORY AND .PRM FILE NAME TO READ
C		AFTER MODELING.PRM (OPTIONAL).  IF NO .PRM FILE JUST IS SET
C		NOTE: CAN BE CHANGED BY PRM= INPUT IN THE .PRM FILE
C		
C	[ P3+ ] = OPTIONS.  PRESENTLY IMPLEMENTED:
C			"SAVE=file" -- SPECIFY NAME OF OUTPUT CSV FILE
C		 	"MAX species" -- FIND MAX OF SPECIES
C			"/INTRATE" -- FORCES "SAVE INTRATE"
C			"/RATE" -- FORCES "SAVE RATE"
C			"REACTCAL" --- REACTCAL INPUT.  RESULT:
C				- .PRM FILE NAMED IN P2 DOES NOT HAVE TO EXIST
C	[ P4 ] = USE DEPENDS ON OPTION.  FOR "MAX" IS NAME OF SPECIES
C		 TO FIND MAXIMUM
C
C
	SUBROUTINE INTINI
C
	INCLUDE 'MAINSPC.FOR'
C
	LOGICAL ANS
C
C	INITIALIZE INPUT UNITS.  MAXIMUM OF 2 LEVELS OF INCLUDES
C	ALLOWED.
C
	CALL INITIN (3)
C
	SAVFIL=' '
	LSAVFL=0
	SAVFL1=' '
	LSAVF1=0
	ABORT=.FALSE.
C
C	READ COMMAND LINE.  (OPTIONS 1, 2 DECODED LATER)
C
	CALL GETARG (1,IOB160)
	IF (IOB160(1:1).EQ.' ') THEN
		WRITE (ICRT,*) 'Use:  ',MOD(1:LNBLNK(MOD(1:8)))//
     &		 ' intfile [prmfile] [SAVE=csvfile] [MAX spec]'//
     &		 ' [/RATE] [/INTRATE]'
		CALL EXIT (1)
	ENDIF
	FILES=IOB160(1:8)
	LFILES=LNBLNK(FILES)
C
	LPRMFL=0
	PRMFIL=' '
	ONLMAX=' '
	RCALL=.FALSE.
C
C	FOLLOWING INITIATIONS MOVED FROM MODL TO ALLOW COMMAND LINE OVERRIDE
C
	PASS=.FALSE.
	INTRAT=.FALSE.
	SAVER=.FALSE.
	WRITCO=.FALSE.
C
	LP=2
   10	CALL GETARG (LP,IOB160)
	IF (IOB160(1:1).EQ.' ') THEN
		GOTO 11
	ELSEIF (IOB160(1:2).EQ.'X ') THEN
	ELSEIF (IOB160(1:5).EQ.'SAVE=') THEN
		SAVFIL=IOB160(6:)
		LSAVFL=LNBLNK(SAVFIL)
	ELSEIF (IOB160(1:1).EQ.'/') THEN
		IF (IOB160(2:6).EQ.'RATE ') THEN
			SAVER=.TRUE.
			WRITCO=.TRUE.
		ELSEIF (IOB160(2:9).EQ.'INTRATE ') THEN
			INTRAT=.TRUE.
			WRITCO=.TRUE.
		ELSE
			WRITE (ICRT,*) 'Unrecognized option ='
     &			 //IOB160(1:LNBLNK(IOB160))
			CALL EXIT (1)
		ENDIF
	ELSEIF (IOB160(1:4).EQ.'MAX ') THEN
		LP=LP+1
		CALL GETARG (LP,ONLMAX)
		IF (ONLMAX(1:1).EQ.' ') THEN
			WRITE (ICRT,*) 'Species name must '//
     &			 'be given with MAX option'
			CALL EXIT (1)
		ENDIF
	ELSEIF (IOB160(1:8).EQ.'REACTCAL') THEN
		RCALL=.TRUE.
	ELSEIF (LPRMFL.EQ.0) THEN
		PRMFIL=IOB160
		LPRMFL=LNBLNK(PRMFIL)
	ELSE
		WRITE (ICRT,*) 'Unrecognized option ='
     &		 //IOB160(1:LNBLNK(IOB160))
		CALL EXIT (1)
	ENDIF
	LP=LP+1
	GOTO 10
   11	CONTINUE
C
C       OPEN INPUT AND OUTPUT FILES
C
	IOB160=FILES(1:LFILES)//'.INT'
	CALL FILEIN
	IF (IORET.EQ.1) THEN
		WRITE (ICRT,*) 'File = ',FILES(1:LFILES),'.INT does ',
     &		 'not exist.'
		CALL EXIT (1)
	ENDIF
C
C	OPEN OUTPUT FILE
C
	IOB160(LFILES+1:)='.OUT'
	OPEN (UNIT=OUT,FILE=IOB160,STATUS='UNKNOWN')
C
C       GET PARAMETERS FROM MODELING.PRM THEN PARAMETER FILE (IF ANY)
C

	OPEN (UNIT=LOGU,FILE='MODELING.PRM',STATUS='UNKNOWN')
	ANS=.TRUE.
C
	MODUIC=' '
	SDRUIC=' '
	CALUIC=' '
	LCALUC=0
	LOGUIC=' '
	LMPUIC=' '
	TMPUIC=' '
	IOBF16=' '
	IOB160=' '
	MXOLST=' '
	PGMUIC=' '
	IF (PRMFIL(1:1).EQ.' ') THEN
		DFLEXT='CALCS'
		LDFLEX=5
	ELSE
		DFLEXT=PRMFIL
		LDFLEX=LPRMFL
	ENDIF
C
  130	READ (LOGU,'(A)',END=138) IOB160
	IF (IOB160(1:4).EQ.'MOD=') THEN
		MODUIC=IOB160(5:)
	ELSEIF (IOB160(1:4).EQ.'SDR=') THEN
		SDRUIC=IOB160(5:)
	ELSEIF (IOB160(1:4).EQ.'CAL=') THEN
		CALUIC=IOB160(5:)
		LCALUC=LNBLNK(CALUIC)
	ELSEIF (IOB160(1:4).EQ.'LOG=') THEN
		LOGUIC=IOB160(5:)
	ELSEIF (IOB160(1:4).EQ.'TMP=') THEN
		TMPUIC=IOB160(5:)
	ELSEIF (IOB160(1:7).EQ.'MAXCAL=') THEN
		MXOLST=IOB160(8:)
	ELSEIF (IOB160(1:5).EQ.'PGMS=') THEN
		PGMUIC=IOB160(6:)
	ELSEIF (IOB160(1:9).EQ.'MODELSET=') THEN
		DFLEXT=IOB160(10:)
		LDFLEX=LNBLNK(DFLEXT)
	ELSEIF (ANS) THEN
		GOTO 130
C
C	FOLLOWING ONLY VALID IN NAMED PRM FILE
	ELSEIF (IOB160(1:4).EQ.'PRM=') THEN
		PRMFIL=IOB160(5:)
		LPRMFL=LNBLNK(DFLEXT)
	ELSEIF ((IOB160(1:8).EQ.'EXTFILE=').OR.
     &	 (IOB160(1:8).EQ.'SAVELOC=')) THEN
		DFLEXT=IOB160(9:)
		LDFLEX=LNBLNK(DFLEXT)
	ENDIF
	GOTO 130
C
 138	CLOSE (UNIT=LOGU)
	IF (ANS.AND.PRMFIL(1:1).NE.' ') THEN
		OPEN (UNIT=LOGU,FILE=PRMFIL(1:LPRMFL)//'.PRM',
     &		 STATUS='OLD',ERR=137)
		ANS=.FALSE.
		GOTO 130
C
  137		IF (.NOT.RCALL) THEN
			WRITE (ICRT,*) 'File = ',PRMFIL(1:LPRMFL),
     &			 '.PRM does not exist.'
			CALL EXIT (2)
		ENDIF
	ENDIF
C
C	INITIALIZE COUNTERS USED BY LSODE AND STOREC
C
	ILLIN=0
	NTREP=0
	PASSED=.FALSE.
C
	RETURN
	END
