C --- INTOPT.FOR
C --- CALLED BY INTMAIN
C --- CALLS ALIN16, MOVLFT, VERTX, FILEIN
C --- UNITS USED:  LOGU (OPEN,READ/WRITE,CLOSE)
C                  OPTU (OPEN,READ/WRITE,CLOSE)
C                  OPT1,OPT2 (OPEN,CLOSE,READ/WRITE.  MAY BE OPEN UPON
C                  EXIT OR WHEN CALLED.)
C
C --- CONDITIONAL COMPILATION:  V = VAX,   S = SMALL RSX, B = BIG RSX(PDP)
C                               C = CYBER, U = UCSD/CRAY, I = IBM/AT
C -------------------------------------------------------------------------
C
      SUBROUTINE INTOPT
C
C     OPTIMIZATION SUBROUTINE TO FIND BEST FIT FOR
C     INTEGRATION PARMS (WHICH MUST BE READABLE BY
C     RDCKC SUBROUTINE)
C
	INCLUDE 'MAINSPC.FOR'
	INCLUDE 'OPTSPEC.FOR'
C
	LOGICAL QUITO,SMALL,SHOWO,ERRIND,CHIBAD
	REAL ARRAY(MAXPRM**2),DERIV(MAXPRM),BADPRM(MAXPRM)
	CHARACTER PRMIND(MAXPRM)*1
	DATA PRMIND /MAXPRM*' '/
C
C	SHOWO .. SET TO T IN THIS VERSION.  CONTROLS IF OPT INFO
C		TO BE OUTPUT TO SCREEN AS PGM IS RUN
C
	DATA QUITO/.FALSE./,SHOWO/.TRUE./
C
C
C     INDOPT:  0 = ONLY FIRST PASS THRU INT.  NEED TO GO THRU
C                      AGAIN TO DO CALC WITH INITIAL PARMS.
C              -1 = JUST FINISHED FIRST PASS.  START OPTIMIZATION.
C              >0 = FINISHED CALCS WITH PARAMETER # INDOPT VARIED.
C              -2 = FINISHED CALCS WITH NEW PARM SET.
C              -3 = OPTIMIZATION DONE (ILLEGAL VALUE ON ENTRY).
C                      TELLS MAIN TO QUIT.
C
      IF (INDOPT.NE.0) GOTO 100
C
C     FIRST PASS THRU.  DO INITIAL CALC.
C
      INDOPT=-1
C
      GOTO 5000
C
C     CALC REQUIRED DONE.  OPT2 CONTAINS DATA OBTAINED.
C     OPT2 IS INPUT DATA FOR CALC DONE, NO LONGER NEEDED.
C
  100 CLOSE (UNIT=OPT2)
      IF (MAXITR.EQ.0) QUITO=.TRUE.
C
  198 FORMAT (A1)
C
C     SEE IF ANYTHING IN 'OPT.CMD' FILE AND READ ITS COMMANDS.
C
	IOB160=' '
	CALL FILNAM (NLEN,IOB160,LOGUIC,'OPT.CMD ',' ')
	OPEN (UNIT=LOGU,FILE=IOB160,STATUS='UNKNOWN',ERR=195)
C
  110	READ (LOGU,1,END=199) IOB160
    1	FORMAT (A)
	IF (IOB160.EQ.' ') GOTO 110
	IF ((IOB160(1:4).EQ.'STOP'.OR.IOB160(1:4).EQ.'QUIT').OR.
     &	 IOB160(1:4).EQ.'END ') THEN
		WRITE (ICRT,*) 'OPTIMIZATION WILL BE ABORTED.'
		QUITO=.TRUE.
	ELSE
		CALL ALIN16(2,IOB160)
		CALL MOVLFT (IOB160)
		IF (IOB160(1:6).EQ.'MINFAC') THEN
			READ (IOB160(17:32),122,ERR=180) MINFAC
  122			FORMAT (G16.0)
			WRITE (OUT,124) MINFAC
			WRITE (ICRT,124) MINFAC
  124			FORMAT (/' NEW MINFAC =',1PG12.3)
		ELSEIF (IOB160(1:6).EQ.'MINCHI') THEN
			READ (IOB160(17:32),122,ERR=180) MINCHI
			WRITE (OUT,134) MINCHI
			WRITE (ICRT,134) MINCHI
  134			FORMAT (/' NEW MINCHI =',1PG12.3)
		ELSEIF (IOB160(1:6).EQ.'MAXITR') THEN
			READ (IOB160(17:32),142,ERR=180) MAXITR
  142			FORMAT (I16)
			WRITE (OUT,144) MAXITR
			WRITE (ICRT,144) MAXITR
  144			FORMAT (/' NEW MAXITR =',I4)
		ELSE
			WRITE (ICRT,*) 'UNRECOGNIZED INPUT IN ',
     &			 'OPT.CMD.  IGNORED'
		ENDIF
	ENDIF
	GOTO 110
C
  180	WRITE (ICRT,*) 'ERROR IN DECODING OPT.CMD LINE.  IGNORED'
	GOTO 110
C
  195	WRITE (ICRT,*) 'PROBLEM OPENING OPT.CMD FILE.  IGNORED.'
C
  199	CLOSE (UNIT=LOGU,STATUS='DELETE')
C
      IF (INDOPT.GT.0) GOTO 1210
      IF (INDOPT.LE.-3) STOP 'ILLEGAL INDOPT ON CALL TO INTOPT'
C
C     WILL BE READING DATA ON OPT1, SO REWIND IT
C
      REWIND OPT1
C
      IF (INDOPT.EQ.-1) GOTO 1000
      IF (INDOPT.EQ.-2) GOTO 4000
C
C     INITIAL CALC DONE.  GET DATA TO PLOT AND TO CALCULATE
C              INITIAL CHISQ
C
 1000 INTOUT=.FALSE.
C
      IF (SHOFIT) WRITE (OUT,1002) NITER
 1002 FORMAT (/' ITERATION',I4,':'//10X,'TIME',8X,'OBS',9X,
     &  'CALC',8X,'DIFF')
      CHISQR=0.0
      N=0
 1004 READ (OPT1,END=1010) K,I,XI,YI,WI,YCI
      IF (WI.EQ.0.0) GOTO 1004
      N=N+1
      AJ=YI-YCI
      IF (SHOFIT) WRITE (OUT,1006) K,XI,YI,YCI,AJ
 1006 FORMAT (' ',I5,1P10G12.3)
      CHISQR=CHISQR+WI*(AJ**2)
      GOTO 1004
C
 1010 CLOSE (UNIT=OPT1)
      IF (N.EQ.0) STOP 'OPT FAILED.  NO DATA TO CALCULATE CHISQR.'
      CHISQR=CHISQR/FLOAT(N)
      IF (CHISQR.LE.0.0) STOP 'PGM ERR OR PERFICT INITIAL PARMS.'
C
C     GIVE RESULTS OF INITIAL CALC. ON LOG DATA SET
C
 1020  OPEN (UNIT=LOGU,FILE=OPTLOG,STATUS='OLD',ERR=8000,
     &  ACCESS='APPEND')
C
C     APPEND BY READING TO END OF FILE, BACKSPACE OVER EOF, THEN GO ON
C     OPEN (UNIT=LOGU,FILE=OPTLOG,STATUS='OLD',ERR=8000)
C1011 READ (LOGU,*,END=1012) IOBF16
C     GOTO 1011
C1012 BACKSPACE LOGU
C
      WRITE (LOGU,'(1X)')
      WRITE (LOGU,1022) NITER,CHISQR,FLAMDA,(PRMLBL(I)
     &  ,PARMS(I),I=1,NPRM)
 1022 FORMAT (' ITER',3X,'CHISQR',5X,'FLAMDA',3X,'TRIES',2X,
     &  'PARAMETER',10X,'VALUE',6X,'SSQDeriv'//1X,I4,1PG12.3,G10.3,8X,
     &  A16,G12.4,:/(35X,A16,G12.4,:))
      CLOSE (UNIT=LOGU)
C
	IF (SHOWO) THEN
		WRITE (ICRT,1022) NITER,CHISQR,FLAMDA,(PRMLBL(I)
     &		,PARMS(I),I=1,NPRM)
	ENDIF
C
C	PRODUCE .SPL FILE FOR INITIAL CALC
C
	CALL PLOT
C
C      ----------NEXT ITERATION-----------------------------
C
 2000 NITER=NITER+1
      NTRIES=1
      CHISQ1=CHISQR
      CHIBAD=.FALSE.
      WRITE (OUT,2002) NITER,CHISQR
 2002 FORMAT (/1X//1X,27('-'),' I T E R A T I O N',I5,' ',
     &  27('-')//' INITIAL CHISQR =',1PG12.4//1X)
C
C     CALCULATIONS FOR DERIVATIVES.
C
      INDOPT=0
 1200 INDOPT=INDOPT+1
      SAVE1=PARMS(INDOPT)
      PARMS(INDOPT)=SAVE1+DPARMS(INDOPT)
C
C     PASS THRU INT WITH MODIFIED PARM(INDOPT).  RETURNS TO 2000
C     WHEN DONE.  DON'T NEED OPT1 DATA NOW, SO CLOSE IT
C
      CLOSE (UNIT=OPT1)
      GOTO 5000
C
C      *** INT DONE AT THIS POINT.  ALL VARIABLES NOT IN COMMONS LOST ***
C
 1210 PARMS(INDOPT)=SAVE1
      IF (INDOPT.LT.NPRM) GOTO 1200
C
C     ALL CALCS FOR DERIV. DONE.
C
      IF (SHOFIT) WRITE (OUT,1302) NITER,(PRMLBL(I)(1:10),I=1,NPRM)
 1302 FORMAT (/' ITERATION',I4,' DERIVATIVES:'//1X,8X,10(A10,2X))
C
C     CALCULATE DERIVATIVES, ALPHA AND BETA MATRICES
C
      DO 2102 J=1,NPRM
        BETA(J)=0.0
        DO 2102 K=1,J
 2102 ALPHA(J,K)=0.0
C
      REWIND OPT1
 2104 READ (OPT1,END=2110) K,I,XI,YI,WI,YCI,(DERIV(J),J=1,NPRM)
      IF (WI.EQ.0.0) GOTO 2104
      DO 2108 J=1,NPRM
        DERIV(J)=(DERIV(J)-YCI)/DPARMS(J)
        WID=WI*DERIV(J)
        BETA(J)=BETA(J)+WID*(YI-YCI)
        DO 2108 I=1,J
 2108 ALPHA(J,I)=ALPHA(J,I)+WID*DERIV(I)
      IF (SHOFIT) WRITE (OUT,1006) K,(DERIV(J),J=1,NPRM)
      GOTO 2104
C
C     WRITE OUT ALPHA AND BETA.  DEFINE DERIVITES
C
 2110 WRITE (OUT,2111) (PRMLBL(I)(1:10),I=1,NPRM)
 2111 FORMAT (/' OPTIMIZATION ARRAYS:'//' ALPHA:',9X,10(A10,2X),:
     &	 /(16X,(A10,2X)))
      DO 2112 J=1,NPRM
      SSQDER(J)=SQRT(ALPHA(J,J)/SUMY2)
 2112 WRITE (OUT,2114) PRMLBL(J)(1:10),(ALPHA(J,I),I=1,J)
 2114 FORMAT (' ',A10,2X,1P10G12.3:/(13X,10G12.3))
      WRITE (OUT,2116) (BETA(J),J=1,NPRM)
 2116 FORMAT (/' BETA:',7X,1P10G12.3,:/(13X,10G12.3))
      WRITE (OUT,2117) (SSQDER(J),J=1,NPRM)
 2117 FORMAT (/' SSQDERIV',3X,1P10G12.3:/(13X,10G12.3))
C
C     INVERT MODIFIED CURVATURE MATRIX TO FIND NEW PARMS
C              NOTE: THIS IS THE ENTRY POINT FOR FINDING
C              NEW PARMS WITH SMALLER FLAMDA IF CURRENT
C              NEW PARMS DO WORSE.
C
 2200 CLOSE (UNIT=OPT1)
      FL1=1.0+FLAMDA
      IF (NPRM.EQ.1) GOTO 2216
CC      ARRAY(1,1)=FL1
      ARRAY(1)=FL1
      DO 2210 J=2,NPRM
        JM=J-1
        DO 2202 K=1,JM
          JK=J+(K-1)*NPRM
          KJ=K+(J-1)*NPRM
          JJ=J+(J-1)*NPRM
          ARRAY(JK)=ALPHA(J,K)/SQRT(ALPHA(J,J)*ALPHA(K,K))
 2202   ARRAY(KJ)=ARRAY(JK)
 2210 ARRAY(JJ)=FL1
C
CC       ARRAY(J,K)=ALPHA(J,K)/SQRT(ALPHA(J,J)*ALPHA(K,K))
CC 2202  ARRAY(K,J)=ARRAY(J,K)
CC 2210  ARRAY(J,J)=FL1
C
C     WRITE (OUT,*) ' ARRAY=',(ARRAY(I),I=1,NPRM**2)
      CALL VERTX (NPRM,ARRAY)
      GOTO 2217
C
 2216 ARRAY(1)=1.0/FL1
CC 2216 ARRAY(1,1)=1.0/FL1
C
C      SAVE OLD PARMS THEN CALCULATE NEW ONES
C
 2217 SMALL=.TRUE.
      DO 2220 J=1,NPRM
        AJ=PARMS(J)
        PRMS2(J)=AJ
        DJ=0.0
        DO 2218 K=1,NPRM
          JK=J+(K-1)*NPRM
 2218   DJ=DJ+BETA(K)*ARRAY(JK)/SQRT(ALPHA(J,J)*ALPHA(K,K))
CC 2218  DJ=DJ+BETA(K)*ARRAY(J,K)/SQRT(ALPHA(J,J)*ALPHA(K,K))
        IF (ABS(DJ).GE.0.5*ABS(DPARMS(J))) SMALL=.FALSE.
        PARMS(J)=AJ+DJ
C       WRITE (OUT,*) ' IN INTOPT, PARMS(',J,')=',PARMS(J)
 2220 CONTINUE
C
C     CHECK ESTIMATED PARMS.  END OPTIMIZATION IF ALL CHANGES LESS
C     THAN DPARMS.
C
	IF (SMALL) THEN
		DO 2219 I=1,NPRM
 2219		PARMS(I)=PRMS2(I)
		GOTO 9050
	ENDIF
C
C     IF NEW PARMS OUT-OF-RANGE, TRY AGAIN WITH LARGER FLAMDA
C
	ERRIND=.FALSE.
	DO 2230 J=1,NPRM
	IF (PARMS(J).LT.PMIN(J)) THEN
		ERRIND=.TRUE.
		PRMIND(J)='-'
	ELSEIF (PARMS(J).GT.PMAX(J)) THEN
		ERRIND=.TRUE.
		PRMIND(J)='+'
	ENDIF
 2230	CONTINUE
C
	IF (ERRIND) THEN
		WRITE (OUT,2242) (PRMLBL(J),PARMS(J),PMIN(J),PMAX(J),
     &		 J=1,NPRM)
 2242		FORMAT (/' ESTIMATED PARMS, GIVEN BELOW, OUT OF RANGE.'/
     &  	/1X,16X,'EST. VALUE    MINIMUM     MAXIMUM    '/
     &  	(' ',A16,1P3G12.3))
		GOTO 4010
	ENDIF
C
C     INTEGRATE WITH NEW PARMS
C
 3999 INDOPT=-2
      GOTO 5000
C
C      *** INT DONE AT THIS POINT.  ALL VARIABLES NOT IN COMMONS LOST ***
C
C     CALCULATE CHISQR FOR NEW PARMS
C
 4000 IF (SHOFIT) WRITE (OUT,1002) NITER
      CHISQR=0.0
      N=0
 4002 READ (OPT1,END=4004) K,I,XI,YI,WI,YCI
      IF (WI.EQ.0.0) GOTO 4002
      N=N+1
      AJ=YI-YCI
      IF (SHOFIT) WRITE (OUT,1006) K,XI,YI,YCI,AJ
      CHISQR=CHISQR+WI*(AJ**2)
      GOTO 4002
C
 4004 IF (N.EQ.0) STOP 'OPT FAILED.  NO DATA TO CALCULATE CHISQR.'
      CHISQR=CHISQR/FLOAT(N)
      WRITE (OUT,4006) NITER,CHISQR,FLAMDA,(PRMLBL(J)(1:10),J=1,NPRM)
      WRITE (OUT,4008) (PARMS(J),J=1,NPRM)
 4006 FORMAT (/' ITERATION:',I4,', CHISQR =',1PG13.4,', FLAMDA =',
     &  G12.3//'  PARM:   ',10(A10,2X))
 4008 FORMAT (' VALUE: ',1P10G12.3)
C
C     IF THIS IS NOT AN IMPROVEMENT, TRY AGAIN WITH LARGER FLAMDA
C
	IF (CHISQR.LE.CHISQ1) THEN
		CHIBAD=.FALSE.
		GOTO 4500
	ENDIF
	WRITE (OUT,'(/'' EST NEW PARMS HAS HIGHER CHISQR.'')')
	CHISQR=CHISQ1
C
C
C     RETRY BECAUSE OF LARGER CHISQR, OR BECAUSE OF PARMS OUT-OF-RANGE
C
 4010	FLAMDA=FLAMDA*10.0
	NTRIES=NTRIES+1
	WRITE (OUT,4012) FLAMDA
 4012	FORMAT (/' TRY AGAIN WITH FLAMDA =',1PG12.3)
	IF (FLAMDA+0.1.EQ.FLAMDA) STOP 'OPT FAILED.  FLAMDA TOO LARGE.'
C
	IF (CHIBAD) THEN
		SMALL=.TRUE.
		DO 4019 J=1,NPRM
	        IF (ABS(PARMS(J)-BADPRM(J)).GE.0.5*ABS(DPARMS(J)))
     &		 SMALL=.FALSE.
 4019		CONTINUE
		IF (SMALL) THEN
			WRITE (OUT,*)
			WRITE (OUT,*) 'Aborted because of small ',
     &			 'change from last failed try.'
			WRITE (ICRT,*) 'Changes too small -- aborting.'
			DO 2232 J=1,NPRM
 2232			PARMS(J)=PRMS2(J)
			CLOSE (UNIT=OPT1)
			GOTO 9050
		ENDIF
	ELSE
		CHIBAD=.TRUE.
	ENDIF
C
	DO 2231 J=1,NPRM
	BADPRM(J)=PARMS(J)
 2231	PARMS(J)=PRMS2(J)
	GOTO 2200
C
C     DONE WITH STEP.  EVALUATE UNC'S OF PARMS.
C
 4500 CLOSE (UNIT=OPT1)
      FLAMDA=FLAMDA/10.0
      DO 4502 J=1,NPRM
        JJ=J+(J-1)*NPRM
 4502 PRMS2(J)=SQRT(ARRAY(JJ)/ALPHA(J,J))
CC 4502  PRMS2(J)=SQRT(ARRAY(J,J)/ALPHA(J,J))
C
C     WRITE RESULTS ON 'OUT' AND 'LOG' FILES.
C
      WRITE (OUT,4504) (PRMS2(I),I=1,NPRM)
 4504 FORMAT (' SIGMA: ',1P10G12.3)
C
 4510 IOB160=' '
C
      OPEN (UNIT=LOGU,FILE=OPTLOG,STATUS='OLD',ERR=8000,
     &  ACCESS='APPEND')
      WRITE (LOGU,4512) NITER,CHISQR,FLAMDA,NTRIES,(PRMLBL(I),
     &  PARMS(I),SSQDER(I),PRMIND(I),I=1,NPRM)
 4512 FORMAT (/1X,I4,1PG12.3,G10.3,I4,4X,A16,2G12.4,1X,A1,:/
     &  (35X,A16,1P2G12.4,1X,A1))
      CLOSE (UNIT=LOGU)
C
	IF (SHOWO) THEN
		WRITE (ICRT,4514) NITER,CHISQR,FLAMDA,NTRIES,
     &		 (PRMLBL(I),PARMS(I),SSQDER(I),PRMIND(I),I=1,NPRM)
 4514		FORMAT (1X,I4,1PG12.3,G10.3,I4,4X,A16,2G12.4,
     &		 1X,A1:/(35X,A16,1P2G12.4,1X,A1))
	ENDIF
C
	DO 4520 I=1,NPRM
	PRMIND(I)=' '
 4520	PRMSAV(I)=PARMS(I)
C
C	PRODUCE .SPL FILE FOR INITIAL CALC
C
	CALL PLOT
C
C     SEE IF DONE, EITHER BECAUSE TOO MANY ITERATIONS,
C     PERFECT FIT, OR CHANGE IN CHISQR SMALL.
C
      IF (NITER.GE.MAXITR) GOTO 9000
      IF (CHISQR.EQ.0.0) GOTO 9010
      IF (CHISQR.LE.MINCHI) GOTO 9020
      IF (CHISQ1/CHISQR.LE.MINFAC) GOTO 9030
C
      GOTO 2000
C
C -----------------------------------------------------------
C     RETURNING TO INT.  OPEN OPT1 TO ACCEPT NEW DATA, AND
C     OPT2 TO CONTAIN EXPT AND PREVIOUS CALC RESULTS (IF
C     NEEDED).  DATA SETS USED DEPENDS ON INDOPT.  IF INDOPT
C     LE 0, GET DATA FROM OPTDAT0.TMP AND WRITE IT ON
C     OPTDAT1.TMP.  IF INDOPT POSITIVE AND ODD, GET DATA
C     FROM OPTDAT1.TMP, AND WRITE IT ON OPTDAT2.TMP.  IF
C     INDOPT IS POSITIVE AND EVEN GET DATA FROM OPTDAT2.TMP
C     AND WRITE IT ON OPTDAT1.TMP.  INITIALIZE IRUN, WHICH
C     TELLS PRNTC WHAT RUN THIS IS.
C     ALSO, OPEN DATA SET TO TELL RDCKC WHAT PARM VALUES TO USE.
C
 5000 IF (QUITO) GOTO 9040
      IRUN=0
C
      IF (INDOPT.LE.0) THEN
        IOB160=' '
        CALL FILNAM (NLEN,IOB160,TMPUIC,'OPTDAT0.TMP ',' ')
        OPEN (UNIT=OPT2,FILE=IOB160,STATUS='OLD',
     &    FORM='UNFORMATTED')
        IOB160=' '
        CALL FILNAM (NLEN,IOB160,TMPUIC,'OPTDAT1.TMP ',' ')
        OPEN (UNIT=OPT1,FILE=IOB160,STATUS='UNKNOWN',
     &    FORM='UNFORMATTED')
C
      ELSEIF (2*(INDOPT/2).NE.INDOPT) THEN
C
        IOB160=' '
        CALL FILNAM (NLEN,IOB160,TMPUIC,'OPTDAT1.TMP ',' ')
        OPEN (UNIT=OPT2,FILE=IOB160,STATUS='OLD',
     &   FORM='UNFORMATTED')
       IOB160=' '
        CALL FILNAM (NLEN,IOB160,TMPUIC,'OPTDAT2.TMP ',' ')
        OPEN (UNIT=OPT1,FILE=IOB160,STATUS='UNKNOWN',
     &   FORM='UNFORMATTED')
C
      ELSE
C
        IOB160=' '
        CALL FILNAM (NLEN,IOB160,TMPUIC,'OPTDAT2.TMP ',' ')
        OPEN (UNIT=OPT2,FILE=IOB160,STATUS='OLD',
     &    FORM='UNFORMATTED')
        IOB160=' '
        CALL FILNAM (NLEN,IOB160,TMPUIC,'OPTDAT1.TMP ',' ')
       OPEN (UNIT=OPT1,FILE=IOB160,STATUS='UNKNOWN',
     &    FORM='UNFORMATTED')
C
      ENDIF
C
C      PUT CURRENT PARMS TO BE USED ON DATA SET=INTOP2.TMP,
C      WHICH IS READ BY RDCKC FIRST
C
 5050 IOB160=' '
C
      CALL FILNAM (NLEN,IOB160,TMPUIC,'INTOP2.TMP ',' ')
      OPEN (UNIT=LOGU,FILE=IOB160,STATUS='UNKNOWN')
C
      WRITE (LOGU,5052) (PRMLBL(J),PARMS(J),J=1,NPRM)
 5052 FORMAT (A16,1PG12.4)
      CLOSE (UNIT=LOGU)
	IF (SHOWO) THEN
		WRITE (ICRT,'('' PARMS:'',1P5G12.4:/(7X,5G12.4))')
     &	 	 (PARMS(J),J=1,NPRM)
	ENDIF
C
C     OPEN INTOPT.TMP;1 TO BE THE INPUT FILE
C
      IOB160=' '
C
      CALL FILNAM (NLEN,IOB160,TMPUIC,'INTOPT.TMP ',' ')
      CALL FILEIN
C
      RETURN
C
C     PROBLEM WITH OPENING LOG FILE
C
 8000	WRITE (ICRT,8002)
 8002	FORMAT (' PROBLEM OPENING OPT .LOG FILE.')
	STOP 'OPTIMIZATION ABORTED.'
C
C     DONE
C
 9000 WRITE (OUT,9002)
 9002 FORMAT (/' MAXIMUM NUMBER OF ITERATIONS EXCEEDED.')
      IOB160(1:14)='not completed.'
      GOTO 9090
 9010 WRITE (OUT,9012)
 9012 FORMAT (/' PERFECT FIT (CHISQR=0) OBTAINED.')
      IOB160(1:14)='completed.    '
      GOTO 9090
 9020 WRITE (OUT,9022)
 9022 FORMAT (/' CHISQR LESS THAN MINIMUM SPECIFIED.')
      IOB160(1:14)='completed.    '
      GOTO 9090
 9030 WRITE (OUT,9032) MINFAC
 9032 FORMAT (/' CHISQR CHANGED BY LESS THAN A FACTOR OF',F8.5)
      IOB160(1:14)='completed.    '
      GOTO 9090
 9040 WRITE (OUT,9042) INDOPT
 9042 FORMAT (/' OPTIMIZATION ABORTED BY COMMAND FROM ''OPT.CMD''.'
     &  /' INDOPT =',I3)
      IOB160(1:14)='aborted.      '
      GOTO 9090
 9050 WRITE (OUT,9052)
 9052 FORMAT (/' OPTIMIZATION TERMINATED BECAUSE CHANGE IN ALL',
     &  /' PARMS LESS THAN 1/2 CHANGE USED TO CALCULATE DERIVATIVES.')
      IOB160(1:14)='completed.    '
C
 9090 INDOPT=-3
C
C	WRITE FINAL SUMMARY OF RESULTS IN LOG FILE
C
	OPEN (UNIT=LOGU,FILE=OPTLOG,STATUS='OLD',ERR=9099,
     &	 ACCESS='APPEND')
	CALL TMARK (IOB160(15:30))
	WRITE (LOGU,9092) FILES(1:8),IOB160(1:14),IOB160(15:30),CHISQR,
     &	 (PRMLBL(I)(1:8),PRMSAV(I),I=1,NPRM)
 9092	FORMAT (/1X,A8,1X,A14,'  [',A16,']',1PE10.2,4X,A8,G12.4,:/
     &	 (58X,A8,G12.4))
	WRITE (LOGU,1) '-------------------------------------------',
     &	 '------------------------------------'
	CLOSE (UNIT=LOGU)
C
 9099	RETURN
	END
