C --- JMATRX.FOR
C --- PREPJ, SGESL.   IN 'JAC' SEGMENT
C --- CALLED BY LSODE
C --- FILE I/O:  NONE
C
C -------------------------------------------------------------------------
C
C       IN THIS FILE ARE THE LSODE SUBROUTINES PREPJ AND SGESL,
C       THESE BOTH OPERATE ON THE JACOBIAN MATRIX
C
C       CALLS VARIOUS LSODE SUBROUTINES IN LSODE.OLB.
C
C
      SUBROUTINE PREPJ (Y, YH, NYH, EWT, FTEM, SAVF, WM, IWM, JMATRX)
C
      INTEGER NEQ, NYH, IWM
      INTEGER IOWND, IOWNS,
     1   ICF, IERPJ, IERSL, JCUR, JSTART, KFLAG, L, METH, MITER,
     2   MAXORD, MAXCOR, MSBP, MXNCF, N, NQ, NST, NFE, NJE, NQU
      INTEGER I, IER, J, J1
      REAL Y, YH, EWT, FTEM, SAVF, WM
      REAL ROWND, ROWNS,
     1   CCMAX, EL0, H, HMIN, HMXI, HU, RC, TN, UROUND
      REAL FAC, HL0, R, R0, SRUR, YJ, VNORM
      DIMENSION Y(*), YH(NYH,*), EWT(*), FTEM(*), SAVF(*),
     1   WM(2), IWM(*)
      REAL JMATRX(*)
C
      COMMON /LS0001/ NEQ,NST,NFE,NJE, ROWND, ROWNS(209),
     2   CCMAX, EL0, H, HMIN, HMXI, HU, RC, TN, UROUND,
     3   IOWND(14), IOWNS(6),
     4   ICF, IERPJ, IERSL, JCUR, JSTART, KFLAG, L, METH, MITER,
     5   MAXORD, MAXCOR, MSBP, MXNCF, NQ, NQU, LASTN
        EQUIVALENCE (NEQ,N),(IOWND(5),LACOR)
C
C ----------------------------------------------------------------------
C PREPJ IS CALLED BY STODE TO COMPUTE AND PROCESS THE MATRIX
C P = I - H*EL(1)*J , WHERE J IS AN APPROXIMATION TO THE JACOBIAN.
C HERE J IS COMPUTED BY THE USER-SUPPLIED ROUTINE JAC IF
C MITER = 1 OR 4, OR BY FINITE DIFFERENCING IF MITER = 2, 3, OR 5.
C IF MITER = 3, A DIAGONAL APPROXIMATION TO J IS USED.
C J IS STORED IN WM AND REPLACED BY P.  IF MITER .NE. 3, P IS THEN
C SUBJECTED TO LU DECOMPOSITION IN PREPARATION FOR LATER SOLUTION
C OF LINEAR SYSTEMS WITH P AS COEFFICIENT MATRIX. THIS IS DONE
C BY SGEFA IF MITER = 1 OR 2, AND BY SGBFA IF MITER = 4 OR 5.
C
C IN ADDITION TO VARIABLES DESCRIBED PREVIOUSLY, COMMUNICATION
C WITH PREPJ USES THE FOLLOWING..
C Y     = ARRAY CONTAINING PREDICTED VALUES ON ENTRY.
C FTEM  = WORK ARRAY OF LENGTH N (ACOR IN STODE).
C SAVF  = ARRAY CONTAINING F EVALUATED AT PREDICTED Y.
C WM    = REAL WORK SPACE FOR MATRICES.  ON OUTPUT IT CONTAINS THE
C         INVERSE DIAGONAL MATRIX IF MITER = 3 AND THE LU DECOMPOSITION
C         OF P IF MITER IS 1, 2 , 4, OR 5.
C         STORAGE OF MATRIX ELEMENTS STARTS AT WM(3).  (JMATRX)
C         WM ALSO CONTAINS THE FOLLOWING MATRIX-RELATED DATA..
C         WM(1) = SQRT(UROUND), USED IN NUMERICAL JACOBIAN INCREMENTS.
C         WM(2) = H*EL0, SAVED FOR LATER USE IF MITER = 3.
C       **NOTE** MODIFIED SO WM(3) REPLACED BY JMATRX
C IWM   = INTEGER WORK SPACE CONTAINING PIVOT INFORMATION, STARTING AT
C         IWM(21), IF MITER IS 1, 2, 4, OR 5.  IWM ALSO CONTAINS BAND
C         PARAMETERS ML = IWM(1) AND MU = IWM(2) IF MITER IS 4 OR 5.
C EL0   = EL(1) (INPUT).
C IERPJ = OUTPUT ERROR FLAG,  = 0 IF NO TROUBLE, .GT. 0 IF
C         P MATRIX FOUND TO BE SINGULAR.
C JCUR  = OUTPUT FLAG = 1 TO INDICATE THAT THE JACOBIAN MATRIX
C         (OR APPROXIMATION) IS NOW CURRENT.
C THIS ROUTINE ALSO USES THE COMMON VARIABLES EL0, H, TN, UROUND,
C MITER, N, NFE, AND NJE.
C
C       MODIFIED VERSION.  ONLY VALID FOR MITER=1 OR 2
C
C ----------------------------------------------------------------------
      NJE = NJE + 1
      IERPJ = 0
      JCUR = 1
      HL0 = H*EL0
C
C -P
C .      IF (MITER.EQ.2) GOTO 200
C IF MITER = 1, CALL JAC AND MULTIPLY BY SCALAR. -----------------------
C .  100 LENP = N*N
C .     DO 110 I = 1,LENP
C . 110    JMATRX(I) = 0.0E0
C .     CALL PEDERV (TN, Y, 0, 0, JMATRX, N)   !JAC
C .     CON = -HL0
C .     DO 120 I = 1,LENP
C . 120    JMATRX(I) = JMATRX(I)*CON
C .     GO TO 240
C -
C IF MITER = 2, MAKE N CALLS TO F TO APPROXIMATE J. --------------------
  200 FAC = VNORM (N, SAVF, EWT)
      R0 = 1000.0E0*ABS(H)*UROUND*FLOAT(N)*FAC
      IF (R0 .EQ. 0.0E0) R0 = 1.0E0
      SRUR = WM(1)
      J1 = 0
      DO 230 J = 1,N
        YJ = Y(J)
        R = AMAX1(SRUR*ABS(YJ),R0/EWT(J))
        Y(J) = Y(J) + R
        FAC = -HL0/R
        CALL DIFFUN (TN, FTEM)
        DO 220 I = 1,N
  220   JMATRX(I+J1) = (FTEM(I) - SAVF(I))*FAC
        Y(J) = YJ
        J1 = J1 + N
  230 CONTINUE
      NFE = NFE + N
C     ADD IDENTITY MATRIX. -------------------------------------------------
  240 J = 1
      DO 250 I = 1,N
        JMATRX(J) = JMATRX(J) + 1.0E0
 250  J = J + (N + 1)
C     DO LU DECOMPOSITION ON P. --------------------------------------------
      CALL SGEFA (JMATRX,N,N,IWM(21),IER)
      IF (IER .NE. 0) IERPJ = 1
      RETURN
C ---------------------- END OF SUBROUTINE PREPJ1 -----------------------
      END
C
C      SUBROUTINE SGESL (A,LDA,N,IPVT,B,JOB)
      SUBROUTINE SGESL (A,LDA,N,IPVT,B)
      INTEGER LDA,N,IPVT(1),JOB
	DATA JOB/0/
      REAL A(LDA,*),B(*)
C
C     SGESL SOLVES THE REAL SYSTEM
C     A * X = B  OR  TRANS(A) * X = B
C     USING THE FACTORS COMPUTED BY SGECO OR SGEFA.
C
C     ON ENTRY
C
C        A       REAL(LDA, N)
C                THE OUTPUT FROM SGECO OR SGEFA.
C
C        LDA     INTEGER
C                THE LEADING DIMENSION OF THE ARRAY  A .
C
C        N       INTEGER
C                THE ORDER OF THE MATRIX  A .
C
C        IPVT    INTEGER(N)
C                THE PIVOT VECTOR FROM SGECO OR SGEFA.
C
C        B       REAL(N)
C                THE RIGHT HAND SIDE VECTOR.
C
C        JOB     INTEGER
C                = 0         TO SOLVE  A*X = B ,
C                = NONZERO   TO SOLVE  TRANS(A)*X = B  WHERE
C                            TRANS(A)  IS THE TRANSPOSE.
C
C     ON RETURN
C
C        B       THE SOLUTION VECTOR  X .
C
C     ERROR CONDITION
C
C        A DIVISION BY ZERO WILL OCCUR IF THE INPUT FACTOR CONTAINS A
C        ZERO ON THE DIAGONAL.  TECHNICALLY THIS INDICATES SINGULARITY
C        BUT IT IS OFTEN CAUSED BY IMPROPER ARGUMENTS OR IMPROPER
C        SETTING OF LDA .  IT WILL NOT OCCUR IF THE SUBROUTINES ARE
C        CALLED CORRECTLY AND IF SGECO HAS SET RCOND .GT. 0.0
C        OR SGEFA HAS SET INFO .EQ. 0 .
C
C     TO COMPUTE  INVERSE(A) * C  WHERE  C  IS A MATRIX
C     WITH  P  COLUMNS
C           CALL SGECO(A,LDA,N,IPVT,RCOND,Z)
C           IF (RCOND IS TOO SMALL) GO TO ...
C           DO 10 J = 1, P
C              CALL SGESL(A,LDA,N,IPVT,C(1,J),0)
C        10 CONTINUE
C
C     LINPACK. THIS VERSION DATED 07/14/77 .
C     CLEVE MOLER, UNIVERSITY OF NEW MEXICO, ARGONNE NATIONAL LABS.
C
C     SUBROUTINES AND FUNCTIONS
C
C     BLAS SAXPY,SDOT
C
C     INTERNAL VARIABLES
C
      REAL SDOT,T
      INTEGER K,KB,L,NM1
C
      NM1 = N - 1
      IF (JOB .NE. 0) GO TO 50
C
C        JOB = 0 , SOLVE  A * X = B
C        FIRST SOLVE  L*Y = B
C
      IF (NM1 .LT. 1) GO TO 30
      DO 20 K = 1, NM1
            L = IPVT(K)
            T = B(L)
            IF (L .EQ. K) GO TO 10
               B(L) = B(K)
               B(K) = T
   10       CONTINUE
            CALL SAXPY(N-K,T,A(K+1,K),1,B(K+1),1)
   20 CONTINUE
   30 CONTINUE
C
C     NOW SOLVE  U*X = Y
C
      DO 40 KB = 1, N
          K = N + 1 - KB
          B(K) = B(K)/A(K,K)
          T = -B(K)
          CALL SAXPY(K-1,T,A(1,K),1,B(1),1)
   40 CONTINUE
      GO TO 100
   50 CONTINUE
C
C     JOB = NONZERO, SOLVE  TRANS(A) * X = B
C     FIRST SOLVE  TRANS(U)*Y = B
C
      DO 60 K = 1, N
            T = SDOT(K-1,A(1,K),1,B(1),1)
            B(K) = (B(K) - T)/A(K,K)
   60 CONTINUE
C
C     NOW SOLVE TRANS(L)*X = Y
C
      IF (NM1 .LT. 1) GO TO 90
      DO 80 KB = 1, NM1
            K = N - KB
            B(K) = B(K) + SDOT(N-K,A(K+1,K),1,B(K+1),1)
            L = IPVT(K)
            IF (L .EQ. K) GO TO 70
               T = B(L)
               B(L) = B(K)
               B(K) = T
   70       CONTINUE
   80 CONTINUE
   90 CONTINUE
  100 CONTINUE
      RETURN
      END
C --- END OF JMATRX.FOR
