C --- MAINSPC.FOR
C
C	SPECIFICATIONS FOR COMMONS AND PARAMETERS FOR INTEGRATION PROGRAM
C
C	MAXIMUM SIZE SPECIFICATIONS
C
	PARAMETER (MAXACT=4000)	! ACTIVE SPECIES (MEMORY GOES AS MAXACT**2)
	PARAMETER (MAXRXN=9000)	! REACTIONS
	PARAMETER (MAXCOE=20000)	! TOTAL COEFFICIENTS
	PARAMETER (MAXCOV=8000)	! VARIABELE COEFS.  MUST BE LT MAXCOE
	PARAMETER (MAXNS=4000)	! TOTAL SPECIES
	PARAMETER (MAXPHK=50)   ! PHOT FILES (PHOTK'S, Z-VARY COEFS).
C
C ------------------------------------
C				  MAX CONSTANT COEFS = MAXCOE-MAXCOV
	PARAMETER (MAXBO=150)	! BUILDUP-ONLY SPECIES
	PARAMETER (MAXCON=50)	! CONSTANT SPECIES
	PARAMETER (MSAMEP=12)   ! PHOT RXNS WITH SAME ABSQY
	PARAMETER (MAXNKP=100)	! KINETIC PARMS CHANGED/CALC.
	PARAMETER (MXVTCO=50)	! TEMP VARYING COEFS
	PARAMETER (MXVTMP=4)	! T-VARYING COEF'S
C
	PARAMETER (MAXMXO=50)	! NO. SPECIES TO FIND MAX CONC.
C
C	SPECIFICATIONS RELATED TO MECHANISM COMPLEXITY
C
	PARAMETER (MAXKBF=3*MAXRXN)	! KINETIC PARM BUFFER LENGTH
	PARAMETER (MAXIKB=40)	! KINETIC INDEX BUFFER LENGTH
	PARAMETER (MAXNWL=1000)	! WL'S IN PHOT FILES (TEMP ARRAY)
C
C	USED FOR OPTIMIZATION FEATURE ONLY
C
	PARAMETER (MAXRUN=50)	! RUNS (INTEGRATIONS) USED IN OPT
	PARAMETER (MAXTIM=100)	! TIMES FOR DATA IN ANY ONE RUN
	PARAMETER (MAXCHN=8)	! DIFFERENT CHANNELS FOR WHICH DATA USED 
C				  IN ANY ONE RUN
	PARAMETER (MAXPRM=20)	! ADJUSTABLE PARMS
	PARAMETER (MAXNPT=MAXTIM*MAXRUN)	! TOTAL DATA POINTS
	PARAMETER (MAXPR1=MAXPRM+1)
C
C	THE FOLLOWING CAN BE CHANGED DEPENDING IF INTRATE FEATURE IS
C	NEEDED.  USED ONLY IN MODL, PRNTC AND NEWSTP.
C
	PARAMETER (MAXRXI=MAXRXN)	! **IF INTRATE FEATURE NEEDED**
C*	PARAMETER (MAXRXI=1)		! **IF INTRATE FEATURE NOT NEEDED**
C
C	THE FOLLOWING IS DEPENDENT ON CODE AND DATA IN NEWPHK AND SETKHV
C
	PARAMETER (NSOLWL=27)	! NUMBER OF WL FOR VARYHV=T.
C
C
C	DEPENDENT PARAMETERS
C
	INTEGER BUFLEN
	PARAMETER (MAXAB=MAXACT+MAXBO)
	PARAMETER (BUFLEN=22+9*MAXACT)
	PARAMETER (MAXASQ=MAXACT*MAXACT)
	PARAMETER (IBFLEN=20+MAXACT)
	PARAMETER (MAXVCO=MAXACT+10,MAXVC1=MAXVCO+1,MAXVDT=1600)
C
C
C
C	MODEL-DEPENDENT SCALARS AND ARRAYS USED BY BOTH INT AND RDCKC.
C
	COMMON/MODPRM/ NS,NSC,NSB,NSS,NSC0,NSC1,NSC2,NB0,NB1,NB2,NA0
     &   ,NA1,NA2,NS0,NS1,NS2,NRK,NCOEFV,NPHOTK,LCODE,PRNT,NDUM
     &   ,LENKBF,INDLIL,INDHV,INDDIL,INDTPR,INDHT,INDARA,INDVOL,INDEF
     &   ,INDER,INDVA,INDLIT,INDATM,NEWKP,NVCO,NNDY,TNEXT
     &   ,C(MAXNS),COEF(MAXCOE),RK(MAXRXN),IPHRK(MAXPHK),IVCOEF(MAXVCO)
     &   ,NPT,LENIKB,NCOC1,NCO,NVTCO,NVTEMP,VTEMP(MXVTMP),IVTCO(MXVTCO)
     &   ,VTCO(MXVTCO,MXVTMP),NOCHN(MAXRUN),NVZCO,MVZCO(MAXPHK)
     &	 ,NMAXO,IMAXO(MAXMXO),CMAXO(MAXMXO,5)
	EQUIVALENCE (NA0,N0),(NRK,NRXN)
C
C	KINETIC PARAMETER DATA
C
	INTEGER RXTYP(MAXRXN)
	INTEGER LKBUF(MAXRXN)
	INTEGER OLDIND(MAXNKP)
	INTEGER IOLDKP(MAXNKP),IKPBUF(MAXIKB)
	REAL KPBUF(MAXKBF),OLDKP(MAXNKP)
	COMMON/KPDAT/KPBUF,OLDKP,IOLDKP,LKBUF,OLDIND,RXTYP,IKPBUF
     &   ,ABSQY(NSOLWL,MAXPHK),DPHOTK(MAXPHK)
C
C	 VAR COEF SPECIFICATIONS
C
	REAL VINT(MAXVCO),VSLOPE(MAXVCO)
C
C	INTEGRATION DATA
C
	INTEGER LSDATA(478)
C
	EQUIVALENCE (LSDATA(1),NDY),(LSDATA(2),NSTP),(LSDATA(3),NFEVAL)
     &   ,(LSDATA(4),NJEVAL),(LSDATA(443),ILLIN),(LSDATA(454),NTREP)
	COMMON /LS0001/ LSDATA
     &   ,VINT,VSLOPE
     &   ,BUF(BUFLEN),IBUF(IBFLEN),ATOL(MAXACT)
     &   ,DY(MAXAB),DYBO(MAXBO),CBO(MAXBO),R(MAXRXN)
	EQUIVALENCE (TCUR,BUF(13)),(NST,IBUF(11)),(NINV,IBUF(13))
C
C	SPECIFICATIONS ARRAYS NOT NEEDED FOR INTEGRATION
C	IN INT PROGRAM, AND WHICH NEED TO BE SAVED AND LATER RESTORED
C	IF THEY ARE OVER-WRITTEN BY CALLING INT IF
C	THE PROGRAM IS OVERLAYED.
C
C	GENERAL DATA
C
	INTEGER IPHRK
	CHARACTER COEFNM*8,PHOTNM*8,NAME*16,RXNLBL*4,SDFIL*12,RUNLBL*8,
     &	 TITLE*80,RUN*80,OLDRUN*80,PRMFIL*8,ONLMAX*16
	COMMON/DAT/ OLDCOE(MAXCOV),CINIT(MAXNS),OLDPHK(MAXPHK)
	COMMON/DAT1/ NAME(MAXNS),COEFNM(MAXCOV),SDFIL,TITLE
     &   ,RUN,OLDRUN,PHOTNM(MAXPHK),RXNLBL(MAXRXN),RUNLBL(MAXRUN)
     &	 ,PRMFIL,ONLMAX
C
C	PROGRAM CONTROL PARAMETERS
C
	LOGICAL PASS,OLDMOD,WRITDY,WRITR,DBGPRT,NPMODL, FIRST
     &   ,ERQUIT,LAST,VARYHV,CXTRA,EOF,NEWTMP,ABORT,WRITCO,SUN
     &   ,CONT,SEPRAT,SHOWT,CLOSEF,SAVER,NOPRNT,OPT,INTOUT,SEEFIL
     &   ,NEWVCO,NODARK,NEWSD,PKSET,REINIT,SAVLST,INTRAT,NOCHEM
     &	 ,MAXONL,CONTC,FORM3,AIRSHD,WRITK,PASSED,CSVOUT
     &	 ,RCALL
	REAL LAT,UVFAC,COSZ,CZMIN,TIMINT
	INTEGER LSAVFL,LCALUC
	CHARACTER*8 MOD,FILES,EXTFIL,DFLEXT
	CHARACTER*40 MODUIC,SDRUIC,CALUIC,LOGUIC,TMPUIC,LMPUIC
	CHARACTER*60 PGMUIC,SAVFIL,GETAL,SAVFL1
	CHARACTER*80 LMPFIL
	CHARACTER*160 MXOLST
	CHARACTER*4 OUTEXT
C
	COMMON /CONTRL/ IRET,KFLAG,TEMP,T,BOLAST,T0,TEND,DPRN
     &   ,CMIN,CMAX,EPS,MF,LAT,DEC,O3STRT,TSTART,TREF
     &   ,TR,NSAVSS,NERR,IVTPR,MAXSTP,IVHT,DELTPR,NTERR,ICAL,F
     &   ,TDAWN,TWRATE,PK1,TLAST,TXLAST,IHV,NSWL
     &   ,PASS,WRITDY,WRITR,DBGPRT,NPMODL,FIRST,ERQUIT,VARYHV
     &   ,CXTRA,EOF,NEWTMP,ABORT,WRITCO,OLDMOD,LAST,CONT,SEPRAT,SHOWT
     &   ,CLOSEF,SAVER,NOPRNT,OPT,INTOUT,SEEFIL,NEWVCO
     &   ,SINLD,COSLD,UVFAC,COSZ,CZMIN,TIMINT
     &	 ,SAVLST,INTRAT,NOCHEM,SUN,MAXONL,CONTC,IK1,REINIT
     &	 ,NODARK,NEWSD,PKSET,FORM3,AIRSHD,ICOSZ,WRITK,LSAVFL,LCALUC
     &	 ,LGETAL,LFILES,LEXTFL,LDFLEX,LSAVF1,PASSED,CSVOUT
     &	 ,RCALL
	COMMON /CNTRL1/ MOD,FILES,MODUIC,SDRUIC,CALUIC,LOGUIC,TMPUIC
     &   ,LMPFIL,LMPUIC,MXOLST,EXTFIL,PGMUIC,SAVFIL,GETAL,SAVFL1,DFLEXT
     &	 ,OUTEXT
C
C
C	OPTIMIZATION SCALAR SPECS AND ARRAYS WHICH ARE SAVED THROUGHOUT
C
	LOGICAL SHOFIT
	INTEGER NDATRN
	REAL MINFAC,MINCHI
	COMMON /OPTPRM/ INDOPT,NPRM,NRUNS,NITER,MAXITR,IRUN,FLAMDA
     &   ,CHISQR,CHISQ1,MINCHI,SAVE1,MINFAC,NDATRN(MAXRUN)
     &   ,NTRIES,SHOFIT
	COMMON /OPTIM/ TIMES(MAXTIM,MAXCHN),DATA(MAXTIM,MAXCHN)
     &   ,WT(MAXTIM,MAXCHN)
	CHARACTER*80 OPTLOG
	COMMON /OPTCHR/ OPTLOG
C
C ---------------------------------------------------------------
C	I/O BUFFER USED FOR INPUT AND AS SCRATCH ARRAYS
C	INCLUDE '..\SUBS\NEWIOBUF.FOR'
C
C       INPUT/OUTPUT BUFFER.  USED BY INBUF
C
	PARAMETER (IKEY=5,ICRT=6)
C
C       PARAMETER CRTUNT=5              !FOR PLOT PROGRAM
C
        PARAMETER (MAXIBF=160)
C
       LOGICAL    SHOW, NOKEY
       INTEGER    IN, IOLEN, IORET, LOUTBF
       CHARACTER*1  BYT16(16), BYT160(160)
       CHARACTER    IOB160*160, IOBF16*16, OUTBUF*132
C
       COMMON /IOBUF/ IN,IOLEN,IORET,MAXUNT,NOKEY,SHOW,LOUTBF
       COMMON /IOBFCH/ BYT16,IOB160,OUTBUF
       EQUIVALENCE (IOB160,BYT160),  (BYT16,IOBF16)
C
C ---   END OF NEWIOBUF
C ---------------------------------------------------------------
C
C	FILE UNIT ASSIGNMENTS.  NOTE THAT THESE ASSUME THAT BOTH
C	  SAVE AND OPT CANT BE TRUE AT THE SAME TIME.
C
C	  UNITS 1-3:                       RESERVED FOR INPUT.  MAINTAINED BY
C	                                   INBUF.
C
	INTEGER OUT,DATA1,DATA2,OPT1,OPT2,TIMEU,LOGU,TMP1,TMP2,TMP3
C
	PARAMETER (OUT=4)                 !OUTPUT FILE.
	PARAMETER (DATA1=7,DATA2=8)
	PARAMETER (OPT1=7,OPT2=8)	!UNFORMATTED I/O FOR SAVING RESULTS
C                                       !OF CALCS (SAVE) OR FOR USE DURING
C                                        OPT.  NOT TO BE USED BY RDCKC, MODL
C                                        OR THEIR SUBROUTINES.
C
	PARAMETER (TIMEU=11)            !USED TO STORE VARIABLE COEFFICIENT
C                                        AND OTHER VALUES WHICH CHANGE WITH
C                                        TIME DURING INT.
C
	PARAMETER (LOGU=12)             !SAVE:  LOG FILES, OPT: WRITE RDCKC
C                                        INPUT.  NOT AVAILABLE TO RDCKC OR
C                                        MODL SUBROUTINES.
C
	PARAMETER (TMP1=9,TMP2=10,TMP3=13)      !TEMPORARY UNITS.  MUST BE CLOSED
C                                        WHEN EXITING A SUBROUTINE BLOCK.
C
C --- END OF MAINSPC.FO
