C --- MODL.FOR --- READS MODEL AND INITIALIZES.
C --- CALLED BY INTMAIN
C --- CALLS INBUF, NEWRK, RDPHK, MISC. UTILITIES
C --- UNITS USED:  OUT  (WRITES)
C             LOGU (NONCRAY: OPENS, WRITES, CLOSES) --- OPEN DURING SUB. CALLS
C             OPTU (CRAY VERSION: OPENS, WRITES) --- OPEN DURING SUB. CALLS
C             TMP1 (OPENS, READS, CLOSES) .MOD
C
C -------------------------------------------------------------------------
C
	SUBROUTINE MODL
C
	INCLUDE 'MAINSPC.FOR'
C-
C
	CHARACTER PHTNAM*8,LBLI*4,LBLI2*4,CHARXN*80,FF*1,FZSFIL*60,TAB*1
C
	REAL PWL(MAXNWL),AQ(MAXNWL)
	LOGICAL NXTNEW,ERRIND
C
	CHARACTER*8 ACTIVE,CONST,STST,FORM,FORMOK,CFORM3
C
C----------------------------------------------------------------------
C       FOLLOWING ARE WAVELENGTHS FOR WHICH ABS*QY DATA ARE
C       STORED.  SOME (HIGHER) WAVELENGTH INTERVALS LUMPED
C       TOGETHER, AND SDIST SUMMED FOR THESE.
C       **** PARMS USED BY DIFFUN MUST BE CONSISTANT WITH THIS.
C               SEE DATA STATEMENTS FOR APARM, ETC. AND SSDIST
C               CALC CODE THERE.
C
      PARAMETER (NSOLW1=NSOLWL+1)
      REAL SOLWL(NSOLW1)
C
      DATA SOLWL   /     0.295,   0.300,    0.305,    0.310,    0.315,
     &          0.320,   0.325,   0.330,    0.335,    0.340,    0.345,
     &          0.350,            0.360,              0.370,
     &          0.380,            0.390,              0.400,
     &          0.410,            0.420,    0.430,    0.440,    0.450,
     &          0.460,   0.470,   0.480,    0.490,    0.500,
     &                   1.000/
C----------------------------------------------------------------------
C
C	RENAMES
C
	PARAMETER (MAXREN=8)
	CHARACTER*16 OLDNAM(MAXREN),NEWNAM(MAXREN)
C
      DATA ACTIVE/'ACTIVE  '/,CONST/'CONSTANT'/,
     &   STST/'ST.STATE'/,FORMOK/'MV:4/89'/,CFORM3/'MV:3/01F'/
C
C	INITIALIZE FOR PARSE0 TO RECOGNIZE "=" AS WELL AS <BLANK> AND
C	<TAB> AS "WORD" SEPARATORS
C
	FF=CHAR(13)
	TAB=CHAR(9)
C
	IOB160(1:1)=' '
	IOB160(2:2)=TAB
	IOB160(3:3)='='
	CALL PARSE0 (-1,IOB160,3)
C
C	MARK TIME OF CALC
C
	CALL TMARK(IOBF16)
C
C     GET FIRST LINE IN INPUT FILE.  IF IT IS 'OPT', THEN THIS
C     IS AN OPTIMIZATION, AND NEXT LINE IS HEADER.  IF NOT, FIRST
C     LINE IS HEADER.  WRITE HEADER ON 'OUT' FILE.  IF AN OPTIMIZATION,
C     OPEN OPT .LOG FILE, AND WRITE HEADER ON IT.
C
	OPT=.FALSE.
	CALL INBUF ('HEADER: ',8)
	IF (IORET.EQ.2) THEN
		GOTO 9999
	ELSEIF (IOB160(1:3).EQ.'OPT') THEN
		OPT=.TRUE.
C
C		OPTIONALLY THE OPT COMMAND CAN BE OF THE FORMAT
C		"OPTLOG filename", WHERE THE FILE IS USED FOR THE
C		LOG.  IF IT EXISTS, THIS RUN IS APPENDED TO IT.
C		THE FULL FILE NAME MUST BE GIVEN.
C
		IF (IOB160(4:6).EQ.'LOG') THEN
			L=LENSTR(IOB160,80)
			OPTLOG=IOB160(8:L)
			OPEN (UNIT=LOGU,FILE=OPTLOG,STATUS='UNKNOWN',
     &			 ERR=8020,ACCESS='APPEND')
			NXTNEW=.TRUE.
		ELSE
C
C			CREATE AND OPEN DEFAULT OPT .LOG FILE
			OPTLOG=' '
			CALL FILNAM (NLEN,OPTLOG,LOGUIC,FILES,'.LOG ')
			OPEN (UNIT=LOGU,FILE=OPTLOG,STATUS='UNKNOWN')
			NXTNEW=.FALSE.
		ENDIF
		CALL INBUF ('OPT HEADER: ',12)
		IF (IORET.EQ.2) THEN
			IF (NXTNEW) THEN
				CLOSE (UNIT=LOGU)
			ELSE
				CLOSE (UNIT=LOGU,STATUS='DELETE')
			ENDIF
			GOTO 9999
		ENDIF
		WRITE (LOGU,1002) IOB160(1:LNBLNK(IOB160)),FILES,IOBF16(1:8),
     &		 IOBF16(9:16)
 1002		FORMAT (A//'FILE = ',A8,5X,'DATE = ',A8,1X,A8)
      ENDIF
C
C     WRITE HEADER ON OUT FILE
C
	WRITE (OUT,1001) FILES(1:LFILES),IOBF16(1:8),IOBF16(9:16)
     &	 ,IOB160
 1001	FORMAT (' ',130('*')//1X,29X,'S A P R C   M O D E L   I N T E',
     &	 ' G R A T I O N   P R O G R A M'//1X,57X,'FILE = ',A/
     &	 /1X,52X,A8,1X,A8//1X,25X,A80//1X,130('*')/)
C
	IF (PRMFIL(1:1).NE.' ') WRITE (OUT,*) 'PARAMETERS READ FROM ',
     &	 PRMFIL(1:LNBLNK(PRMFIL)),'.PRM.'
C
	WRITE (OUT,'(/'' LIST OF PARAMETERS INPUT:''/)')
C
C	WRITE REST OPT LOG DATA UNTIL *END INPUT IF OPTLOG
C	OPTION GIVEN
C
	IF (OPT) THEN
		IF (NXTNEW) THEN
			OPEN (UNIT=TMP1,FILE='OPTLOG.TMP',STATUS='UNKNOWN')
			CLOSE (UNIT=TMP1,STATUS='DELETE')
			OPEN (UNIT=TMP1,FILE='OPTLOG.TMP',STATUS='UNKNOWN')
			WRITE (LOGU,'(1X)')
			WRITE (OUT,'(1X)')
 1012			CALL INBUF ('OPTLOG: ',8)
			IF (IORET.EQ.2) GOTO 9999
			IF (IOB160(1:4).EQ.'*END') GOTO 1013
			L=LENSTR(IOB160,80)
			IF (L.EQ.0) L=1
			IF (L.NE.1.AND.IOB160(1:1).EQ.'*') THEN
				IF (L.GT.0) WRITE (TMP1,1) 
     &				 IOB160(2:L)
				WRITE (OUT,'(10X,'' --> '',A)')
     &				 IOB160(2:L)
				WRITE (LOGU,'('' --> '',A)') IOB160(2:L)
			ELSE
				WRITE (OUT,'(10X,A)') IOB160(1:L)
				WRITE (LOGU,1) IOB160(1:L)
			ENDIF
			GOTO 1012
 1013			WRITE (LOGU,'(1X)')
			WRITE (OUT,'(1X)')
			CLOSE (UNIT=TMP1)
		ENDIF
	ENDIF
C
C     INITIALIZE CONTROL PARAMETERS TO DEFAULT
C
C     THE PRESENT VERSION ONLY WORKS FOR MF=22
	MF=22
C	SHOWT=.TRUE.
	SHOWT=.FALSE.
	OLDMOD=.FALSE.
	ERQUIT=.TRUE.
	IK1=0
	PK1=0.0
C	PASS=.FALSE.	! MOVED TO INTINI
C	SAVER=.FALSE.	! MOVED TO INTINI
C	INTRAT=.FALSE.	! MOVED TO INTINI
	SAVLST=.FALSE.
	NSAVSS=-1
C	NSAVBO=-1
	WRITDY=.FALSE.
	WRITR=.FALSE.
	CLOSEF=.TRUE.
	DBGPRT=.FALSE.
	NPMODL=.FALSE.
	MAXSTP=500
	EXTFIL=DFLEXT
	LEXTFL=LDFLEX
	WRITK=.FALSE.
	CSVOUT=.FALSE.

	CMAX=1.0
C	CMAX = VALUE OF YMAX INITIALLY USED BY STIFF FOR ACTIVE SPECIES
C	WHOSE INITIAL CONC AND DERIVATIVE IS 0.  ONE SHOULD BE 'TYPICAL'
C	OF ACTIVE SPECIES CONCENTRATIONS IN UNITS USED.  DEFAULT APPROPRIATE
C	FOR PPM-MIN UNITS.

	TEMP=0.0
	IVTPR=0                   ! V COEF INDEX IF TEMPERATURE VARIED
	IVHT=0                    ! V COEF INDEX FOR 'HEIGHT' IF VARIED.
C                               ! (USED TO CALCULATE ENTRAINMENT RATES)
	T0=0.0
	TEND=360.
	DPRN=10.0
C	EPS = RELATIVE ERROR TEST PARM USED BY LSODE FOR ERROR TEST
	EPS=1.0E-04
C	CMIN = MINIMUM VAXUE OF YMAX USED BY LSODE FOR ERROR TEST PURPOSES
	CMIN=1.0E-2
C	XTRA NOT USED.  RESERVED FOR INT PARMS.
	XTRA=0.0
	VARYHV=.FALSE.
	SUN=.FALSE.
	NVZCO=0
	FZSFIL=' '
C	WRITCO=.FALSE.		! MOVED TO INTINI
	NOPRNT=.FALSE.
C	WRITCO..PRINT VAR COEF'S AT EACH STEP IF TRUE
C	DEFAULT MF SET IN MODL
C
C	FOLLOWING ARE FOR SOLAR HV'S  (DEFAULT = STD EKMA):
	LAT=34.06
	DEC=23.50
C       O3STRT=0.295
	CZMIN=1.0E-6
	TSTART=0.0
	NVCO=0
	INTOUT=.TRUE.
	OLDRUN=' '
	LMPFIL=' '
	REINIT=.TRUE.     ! NEED TO INITIALIZE LUMPING PARMS (IF LUMPING USED)
	NEWKP=0           ! # NEW KINETIC PARMS READ BY RDCKC
	UVFAC=1.0         ! CORRECTION FACTOR APPLIED WHEN UV CALCULATED
C                       ! (VARYHV=T ONLY)
	NREN=0
C
	NOCHEM=.FALSE.
C
C	READ CONTROL PARAMETERS
C
 1100 CALL INBUF ('PARM: ',5)
      IF (IORET.EQ.2) GOTO 9999
      IF (BYT160(1).EQ.' ') GOTO 1100
      IF (BYT160(1).EQ.'!') GOTO 1100
      IF (BYT160(1).EQ.'.') GOTO 1900
      IF (INTOUT) WRITE (OUT,*) ' ',IOB160(1:LNBLNK(IOB160))
C
	IF (IOB160(1:4).EQ.'CMAX') THEN
		CALL PARSE0 (2,IOB160,80)
		CALL PARSER (2,CMAX,ERRIND,IOB160)
		IF (ERRIND) GOTO 1800
C
	ELSEIF (IOB160(1:4).EQ.'CMIN') THEN
		CALL PARSE0 (2,IOB160,80)
		CALL PARSER (2,CMIN,ERRIND,IOB160)
		IF (ERRIND) GOTO 1800
C
	ELSEIF (IOB160(1:5).EQ.'DEBUG') THEN
		DBGPRT=.TRUE.
		CLOSEF=.FALSE.
C
	ELSEIF (IOB160(1:3).EQ.'DEC') THEN
		CALL PARSE0 (2,IOB160,80)
		CALL PARSER (2,DEC,ERRIND,IOB160)
		IF (ERRIND) GOTO 1800
C
	ELSEIF (IOB160(1:3).EQ.'EPS') THEN
		CALL PARSE0 (2,IOB160,80)
		CALL PARSER (2,EPS,ERRIND,IOB160)
		IF (ERRIND) GOTO 1800
C
	ELSEIF (IOB160(1:5).EQ.'ERROK') THEN
		ERQUIT=.FALSE.
C
	ELSEIF (IOB160(1:3).EQ.'LAT') THEN
		CALL PARSE0 (2,IOB160,80)
		CALL PARSER (2,LAT,ERRIND,IOB160)
		IF (ERRIND) GOTO 1800
C
	ELSEIF (IOB160(1:6).EQ.'MAXSTP') THEN
		CALL PARSE0 (2,IOB160,80)
		CALL PARSEI (2,MAXSTP,ERRIND,IOB160)
		IF (ERRIND) GOTO 1800
C
	ELSEIF (IOB160(1:5).EQ.'CZMIN') THEN
		CALL PARSE0 (2,IOB160,80)
		CALL PARSER (2,CZMIN,ERRIND,IOB160)
		IF (ERRIND) GOTO 1800
C
	ELSEIF (IOB160(1:5).EQ.'UVFAC') THEN
		CALL PARSE0 (2,IOB160,80)
		CALL PARSER (2,UVFAC,ERRIND,IOB160)
		IF (ERRIND) GOTO 1800
C
	ELSEIF (IOB160(1:6).EQ.'RENAME') THEN
		IF (NREN.EQ.MAXREN) THEN
			WRITE (ICRT,*) 'Increase MAXREN in MODL.FOR'
			GOTO 1800
		ENDIF
		NREN=NREN+1
		CALL PARSE0 (3,IOB160,80)
		CALL PARSE1 (2,OLDNAM(NREN),I,16,IOB160)
		IF (OLDNAM(NREN)(1:1).EQ.' ') GOTO 1800
		CALL PARSE1 (3,NEWNAM(NREN),I,16,IOB160)
		IF (NEWNAM(NREN)(1:1).EQ.' ') GOTO 1800
C
	ELSEIF (IOB160(1:9).EQ.'MODELSET=') THEN
		EXTFIL=IOB160(10:)
		LEXTFL=LNBLNK(EXTFIL)
C				
	ELSEIF (IOB160(1:5).EQ.'MODEL') THEN
		CALL PARSE0 (2,IOB160,80)
		CALL PARSE1 (2,CHARXN,L,16,IOB160)
		IF (CHARXN(1:1).NE.' '.AND.(CHARXN(1:16).NE.MOD)) THEN
			WRITE (OUT,1004) CHARXN(1:LNBLNK(CHARXN(1:16))),
     &			 MOD(1:LNBLNK(MOD))
			WRITE (ICRT,1004) CHARXN(1:LNBLNK(CHARXN(1:16))),
     &			 MOD(1:LNBLNK(MOD))
 1004			FORMAT (' Model specified (',A,') differs ',
     &			 'from model used (',A,')')
		ENDIF
C
	ELSEIF (IOB160(1:8).EQ.'NOCLOSE ') THEN
		CLOSEF=.FALSE.
C
	ELSEIF (IOB160(1:8).EQ.'NOOUT   ') THEN
		INTOUT=.FALSE.
		NPMODL=.TRUE.
		NOPRNT=.TRUE.
		WRITR=.FALSE.
		WRITDY=.FALSE.
C
	ELSEIF (IOB160(1:8).EQ.'NOPRINTT') THEN
		NOPRNT=.TRUE.
		WRITR=.FALSE.
		WRITDY=.FALSE.
		WRITCO=.FALSE.
C
	ELSEIF (IOB160(1:6).EQ.'NPMODL') THEN
		NPMODL=.TRUE.
C
	ELSEIF (IOB160(1:6).EQ.'NSAVSS') THEN
		CALL PARSE0 (2,IOB160,80)
		CALL PARSEI (2,NSAVSS,ERRIND,IOB160)
		IF (ERRIND) GOTO 1800
C
C	"MUSTSAVE" IGNORED INT THIS VERSION
	ELSEIF (IOB160(1:8).EQ.'MUSTSAVE') THEN
C
	ELSEIF (IOB160(1:4).EQ.'SAVE'.OR.IOB160(1:8).EQ.'MUSTSAVE') THEN
		IF (OPT) GOTO 1800
		PASS=.TRUE.
		CALL PARSE0 (4,IOB160,80)
		J=2
 1005		CALL PARSE1 (J,CHARXN,L,8,IOB160)
		IF (CHARXN(1:1).NE.' ') THEN
			IF (CHARXN(1:L).EQ.'CSV') THEN
				CSVOUT=.TRUE.
C				"SAVE CSV" -- USE OUTPUT SAME AS INPUT
C				TO BE COMPATIBLE WITH OLDER VERSIONS
C				IGNORE IF OUTPUT ALREADY DEFINED
				IF (LSAVFL.EQ.0) THEN
					SAVFIL=FILES
					LSAVFL=LFILES
				ENDIF
			ELSEIF (CHARXN(1:L).EQ.'RATE') THEN
				SAVER=.TRUE.
				WRITCO=.TRUE.
			ELSEIF (CHARXN(1:L).EQ.'INTRATE') THEN
				IF (MAXRXN.NE.MAXRXI) THEN
				WRITE (ICRT,*) 'Must recompile with MAXRXI',
     &				 '=MAXRXN for INTRATE option to work.'
				ELSE
					INTRAT=.TRUE.
					WRITCO=.TRUE.
				ENDIF
			ELSEIF (LSAVFL.EQ.0) THEN
				SAVFIL=CHARXN
				LSAVFL=L
				J=99
			ELSE
C				SAVE savfil OVERRIDEN BY COMMAND LINE
				J=99
			ENDIF
			IF (J.LT.4) THEN
				J=J+1
				GOTO 1005
			ENDIF
		ENDIF
C
	ELSEIF (IOB160(1:6).EQ.'SAVLST') THEN
		IF (OPT) GOTO 1800
		SAVLST=.TRUE.
C
	ELSEIF (IOB160(1:5).EQ.'SHOWT') THEN
		SHOWT=.TRUE.
C
	ELSEIF (IOB160(1:7).EQ.'NOSHOWT') THEN
		SHOWT=.FALSE.
C
	ELSEIF (IOB160(1:3).EQ.'SUN') THEN
		VARYHV=.TRUE.
		SUN=.TRUE.
C
	ELSEIF (IOB160(1:5).EQ.'TITLE') THEN
		CALL INBUF ('TITLE: ',7)
		IF (IORET.EQ.2) GOTO 9999
		OLDRUN=IOB160
C
	ELSEIF (IOB160(1:6).EQ.'WRITCO') THEN
		WRITCO=.TRUE.
		NOPRNT=.FALSE.
C
	ELSEIF (IOB160(1:6).EQ.'WRITDY') THEN
		WRITDY=.TRUE.
		NOPRNT=.FALSE.
C
	ELSEIF (IOB160(1:5).EQ.'WRITR') THEN
		WRITR=.TRUE.
		NOPRNT=.FALSE.
C
	ELSEIF (IOB160(1:7).EQ.'INTRATE') THEN
		IF (MAXRXN.EQ.MAXRXI) THEN
			INTRAT=.TRUE.
		ELSE
			WRITE (ICRT,*) 'Must recompile with ',
     &			 'MAXRXI=MAXRXN for INTRATE option to work.'
		ENDIF
C
	ELSEIF (IOB160(1:4).EQ.'XTRA') THEN
		CALL PARSE0 (2,IOB160,80)
		CALL PARSER (2,XTRA,ERRIND,IOB160)
		IF (ERRIND) GOTO 1800
C
	ELSEIF (IOB160(1:4).EQ.'TEMP') THEN
		CALL PARSE0 (2,IOB160,80)
		CALL PARSER (2,TEMP,ERRIND,IOB160)
		IF (ERRIND) GOTO 1800
C
	ELSEIF (IOB160(1:6).EQ.'NOCHEM') THEN
		NOCHEM=.TRUE.
C
	ELSEIF (IOB160(1:6).EQ.'LOGEXT') THEN
		IF (IOB160(8:8).EQ.' ') THEN
			EXTFIL=FILES(1:LFILES)
			LEXTFL=LFILES
		ELSEIF (IOB160(7:7).NE.'=') THEN
			GOTO 1800
		ELSE
			LEXTFL=LNBLNK(IOB160(8:))
			EXTFIL=IOB160(8:LEXTFL+7)
		ENDIF
C
	ELSEIF (IOB160(1:5).EQ.'P(Z)=') THEN
		VARYHV=.TRUE.
		SUN=.FALSE.
		IF (MODUIC(1:1).EQ.' ') THEN
			FZSFIL=IOB160(6:LNBLNK(IOB160))//'.FZS'
		ELSE
			FZSFIL=MODUIC(1:LNBLNK(MODUIC))//
     &			 IOB160(6:LNBLNK(IOB160))//'.FZS'
		ENDIF
C
	ELSEIF (IOB160(1:5).EQ.'WRITK') THEN
		WRITK=.TRUE.
C
	ELSE
		GOTO 1800
	ENDIF
    1	FORMAT (A)
C
C
C     SUCCESSFUL INPUT LINE
C
      GOTO 1100
C
C     INPUT ERROR
C
C
 1800	WRITE (OUT,*) ' MODL ERROR.  BAD LINE = "',
     &	 IOB160(1:LNBLNK(IOB160)),'"'
	WRITE (ICRT,*) 'Unrecognized option line: ',
     &	 IOB160(1:LNBLNK(IOB160))
	NERR=NERR+1
      GOTO 1100
C
C
C ---------------------------------------------------------------
C     ALL PARMS INPUT.
C
 1900 IF (INTOUT) WRITE (OUT,1901) EPS,CMIN,XTRA,CMAX,MAXSTP
 1901 FORMAT (/' INTEGRATION PARAMETERS USED:'//1X,5X,'EPS =',
     1 1PG11.3,              T50,'CMIN =',G11.3/' ',5X,'XTRA =',
     2 G11.3,T30,'CMAX =',G11.3,T50,'MAXSTP =',I5)
C
	IF (NOCHEM) WRITE (OUT,*) '****** CHEMISTRY TURNED OFF ******'
C
	IF (OPT) THEN
		WRITE (LOGU,'(''Model used = '',A)') MOD(1:LNBLNK(MOD))
		CLOSE (UNIT=LOGU)
	ENDIF
C
C     OPEN MODEL INPUT DATA SET
C
	IOB160=MODUIC(1:LNBLNK(MODUIC))//MOD(1:LNBLNK(MOD))//'.MOD'
	OPEN (UNIT=TMP1,FILE=IOB160,STATUS='OLD',ERR=8000)
C
	READ (TMP1,300) FORM
  300	FORMAT (A8)
C
	IF (FORM.EQ.FORMOK) THEN
		FORM3=.FALSE.
	ELSEIF (FORM.EQ.CFORM3) THEN
		FORM3=.TRUE.
	ELSE
		WRITE (OUT,7001) FORM,FORMOK
 7001		FORMAT (' WRONG MODEL FILE FORMAT.  FORMAT = ''',
     &		 A8,''', SHOULD BE ''',A8,'''.')
		STOP 'WRONG MODEL FILE FORMAT'
	ENDIF
C
	READ(TMP1,301) TITLE,NS,NNDY,NSC,NSB,NDUM,NRK,NCOEFV,NCOC1,
     &      NCOC2,NPHOTK,LENKBF,LENIKB
 301	FORMAT (A80/12I6)
	READ (TMP1,302) TEMPX,TREF,LCODE,NVTEMP,NVTCO
 302	FORMAT (2F10.3,3I6)
	IF (TEMP.EQ.0.0) TEMP=TEMPX
C
C       VAR COEF INDICES FOR:
C                   LITTLE   HV  DILUT.  TEMPR HEIGHT AREA  VOLUME
C       	    EMIT FAC
C
	IF (NPHOTK.GT.MAXPHK) THEN
		WRITE (ICRT,*) 'MODL:MAXPHK EXCEEDED. NPHOTK=',NPHOTK
		STOP
	ENDIF
	READ (TMP1,303) INDLIL,INDHV,INDDIL,INDTPR,INDHT,INDARA,
     &                  INDVOL,INDEF,INDER,INDVA,INDATM
C	NOTE: INDATM IS THE SAME AS INDM IN PREP
 303	FORMAT (11I6)
C
	NDY=NNDY
	NSC0=0
	NSC1=1
	NSC2=NSC
	N0=NSC+NSB+NDUM
	NA1=N0+1
	NA2=N0+NNDY
	NB0=NSC2
	NB1=NSC+1
	NB2=NB0+NSB
	NSS=NS-NA2
	NS1=NA2+1
	NS0=NA2
	NS2=NS
C
	IF (NS.GT.MAXNS) GOTO 9900
	IF (NNDY.GT.MAXACT) GOTO 9900
	IF (NSB.GT.MAXBO) GOTO 9900
	IF (NRK.GT.MAXRXN) GOTO 9900
	IF (NCOEFV.GT.MAXCOV) GOTO 9900
	IF (NCOC2.GT.MAXCOE) GOTO 9900
	IF (NPHOTK.GT.MAXPHK) GOTO 9900
C
C	IF (NSAVBO.LT.0) NSAVBO=NSB
	IF (NSAVSS.LT.0) NSAVSS=MIN0(5,NSS) ! DEFAULT MINIMUM = 5.
C
C                              READ CONSTANT NAMES
	IF (NSC.GT.0) READ (TMP1,304) (NAME(I),CINIT(I),I=1,NSC)
  304	FORMAT (A16,1PE14.6,2X,A16,E14.6)
C
C                              READ REST OF NAMES
C
	READ (TMP1,305) (NAME(I),I=NB1,NS)
  305	FORMAT (5A16)
C
C	DO RENAMES, IF APPLICABLE
C
	IF (NREN.GT.0) THEN
		DO 3060 J=1,NREN
		IOBF16=OLDNAM(J)
		DO 3061 I=1,NS
		IF (NAME(I).EQ.IOBF16) THEN
			NAME(I)=NEWNAM(J)
			GOTO 3060
		ENDIF
 3061		CONTINUE
		WRITE (ICRT,*) 'Name "',IOBF16,'" not found.'
		GOTO 1800
 3060		CONTINUE
	ENDIF
C
	DO 2 I=NB1,NS
    2	CINIT(I)=0.0
C
	IF (INDATM.GT.0) C(INDATM)=CINIT(INDATM) ! C FOR ATM PR MUST BE DEFINED
C                                                ! BEFORE K'S CALC'D.
C                              READ COEFS
C
	IF (NCOEFV.GT.0) READ (TMP1,306) (COEFNM(I),OLDCOE(I),I=1,NCOEFV)
  306	FORMAT (3(A8,1PE14.6,4X))
	IF (NCOC2.GE.NCOC1) READ (TMP1,307) (COEF(I),I=NCOC1,NCOC2)
  307	FORMAT (1P6E13.6)
	AIRSHD=(INDHT.NE.0).AND.(INDEF.NE.0)
	IF (NVTCO.GT.0) THEN
		READ (TMP1,307) (VTEMP(I),I=1,NVTEMP)
		READ (TMP1,309) (IVTCO(I),I=1,NVTCO)
  309		FORMAT (16I5)
		DO 3 I=1,NVTCO
  3		READ (TMP1,307) (VTCO(I,IT),IT=1,NVTEMP)
      ENDIF
C
	ICOSZ=0
	DO 3067 I=1,NCOEFV
	IF (COEFNM(I).EQ.'COSZ    ') THEN
		ICOSZ=I
		GOTO 3068
	ENDIF
 3067	CONTINUE
 3068	CONTINUE
C
      IF (INDTPR.GT.0) OLDCOE(INDTPR)=TEMP
      INDLIT=0                  ! INDEX FOR #LIGHT COEF.
C
C
C	READ AQSQY DATA (IF APPLICABLE)
C
	IF (NPHOTK.NE.0) THEN
C
C		"SUN" OPTION .. READ AND ALLIGN DATA FOR CALC WITH
C		BUILT-IN SPECTRUM
C		P(Z) OPTION:  PHOTKS ARE READ IN, SO THOSE IN THE MOD FILE
C		ARE IGNORED.  NEED TO READ PAST THEM.
C
		IF (VARYHV) THEN        !NOTE NSWL, SWL INITIALIZED
C                                       ! TO BE FOR SOLAR SDIST
			DO 102 IPHOT=1,NPHOTK
			READ (TMP1,310) IPHRK(IPHOT),PHOTNM(IPHOT)
  310			FORMAT (I5,2X,A8)
			READ (TMP1,309) NWL
			READ (TMP1,'(1P6E13.6)') (PWL(I),AQ(I),I=1,NWL)
			OLDPHK(IPHOT)=0.0
			IF (SUN) THEN
				CALL PFALIN (ABSQY(1,IPHOT),NWL,PWL,AQ,
     &				 NSOLWL,SOLWL)
			ELSE
				ABSQY(1,IPHOT)=0.0
			ENDIF
			MVZCO(IPHOT)=0
  102			CONTINUE
C                       ADD COEF '#LIGHT1', ETC, TO DETERMINE OVERALL SUNLIGHT
C                       LEVEL.  DEFAULT=1.
			NCOEFV=NCOEFV+3
			IF (NCOEFV.GT.MAXCOV) GOTO 9900
			INDLIT=NCOEFV-2
			COEFNM(INDLIT)='#LIGHT1 '
C                                       !OVERALL LIGHT = LIGHT1 * LIGHT2
			OLDCOE(INDLIT)=1.0
			COEFNM(NCOEFV-1)='#LIGHT2 '
			OLDCOE(NCOEFV-1)=1.0
			COEFNM(NCOEFV)='#LIGHTSP'
C                                       !LIGHT3 IS INDEX FOR SPECIAL TREATMENT.
			OLDCOE(NCOEFV)=0.0
C
C		DEFAULT OPTION:  READ AND SAVE ABSQY'S FOR CONSTANT
C		SDIST TO BE SPECIFIED LATER
C
		ELSE
			CALL RDPHK
			NSWL=0
		ENDIF
	ENDIF
C
C	READ IN KINETIC PARMS BUFFER
C
	READ (TMP1,307) (KPBUF(I),I=1,LENKBF)
	READ (TMP1,309) (LKBUF(I),I=1,NRK)
	READ (TMP1,309) (RXTYP(I),I=1,NRK)
	IF (LENIKB.GT.0) READ (TMP1,309) (IKPBUF(I),I=1,LENIKB)
C
C	READ IN REACTIONS AND (IF APPLICABLE) PRINT THEM.
C
	IF (NPMODL) THEN
		DO 4000 I=1,NRK
		READ (TMP1,1315) RXNLBL(I),RK(I),L,NXTNEW,CHARXN(1:L)
 4020		IF (.NOT.NXTNEW) THEN
			READ (TMP1,1316) L,NXTNEW,CHARXN(1:L)
			GOTO 4020
		ENDIF
 4000		CONTINUE
C
		CALL NEWRK (0)
C
		IF (NVTCO.GT.0) THEN
			DO 6 I=1,NVTCO
   6			OLDCOE(IVTCO(I))=COEF(IVTCO(I))
		ENDIF
	ELSE    ! BEGIN 'IF' BLOCK FOR NPMODL=F
C           

C         PRINT MODEL HEADER BEFORE READING AND PRINTING REACTIONS
C
          IF (NSC.NE.0) WRITE (OUT,61) CONST,NSC,(I,NAME(I),I=NSC1,NSC2)
          IF (NSB.NE.0) WRITE (OUT,61) 'BUILDUP, SLOW, OR DUMMY',
     &	   NSB+NDUM,(I,NAME(I),I=NB1,N0)
          IF (NNDY.NE.0) WRITE (OUT,61)ACTIVE,NNDY,(I,NAME(I),I=NA1,NA2)
          IF (NSS.NE.0) WRITE (OUT,61) STST,NSS,(I,NAME(I),I=NS1,NS2)
   61 FORMAT (/1X,A8,' SPECIES (',I3,'):'//(' ',5(I7,') ',A16)))
          IF (NCOEFV.NE.0) WRITE (OUT,62) NCOEFV,(COEFNM(I),OLDCOE(I),
     &     I=1,NCOEFV)
   62 FORMAT (/1X,I3,' VARIABLE COEFFICIENTS USED:'//(' ',5(4X,'#',A8,
     &  ' =',1PG10.3)))
          IF (NVTCO.GT.0) THEN
              WRITE (OUT,612) NVTCO,(VTEMP(I),I=1,NVTEMP)
  612 FORMAT (/1X,I3,' TEMPERATURE VARYING COEFFICIENTS:'/
     &          '    TEMPERATURES: ',8(1PG12.3)/)
              DO 615 I=1,NVTCO
                  WRITE (OUT,613)COEFNM(IVTCO(I)),(VTCO(I,J),J=1,NVTEMP)
  613 FORMAT (5X,A8,5X,8(1PG12.3))
  615         CONTINUE
          ENDIF
          WRITE (OUT,6003) NPHOTK
 6003 FORMAT (/1X,I2,' TYPES OF ABSORBTION COEFFICIENTS-QUANTUM YIELDS',
     &  ' READ IN.')
C
          WRITE (OUT,63) FF,TITLE
   63 FORMAT (A1,A80//' REACTIONS:'/11X,'K',7X,'(     A       EA     B',
     &  '   )'/' ')
C
		DO 4001 I=1,NRK
		READ (TMP1,1315) RXNLBL(I),RK(I),L,NXTNEW,CHARXN(1:L)
 1315		FORMAT (A4,E14.6,I5,2X,L1,/A)
		LBLI=RXNLBL(I)
		IND=RXTYP(I)
		LOCB=LKBUF(I)
		IF (IND.LE.2) LBLI2=RXNLBL(LOCB)
		IF (IND.EQ.7) PHTNAM=PHOTNM(LOCB)
		IF (IND.EQ.0) THEN      ! SAME K AS ANOTHER REACTION
			WRITE (OUT,65) LBLI,LBLI2,CHARXN(1:L)
   65			FORMAT (' ',A4,')',17X,'K SAME AS RXN ',A4,7X,A)
		ELSEIF (IND.EQ.1) THEN  ! K = RATE OF ANOTHER REACTION
			WRITE (OUT,66) LBLI,LBLI2,CHARXN(1:L)
   66			FORMAT (' ',A4,')',16X,'K = RATE OF RXN ',A4,
     &			 6X,A)
		ELSEIF (IND.EQ.2) THEN  ! TYPE=2 NOT IMPLEMENTED
			GOTO 8010
		ELSEIF (IND.EQ.3) THEN  ! CONSTANT K.  NO T DEPENDENCE
			WRITE (OUT,67) LBLI,RK(I),(CHARXN(1:L))
   67			FORMAT (' ',A4,')',1PE12.3,30X,A)
		ELSEIF (IND.EQ.4) THEN  ! ARRHENIUS-TYPE T DEPENDENCE
			CALL NEWRK (I)
			WRITE (OUT,64) LBLI,RK(I),KPBUF(LOCB),
     &			 KPBUF(LOCB+1),KPBUF(LOCB+2),(CHARXN(1:L))
   64			FORMAT (' ',A4,')',1PE12.3,' (',E11.3,0PF6.2,
     &			 F7.3,') ','  ',A)
		ELSEIF (IND.EQ.5) THEN  ! FALLOFF-TYPE T DEPENDENCE
			CALL NEWRK (I)
			WRITE (OUT,68) LBLI,RK(I),(KPBUF(LOCB+J),J=0,7),
     &			 (CHARXN(1:L))
   68	FORMAT (' ',A4,')',1PE12.3,' 0(',E10.3,0PF6.2,F7.3,')'/
     &           19X,'A(',1PE10.3,0PF6.2,F7.3,')'/21X,'F =',F6.3,4X,
     &           'N =',F6.3,5X,A)
		ELSEIF (IND.EQ.9) THEN  ! K1+K2[M] T DEPENDENCE
			CALL NEWRK (I)
			WRITE (OUT,6801) LBLI,RK(I),(KPBUF(LOCB+J),J=0,5),
     &			 (CHARXN(1:L))
 6801	FORMAT (' ',A4,')',1PE12.3,' 1(',E10.3,0PF6.2,F7.3,')'/
     &           19X,'2(',1PE10.3,0PF6.2,F7.3,')'/21X,'K = K1 + K2 [M]'
     &		,12X,A)
		ELSEIF (IND.EQ.10) THEN  ! K0+K3M/(1+K3M/K2)
			CALL NEWRK (I)
			WRITE (OUT,6802) LBLI,RK(I),(KPBUF(LOCB+J),J=0,8),
     &			 (CHARXN(1:L))
 6802	FORMAT (' ',A4,')',1PE12.3,' 0(',E10.3,0PF6.2,F7.3,')'/
     &		19X,'2(',1PE10.3,0PF6.2,F7.3,')'/
     &            19X,'3(',1PE10.3,0PF6.2,F7.3,')'/21X,'K=K0+K3[M]/(1+'
     &		,'K3[M]/K2)',4X,A)
              ELSEIF (IND.EQ.6) THEN
                CALL NEWRK (I)
                I1=IKPBUF(LOCB)-2       ! LOC FIRST T -2
                I2=IKPBUF(LOCB+1)+1     ! N RXNS REF'D +1
                WRITE (OUT,69) LBLI,RK(I),(IKPBUF(LOCB+J),KPBUF(I1+J),
     &           J=2,I2)
   69 FORMAT (' ',A4,')',1PE12.3,2X,'LTEMP:',5(I5,0PF7.1),:
     &           /' ',25X,5(I5,F7.1))
                WRITE (OUT,4022) CHARXN(1:L)
              ELSEIF (IND.EQ.7) THEN    ! PHOTOLYSIS REACTION
                WRITE (OUT,4021) LBLI,PHTNAM,CHARXN(1:L)
 4021           FORMAT (' ',A4,')',20X,'PHOT=',A8,9X,A)
              ELSEIF (IND.EQ.8) THEN    ! K IS COEFFICIENT
                WRITE (OUT,'('' '',A4,'')'',20X,''COEF='',A8,9X,A)')
     &		 LBLI,COEFNM(LKBUF(I)),CHARXN(1:L)
              ELSE
                GOTO 8010
              ENDIF
 4030         IF (.NOT.NXTNEW) THEN
		READ (TMP1,1316) L,NXTNEW,CHARXN(1:L)
 1316		FORMAT (2X,I5,2X,L1,/A)
		WRITE (OUT,4022) CHARXN(1:L)
 4022		FORMAT (48X,A)
		GOTO 4030
              ENDIF
 4001     CONTINUE
C
C       CALCULATE VALUES FOR TEMP-VARYING COEFS
C
          CALL NEWRK (-1)
          IF (NVTCO.GT.0) THEN
              DO 7 I=1,NVTCO
   7          OLDCOE(IVTCO(I))=COEF(IVTCO(I))
          ENDIF
C
      ENDIF             ! END 'IF' BLOCK FOR NPMODL=F
C
C
      IF (INTOUT) THEN
          WRITE (OUT,5020) LCODE
 5020     FORMAT (/' CODE LENGTH =',I5,' STATEMENTS.')
          IF (INDTPR.NE.0) WRITE (OUT,5021) TEMP
 5021     FORMAT (/' DEFAULT TEMPERATURE =',F7.1,' DEG K.')
      ENDIF
C
C	DONE READING MODEL DATA SET
C
	CLOSE (UNIT=TMP1)
C
C	IF P(Z) OPTION SPECIFIED, READ PHOT DATA FROM FILE
C
	IF (FZSFIL(1:1).NE.' ') CALL SETPZ (FZSFIL)
C
C	IF "MAX" OPTION SPECIFIED ON COMMAND LINE, FIND WHICH
C	SPECIES IS INVOLVED.  MUST BE AN ACTIVE SPECIES.  RUN NOT
C	SAVED IF THIS IS THE CASE.
C
C	CMAXO:  1 = MAX, 2 = TIME OF MAX, 3 = SUM, 4 = MAX MOLES
C		5 = TIME OF MAX MOLES.
C
	MAXONL=.FALSE.
	NMAXO=0
	IF (ONLMAX(1:1).NE.' ') THEN
		DO 5100 I=NA1,NA2
		IF (NAME(I).EQ.ONLMAX) THEN
			NMAXO=1
			CMAXO(1,1)=0.0
			CMAXO(1,2)=0.0
			CMAXO(1,3)=0.0
			CMAXO(1,4)=0.0
			CMAXO(1,5)=0.0
			IMAXO(1)=I-N0
			WRITE (OUT,*) '--- THIS CALC IS TO FIND MAX'//
     &			 ' OF '//ONLMAX(1:LNBLNK(ONLMAX))//' ONLY ---'
			PASS=.FALSE.
			MAXONL=.TRUE.
			INTOUT=.FALSE.
			NPMODL=.TRUE.
			NOPRNT=.TRUE.
			WRITR=.FALSE.
			WRITDY=.FALSE.
			GOTO 5199
		ENDIF
 5100		CONTINUE
		WRITE (ICRT,5101) ONLMAX(1:LNBLNK(ONLMAX))
		WRITE (OUT,5101) ONLMAX(1:LNBLNK(ONLMAX))
 5101		FORMAT ('Invalid MAX option.  ',A,
     &		 ' is not an active species')
		NERR=NERR+1
 5199		CONTINUE
	ENDIF
C
C	SEE IF THERE ARE SPECIES TO FIND MAX OF (OTHER THAN
C	THAT ON "MAX" OPTION OF COMMAND LINE, IF ANY).  IGNORE
C	UNRECOGNIZED NAMES
C
	IF (MXOLST(1:1).EQ.'@') THEN
		OPEN (UNIT=TMP1,FILE=MXOLST(2:LNBLNK(MXOLST(2:))+1),
     &		 STATUS='OLD',ERR=5212)
		NMAXO=0
 5210		READ (TMP1,1,END=5214) IOBF16
		IF (IOBF16(1:1).EQ.' '.OR.IOBF16(1:1).EQ.'!') GOTO 5210
		DO 5211 I=NA1,NA2
		IF (NAME(I).EQ.IOBF16) THEN
			WRITE (OUT,*) '--- WILL REPORT MAX OF ',
     &			 IOBF16(1:LNBLNK(IOBF16))
			NMAXO=NMAXO+1
			CMAXO(NMAXO,1)=0.0
			CMAXO(NMAXO,2)=0.0
			CMAXO(NMAXO,3)=0.0
			CMAXO(NMAXO,4)=0.0
			CMAXO(NMAXO,5)=0.0
			IMAXO(NMAXO)=I-N0
			GOTO 5210
		ENDIF
 5211		CONTINUE
		WRITE (OUT,*) '--- MAX NAME: ',
     &		 IOBF16(1:LNBLNK(IOBF16)),' IGNORED.'
		GOTO 5210
 5212		WRITE (ICRT,*) 'MAXCAL File: ',
     &		 MXOLST(2:LNBLNK(MXOLST(2:))+1),' not found.'
		GOTO 9999
 5214		CLOSE (UNIT=TMP1)		
C
	ELSEIF (MXOLST(1:1).NE.' ') THEN
		CALL PARSE0 (MAXMXO-NMAXO,MXOLST,160)
		K=NMAXO
		DO 5200 J=1,MAXMXO-K
		CALL PARSE1 (J,IOBF16,I,16,MXOLST)
		IF (IOBF16(1:1).EQ.' ') GOTO 5208
		DO 5201 I=NA1,NA2
		IF (NAME(I).EQ.IOBF16) THEN
			WRITE (OUT,*) '--- WILL REPORT MAX OF ',
     &			 IOBF16(1:LNBLNK(IOBF16))
			NMAXO=NMAXO+1
			CMAXO(NMAXO,1)=0.0
			CMAXO(NMAXO,2)=0.0
			CMAXO(NMAXO,3)=0.0
			CMAXO(NMAXO,4)=0.0
			CMAXO(NMAXO,5)=0.0
			IMAXO(NMAXO)=I-N0
			GOTO 5200
		ENDIF
 5201		CONTINUE
 5200		CONTINUE
 5208		CONTINUE
	ENDIF
C
	RETURN
C
C	ERROR
C
 8000	STOP 'MODL: ERROR IN OPENING MODEL FILE.'
C
 8010	WRITE (OUT,8011) IND
 8011	FORMAT (' MODEL COMPATIBILITY ERROR.  ILLEGAL IND =',I8)
	STOP 'MODEL INCOMPATIBLE'
 8020	WRITE (ICRT,*) 'CAN''T OPEN OPT LOG FILE = ',OPTLOG
	GOTO 9999
C
 9900	WRITE (OUT,9902) NS,MAXNS,NNDY,MAXACT,NSB,MAXBO,NSS,
     &  NRK,MAXRXN,NCOEFV,MAXCOV,NCOC2,MAXCOE,NPHOTK,
     &  MAXPHK
 9902	FORMAT (/' PROGRAM HALTED BECAUSE MODEL EXCEEDS MAXIMUM ',
     &  'DIMENSIONS FOR THIS VERSION'/'GIVEN BELOW IS CURRENT AND',
     &  ' MAXIMUM VALUES OF RELEVANT PARAMETERS.'
     &  /' TOTAL SPECIES:',2I6/' ACTIVE SPECIES:',2I6
     &  /' BUILDUP SPECIES:',2I6/' STEADY STATE SPECIES:',I6,'  N/A'
     &  /' REACTIONS:',2I6/' VARIABLE COEFFICIENTS:',2I6
     &  /' HIGHEST INDEX IN COEF ARRAY (CONSTANT COEFS):',2I6
     &  /' PHOTOLYSIS REACTIONS:',2I6)
      WRITE(ICRT,*)'MODEL EXCEEDS PROGRAM LIMITS.  SEE ''.OUT'' FILE.'
C
 9999 CALL EXIT (2)
C
      END
C --- END OF MODL.FOR
