C --- PRNTC.FOR --- WRITES CONCENTRATIONS AT TIME=T
C     ALSO CONATINS INTPRP.FOR -- WRITES NAMES OF SPECIES IN FORMAT
C     COMPATIBLE WITH PRNTC
C --- CALLED BY INT
C --- CALLS NOTHING
C --- UNITS USED:  OUT:  (WRITES)
C                  DATA1:  (WRITES)
C                  DATA2:  (WRITES)
C
C
	SUBROUTINE PRNTC
C
	INCLUDE 'MAINSPC.FOR'
C
C	USED FOR INTRATE FEATURE.  SHARED WITH PRNTC
C	THIS VERSION ALSO OUTPUTS STEPS AT END
C
	COMMON /RIDATA/ RINT(MAXRXI),RINTSV(MAXRXI),RLAST(MAXRXI)
	REAL FF(2)
	CHARACTER*60 OUTFMT
C
	REAL TLASTS /-1.0E+30/		! LAST TIME SAVED
C
C
C	CALCULATE SS CONC'S, RATES AND DERIV'S FOR CURRENT TIME.  ALSO,
C	CALCULATE BO DERIV'S, IF NEEDED,  AND CURRENT VALUES, IF
C	CURRENT INT TIME NOT PRINTSV TIME
C
C	FOLLOWING DATA OUTPUT FORMAT USED:
C	--------------------
 1009	FORMAT (10Z8)
C 1009	FORMAT (1P10E18.10)
C	--------------------
C
	IF (NOPRNT.AND.(.NOT.ABORT)) GOTO 10
C
	WRITE (OUT,60) T,TCUR,NST,NINV
   60	FORMAT (/' T =',1PG11.4,4X,'SOLVER T =',G11.4,I10,' STEPS, AND'
     &   ,I5,' INVERSIONS'/' ')
	WRITE (OUT,61) (I,C(I),I=NA1,NA2)
   61	FORMAT (' .',I3,'C',1PE10.3,4(I5,'C',E10.3)/
     &   (5(I5,'C',E10.3)))
	IF (WRITDY.OR.ABORT) WRITE (OUT,62) (DY(I),I=1,NDY)
   62	FORMAT (5(5X,'D',1PE10.3))
	IF (NB1.LE.N0) THEN
		WRITE (OUT,61) (I,C(I),I=NB1,N0)
		IF (WRITDY.OR.ABORT) THEN
			I1=NDY+1
			I2=NDY+NSB
			WRITE (OUT,62)  (DY(I),I=I1,I2)
		ENDIF
	ENDIF
	IF (NSS.GT.0) WRITE (OUT,61) (I,C(I),I=NS1,NS2)
	IF (WRITCO) THEN
		WRITE (OUT,66) (COEFNM(I),COEF(I),I=1,NCOEFV)
   66		FORMAT (/(3(4X,A8,1PG12.4)))
		WRITE (OUT,*)
	ENDIF
C
	IF (WRITR.OR.ABORT) WRITE (OUT,63) (I,R(I),I=1,NRK)
   63	FORMAT (' .',I3,'R',1PE10.3,4(I5,'R',E10.3)/
     &   (5(I5,'R',E10.3)))
C
C	UPDATE SUMS TO SAVE, IF APPLICABLE.
C
   10	IF ((NMAXO.GT.0).AND.(T.NE.TLASTS)) THEN
		TLASTS=T
		DO 1001 I=1,NMAXO
 1001		CMAXO(I,3)=CMAXO(I,3)+C(IMAXO(I)+N0)
	ENDIF
C
C	SAVE DATA IF PASS=T.
C
	IF (PASS) THEN
		IF (CSVOUT) THEN
			OUTFMT='(F7.1,1000('','',1PE10.3))'
		ELSE
			OUTFMT='(F10.2/(1PE10.3,7E11.3))'
		ENDIF
		FNST=FLOAT(NST)
		IF (INTRAT) THEN
			IF (SAVER) THEN
				WRITE (DATA1,OUTFMT) T,(C(I),I=NA1,NA2),
     &				 (C(I),I=NB1,N0),(C(I),
     &				 I=NS1,NS0+NSAVSS),(R(I),I=1,NRK),
     &          	        	 (RINTSV(I),I=1,NRK),FNST
			ELSE
				WRITE (DATA1,OUTFMT) T,(C(I),I=NA1,NA2),
     &				 (C(I),I=NB1,N0),(C(I),
     &				 I=NS1,NS0+NSAVSS),(RINTSV(I),I=1,NRK),FNST
			ENDIF
		ELSE
			IF (SAVER) THEN
				WRITE (DATA1,OUTFMT) T,(C(I),I=NA1,NA2),
     &				 (C(I),I=NB1,N0),
     &				 (C(I),I=NS1,NS0+NSAVSS),(R(I),I=1,NRK),FNST
			ELSE
				WRITE (DATA1,OUTFMT) T,(C(I),I=NA1,NA2),
     &				 (C(I),I=NB1,N0),
     &				 (C(I),I=NS1,NS0+NSAVSS),FNST
			ENDIF
		ENDIF
	ENDIF
	RETURN
	END
C ----------------------------------------------------------------------
C --- INTPRP.FOR
C --- SUBROUTINES INTPRP
C --- CALLED BY INTMAIN
C --- NO CALLS OTHER THAN SUBS IN THIS FILE.
C --- UNITS USED:  TMP1  (OPEN,READ OR WRITE,CLOSE)
C
C
	SUBROUTINE INTPRP
C
	INCLUDE 'MAINSPC.FOR'
C
C	PRINT HEADERS IF REQUIRED.
C
	IF (NOPRNT.OR.OPT) RETURN
C
	IF (NSC.GT.0) THEN
		WRITE (OUT,605) NSC,(I,NAME(I)(1:8),C(I),I=NSC1,NSC2)
  605		FORMAT (/I3,' CONSTANT SPECIES:'/(3(I5,A8,1PE10.3)))
	ENDIF
   70	WRITE (OUT,*)
	WRITE (OUT,64) (I,NAME(I)(1:9),I=NA1,NA2)
   64	FORMAT (' .',I3,') ',A9,4(I5,') ',A9)/(5(I5,') ',A9)))
	IF (NB1.LE.N0) WRITE (OUT,64) (I,NAME(I),I=NB1,N0)
	IF (NSS.GT.0) WRITE (OUT,64) (I,NAME(I),I=NS1,NS2)
	IF (WRITR) WRITE (OUT,68) (I,RXNLBL(I),I=1,NRK)
   68	FORMAT (' .',I3,') R(',A4,')  ',4(I5,') R(',A4,')  ')/
     &   (5(I5,') R(',A4,')  ')))
	RETURN
	END
