C --- RDVCO.FOR --- CALLED BY INTMAIN TO READ IN VARIABLE COEFFICIENT
C			VALUES AFTER EXITING FROM RDCKC (IF '.VCO' OPTION
C			GIVEN.  SORTS VALUES AND STORES THEM ON UNIT=TIMEU
C --- UNITS USED:  IN, OUT
C		   TIMEU (READS, DELETES, OPENS, WRITES, REWINDS, KEEPS OPEN)
C                  LOGU (OPENS, WRITES, CLOSES) (IF PASS=.TRUE.)
C*
C*	*NOTE* WRITES TO LOGU TEMPORARILY C*'D OUT.
C*
C --- CONDITIONAL COMPILATION: B - BIG RSX, S - SMALL RSX, V - VAX 
C
	SUBROUTINE RDVCO
C
	INCLUDE 'MAINSPC.FOR'
C
	CHARACTER*16 NAMEIN(MAXNS)
	INTEGER NIN,SPTOIN(MAXNS)
	REAL CIN(MAXNS)
	COMMON /SCRTCH/CIN,NIN,SPTOIN
	COMMON /CCRTCH/NAMEIN
C
C	VARIABLE COEF PARMS IN MAIN:  VARYCO (LOG), TNEXTV
C
	LOGICAL DONE,HAVEAL,ANS
C
C	SPECIFICATIONS FOR VARIABLE COEFFICIENTS
C
	INTEGER LTVCO(MAXVC1),ITVCO(MAXVCO),VCOTYP(MAXVCO)
	REAL TVCO(MAXVDT),VCO(MAXVDT),NEWC(MAXACT),OLDC(MAXACT)
	CHARACTER*4 TYPLBL(2)
	COMMON /VCOCOM/ TVCO,VCO,LTVCO,ITVCO,VCOTYP
	DATA TYPLBL/'LIN ','CON '/
C
C
C ------------------------------------------------------------
C	NVCO	...	MAX NO. VAR COEF'S (DEFINED BY PREP)
C	TNEXT   ...	TIME WHEN VARIABLE COEFFICIENT PARMS CHANGE
C
C	  IV	...	VAR COEF INDEX
C
C
C	VCOTYP(IV) ...  1 IF LINEAR EXTRAPOLATION BETWEEN VALUES AT
C			CURRENT AND NEXT TIME.
C			2 IF CONSTANT VALUE STARTING AT GIVEN TIME
C	IVCOEF(IV) ...	COEF INDEX NO. FOR THE IV'TH VAR COEF
C			(I.E. COEF(IVCOEF(IV)) IS WHAT IS BEING DEFINED)
C	VSLOPE(IV) ...	DERIVITIVE OF COEF AT CURRENT INTERVAL
C	VINT(IV)   ...	SLOPE OF COEF AT CURRENT INTERVAL
C
C	LTVCO(IV) ...	LOC OF FIRST TIME, COEF VALUE 
C	LTVCO(IV+1)-1 ... LOC OF LAST TIME, COEF VALUE
C	ITVCO(IV) ...	NEXT TIME INDEX
C	TVCO(ITVCO(IV),IV) ... NEXT TIME VALUE
C	VCO(ITVCO(IV),IV) ... NEXT VCOEF VALUE
C ------------------------------------------------------------------------
C ------ NVCO, TNEXT, IVCOEF, VSLOPE, AND VINT GO IN THE MAIN SEGMENT
C	 THE REST ARE LOCAL
C
C	READ IN VALUES OF VARIABLE COEFFICIENTS FROM VCO.TMP:
C		L#(name) ... INPUT VALUES FOR VAR. COEF (name).  LINEAR
C				EXTRAPOLATION FOR TIMES BETWEEN VALUES INPUT.
C		C#(name) ... AS ABOVE, BUT VALUES CONSTANT UNTIL NEXT TIME.
C		VALUES INPUT AS (TIME, VALUE) (ONE SET PER RECORD) 
C		UNTIL ANOTHER NAME, OR <EOF>.
C
C	READ IN VALUES FOR ALOFT VARIABLE COEFFICIENTS FROM CALCULATION DATA
C	SET IF GATEL DEFINED (LGETAL>0).  GETAL IS THE CALC DATA SET WITH THE
C	ALOFT DATA
C
C      THESE DATA SETS ARE NAMED CALCnnnn.CDT, WHERE nnnn IS CALC NO.  
C
C      FORMAT OF DATA SET:
C
C      FIRST RECORD:   -DATA SET FORMAT INDICATOR = 1, CALC NO (nnnn ABOVE)
C      SECOND:         -RUN TITLE (80 CHAR), MODEL FILE NAME (8)
C      THIRD:          -NO. CONC'S SAVED, NAMES (16 CHAR EACH)
C      REST:           -TIME, CONC'S AT THAT TIME
C
	NVCO=0
	NEWVCO=.FALSE.
	NTV=0
        HAVEAL=.FALSE.
        NNVCO=0
C
        REWIND (TIMEU)
	IF (INTOUT) WRITE (OUT,8)
    8	FORMAT (/' TIME-VARYING COEFFICIENTS INPUT:'/
     &	 ' TYPE NAME',8X,5(5X,'TIME',4X,'VALUE',4X))
C
C	LOOP TO READ VCO.TMP
C
   10   IOB160=' '
C
	READ (TIMEU,'(A)',END=11) IOB160
	IOLEN=LENSTR(IOB160,80)
C
	IF (IOB160.EQ.' ') THEN
C					!IGNORE BLANK RECORDS
		GOTO 10
C
	ELSEIF (BYT160(2).NE.'#') THEN
C
C		PROCESS NEXT V COEF VALUE.
C
		IF (NVCO.EQ.0) GOTO 8030
		CALL ALIN16 (2,IOB160)
		IF (NTV.EQ.MAXVDT) GOTO 8020
		NTV=NTV+1
		READ(IOB160,12,ERR=8000) TVCO(NTV),VCO(NTV)
   12		FORMAT (2G16.0)
		IF (NTV.LE.LTVCO(NVCO)) GOTO 10
		IF (TVCO(NTV).LE.TVCO(NTV-1)) GOTO 8010
		GOTO 10
C
	ELSE
C
C		RECORD STARTS WITH A #.  NEW VCOEF TO PROCESS
C
		IF (NVCO.GT.0) THEN
C
C			PROCESS LAST VCOEF INPUT BEFORE STARTING WITH
C			THIS NEW ONE
C
			IF (NVCO.EQ.MAXVCO) THEN
				WRITE (OUT,*) 'TOO MANY VAR. COEF''S'
     &			 ,'.  MAX =',NVCO
				STOP 'TOO MANY VAR. COEF''S'
			ELSEIF (NTV.LE.LTVCO(NVCO)) THEN
				WRITE (OUT,14) COEFNM(IVCOEF(NVCO))
   14			        FORMAT (/' NO DATA INPUT OR ONLY ONE',
     &			 	' POINT FOR VARIABLE COEF = ',A8,
     &				 '.  INPUT IGNORED.')
 				NERR=NERR+1
				NTV=LTVCO(NVCO)-1
				NVCO=NVCO-1
			ELSE
				IF (INTOUT) WRITE (OUT,16) TYPLBL(VCOTYP
     &				 (NVCO)),COEFNM(IVCOEF(NVCO)),
     &				 (TVCO(I),VCO(I),I=LTVCO(NVCO),NTV)
   16				FORMAT (' ',A4,A8,4X,5(0PF10.2,1PG12.3)
     &				 ,:/(' ',17X,5(0PF10.2,1PG12.3)))
			ENDIF
		ENDIF
C
C		PROCESS NEXT V. COEF
C
		NVCO=NVCO+1
		LTVCO(NVCO)=NTV+1
		IF (BYT160(1).EQ.'L') THEN
			VCOTYP(NVCO)=1
		ELSEIF (BYT160(1).EQ.'C') THEN
			VCOTYP(NVCO)=2
		ELSE
			GOTO 8030
		ENDIF
C
                IOBF16(1:8)=IOB160(3:10)
		IOBF16(9:16)=' '
C						! FIND COEF NO. ASSOCIATED
C						! WITH THIS VAR COEF.
		DO 20 I=1,NCOEFV
		IF (IOBF16.NE.COEFNM(I)) GOTO 20
		IVCOEF(NVCO)=I
		IF (I.EQ.INDTPR) THEN
			IVTPR=NVCO
		ELSEIF (I.EQ.INDHT) THEN
			IVHT=NVCO
		ENDIF
		GOTO 10				! THEN LOOP BACK TO GET DATA
   20		CONTINUE
C
C		THIS NOT A COEFFICIENT.  THEN IT MUST BE A CONSTANT
C		SPECIES NAME.  IT IS INDICATED BY HAVING A "VARIABLE
C		COEFFICIENT NUMBER" WHICH IS GREATER THAN THE NUMBER
C		OF VARIABLE COEFFICIENTS BY AN AMOUNT EQUAL TO THE
C		CONSTANT SPECIES NO.  IF THERE'S ROOM, THE SPECIES NAME
C		IS ADDED TO THE LIST OF COEFFICIENT NAMES, BUT IF THERE'S
C		NOT, THE PROGRAM CAN PROCEED ANYWAY, BUT MESSAGES REGARDING
C		THIS VARIABLE "COEFFICIENT" NAME WILL OUTPUT GARBAGE.
C
		DO 201 I=1,NSC
		IF (IOBF16.NE.NAME(I)) GOTO 201
		IVCOEF(NVCO)=NCOEFV+I
		IF (NCOEFV+I.LE.MAXCOV) COEFNM(NCOEFV+I)=IOBF16(1:8)
		GOTO 10
  201		CONTINUE
C
		WRITE (OUT,22) IOBF16
   22		FORMAT (' COEF OR CONSTANT SPECIES NAME = ''',A8,
     &		 ''' NOT FOUND')
		STOP 'VAR COEF NAME NOT FOUND'
	ENDIF
C
C
C	<EOF> ON VCO.TMP.  END OF INPUT (EXCEPT FOR .GETALO, IF APPLICABLE)
C
C       ALL INPUT READ
C
   11	IF (NVCO.EQ.0) THEN
		WRITE (OUT,*) ' .VCO SPECIFIED, BUT NO VAR ',
     &		 'COEF  DATA'
                 NERR=NERR+1
	         RETURN
	ELSEIF (NTV.LE.LTVCO(NVCO)) THEN
	        WRITE (OUT,14) COEFNM(IVCOEF(NVCO))
		NERR=NERR+1
	        NTV=LTVCO(NVCO)-1
	        NVCO=NVCO-1
	       	IF (NVCO.EQ.0) RETURN
        ELSE
		LTVCO(NVCO+1)=NTV+1
		IF (INTOUT) WRITE (OUT,16) TYPLBL(VCOTYP(NVCO)),
     &	         COEFNM(IVCOEF(NVCO)),
     &      	 (TVCO(I),VCO(I),I=LTVCO(NVCO),NTV)
	ENDIF
C
C ------------------------------------------------------------------------
C	VAR COEF DATA ALL INPUT FROM VCO.TMP.
C       GET DATA FOR ALOFT SPECIES FROM CALCULATION DATA SET IF GETAL NONBLANK
C
C       SORT ALL DATA IN ORDER OF TIME AND WRITE IT ON DATA SET 'VCO.TMP'
C       ON UNIT TIMEU TO BE READ DURING INTEGRATION.
C
C	OPEN DATA SET.  FIRST DELETE OLD FILE, DONE USING FOR INPUT
C
	CLOSE (UNIT=TIMEU,STATUS='DELETE')
C
	IOB160=' '
C
	CALL FILNAM (NLEN,IOB160,TMPUIC,'VCO.TMP ',' ')
	OPEN (UNIT=TIMEU,FILE=IOB160,STATUS='NEW',FORM='UNFORMATTED')
C
	ZER0=0.0
	BIG=1.0E+30
        ALTNXT=BIG
        NNVCO=NVCO 
C		           !NUMBER OF VAR COEFS BEFORE GETTING ALOFT DATA
C
        IF (LGETAL.EQ.0) THEN
		DONE=.TRUE.
	ELSE
C
C		INITIALIZING FOR ALOFT DATA.
C
		IF (INDVA.EQ.0) GOTO 8100
C					    !MODEL NOT ABLE TO PROCESS ALOFTS
		HAVEAL=.TRUE.
		DONE=.FALSE.
C
		IF (GETAL(1:1).EQ.'*') THEN
			IOB160=SAVFL1
			LF=LSAVF1
			IF (GETAL(2:2).NE.' ') THEN
				IOB160(LF+1:)=GETAL(2:LGETAL)//OUTEXT
				LF=LF+LGETAL+3
			ENDIF
		ELSE
			IOB160=CALUIC(1:LCALUC)//EXTFIL(1:LEXTFL)//'\'//
     &			 GETAL(1:LGETAL)//OUTEXT
			LF=LCALUC+LEXTFL+LGETAL+5
		ENDIF
		INQUIRE (FILE=IOB160,EXIST=ANS)
		IF (.NOT.ANS) THEN
			WRITE (6,*) 'RDVCO calc file does not exist: '
     &			 //IOB160(1:LF)
			GOTO 8062
		ENDIF
		OPEN (UNIT=TMP1,FILE=IOB160,STATUS='OLD',ERR=8060)
C
		READ (TMP1,'(2X,I5)',ERR=8070) NIN
		IF (NIN.GT.MAXNS) STOP 'INCREASE MAXNS (GETCAL)'
		READ (TMP1,'(8A11)') (NAMEIN(I),I=1,NIN)
C
C		DETERMINE INDEX NO. FOR ALOFT SPECIES.
C
		DO 2101 I=1,NNDY
		DO 2102 J=1,NIN
		IF (NAMEIN(J).EQ.NAME(I+NA0)) THEN
			SPTOIN(I)=J
			GOTO 2101
		ENDIF
 2102		CONTINUE
		SPTOIN(I)=0
 2101		CONTINUE
C
C                 GET ALOFT DATA FOR ALL ACTIVE SPECIES
C
		READ (TMP1,2119,END=8080,ERR=8070) ALTNXT,(CIN(I),I=1,NIN)
 2119		FORMAT (F10.2/(E10.3,7E11.3))
		DO 2111 I=1,NNDY
		IF (SPTOIN(I).NE.0) THEN
			NEWC(I)=CIN(SPTOIN(I))
		ELSE
			NEWC(I)=0.0
		ENDIF
 2111		CONTINUE
C
		NVCO=NVCO+NNDY
		DO 99 I=1,NNDY
 99		IVCOEF(NNVCO+I)=INDVA+I-1
	ENDIF
C
C	SIMPLE IF ONLY ONE VARIABLE COEF TO WORK WITH
C
	IF (NVCO.EQ.1.AND..NOT.HAVEAL) THEN
C
	IF (VCOTYP(1).EQ.1) THEN
		TV=TVCO(1)
		WRITE (TIMEU) TV,VCO(1),ZER0
		DO 100 I=2,LTVCO(2)-1
		VSLOPE(1)=(VCO(I)-VCO(I-1))/(TVCO(I)-TV)
		TV=TVCO(I)
		VINT(1)=VCO(I)-VSLOPE(1)*TV
  100		WRITE (TIMEU) TV,VINT(1),VSLOPE(1)
	ELSE
                WRITE (TIMEU) TVCO(1),VCO(1),ZER0
		DO 102 I=2,LTVCO(2)-1
  102		WRITE (TIMEU) TVCO(I),VCO(I-1),ZER0
	ENDIF
	WRITE (TIMEU) BIG,VCO(LTVCO(2)-1),ZER0
C
	ELSE
C
C	FOR MORE THAN ONE VAR COEF:
C	FIRST: FIND SMALLEST TIME VALUE AND INITIALIZE VINT,VSLOPE, ITVCO
C
	TNEXT=TVCO(1)
	VINT(1)=VCO(1)
	VSLOPE(1)=0.0
	IF (VCOTYP(1).EQ.1) THEN
		ITVCO(1)=1
	ELSE
		ITVCO(1)=2
	ENDIF
	DO 106 IV=2,NNVCO
        I=LTVCO(IV)
        VINT(IV)=VCO(I)
	IF (VCOTYP(IV).EQ.2) I=I+1
	IF (TVCO(I).LT.TNEXT) TNEXT=TVCO(I)
	ITVCO(IV)=I
  106	VSLOPE(IV)=0.0
        TNXT=TNEXT
C
        IF (HAVEAL) THEN
                DO 107 IV=NNVCO+1,NVCO
                VINT(IV)=NEWC(IV-NNVCO) 
  107           VSLOPE(IV)=0.0
                IF (ALTNXT.LT.TNXT) TNXT=ALTNXT
        ENDIF
C
C	SECOND: WRITE SMALLEST TIME AND INITIAL COEF VALUES
C
	WRITE (TIMEU) TNXT,(VINT(IV),ZER0,IV=1,NVCO)
C
C	NEXT:  FIND NEXT TIME INTERVAL, AND WRITE UPDATED VALUES.
C	REPEAT UNTIL NO MORE UPDATES.
C
	KOUNT=0
C				! ADDED TO PREVENT INFINITE LOOPS
C				! DUE TO PGM ERR
	KMAX=LTVCO(NNVCO+1)
C
  110   IF (ALTNXT.LE.TNEXT.AND..NOT.DONE) THEN
                 ALTNOW=ALTNXT
CD                WRITE (ICRT,*) '110 LOOP: ALTNOW,TNEXT=',ALTNOW,TNEXT
                 DO 109 I=1,NNDY
 109             OLDC(I)=NEWC(I)
C
		READ (TMP1,2119,END=120,ERR=8070) ALTNXT,(CIN(I),I=1,NIN)
		DO 2112 I=1,NNDY
		IF (SPTOIN(I).NE.0) THEN
			NEWC(I)=CIN(SPTOIN(I))
		ELSE
			NEWC(I)=0.0
		ENDIF
 2112		CONTINUE
C
                 DO 111 IV=NNVCO+1,NVCO
                 I=IV-NNVCO
                 VSLOPE(IV)=(NEWC(I)-OLDC(I))/(ALTNXT-ALTNOW)
 111             VINT(IV)=NEWC(I)-VSLOPE(IV)*ALTNXT  
                 GOTO 115 
C					        !SKIP AROUND EOF CODE
C
C                ALL ALOFT DATA READ
 120             DONE=.TRUE.
                 CLOSE (UNIT=TMP1)
 		 IF (INTOUT) WRITE (OUT,121) ALTNOW
 121		 FORMAT (/' LAST ALOFT TIME = ',F6.1)
 		 IF (ALTNOW.LE.T0) GOTO 8110
C						!ERROR
                 DO 112 IV=NNVCO+1,NVCO
                 VINT(IV)=0.0
 112             VSLOPE(IV)=0.0
                 ALTNXT=BIG
C
 115             TNXT=AMIN1(ALTNXT,TNEXT)
C					        !MINIMUM
                 IF (ALTNOW.LT.TNEXT.OR.TNXT.EQ.BIG) THEN
                        WRITE (TIMEU) TNXT,(VINT(IV),VSLOPE(IV),
     &                    IV=1,NVCO)
                 ENDIF
                 GOTO 110
          ENDIF 
C
 130      IF (TNEXT.LT.BIG) THEN
                TNOW=TNEXT
	        TNEXT=BIG
C
        	DO 200 IV=1,NNVCO
	        IF (ITVCO(IV).EQ.0) GOTO 200
        	IT=ITVCO(IV)
	        IF (TNOW.LT.TVCO(IT)) THEN
		        IF (TVCO(IT).LT.TNEXT) TNEXT=TVCO(IT)
        	ELSE
C					! NOTE THAT TNOW=TVCO(IT)
	        	NTV=LTVCO(IV+1)-1
        		IF (IT.EQ.NTV) THEN
	        		ITVCO(IV)=0
		        	VINT(IV)=VCO(NTV)
			        VSLOPE(IV)=0.0
        		ELSE
	        		IT=IT+1
		        	TV=TVCO(IT)
			        IF (TNOW.GE.TV) STOP 'RDVCO ER: BAD TVCO ORDER'
			        IF (VCOTYP(IV).EQ.1) THEN
				        VSLOPE(IV)=(VCO(IT)-VCO(IT-1))/
     &			         	  (TV-TNOW)
				        VINT(IV)=VCO(IT)-VSLOPE(IV)*TV
			        ELSE
				        VINT(IV)=VCO(IT-1)
		        	ENDIF
			        ITVCO(IV)=IT
			        IF (TV.LT.TNEXT) TNEXT=TV
        		ENDIF
	        ENDIF
  200	        CONTINUE
C
C	        WRITE (TIME TO READ IN NEXT VALUES), (VALUES TO USE UNTIL THEN)
C
                TNXT=AMIN1(ALTNXT,TNEXT)   
	        WRITE (TIMEU) TNXT,(VINT(IV),VSLOPE(IV),IV=1,NVCO)
CD        	WRITE (OUT,*) TNXT,(VINT(IV),VSLOPE(IV),IV=1,NVCO)
        ENDIF
C
	KOUNT=KOUNT+1
CD       WRITE (ICRT,*) 'KOUNT= ',KOUNT
	IF (KOUNT.GT.KMAX) STOP 'RDVCO PGM ER.  ITER COUNT EXCEEDED'
        IF (.NOT.DONE) GOTO 110
	IF (TNEXT.LT.BIG) GOTO 130
C
CD       WRITE (ICRT,*) ' DONE WRITING TO VCO.TMP (TNXT,VINT,VSLOPE)'
	ENDIF
C
C	DONE SAVING VCOEF DATA.  REWIND DATA AND READ UNTIL T0 < TNEXT
C	THEN DATA SET IS READY TO BE READ BY INT
C
	REWIND (TIMEU)
C
  300	READ (TIMEU) TNEXT,(VINT(IV),VSLOPE(IV),IV=1,NVCO)
CD	WRITE (OUT,*) 'TIMEU READ IN RDVCO:  T0,TNEXT=',T0,TNEXT
	IF (T0.GE.TNEXT) GOTO 300
C	
C*        IF (PASS) CLOSE (UNIT=LOGU)
C-B
C.	CALL REMAP(MEMDAT)
C				! MAP /DAT/ BACK IN, AS WHEN SUBR CALLED
C-
	RETURN
C -----------------------------------------------------------------------
C	ERRORS
C
 8000	WRITE (OUT,*) 'INPUT ERROR READING VCOEF DATA'
	GOTO 8011
 8010	WRITE (OUT,*) 'VCOEF TIMES OUT OF ORDER'
 8011	WRITE (OUT,8013) COEFNM(IVCOEF(NVCO)),IOB160
 8013	FORMAT (' VAR. COEF INPUT = ''',A8,'''.  BAD LINE ='/' ',A80)
	STOP 'BAD VAR COEF INPUT'
 8020	WRITE (OUT,8022) COEFNM(IVCOEF(NVCO)),NTV
 8022	FORMAT (' TOO MANY TIMES FOR VAR COEF = ''',A8,'''.  MAX =',I4)
	STOP 'TOO MANY VAR COEF TIMES'
 8030	WRITE (OUT,8032) IOB160(1:16)
 8032	FORMAT (' VAR. COEF NAME SPECIFICATION ERROR.  INPUT = ''',A16,
     &	 '''')
	STOP 'BAD VAR COEF NAME INPUT'
 8060   WRITE (OUT,8061) IOB160(1:LF)
 8061   FORMAT (' RDVCO: ERROR OPENING CALCULATION DATA SET:' /' ',A)
 8062	WRITE (ICRT,8061) IOB160(1:LF)
        CLOSE (UNIT=TMP1)
        STOP 'ERROR OPENING CALC DATA SET'
 8070   WRITE (OUT,*) 'RDVCO: ERROR READING CALCULATION DATA SET'
        CLOSE (UNIT=TMP1)
        STOP 'INPUT ERROR READING CALC DATA'
 8080   WRITE (OUT,*) 'RDVCO: NO DATA POINTS IN CALCULATION DATA SET'
        CLOSE (UNIT=TMP1)
        STOP 'NO DATA IN CALC DATA SET'
C 8090   WRITE (OUT,*) 'RDVCO: NO. OF DATA POINTS IN CALC DATA SET < NDY'
C        CLOSE (UNIT=TMP1)
C        STOP 'DATA SET HAS TOO FEW DATA POINTS'
 8100   WRITE (OUT,*) '.GETALO SPECIFIED BUT INDVA NOT SET'
        STOP '.GETALO SPECIFIED BUT INDVA NOT SET'
 8110	WRITE (OUT,*) 'RDVCO ERR: LAST TIME OF ALOFT DATA IS BEFORE T0'
	STOP 'LAST TIME OF ALOFT DATA IS BEFORE T0'
C
	END
