C --- RDCKC.FOR --- READS INPUT FOR CALCULATION
C --- CALLED BY INTMAIN
C --- CALLS INBUF,ALIN16,MOVLFT,GETCAL,MOVLF8,ALIN8,SDREAD,photks
C ---       NEWRK,SETPHK
C --- UNITS USED:  LOGU  (OPEN,WRITE,CLOSE).  *NOTE* NONE OF RDCKC'S
C                         SUBROUTINES CAN USE THIS UNIT.
C                  TMP1   (USED BY SOME OF ITS SUBROUTINES.  O,R/W,C)
C                  TMP2   (USED BY PHOTKS SUBROUTINE.  O,R/W,C)
C			  (ALSO USED LOCALLY IF .OPTLOG COMMAND INPUT
C			  AND OPT=T)
C
	SUBROUTINE RDCKC
C
	INCLUDE 'MAINSPC.FOR'
C
	PARAMETER (HR24=1440.0,HR12=720.0,PI=3.1415927,
     &   PID180=1.745329E-2,RADDEG=4.363323E-3)
C
	LOGICAL NOTITL,REWND,NEWVTC,ERRIND,CHGDKP
	CHARACTER TMPBUF*80,LBL*4,C2*2,FF*1,NAME2*16,SAVFL2*60
C
	FF=CHAR(13)
C
C
	IK1=0
	NEWSD=.FALSE.
	NEWVCO=.FALSE.
	LAST=.FALSE.
	EOF=.FALSE.
	NOTITL=.TRUE.
	LGETAL=0
	PKSET=.FALSE.
	REWND=.FALSE.
	NEWVTC=.FALSE.
	CONTC=.FALSE.
	CONT=.FALSE.
	FAC=1.0
C
C	BEFORE RE-SETTING PARMS TO OLD DEFAULT, CHECK TO SEE IF THIS
C	IS END OF FILE.  THIS ALLOWS RESULTS OF LAST CALC TO BE AVAILABLE
C	AT END OF RUN, IF NEEDED
C
	CALL INBUF ('NEW RDCKC: ',11)
	IF (IORET.EQ.2) GOTO 2995
C
C	UNDO CHANGES IN KINETIC PARAMETERS IF ANY CHANGED, TO GET BACK
C	TO DEFAULT VALUES.  FORCE RECALCULATION OF ALL T-DEPENDENT K'S
C	IF ANY NON-K KINETIC PARAMETER CHANGED.
C
	CHGDKP=.FALSE.
	IF (NEWKP.GT.0) THEN
		DO 2 I=1,NEWKP
		J=IOLDKP(I)
		IF (J.LT.0) THEN
			KPBUF(-J)=OLDKP(I)
			CHGDKP=.TRUE.
		ELSE
			RK(J)=OLDKP(I)
			RXTYP(J)=OLDIND(I)
		ENDIF
    2		CONTINUE
		NEWKP=0
	ENDIF
C
C - - CHANGE COEF'S TO OLD DEFAULT
C
	DO 3 I=1,NCOEFV
    3	COEF(I)=OLDCOE(I)
C
C	CHANGE K'S TO OLD TEMPERATURE IF IT CHANGED
C
	IF (INDTPR.NE.0.AND.(CHGDKP.OR.COEF(INDTPR).NE.TEMP)) THEN
		TEMP=COEF(INDTPR)
		CALL NEWRK (0)          ! RECALCS ALL K'S FOR NEW TEMP
C		NEWVTC=.FALSE.          !!! NOTE: IT IS ASSUMED THAT NEWVTC
C                                           IS ALWAYS FALSE AT THIS POINT.
	ENDIF
C
C	CHANGE PHOTKS TO DEFAULT, IF APPLICABLE
C
	IF (.NOT.VARYHV.AND.NPHOTK.GT.0) THEN
		DO 4 I=1,NPHOTK
    4		COEF(IPHRK(I))=OLDPHK(I)
	ENDIF
C
C	CHANGE CALC LABEL TO DEFAULT
C
	RUN=OLDRUN
C
C	SKIP OVER FIRST READ SINCE IT WAS ALREADY READ TO SEE IF <EOF>
C
	GOTO 1001
C
C
C	GET NEXT INITIAL CONDITION
C
 1000	CALL INBUF ('RDCKC: ',7)
	IF (IORET.EQ.2) GOTO 2995
 1001	CONTINUE
C
C
	IF (IOB160(1:2).EQ.'.  ') GOTO 1000    ! DO NOTHING
C
C	'.END' ... READ NEW MODEL.  NO CALC DONE
C
	IF (IOB160(1:4).EQ.'.END') THEN
		LAST=.TRUE.
		GOTO 2999
C
C	IF OPT, '.OPTLOG COMMAND ALLOWS COMMENTS TO BE ENTERED INTO
C	THE LOG FILE.   THIS OPTION IS IGNORED IF NOT OPT.
C
	ELSEIF (IOB160(1:7).EQ.'.OPTLOG') THEN
		IF (OPT) THEN
			WRITE (OUT,'(//'' LOG COMMENTS:'')')
			OPEN (UNIT=TMP2,FILE=OPTLOG,STATUS='OLD',
     &			 ACCESS='APPEND')
			WRITE (TMP2,'(1X)')
 1302			CALL INBUF ('LOG COMMENT: ',13)
			IF (IORET.EQ.2) GOTO 2995
			IF (IOB160(1:4).EQ.'*END') GOTO 1304
			L=LENSTR(IOB160,80)
			WRITE (OUT,'(20X,A)') IOB160(1:L)
			WRITE (TMP2,1) IOB160(1:L)
			GOTO 1302
 1304			CLOSE (UNIT=TMP2)
		ENDIF
		GOTO 1000
C
C	WRITE TITLE IF NOT WRITTEN BEFORE AND ABOVE CONDITIONS NOT SATISFIED.
C	ALSO, IF FIRST COMMAND BEING PROCESSED IS NOT '.CONT', INITIAL CONC'S
C	TO CURRENT MODEL DEFAULT, AND LOOP BACK TO GET NEXT COMMAND.
C
	ELSEIF (NOTITL) THEN
		NOTITL=.FALSE.
		IF (INTOUT.AND.(.NOT.OPT)) WRITE (OUT,9) FF,
     &		 TITLE(1:LNBLNK(TITLE))
    9		FORMAT (A1/A//' INITIAL CONDITIONS AND PARAMETERS '
     &           ,'SPECIFIED'//1X)
C
		IF (IOB160(1:5).EQ.'.CONT') THEN
			IF (INTOUT) WRITE (OUT,*) ' *NOTE*  THIS IS ',
     &			 'A CONTINUATION OF THE LAST CALC.'
			T0=TEND
			CONTC=.TRUE.
			GOTO 1000
		ELSE
C
C			IF NOT A CONTINUATION, SET CONC'S TO
C                       CURRENT DEFAULT INITIAL VALUES.
C
			DO 92 I=1,NS
   92			C(I)=CINIT(I)
				IF (NVCO.GT.0) THEN
				REWIND (UNIT=TIMEU)
				READ (TIMEU) TNEXT,(VINT(I),VSLOPE(I),
     &				 I=1,NVCO)
				REWND=.TRUE.
			ENDIF
		ENDIF
C
C		FOR A CONTINUATION, .CONT MUST BE FIRST COMMAND TO BE 
C		USED FOR INT
C
	ELSEIF (IOB160(1:4).EQ.'.CONT') THEN
		WRITE (OUT,*) ' RDCKC ERROR: ''.CONT'' COMMAND ',
     &		 'OUT-OF-PLACE.'
		NERR=NERR+1
		GOTO 1000
	ENDIF
C
C
C
C     '.SETDEF' ... CURRENT CONC'S, K'S, COEF'S, TEMP, TITLE BECOMES
C                  DEFAULT FOR SUBSEQUENT CALCS (INSTEAD OF MODEL
C                  DEFAULT OR LAST SETDEF.)
C
	IF (IOB160(1:7).EQ.'.SETDEF') THEN
		NEWKP=0                         ! KEEP KP CHANGES BY
C                                               ! ERASING THE RECORD OF THEM
C
		IF (.NOT.VARYHV.AND.NPHOTK.GT.0) THEN
			CALL SETPHK
			DO 2903 I=1,NPHOTK
 2903			OLDPHK(I)=COEF(IPHRK(I))
		ENDIF
		IF (INDTPR.NE.0.AND.COEF(INDTPR).NE.TEMP) THEN
			TEMP=COEF(INDTPR)
			CALL NEWRK (0)  ! RECALCS ALL K'S FOR NEW TEMP
			NEWVTC=.FALSE.
		ELSEIF (NEWVTC) THEN   ! RECALC T-VARYING COEF'S
			TEMP=COEF(INDTPR)
			CALL NEWRK (-1)
			NEWVTC=.FALSE.
		ENDIF
 2911     	CONTINUE
		DO 2912 I=1,NS
 2912		CINIT(I)=C(I)
		DO 2916 I=1,NCOEFV
 2916		OLDCOE(I)=COEF(I)
		OLDRUN=RUN
		IF (INTOUT) THEN
			WRITE (OUT,*) 
			WRITE (OUT,*) ' ABOVE ARE DEFAULTS ',
     &			 'FOR FOLLOWING CALCULATIONS.'
		ENDIF
		OLDMOD=.TRUE.
		GOTO 1000
C
C       '.SETHV' ... FORCE CALCULATION (AND NORMALIZATION) OF
C                       PHOTOLYSIS RATES (VARYHV=F ONLY)
C
	ELSEIF (IOB160(1:6).EQ.'.SETHV') THEN
		IF (VARYHV) THEN
			WRITE (OUT,*) 'CAN''T SET PHOT. K''S WITH',
     &			 'VARIABLE LIGHT INTENSITY.'
			NERR=NERR+1
		ELSE
			IF (INTOUT) WRITE (OUT,*) ' PHOTOLYSIS RATES SET'
			CALL SETPHK
		ENDIF
		GOTO 1000
C
C	'.INTCONT' NO LONGER USED IN THIS VERSION.
C
	ELSEIF (IOB160(1:8).EQ.'.INTCONT') THEN
		WRITE (OUT,*) 'RDCKC ERROR.','  ''.INTCONT'' NOT USED ',
     &		 'IN THIS VERSION.'
		NERR=NERR+1
		GOTO 1000
C
C	'.INT [savfil]' ... DO INTEGRATION WITH THESE PARMS.
C		savfil: SAVE WITH THIS FILE NAME
C		0: FORCE SAVE USING CALC NO'S (CALCS\CALCnnnn)
C		(default): SAVE WITH INT FILE NAME.
C	'.INTAPND [savfil|FIRST]' ... APPEND CALCULATION TO EXISTING FILE
C		Default is first saved calculation.
C		"FIRST" is first calc.
C
	ELSEIF (IOB160(1:4).EQ.'.INT') THEN
C
	    	IF (PASS) THEN
		    IF (IOB160(5:5).EQ.' ') THEN
			IF (IOB160(6:7).EQ.'0 ') THEN
				IOB160(6:6)=' '
			ENDIF
			IF (IOB160(6:6).EQ.' ') THEN
				IF (LSAVFL.EQ.0) THEN
					SAVFIL=CALUIC(1:LCALUC)
     &					 //EXTFIL(1:LEXTFL)//'\'//
     &					 FILES(1:LFILES)
					LSAVFL=LCALUC+LEXTFL+1+LFILES
				ELSEIF (PASSED) THEN
					WRITE (ICRT,*)
     &					 'Need save file for multi-calc'
					WRITE (OUT,*)
     &					 'Need save file for multi-calc'
					GOTO 1800
				ENDIF
			ELSEIF (IOB160(6:6).EQ.'*') THEN
				IF (LSAVF1.EQ.0) THEN
					WRITE (ICRT,*) 'No first calc to'
     &					 //' reference.'
					WRITE (OUT,*) 'No first calc to'
     &					 //' reference.'
					GOTO 1800
				ENDIF
				SAVFIL=SAVFL1
				LSAVFL=LSAVF1
				IF (IOB160(7:7).NE.' ') THEN
					SAVFIL(LSAVF1+1:)=IOB160(7:)
					LSAVFL=LSAVFL+LNBLNK(IOB160(7:))
				ENDIF
			ELSE
				SAVFIL=CALUIC(1:LCALUC)//
     &				 EXTFIL(1:LEXTFL)//'\'//IOB160(6:)
				LSAVFL=LCALUC+LEXTFL+1+LNBLNK(IOB160(6:))
			ENDIF
			IF (LSAVF1.EQ.0) THEN
		        	SAVFL1=SAVFIL
				LSAVF1=LSAVFL
			ENDIF
		    ELSEIF (IOB160(1:9).EQ.'.INTAPND ') THEN
			CONT=.TRUE.
			IF (IOB160(10:10).EQ.' ') THEN
				IF (LSAVFL.EQ.0) THEN
					WRITE (ICRT,*)
     &					 'Need to give file to append'
					WRITE (OUT,*)
     &					 'Need to give file to append'
					GOTO 1800
				ENDIF
			ELSEIF (IOB160(10:10).EQ.'*') THEN
				IF (LSAVF1.EQ.0) THEN
					WRITE (ICRT,*) 'No first calc to'
     &					 //' append.'
					WRITE (OUT,*) 'No first calc to'
     &					 //' append.'
					GOTO 1800
				ENDIF
				SAVFIL=SAVFL1
				LSAVFL=LSAVF1
				IF (IOB160(11:11).NE.' ') THEN
					SAVFIL(LSAVFL+1:)=IOB160(11:)
					LSAVFL=LSAVFL+LNBLNK(IOB160(11:))
				ENDIF
			ELSE
				SAVFIL=CALUIC(1:LCALUC)//
     &				 EXTFIL(1:LEXTFL)//'\'//IOB160(10:)
				LSAVFL=LCALUC+LEXTFL+1+LNBLNK(IOB160(10:))
			ENDIF
			INQUIRE (FILE=SAVFIL(1:LSAVFL)//'.CDA',EXIST=CONT)
			IF (.NOT.CONT) THEN
				WRITE (OUT,*) 'File = '//
     &				 SAVFIL(1:LSAVFL)//
     &				 '.CDA does not exist for append.'
				WRITE (ICRT,*) 'File = '//
     &				 SAVFIL(1:LSAVFL)//
     &				 '.CDA does not exist for append.'
				STOP
			ENDIF
		    ENDIF
		ENDIF
C
		CALL TMARK (RUN(65:72))
		IF (INTOUT) WRITE (OUT,3001) RUN(1:LNBLNK(RUN))
 3001		FORMAT (/1X/' ',A)
		IF (NVCO.GT.0.AND.T0.GE.TNEXT) THEN
C		      - REWIND AND POSITION VARY COEF DS.
 3006			READ (TIMEU) TNEXT,(VINT(I),VSLOPE(I),I=1,NVCO)
			IF (T0.GE.TNEXT) GOTO 3006
		ENDIF
C
C		CALCULATE PHOTKS
C
		IF (VARYHV) THEN
C                                       ! INITIALIZE FOR VARYHV PHOTKS
C
			SINLD=SIN(PID180*LAT)*SIN(PID180*DEC)
			COSLD=COS(PID180*LAT)*COS(PID180*DEC)
			IF (COSLD.EQ.0.0) THEN
				TDAWN=0.0
			ELSE
				F=-SINLD/COSLD
				IF (ABS(F).GE.1.0) THEN
					TDAWN=0.0
				ELSE
					TDAWN=HR12-ACOS(F)/RADDEG
				ENDIF
			ENDIF
			IF (INTOUT) WRITE (OUT,3020) LAT,DEC,TDAWN,CZMIN
 3020			FORMAT (/4X,'SOLAR LIGHT INTENSITY:'
     &			 /' ',17X,'LATITUDE =',F6.2,' DEG.'
     &			 / ' ',17X,'DECLINATION =',F6.2,' DEG.'
     &			 / ' ',17X,'SUNRISE AT',F7.1,' MIN. AFTER ',
     &			 'MIDNIGHT.'/' ',17X,'MINIMUM COS(Z) =',1PE10.2)
			TLAST=-1.6E+38
			TXLAST=-1.6E+38
			NODARK=.TRUE.           ! 'DARK' SDIST NOT CACL'D
		ELSE
			CALL SETPHK
		ENDIF
C
C		CHANGE K'S IF NEW TEMPERATURE
C
		IF (INDTPR.NE.0.AND.COEF(INDTPR).NE.TEMP) THEN
			TEMP=COEF(INDTPR)
			CALL NEWRK (0)          ! RECALCS ALL K'S FOR NEW TEMP
			NEWVTC=.FALSE.
		ELSEIF (NEWVTC) THEN            ! RECALC T-VARYING COEF'S
			TEMP=COEF(INDTPR)
			CALL NEWRK (-1)
			NEWVTC=.FALSE.
		ENDIF
C
 3201		IF (CONT.AND.INTOUT) WRITE (OUT,3202)
 3202		FORMAT (/' THIS CALCULATION IS PART OF A MULTI-PA',
     &		 'RT SET.')
		GOTO 2999
C
C		'.LBLi comment'  ADD 'comment' STARTING AT i'TH 8-CHAR 
C		FIELD OF LABEL.
C
	ELSEIF (IOB160(1:4).EQ.'.LBL') THEN
		READ (BYT160(5),1042,ERR=1800) ICOM
 1042		FORMAT (I1)
		IF (ICOM.EQ.0) ICOM=1
		IF (ICOM.GE.7) GOTO 1048
		I=6
 1044		I=I+1
		IF (I.GT.16) GOTO 1048
		IF (BYT160(I).EQ.' ') GOTO 1044
		ITCHAR=ICHAR(BYT160(I))
		IF (ITCHAR.EQ.9) GOTO 1044
		J=I+63
		TMPBUF(1:64)=IOB160(I:J)
		J=1
		DO 1046 I=ICOM,6
		N1=(I-1)*8+1
		N2=N1+7
		J1=(J-1)*8+1
		J2=J1+7
		IF (TMPBUF(J1:J2).EQ.' ') GOTO 1000
		RUN(N1:N2)=TMPBUF(J1:J2)
 1046		J=J+1
		GOTO 1000
 1048		IF (INTOUT) WRITE (OUT,*) ' ** IGNORED .LBL INPUT: "'
     &		 ,IOB160(1:LNBLNK(IOB160)),'"'     
C
C		'.TITLE' ... READ ENTIRE TITLE
C
		GOTO 1000
	ELSEIF (IOB160(1:6).EQ.'.TITLE') THEN
 1060		CALL INBUF ('TITLE: ',7)
		IF (IORET.EQ.2) GOTO 2995
		IF (BYT160(1).EQ.'!') GOTO 1060
		RUN=IOB160
		GOTO 1000
C
C	IF INPUT NOT ONE OF THE ABOVE, THE INPUT LINE IS PRINTED.
C
	ELSE
        	IF (INTOUT) WRITE (OUT,*) ' INPUT = "',
     &		 IOB160(1:LNBLNK(IOB160)),'"'
	ENDIF
C
C
C	DECODE INPUT LINE WRITTEN TO OUTPUT FILE.
C
C	'.SD-(data set name)' = READ SPECTRAL DIST. FROM DATA SET
C	'.SD-        ' = READ SPECTRAL DIST. FROM INPUT STREAM (TAKEN
C       		CARE OF IN SDREAD)
C
	IF (IOB160(1:4).EQ.'.SD-') THEN
		IF (NPHOTK.EQ.0) GOTO 1800
		SDFIL=IOB160(5:16)
		NEWSD=.TRUE.
		CALL SDREAD
		IF (IRET.EQ.2) NERR=NERR+1
		IF (SDFIL.EQ.' '.AND.IORET.EQ.2) GOTO 2995
C
C	.VARYCO ... RESET VARIABLE COEF'S (IF PREVIOUSLY READ IN),
C	READ NEW SET AND WRITE INTO FILE VCO.TMP
C
	ELSEIF (IOB160(1:7).EQ.'.VARYCO') THEN
		IF (NVCO.NE.0) THEN
			CLOSE (UNIT=TIMEU,STATUS='DELETE')
			NVCO=0
		ENDIF
		NEWVCO=.TRUE.
		TMPBUF=TMPUIC(1:LNBLNK(TMPUIC))//'VCO.TMP'
		OPEN (UNIT=TIMEU,FILE=TMPBUF,STATUS='UNKNOWN')
C
 1006		CALL INBUF ('VCO: ',5)
		IF (IORET.EQ.2) GOTO 2995
		IF (IOB160(1:4).NE.'#END') THEN
			WRITE (TIMEU,1) IOB160(1:IOLEN)
			GOTO 1006
		ENDIF
    1		FORMAT (A)
C
C	.NOVCO ... GET RID OF VARYCO INPUT
C
	ELSEIF (IOB160(1:6).EQ.'.NOVCO') THEN
		IF (NVCO.NE.0) THEN
			CLOSE (UNIT=TIMEU,STATUS='DELETE')
			NVCO=0
		ENDIF
		NEWVCO=.FALSE.
C
C	'.GETALO [savfil|*]' ... get aloft concntrations from
C				a previous calculation
C
	ELSEIF (IOB160(1:7).EQ.'.GETALO') THEN
		CALL PARSE0 (2,IOB160,80)
		CALL PARSE1 (2,GETAL,LGETAL,60,IOB160)
		IF (GETAL(1:1).EQ.' ') GOTO 1800
C
C       '.GET savfil|* ttt' ... GET CONC'S FROM CALCULATION nnn AT TIME ttt.
C
	ELSEIF (IOB160(1:4).EQ.'.GET') THEN
		CALL PARSE0 (3,IOB160,80)
		CALL PARSE1 (2,SAVFL2,LSAVF2,60,IOB160)
		IF (SAVFL2(1:1).EQ.' ') GOTO 1800
		CALL PARSER (3,F,ERRIND,IOB160)
		IF (ERRIND) GOTO 1800
		CALL GETCAL (SAVFL2,LSAVF2,F)
		IF (IRET.NE.0) GOTO 1800
C
C	'.NAME. oldname newname' ... RENAME A SPECIES OR COEF.
C	CHECKS FOR PREVIOUS USE OF NAME, BUT SUBSEQUENT USE OK BECAUSE
C	IT WILL BE OVER-WRITTEN BY THIS DEFINITION.
C
	ELSEIF (IOB160(1:5).EQ.'.NAME') THEN
		CALL PARSE0 (3,IOB160,80)
		CALL PARSE1 (2,IOBF16,I,16,IOB160)
		CALL PARSE1 (3,NAME2,I,16,IOB160)
		DO 6000 I=1,NS
		IF (NAME(I).EQ.NAME2) THEN
			WRITE (OUT,*) ' ** .NAME FAILED. NAME IN USE: ',NAME2
			WRITE (ICRT,*) '.NAME failed.  ',NAME2,' in use.'
			GOTO 1800
		ELSEIF (NAME(I).EQ.IOBF16) THEN
			NAME(I)=NAME2
			GOTO 1000
		ENDIF
 6000		CONTINUE
		DO 6001 I=1,NCOEFV
		IF (COEFNM(I).EQ.NAME2(1:8)) THEN
			WRITE (OUT,*) ' ** COEF. NAME IN USE: ',NAME2
			WRITE (ICRT,*) '.NAME failed.  ',NAME2,' in use.'
			GOTO 1800	
		ELSEIF (COEFNM(I).EQ.IOBF16(1:8)) THEN
			COEFNM(I)=NAME2(1:8)
			GOTO 1000
		ENDIF
 6001		CONTINUE
		GOTO 1800
C
C
C	'.LUMP ' NOT SUPPORTED IN THIS VERSION.
C
	ELSEIF (IOB160(1:5).EQ.'.LUMP') THEN
		WRITE (OUT,*) ' ** LUMP NOT SUPPORTED **'
		GOTO 1800
C
C	.SOLPARM   READ IN SPECIAL DATA FOR SOLAR SPECTRAL DISTRIBUTION
C	CALCULATION.  THIS IS INDICATED BY CALLING NEWPHK WITH A NEGATIVE
C	"TIME" ARGUMENT.
C
	ELSEIF (IOB160(1:8).EQ.'.SOLPARM') THEN
C
		CALL NEWPHK (-1.0)
C
C	.LOGMAX OR .NOLOGMAX CONTROLS WHETHER MAXIMUM CONCENTRATIONS
C	ARE TO BE MONITORED FOR SAVING IN STATUS.PRM.  ONLY APPLICABLE
C	IF THIS IS BEING LOGGED. (I.E., AS USED FOR REACTIVITY CALCULATIONS)
C
	ELSEIF (IOB160(1:7).EQ.'.LOGMAX') THEN
		NMAXO=IABS(NMAXO)
	ELSEIF (IOB160(1:9).EQ.'.NOLOGMAX') THEN
		NMAXO=-IABS(NMAXO)
C
C
C	IF INPUT NOT YET DECODED, IT IS ASSUMED TO BE OF THE FORM
C	(name)  (value[s]).  DECODE IT.  UP TO 4 VALUES PERMITTED.
C
	ELSE
		CALL PARSE0 (MAX0(5,NVTEMP+1),IOB160,80)
		CALL PARSE1 (1,IOBF16,I,16,IOB160)
		CALL PARSER (2,F,ERRIND,IOB160)
		IF (ERRIND) GOTO 1800
		GOTO 1002
	ENDIF
C
C	LOOP BACK IF INPUT PROCESSED, CONTINUE IF INPUT PARSED
C
	GOTO 1000
 1002	CONTINUE
C
C
C	PROCESS INPUT OF FORM (name) (value).
C
C	INPUT OF FORM 'c(nnnn).  DECODE nnnn INTO NN
C
	IF (IOBF16(2:2).EQ.'(') THEN
		C2=IOBF16(1:2)
		LBL=' '
		DO 111 I=3,6
		IF (IOBF16(I:I).EQ.')') GOTO 112
  111		LBL(I-2:I-2)=BYT160(I)
C             - DETERMINE WHICH RXN HAS THAT LBL.
  112		DO 115 I=1,NRK
		IF (LBL.EQ.RXNLBL(I)) GOTO 117
  115		CONTINUE
		GOTO 1800
  117		NN=I
C
		ITYP=RXTYP(NN)
		IF (ITYP.LE.2) THEN           ! UN-REFERENCEABLE REACTION
			GOTO 1800
		ELSEIF (C2.EQ.'P(') THEN          ! NORMALIZE SDIST TO INPUT
C                                                 ! PHOT K
			IF (ITYP.NE.7) GOTO 1800
			PK1=F
			IK1=LKBUF(NN)
		ELSEIF (C2.EQ.'K(') THEN
C
C			RATE CONSTANT.  
C
			LOCB=LKBUF(NN)
			IF (ITYP.EQ.7) THEN
				PKSET=.TRUE.
				IF (INTOUT) WRITE (OUT,212) 
     &				 COEF(IPHRK(LOCB))
  212				FORMAT ('  OLD PHOTK = ',1PE10.3)
				COEF(IPHRK(LOCB))=F
			ELSE
C
C				UPDATE K. PARMS IF GIVEN,
C				AND IF STANDARD ARRHENIUS TYPE (ITYP=4).
C
				IF (INTOUT) WRITE (OUT,211) RK(NN)
  211				FORMAT ('  OLD K = ',1PE10.3)
				IF (NEWKP.EQ.MAXNKP) THEN
					WRITE (OUT,*) '**INCREASE ',
     &					 'MAXNKP**'
					NERR=NERR+1
					GOTO 1800
C
				ENDIF
				NEWKP=NEWKP+1
				OLDKP(NEWKP)=RK(NN)
				IOLDKP(NEWKP)=NN
				OLDIND(NEWKP)=ITYP
C
C				UPDATE ARRHENIUS PARMS IF GIVEN, AND IF TYPE 4
C
				IF (ITYP.NE.4) THEN
					ERRIND=.TRUE.
				ELSE
					CALL PARSER (3,F2,ERRIND,IOB160)
				ENDIF
				IF (ERRIND) THEN
C
C					K. PARMS NOT GIVEN.  SET TO CONSTANT
C					TYPE.
C
					RK(NN)=F
					RXTYP(NN)=3
				ELSE
C
C					K. PARMS GIVEN.
C
					IF (NEWKP+2.GT.MAXNKP) THEN
						WRITE (OUT,*) 
     &						 '** INCREASE MAXNKP **'
						NERR=NERR+1
						GOTO 1800
					ENDIF
C
					IF (INTOUT) WRITE (OUT,2114) 
     &					 KPBUF(LOCB),KPBUF(LOCB+1),
     &					 KPBUF(LOCB+2)
 2114					FORMAT ('  OLD A,EA,B = ',
     &					 1PE10.3,0P2F8.3)
					OLDKP(NEWKP)=KPBUF(LOCB)
					OLDKP(NEWKP+1)=KPBUF(LOCB+1)
					OLDKP(NEWKP+2)=KPBUF(LOCB+2)
					IOLDKP(NEWKP)=-LOCB
					IOLDKP(NEWKP+1)=-(LOCB+1)
					IOLDKP(NEWKP+2)=-(LOCB+2)
					OLDIND(NEWKP+1)=0
					OLDIND(NEWKP+2)=0
					NEWKP=NEWKP+2
C
					KPBUF(LOCB)=F2
					CALL PARSER (4,F2,ERRIND,IOB160)
					IF (ERRIND) F2=0
					KPBUF(LOCB+1)=F2
					CALL PARSER (5,F2,ERRIND,IOB160)
					IF (ERRIND) F2=0
					KPBUF(LOCB+2)=F2
C
					CALL NEWRK (NN) 	! UPDATE K
				ENDIF
			ENDIF
			GOTO 1000
		ELSE
			GOTO 1800
		ENDIF
C
C	INPUT IN FORM 'KPn(lbl)'.  CHANGE KINETIC PARM n FOR REACTION
C	LABELED lbl.
C
	ELSEIF (IOBF16(1:2).EQ.'KP'.AND.IOBF16(4:4).EQ.'(') THEN
		READ (IOBF16,2102,ERR=1800) IPRM
 2102		FORMAT (2X,I1)
		IF (IPRM.EQ.0) GOTO 1800
		LBL=' '
		DO 2104 I=5,8
		IF (IOBF16(I:I).EQ.')') GOTO 2106
 2104		LBL(I-4:I-4)=BYT160(I)
 2106		DO 2108 I=1,NRK
		IF (LBL.EQ.RXNLBL(I)) GOTO 2110
 2108		CONTINUE
		GOTO 1800
 2110		NN=I
C
		ITYP=RXTYP(NN)
		IF (ITYP.LE.3.OR.(ITYP.GE.6.AND.ITYP.LT.9)) GOTO 1800
		LOCB=LKBUF(NN)
		IF (ITYP.EQ.4) THEN
			IF (IPRM.GT.3) GOTO 1800
		ELSEIF (ITYP.EQ.5) THEN
			IF (IPRM.EQ.8) GOTO 1800
		ELSEIF (ITYP.EQ.9) THEN
			IF (IPRM.GT.6) GOTO 1800
		ELSEIF (ITYP.EQ.10) THEN
			IF (IPRM.GT.9) GOTO 1800
		ELSE
			GOTO 1800
		ENDIF
		J=LOCB+IPRM-1
		IF (NEWKP.EQ.MAXNKP) THEN
			WRITE (OUT,*) '** INCREASE MAXNKP **'
			NERR=NERR+1
			GOTO 1800
		ENDIF
		NEWKP=NEWKP+1
		OLDKP(NEWKP)=KPBUF(J)
		KPBUF(J)=F
		IOLDKP(NEWKP)=-J
		OLDIND(NEWKP)=0
C
		CALL NEWRK (NN)                 ! CHANGE K FOR NEW PARMS
C                              
		IF (INTOUT) WRITE (OUT,2112) RK(NN)
 2112		FORMAT (' NEW K = ',1PE10.3)
		GOTO 1000
C
C	IF INPUT NAME DOESN'T START WITH A '.', FIRST SEE IF NAME
C	MATCHES SPECIES NAME, THEN SEE IF IT MATCHES COEF NAME
C	AND IF SO, ASSIGN NEW VALUE TO IT.
C
	ELSEIF (IOBF16(1:1).NE.'.') THEN
		DO 201 I=1,NS
		IF (NAME(I).EQ.IOBF16) THEN
			C(I)=F*FAC
			GOTO 1000
		ENDIF
  201		CONTINUE
C
C		IF STARTS WITH A "+", THEN SPECIES IS ADDED
C
		IF (IOBF16(1:1).EQ.'+') THEN
			DO 2011 I=1,NS
			IF (NAME(I)(1:15).EQ.IOBF16(2:16)) THEN
				C(I)=C(I)+(F*FAC)
				GOTO 1000
			ENDIF
 2011			CONTINUE
		ENDIF
C
C		LOOK FOR COEF
C
		IF (IOBF16(1:1).EQ.'#') THEN
			DO 2221 I=1,NCOEFV
			IF (COEFNM(I).EQ.IOBF16(2:9)) THEN
				ICOE=I
				GOTO 222
			ENDIF
 2221   		CONTINUE
		ENDIF
		DO 221 I=1,NCOEFV
		IF (COEFNM(I).EQ.IOBF16(1:8)) THEN
			ICOE=I
			GOTO 222
		ENDIF
  221		CONTINUE
		WRITE (OUT,*) ' ** COEFFICIENT OR SPECIES NAME NOT',
     &		 ' FOUND.'
		GOTO 1800
  222		IF (ICOE.EQ.INDVOL.OR.ICOE.EQ.INDER) THEN
			WRITE (OUT,*) ' ** COEF(',COEFNM(I),
     &			 ') IS SUPOSSED TO BE SET INTERNALLY ONLY.'
			NERR=NERR+1
		ENDIF
C
C		COEFFICIENT FOUND.  IS IT T-VARYING?
C
		DO 604 IV=1,NVTCO
		IF (ICOE.EQ.IVTCO(IV)) THEN
			IF (INTOUT) WRITE (OUT,605) (VTCO(IV,IT),
     &                   IT=1,NVTEMP)
  605			FORMAT (' OLD VTCO VALUES = ',4(1PG10.3))
			VTCO(IV,1) = F
			DO 6041 IT=2,NVTEMP
			CALL PARSER (IT+1,VTCO(IV,IT),ERRIND,IOB160)
			IF (ERRIND) THEN
				WRITE (OUT,*) ' ** ERROR DECODING ',
     &				 ' T-VARYING PARAMETER'
				GOTO 1800
			ENDIF
 6041			CONTINUE
			NEWVTC=.TRUE.   ! NEWVTC SET TO TRUE SO T.V. COEF'S
C                                       ! WILL BE RECALCULATED FOR CURRENT 
C					! TEMPERATURE ON .SETDEF OR .INT.
			GOTO 1000
		ENDIF
  604		CONTINUE
		IF (INTOUT) WRITE (OUT,602) COEF(I)
  602		FORMAT (' OLD COEF = ',1PG10.3)
		COEF(I)=F
		GOTO 1000
C
C	INPUT NAME STARTS WITH '.'
C
C	.TEM    ...     CHANGE TEMPERATURE.  NOTE:
C               1) TEMP = CURRENT 'TEMPERATURE' FOR ALL CURRENT K'S
C               2) OLDCOE(INDTPR) = 'TEMPERATURE' OF 'DEFAULT' K'S (RK)
C               3) COEF(INDTPR) = MODEL TEMPERATURE.
C
	ELSEIF (IOBF16(1:4).EQ.'.TEM') THEN
		IF (INTOUT) WRITE (OUT,1303) TEMP
 1303		FORMAT (' OLD TEMP =',F7.1)
		IF (INDTPR.NE.0) THEN
			COEF(INDTPR)=F
		ELSE
			WRITE (OUT,*) ' **CAN''T VARY TEMPERATURE ',
     &			 'WITH THIS MODEL**'
			NERR=NERR+1
		ENDIF
		GOTO 1000
C
	ELSEIF (IOBF16(1:3).EQ.'.T0') THEN
		IF (NVCO.GT.0.AND..NOT.REWND) THEN
			REWIND (UNIT=TIMEU)
			READ (TIMEU) TNEXT,(VINT(I),VSLOPE(I),I=1,NVCO)
		ENDIF
		T0=F
C
	ELSEIF (IOBF16(1:6).EQ.'.TEND+') THEN
		TEND=T0+F
C
	ELSEIF (IOBF16(1:5).EQ.'.TEND') THEN
		TEND=F
C
	ELSEIF (IOBF16(1:4).EQ.'.DPR') THEN
		DPRN=F
C
	ELSEIF (IOBF16(1:4).EQ.'.DIL') THEN
		IF (INDDIL.EQ.0) THEN
			WRITE (OUT,*) '** DILUTION INPUT ILLEGAL **'
			GOTO 1800
		ELSE
			COEF(INDDIL)=F
		ENDIF
C
	ELSEIF (IOBF16(1:4).EQ.'.LAT') THEN
		IF (VARYHV) THEN
			LAT=F
		ELSE
			WRITE (OUT,*) ' ** .LAT INPUT IGNORED **'
		ENDIF
C
	ELSEIF (IOBF16(1:4).EQ.'.DEC') THEN
		IF (VARYHV) THEN
			DEC=F
		ELSE
			WRITE (OUT,*) ' ** .DEC INPUT IGNORED **'
		ENDIF
C
	ELSEIF (IOBF16(1:4).EQ.'.O3S') THEN
		WRITE (OUT,*) ' ** .O3STRAT INPUT IGNORED **'
C
	ELSEIF (IOBF16(1:7).EQ.'.TSTART') THEN
		TSTART=F
C
	ELSEIF (IOBF16(1:6).EQ.'.UVFAC') THEN
		UVFAC=F
C
	ELSEIF (IOBF16(1:6).EQ.'.FAC  ') THEN
		FAC=F
	ELSEIF (IOBF16(1:6).EQ.'.NOFAC') THEN
		FAC=1.0
C
	ELSE
		WRITE (OUT,*) ' ** UNRECOGNIZED "." COMMAND **'
		GOTO 1800
	ENDIF
C
C	INPUT RECOGNIZED OK
C
	GOTO 1000
C
C	UNRECOGNIZED INPUT
C
 1800	WRITE (OUT,*) ' *** ERROR IN READING RUN CONDITIONS ***'
	WRITE (OUT,*) ' BAD LINE = "',IOB160(1:LNBLNK(IOB160)),'"'
	WRITE (ICRT,*) 'INPUT ERROR.  BAD LINE = "',
     &	 IOB160(1:LNBLNK(IOB160)),'"'
	NERR=NERR+1
	GOTO 1000
C -------------------------------------------------------------------
C
C      <EOF> ... QUIT PROGRAM.  NO CALC DONE
C
 2995	EOF=.TRUE.
C
C	DONE
C
 2999	IF (PASS) CLOSE (UNIT=LOGU)
	RETURN
	END
