C --- SDREAD.FOR
C --- CALLED BY RDCKC                   FOR VARYHV=F ONLY.
C --- CALLS FILNAM, ALIN16, INBUF
C --- UNITS USED: TMP1  (OPEN,READ,CLOSE)
C
C -------------------------------------------------------------------------
C
      SUBROUTINE SDREAD
C
C     READS SPECTRAL DISTRIBUITON DATA ON TMP1.
C     SPECTRAL DIST DATA SET NAME IN 'SDFIL', IN COMMON
C     DEFINE ASDIST, BSDIST SO PHOTKS CAN BE CALCULATED
C     PRINT OUT DISTRIBUTION
C
C     * NOTE * THIS VERSION FOR CONSTANT SDIST ONLY
C
	INCLUDE 'MAINSPC.FOR'
C
C     CHVDAT COMMON SHARED BY PHOTKS. ANY CHANGES HERE MUST BE MATCHED THERE
C
	PARAMETER (MAXSWL=1200)
	COMMON /CHVDAT/ ASDIST(MAXSWL),BSDIST(MAXSWL),SWL(MAXSWL)
C
	INTEGER STDNWL
	PARAMETER (STDNWL=26,DWL=0.01,WL1=0.250,WL2=0.500)
	LOGICAL NOCORR,NOSDFL,POWER
	REAL RCORR(STDNWL)
C -------------------------------------------------------------------------
C     FOLLOWING VALUES TAKEN FROM CALIBRATION DONE BY CHRIS PLUM
C              11-18-82
C
      DATA RCORR/1.5, 1.1, .86, .67, .625, .59, .533, .50, .487,
     &  .475, .464, .495, .505, .500, .460, .485, .495, .520, .565,
     &  .610, .655, .735, .810, .855, .880, 1.0/
C -------------------------------------------------------------------------
C
	NOCORR=.TRUE.
	NOSDFL=.FALSE.
	POWER=.FALSE.
C
      IRET=0
C
C     IF NO SDIST FILENAME SPECIFIED, READ DATA FROM INPUT STREAM.
C     OTHERWISE, OPEN SDIST DATA SET ON TMP1.
C
      IF (SDFIL.EQ.' ') THEN
          NOSDFL=.TRUE.
      ELSE
          IOB160=' '
          CALL FILNAM (NLEN,IOB160,SDRUIC,SDFIL,'.SDR ')
          IF (INTOUT) WRITE (OUT,1000) SDFIL
 1000 FORMAT (/' SPECTRAL DISTRIBUTION FILE = ',A12)
          OPEN (UNIT=TMP1,FILE=IOB160,STATUS='OLD',ERR=990)
      ENDIF
C
      IF (NOSDFL) THEN
          CALL INBUF('SDIST: ',7)
          IF (IORET.EQ.2) GOTO 998
C                                               !END OF FILE
          IF (IOB160(1:4).EQ.'#END') GOTO 998
      ELSE
          READ (TMP1,1111,END=992) IOB160
 1111 FORMAT (A80)
      ENDIF
      IF (INTOUT) WRITE (OUT,1115) IOB160
 1115 FORMAT (/5X,'LABEL = ',A80)
      NSWL=0
 1110 NSWL=NSWL+1
      IF (NSWL.GT.MAXSWL) STOP 'INCREASE MAXSWL IN SDREAD'
 1114 IF (NOSDFL) THEN
          CALL INBUF('SDIST: ',7)
          IF (IORET.EQ.2) GOTO 1112
      ELSE
          READ (TMP1,1111,END=1112) IOB160
      ENDIF
      IF (IOB160(1:4).EQ.'#END') GOTO 1112
      IF (IOB160(1:8).EQ.'        ') GOTO 1112
      IF (BYT160(1).EQ.'!') GOTO 1114
      IF (IOB160(1:4).EQ.'UNCO') GOTO 1116
	IF (IOB160(1:5).EQ.'POWER') THEN
		POWER=.TRUE.
		IF (INTOUT) WRITE (OUT,*) '     POWER CORRECTIONS APPLIED'
		GOTO 1114
	ENDIF
      CALL ALIN16 (2,IOB160)
      READ (IOB160,1113,ERR=994) SWL(NSWL),ASDIST(NSWL)
 1113 FORMAT (2G16.0)
      GOTO 1110
 1116 NOCORR=.FALSE.
      IF (INTOUT) WRITE (OUT,*) '     RESPONSE CORRECTIONS APPLIED'
      GOTO 1114
 1112 NSWL=NSWL-1
      IF (.NOT.NOSDFL) CLOSE (UNIT=TMP1)
      IF (NSWL.LT.2) GOTO 996
C
C     CORRECT FOR SPECTROMETER RESPONSE, IF 'UNCORR' COMMAND ENCOUNTERED
C     *NOTE* ABORTS IF CORRECTION FOR WL<250, BUT FOR WL>500, ASSUMES
C         NO CORRECTION (I.E., SAME CORRECTION AS WL=500)
C         IN REALITY, THIS CANNOT BE THE CASE.
C
	IF (POWER) THEN
		DO 1118 I=1,NSWL
 1118		ASDIST(I)=ASDIST(I)*SWL(I)
	ENDIF
C
      IF (NOCORR) GOTO 1300
      IF (SWL(1).LT.WL1) GOTO 9900
      J=1
      WL=WL1
      DO 1200 I=1,NSWL
 1202 IF (J.GT.STDNWL) GOTO 1300
      IF (WL-SWL(I)) 1204,1208,1206
 1204 J=J+1
      WL=WL+DWL
      GOTO 1202
 1206 ASDIST(I)=ASDIST(I)*(RCORR(J)+(SWL(I)-WL)*(RCORR(J)-RCORR(J-1))
     &  /DWL)
      GOTO 1200
 1208 ASDIST(I)=ASDIST(I)*RCORR(J)
      J=J+1
      WL=WL+DWL
 1200 CONTINUE
C
C     LIST SDISTS
C
 1300 IF (INTOUT) WRITE (OUT,1134) (SWL(I),ASDIST(I),I=1,NSWL)
 1134 FORMAT  (' ',5X,'(WL,SDIST) =',5('  (',0PF5.3,1PE11.3,')'
     1 ,:)/(' ',18X,5('  (',0PF5.3,1PE11.3,')',:)))
C
C     CALCULATE SLOPE AND INTERCEPT FOR EACH INTERVAL OF SDIST, AND STORE
C     THEM IN BSDIST AND ASDIST, RESPECTIVELY.  THESE ARE REQUIRED FOR
C     PHOTK CALCULATION.
C
      N2=NSWL-1
      DO 254 I=1,N2
      IP=I+1
      F=SWL(IP)-SWL(I)
      IF (F.EQ.0.0) GOTO 253
      BSDIST(I)=(ASDIST(IP)-ASDIST(I))/F
      ASDIST(I)=ASDIST(I)-BSDIST(I)*SWL(I)
      GOTO 254
  253 BSDIST(I)=0.0
      ASDIST(I)=0.0
  254 CONTINUE
       RETURN
C
C	CAN'T OPEN FILE.  DEFER ERROR UNTIL LATER, IN CASE A VALID
C	ONE SPECIFIED IN LATER INPUT.
C
  990	IRET=1
	WRITE (OUT,'(/1X,A)') 'Can''t open Sdist file = '//
     &	 SDFIL(1:LNBLNK(SDFIL))
	SDFIL='*ERROR*'
	RETURN
C
C      ERROR
C
  992 WRITE (OUT,993)
  993 FORMAT (/' THIS SDIST FILE IS EMPTY')
      GOTO 999
  994 WRITE (OUT,995) IOB160
  995 FORMAT (/' UNDECODABLE INPUT LINE = ',A80)
      GOTO 999
  996 WRITE (OUT,997) NSWL
  997 FORMAT (/' NEED AT LEAST 2 WAVELENGTHS TO DEFINE SDIST.',
     &  I3,' INPUT.')
      GOTO 999
  998 WRITE (OUT,9981)
 9981 FORMAT (/' NO SDIST DATA INPUT AFTER .SD- SPECIFIED')
      GOTO 999
 9900 WRITE (OUT,9901)
 9901 FORMAT (/' ATTEMPT TO CORRECT SDIST FOR WL<.250')
  999 IRET=2
      RETURN
      END
C --- END OF SDREAD.FOR
