	PROGRAM DO3NO
C
C	ADDS D(O3-NO) CHANNEL TO CALCnnnn.CSV FILES.  
C
C	CALC NO'S TO COMPRESS ON COMMAND LINE.
C
C	P1 = FILE NAME (appended to CAL= directory in modeling.prm)
C
	PARAMETER (MAXCHN=1000)
	CHARACTER*8 NAME(MAXCHN)
	REAL T,DATA(MAXCHN)
C
	LOGICAL ERRIND,FIRST
	CHARACTER FILNAM*80,INLIN*80,CALUIC*60
	CHARACTER HEADERS(3)*80
C
C
C	READ COMMAND LINE AND GET RUN NO'S TO PROCESS
C
	CALL GETARG (1,FILNAM)
	IF (FILNAM(1:1).EQ.' ') THEN
		WRITE (6,*) 'Adds D(O3-NO) channel to calc .CSV files.'
		WRITE (6,*) 'Use:  DO3NO calcid'
		WRITE (6,*) ' or:  DO3NO calcset\\runid'
		GOTO 990
	ENDIF
	LFIL=LNBLNK(FILNAM)
C
C	GET PARMS FROM MODELING.PRM
C
	OPEN (UNIT=1,FILE='MODELING.PRM',STATUS='UNKNOWN')
C
	LCALUC=0
   10	READ (1,'(A)',END=18) INLIN
	IF (INLIN(1:4).EQ.'CAL=') THEN
		CALUIC=INLIN(5:)
		LCALUC=LNBLNK(CALUIC)
	ENDIF
	GOTO 10
C
   18	CLOSE (UNIT=1)
	IF (LCALUC.GT.0) THEN
		FILNAM=CALUIC(1:LCALUC)//FILNAM(1:LFIL)
		LFIL=LCALUC+LFIL
	ENDIF
C
C	OPEN CALC FILE
C
	OPEN (UNIT=1,FILE=FILNAM(1:LFIL)//'.CSV',STATUS='OLD',ERR=900)
C
	READ (1,'(A/A/A/8X,I5)',ERR=910) HEADERS,N
	IF (N.GT.MAXCHN-2) GOTO 930
	READ (1,11,ERR=910) (NAME(I),I=1,N)
   11	FORMAT (/7X,1000(1X,A8,2X))
C
C	FIND O3, NO CHANNEL.   ALSO, ABORT IF D(O3-NO) OR O3-NO
C	CHANNEL ALREADY EXISTS.
C
	INDO3=0
	INDNO=0
	DO 110 I=1,N
	IF (NAME(I).EQ.'D(O3-NO)') THEN
		GOTO 980
	ELSEIF (NAME(I).EQ.'O3-NO   ') THEN
		GOTO 980
	ELSEIF (NAME(I)(1:3).EQ.'O3 ') THEN
		INDO3=I
	ELSEIF (NAME(I)(1:3).EQ.'NO ') THEN
		INDNO=I
	ENDIF
  110	CONTINUE
	ERRIND=.FALSE.
	IF (INDO3.EQ.0) THEN
		ERRIND=.TRUE.
		WRITE (6,*) 'Calc has no O3 channel'
	ENDIF
	IF (INDNO.EQ.0) THEN
		ERRIND=.TRUE.
		WRITE (6,*) 'Calc has no NO channel'
	ENDIF
	IF (ERRIND) GOTO 940
C
C	OPEN NEW FILE TO WRITE.
C
	OPEN (UNIT=2,FILE=FILNAM(1:LFIL)//'.TMP',STATUS='UNKNOWN')
	WRITE (2,1) HEADERS(1)(1:LNBLNK(HEADERS(1)))
	WRITE (2,1) HEADERS(2)(1:LNBLNK(HEADERS(2)))
	WRITE (2,1) HEADERS(3)(1:LNBLNK(HEADERS(3)))
    1	FORMAT (A)
	WRITE (2,12) N+2,'D(O3-NO)','O3-NO   ',(NAME(I),I=1,N)
   12	FORMAT ('Species,',I5//'Time ',1000('  ,',A8))
C
	FIRST=.TRUE.
  120	READ (1,13,ERR=950,END=130) T,(DATA(I),I=1,N)
   13	FORMAT (F7.1,1000(1X,1PE10.3))
	O3MNO=DATA(INDO3)-DATA(INDNO)
	IF (FIRST) THEN
		O3MNO0=O3MNO
		FIRST=.FALSE.
	ENDIF
	WRITE (2,14) T,O3MNO-O3MNO0,O3MNO,(DATA(I),I=1,N)
   14	FORMAT (F7.1,1000(',',1PE10.3))
	GOTO 120
C
C	DONE.  DELETE OLD FILE AND RENAME TEMPORARY FILE
C
  130	CLOSE (UNIT=2)
C
	DO 131 I=LFIL-1,1,-1
	IF (FILNAM(I:I).EQ.'\\') THEN
		IIND=I+1
		GOTO 132
	ENDIF
  131	CONTINUE
	IIND=1
	GOTO 132
  132	CONTINUE
C
CD	CLOSE (UNIT=1)
	CLOSE (UNIT=1,STATUS='DELETE')
C
	INLIN='RENAME '//FILNAM(1:LFIL)//'.TMP '//
     &	 FILNAM(IIND:LFIL)//'.CSV'
CD	WRITE (6,*) 'CMD='//INLIN(1:LNBLNK(INLIN))
	CALL SYSTEM (INLIN)
C
	WRITE (6,*) 'D(O3-NO) added to '//FILNAM(1:LFIL)//'.CSV'
	CALL EXIT (0)
C
C	ERRORS OR ABORT
C
  900	WRITE (6,*) 'Error opening '//FILNAM(1:LFIL)//
     &	 '.CSV to add D(O3-NO) channel.'
	CALL EXIT (2)
C
  910	WRITE (6,*) 'Error reading '//FILNAM(1:LFIL)//
     &	 '.CSV to add D(O3-NO) channel.'
	GOTO 990
C
  930	WRITE (6,*) 'Too many channels. NCHN=',N,', max=',MAXCHN-2
C
  940	WRITE (6,*) 'Cannot add D(O3-NO) channels to '//
     &	FILNAM(1:LFIL)//'.CSV'
	GOTO 980
C
  950	WRITE (6,*) 'Error reading data in '//FILNAM(1:LFIL)//
     &	 '.CSV to add D(O3-NO) channel.'
	CLOSE (UNIT=2,STATUS='DELETE')
C
C	NOT PROCESSED. NO OUTPUT PRODUCED.
C
  980	CLOSE (UNIT=1)
	CALL EXIT (1)
C
  990	CLOSE (UNIT=1)
	CALL EXIT (2)
	END
