	PROGRAM JZTOKZ
C
C	PRODUCES FILES GIVING PHOTK'S AS F(Z) GIVEN J(Z) VALUES
C	PRODUCED BY JEFFRIES.
C	(photons/cm^2/min in interval x 10^15)
C
C	P1 = NAME OF THE "JZS" FILE WITH J(Z) VALUES.  IN [JZS=]
C	     DIRECTORY.  THIS HAS J VAULES FOR THE "STANDARD PETERSON"
C	     SET OF Z'S.  IN FORMAT PRODUCED BY JEFFRIES' PROGRAMS
C	P2 = INPUT FILE, GIVING LIST OF PHOTOLYSIS FILE NAMES.
C	     DEFAULT OR ("*") IS TO USE ALL .PHK FILES FOUND IN LOCAL 
C	     DIRECTORY.
C	P3 = OUTPUT FILE NAME.  IF NOT GIVEN, P2 IS USED.
C	     IF "/F" SWITCH USED, OUTPUT FILE IS FORMATTED TABULATION
C	     OF J(Z) AND K(Z)'S.
C
C	OUTPUT FILE IS P1.KZS, WITH PHOTKS
C
C
C	MUST USE "STANDARD PETERSON" SET OF Z'S
C
	PARAMETER (NZS=10)
	REAL ZANG(NZS),ZCHK(NZS)
	DATA ZANG/0., 10., 20., 30., 40., 50., 60., 70., 78., 86./
C
C	SPECTRAL DISTRIBUTION DATA
C
	PARAMETER (MAXWL=400,MAXWL1=MAXWL+1)
	INTEGER NWL
	REAL WL(MAXWL1),SDIST(MAXWL,NZS),SDFAC
C
C
C	PHOTOLYSIS RATE DATA
C
	PARAMETER (MAXPHK=100,MAXPWL=600)
	INTEGER NPHOTK,NPWL
	CHARACTER PHOTNM(MAXPHK)*8
	REAL PWL(MAXPWL),PAQ(MAXPWL),ABSQY(MAXWL),PHOTKS(NZS,MAXPHK)
C
C
C	LOCAL VARIABLES
C
	CHARACTER INFILE*40,JZSFIL*40,JZSUIC*60,INLIN*80,FILNAM*80,
     &	 PHFUIC*60,NAMEIN*8,TITLE*80,KZSFIL*40
	LOGICAL ANS,ERROR,ALL,FMTOUT
C
C
C
C	GET INPUT AND OUTPUT FILE NAMES
C
	CALL GETARG (1,JZSFIL)
	IF (JZSFIL(1:1).EQ.' ') THEN
		WRITE (6,*) 'Use:  JZTOKZ jzsname [infile|*] ',
     &		 '[kzsname]|[outfile/F]'
		WRITE (6,*) 'Where: infile = file with list of ',
     &		 'photolysis names.'
		WRITE (6,*) '(* = use all .PHF files in ',
     &		 '[PHF] directory (default).'
		WRITE (6,*) '"/F" switch for formatted tabulation'
		WRITE (6,*) 'Reads J(z) values (standard z''s) fr',
     &		 'om file = [JZS]jzsname.JZS.'
		WRITE (6,*) 'Creates file = kzsname.KZS (or jzsn',
     &		 'ame.KZS) with PHOTK(z)''s.'
		CALL EXIT (2)
	ENDIF
	LJZSFL=LNBLNK(JZSFIL)
	CALL GETARG (2,INFILE)
	CALL GETARG (3,KZSFIL)
	LKZSFL=LNBLNK(KZSFIL)
	FMTOUT=.FALSE.
	IF (KZSFIL(1:1).EQ.' ') THEN
		KZSFIL=JZSFIL
		LKZSFL=LJZSFL
	ELSEIF (LKZSFL.GT.3) THEN
		IF (KZSFIL(LKZSFL-1:LKZSFL).EQ.'/F') THEN
			LKZSFL=LKZSFL-2
			FMTOUT=.TRUE.
		ENDIF
	ENDIF
C
C	MAKE SURE INPUT FILE EXISTS, IF APPLICABLE.
C
	IF (INFILE(1:1).EQ.' '.OR.INFILE(1:1).EQ.'*') THEN
		ALL=.TRUE.
	ELSE
		ALL=.FALSE.
		INQUIRE (FILE=INFILE,EXIST=ANS)
		IF (.NOT.ANS) THEN
			WRITE (6,*) 'File = ',INFILE(1:LNBLNK(INFILE)),
     &			 ' does not exist.'
			CALL EXIT (2)
		ENDIF
	ENDIF
C
C	FIND JZS FILE INFO IN MODELING.PRM
C
C
	OPEN (UNIT=1,FILE='MODELING.PRM',STATUS='UNKNOWN')
C
	PHFUIC='.\'
	JZSUIC='.\'
C
   10	READ (1,1,END=12) INLIN
    1	FORMAT (A)
	IF (INLIN(1:4).EQ.'JZS=') THEN
		JZSUIC=INLIN(5:)
	ELSEIF (INLIN(1:4).EQ.'PHF=') THEN
		PHFUIC=INLIN(5:)
	ENDIF
	GOTO 10
C
   12	CLOSE (UNIT=1)
C
	LPHFUC=LNBLNK(PHFUIC)
C
C	MAKE .JZS FILE NAME AND MAKE SURE IT EXISTS
C
	INLIN=JZSUIC(1:LNBLNK(JZSUIC))//JZSFIL(1:LJZSFL)//'.JZS'
	LJZSFL=LNBLNK(INLIN)
	JZSFIL=INLIN(1:LJZSFL)
	INQUIRE (FILE=JZSFIL,EXIST=ANS)
	IF (.NOT.ANS) THEN
		WRITE (6,*) 'File = ',JZSFIL(1:LJZSFL),' does not ',
     &		 'exist.'
		CALL EXIT (2)
	ENDIF
	OPEN (UNIT=1,FILE=JZSFIL(1:LJZSFL),STATUS='OLD')
C
C	OPEN OUTPUT FILE
C
	IF (FMTOUT) THEN
		OPEN (UNIT=3,FILE=KZSFIL(1:LKZSFL),STATUS='UNKNOWN')
	ELSE
		KZSFIL(LKZSFL+1:LKZSFL+4)='.KZS'
		OPEN (UNIT=3,FILE=KZSFIL,STATUS='UNKNOWN')
	ENDIF
C
C	READ J(Z) FILE
C	READ HEADER COMMENTS.  PROCESS "FAC" INPUT (IF ANY)
C
	READ (1,1,END=810) TITLE
	WRITE (6,*) 'J(z) data read from file = ',JZSFIL(1:LJZSFL)
C
	LMAX=52-LJZSFL
	L=LNBLNK(TITLE)
	IF (.NOT.FMTOUT) THEN
		WRITE (3,1) 'Sdist file = '//JZSFIL(1:LJZSFL)//
     &		 ',  Label = "'//TITLE(1:LNBLNK(TITLE(1:LMAX)))//'"'
		IF (LMAX.LT.L) WRITE (3,1) TITLE(1:LNBLNK(TITLE))
	ENDIF
C
	SDFAC=1.0
   20	READ (1,1,END=810) INLIN
	IF (INLIN(1:4).EQ.'FAC='.OR.INLIN(1:4).EQ.'FAC ') THEN
		IF (INLIN(4:4).EQ.'=') INLIN(4:4)=' '
		CALL PARSE0 (2,INLIN,80)
		CALL PARSER (2,SDFAC,ANS,INLIN)
		IF (ANS.OR.SDFAC.LE.0.0) THEN
			WRITE (6,*) 'Error:  Bad "',INLIN(1:LNBLNK(INLIN)),'"'
			CLOSE (UNIT=1)
			CALL EXIT (2)
		ENDIF
		GOTO 20
	ELSEIF (INLIN(1:1).NE.'.') THEN
		IF (.NOT.FMTOUT) WRITE (3,1) INLIN(1:LNBLNK(INLIN))
		GOTO 20
	ENDIF
C
C	READ Z'S.  THEY MUST BE EXACTLY SAME AS STANDARD
C
	ANS=.TRUE.
	READ (1,*,ERR=820) N,ZCHK
	IF (N.NE.NZS) THEN
	  WRITE (6,*) 'This only works if ',NZS, 'Z values are input.'
	  WRITE (6,*) JZSFIL(1:LJZSFL),' has ',N
	  GOTO 899
	ENDIF
	DO 22 I=1,NZS
	IF (ZCHK(I).NE.ZANG(I)) THEN
	  IF (ANS) THEN
	    ANS=.FALSE.
	    WRITE (6,*) 'Warning: Z values do not match standard.'
	  ENDIF
	  ZANG(I)=ZCHK(I)
	ENDIF
   22	CONTINUE
C
	NWL=1
   30	READ (1,*,END=40,ERR=840) X1,(SDIST(NWL,I),I=1,NZS)
	WL(NWL+1)=X1/1000.
	IF (X1.LE.0.0) THEN
		WRITE (6,*) 'Bad WL.  NWL = ',NWL
		CLOSE (UNIT=1)
		CALL EXIT (2)
	ENDIF
	IF (NWL.EQ.1) THEN
		NWL=2
	ELSE
		NWL=NWL+1
		IF (WL(NWL).LE.WL(NWL-1)) THEN
			WRITE (6,*) 'Bad WL order.  NWL = ',NWL
			CLOSE (UNIT=1)
			CALL EXIT (2)
		ELSEIF (NWL.EQ.MAXWL) THEN
			WRITE (6,*) 'Too many wavelengths.  Increa',
     &			 'se MAXWL in JZTOKZ.FOR.'
			CLOSE (UNIT=1)
			CALL EXIT (2)
		ENDIF
	ENDIF
	GOTO 30
C
   40	NWL=NWL-1
	IF (NWL.EQ.0) THEN
		WRITE (6,*) 'No J data in file.'
		CALL EXIT (2)
	ELSEIF (NWL.EQ.1) THEN
		WRITE (6,*) 'J''s for only one Z in file.'
		CALL EXIT (2)
	ENDIF
	CLOSE (UNIT=1)
C
C	J'S ASSUMED TO BE ZERO AT WL'S WL(2)-WL(1) BELOW WL(1)
C
	WL(1)=(2.0*WL(2))-WL(3)
C
C
C	OUTPUT FORMATTED LISTING OF SDISTS, IF APPLICABLE
C
	IF (FMTOUT) WRITE (3,3001) ZANG,(WL(I),WL(I+1),
     &	 (SDIST(I,J)*1.E+15,J=1,NZS),I=1,NWL)
 3001	FORMAT (
     &   'WL Interval    -------------------------------- Actinic fl',
     &   'uxes in units of photons/cm2/min ------------------------',
     &   '--------'/' (microns) ',10F11.0/(0PF5.3,F7.3,1X,1P10E11.3))
C
C	IF "*" OPTION GIVEN, CREATE DIRECTORY LISTING.  THEN OPEN
C	INPUT FILE FOR NAMES.
C
	IF (ALL) THEN
		INLIN=
     &		 'DIR '//PHFUIC(1:LPHFUC)//'*.PHF/B |SORT >JZTOKZ.TMP'
		CALL SYSTEM (INLIN)
		OPEN (UNIT=1,FILE='JZTOKZ.TMP',STATUS='OLD')
	ELSE
		OPEN (UNIT=1,FILE=INFILE,STATUS='OLD')
	ENDIF
C
C	READ PHOTOLYSIS NAMES
C
	NPHOTK=0
	ERROR=.FALSE.
	GOTO 100
C
  101	CLOSE (UNIT=2)
  102	ERROR=.TRUE.
	NPHOTK=NPHOTK-1
C
  100	READ (1,1,END=200) INLIN
	IF (INLIN(1:1).EQ.'!'.OR.INLIN(1:1).EQ.' ') GOTO 100
	IF (NPHOTK.GT.MAXPHK) THEN
		WRITE (6,*) 'Phot file = ',INLIN(1:8),' and those',
     &		 ' following ignored.  Increase MAXPHK in JZTOKZ.FOR.'
		ERROR=.TRUE.
		GOTO 200
	ENDIF
	NPHOTK=NPHOTK+1
	L=LNBLNK(INLIN)
	IF (ALL) THEN
		FILNAM=PHFUIC(1:LPHFUC)//INLIN(1:L)
		PHOTNM(NPHOTK)=INLIN(1:L-4)
		LFIL=LPHFUC+L
	ELSE
		FILNAM=PHFUIC(1:LPHFUC)//INLIN(1:L)//'.PHF'
		PHOTNM(NPHOTK)=INLIN(1:L)
		LFIL=LPHFUC+L+4
	ENDIF
C
C	OPEN PHOTOLYSIS FILE
C
	INQUIRE (FILE=FILNAM(1:LFIL),EXIST=ANS)
	IF (.NOT.ANS) THEN
		WRITE (6,*) 'Photolysis file = ',FILNAM(1:LFIL),
     &		 ' does not exist.'
		GOTO 102
	ENDIF
C
C	OPEN FILE AND SKIP TITLE
C	READ PHOTOLYSIS DATA
C
	OPEN (UNIT=2,FILE=FILNAM,STATUS='OLD')
	FAC=1.0
	NPWL=0
	READ (2,1,END=120) INLIN
C
  110	READ (2,1,END=120) INLIN
	IF (INLIN(1:1).EQ.'!') GOTO 110
	IF (INLIN(1:3).EQ.'FAC') THEN
		IF (INLIN(4:4).EQ.'=') INLIN(4:4)=' '
		CALL PARSE0 (3,INLIN,80)
		CALL PARSER (2,FAC,ANS,INLIN)
		IF (ANS.OR.FAC.LE.0.0) GOTO 118
	ELSE
		CALL PARSE0 (3,INLIN,80)
		CALL PARSE1 (1,NAMEIN,I,8,INLIN)
		IF (NAMEIN(1:1).EQ.' ') THEN
			GOTO 110
		ELSEIF (NPWL.EQ.MAXPWL) THEN
			WRITE (6,*) 'Too many wl''s in file = ',
     &			 FILNAM(1:LFIL),'.'
			WRITE (6,*) 'Increase MAXPWL in JZTOKZ.FOR.'
			GOTO 101
		ELSE
			NPWL=NPWL+1
			CALL PARSER (1,PWL(NPWL),ANS,INLIN)
			IF (ANS) GOTO 118
			CALL PARSER (2,X1,ANS,INLIN)
			IF (ANS) GOTO 118
			CALL PARSR2 (3,X2,1.0,ANS,INLIN)
			IF (ANS) GOTO 118
			PAQ(NPWL)=FAC*X1*X2
		ENDIF
	ENDIF
	GOTO 110
C
  118	WRITE (6,*) 'Error reading data in file = ',FILNAM(1:LFIL)
	WRITE (6,*) 'Bad line = ',INLIN(1:LNBLNK(INLIN))
	GOTO 101
C
C
  120	CLOSE (UNIT=2)
	IF (NPWL.EQ.0) THEN
		WRITE (6,*) 'No data in file = ',FILNAM(1:LFIL)
		GOTO 102
	ELSEIF (NPWL.EQ.1) THEN
		WRITE (6,*) 'Only one wavelenghth in file = ',
     &		 FILNAM(1:LFIL)
		GOTO 102
	ENDIF
C
C	ALLIGN WAVELENGTHS
C
	CALL PFALIN (ABSQY,NPWL,PWL,PAQ,NWL,WL)
C
C
C	CALCULATE PHOTKS FOR ALL Z'S.
C
	DO 130 IZ=1,NZS
	X=0.0
	DO 132 I=1,NWL
	X=X+SDIST(I,IZ)*ABSQY(I)
  132	PHOTKS(IZ,NPHOTK)=X*SDFAC
  130	CONTINUE
C
C	DONE WITH THIS PHOTK
C
	WRITE (6,138) PHOTNM(NPHOTK)(1:LNBLNK(PHOTNM(NPHOTK)))
     &	 ,PHOTKS(1,NPHOTK)
  138	FORMAT (1X,'Photk(',A,',Z0) =',1PE10.3)
	GOTO 100
C
C
C	ALL DATA INPUT.  OUTPUT .KZS DATA
C
  200	IF (ALL) THEN
		CLOSE (UNIT=1,STATUS='DELETE')
	ELSE
		CLOSE (UNIT=1)
	ENDIF
C
	IF (FMTOUT) THEN
		WRITE (3,3002) ZANG,(PHOTNM(I),(PHOTKS(IZ,I),IZ=1,NZS),
     &		 I=1,NPHOTK)
 3002		FORMAT (//'Phot File      ---------------------------',
     &           '----- Photolysis rate constants in units of /min --',
     &           '------------------------------'/10X,10F11.0/
     &           (A8,5X,1P10E11.3))
		WRITE (6,*) 'File = ',KZSFIL(1:LKZSFL),' created.'
	ELSE
		WRITE (3,201) NZS,ZANG
  201		FORMAT ('.'/I2,7X,7F10.0,:/(9X,7F10.0))
		DO 210 I=1,NPHOTK
  210		WRITE (3,212) PHOTNM(I),(PHOTKS(IZ,I),IZ=1,NZS)
  212		FORMAT (A8,1X,1P7E10.3,:/(9X,7E10.3))
		WRITE (6,*) 'File = ',KZSFIL(1:LKZSFL),'.KZS created.'
	ENDIF
	CLOSE (UNIT=3)
C
	IF (ERROR) THEN
		CALL EXIT (1)
	ELSE
		CALL EXIT (0)
	ENDIF
C
C
  810	WRITE (6,*) 'Unexpected <EOF> reading file = ',JZSFIL(1:LJZSFL)
	GOTO 899
  820	WRITE (6,*) 'Error reading header data from file = ',
     &   JZSFIL(1:LJZSFL)
	GOTO 899
  840	WRITE (6,*) 'Error reading data from file = ',JZSFIL(1:LJZSFL),
     &	 ' for NWL = ',NWL
  899	CALL EXIT (2)
	END
