	PROGRAM SUMCALC
C
C	** THIS VERSION FOR CALCS IN CDA FORMAT ONLY
C
C	SUMMARIZES RESULTS OF CALCULATIONS FOR STATISTICAL TABULATIONS
C	HOURLY DATA STARTING AT T=60 FOR MOST RUNS
C	DATA EVERY 100 MINUTES STARTING AT T=480 FOR UNC RUNS
C	UNC RUNS HAVE RUNIDS WITH FIRST 2 CHARACTERS GIVEN IN UNCCHR ARRAY
C
C	P1 = INPUT FILE GIVING LIST OF RUN ID'S
C	P2 = OUTPUT FILE
C	P3 = EXT FILE GIVING CALCNOS (MODEL)
C	P4+ = SPECIES FOR MAXIMUM
C
C
C	OUTTYP:	 0: MAX
C		-300: INITIAL (/I)
C		-200: FINAL (/F)
C		-400: AVERAGE (/A)
C		-500: INTEGRATED (/D)
C		-1: DAY 1 MAX
C		-2: DAY 2 MAX
C		>0: MAX TO HR.
C
	PARAMETER (MAXOUT=48)
	CHARACTER OUTNAM(MAXOUT)*8,OUTBUF*8,OUTLBL(MAXOUT)*10
	CHARACTER TITLE*56,OUTLIN*255
	INTEGER OUTTYP(MAXOUT)
	REAL OUTDAT(MAXOUT),OUTSAV(MAXOUT),OUTDT0(MAXOUT),
     &	 OUTTM0(MAXOUT)
	LOGICAL USED(MAXOUT),USEAVG,USETIT
	DATA USEAVG/.FALSE./,USETIT/.FALSE./
C
	CHARACTER*2 UNCCHR(12)/"JA","FB","MR","AP","MY","JN",
     &	 "JL","AU","ST","OC","NV","DE"/
C
	REAL NODATA/-9.99E9/
C
	PARAMETER (MAXLIS=6000)
	INTEGER LOCDAT(MAXLIS)
C
        PARAMETER (MAXCCH=1200)
        INTEGER NCHS
        REAL CX(MAXCCH)
	CHARACTER NAME(MAXCCH)*16
C
	LOGICAL APND
	CHARACTER CALUIC*40,MODEL*8,RUNID*8,INFILE*40,OUTFIL*40
	CHARACTER INLIN*250,FILNAM*60
C
C	GET OPTIONS
C
	CALL GETARG (1,INFILE)
	LINFIL=LNBLNK(INFILE)
	CALL GETARG (2,OUTFIL)
	LOUTFL=LNBLNK(OUTFIL)
	IF (LOUTFL.LT.3) LOUTFL=3
	CALL GETARG (3,MODEL)
	LMODEL=LNBLNK(MODEL)
	IF (INFILE(1:1).EQ.'?'.OR.INFILE(1:1).EQ.' '.OR.
     &	 OUTFIL(1:1).EQ.' '.OR.MODEL(1:1).EQ.' ') THEN
		WRITE (6,*) 'Outputs summary of model calculations of',
     &		 ' maximum conc''s for species in runs.'
		WRITE (6,*) 'Use SUMCALC infile outfile[/A] model',
     &		 ' spec1 [spec2 ... spec9] [TITLE]'
		WRITE (6,*) 'Spec = name   ... maximum'
		WRITE (6,*) 'Spec = name n ... Hourly to hour n'
		WRITE (6,*) 'Spec = name/n ... maximum to day n'
		WRITE (6,*) 'Spec = name/I ... initial value'
		WRITE (6,*) 'Spec = name/F ... final value'
		WRITE (6,*) 'Spec = name/A ... average value'
		WRITE (6,*) 'Spec = name/D ... integrated value (dose)'
		WRITE (6,*) 'Spec = name-n ... value at hour n'
		WRITE (6,*) 'Spec = O3DAT[n] ... hourly',
     &		 ' O3 to hour n (dflt=6)'
		WRITE (6,*) 'TITLE = Output title also.'
		WRITE (6,*) 'Spec = RCT[n] ... day 1 maxO3 and hourly',
     &		 ' D(O3-NO) to hour n (dflt=6)'
		WRITE (6,*) 'NOTE: For UNC runs (first 2 char=month i'
     &		 //'d) "hourly" is every 100 minutes'
		WRITE (6,*) '      starting at t=480,'
		WRITE (6,*) '"-n" for input file means use last n calcs.'
C     &		 ' d(O3-NO)/dt to hour n (dflt=6)'
		CALL EXIT
	ENDIF
C
C	GET LIST OF SPECIES
C
	I=1
	NOUT=1
    5	CALL GETARG (I+3,OUTLBL(NOUT))
	LLBL=LNBLNK(OUTLBL(NOUT))
	IF (OUTLBL(NOUT)(1:1).EQ.' ') THEN
		IF (NOUT.EQ.1) THEN
			WRITE (6,*) 'No species listed'
			CALL EXIT
		ENDIF
		NOUT=NOUT-1
		GOTO 6
	ENDIF
	IF (OUTLBL(NOUT)(1:3).EQ.'RCT') THEN
		IF (OUTLBL(NOUT)(4:4).EQ.' ') THEN
			NRCT=6
		ELSEIF (OUTLBL(NOUT)(5:5).EQ.' ') THEN
			READ (OUTLBL(NOUT)(4:4),'(I1)',ERR=1005) NRCT
		ELSE
			READ (OUTLBL(NOUT)(4:5),'(I2)',ERR=1005) NRCT
		ENDIF
		GOTO 1006
 1005		NRCT=6
 1006		IF (NRCT.LE.0) NRCT=6
		IF (NOUT+NRCT.GT.MAXOUT) THEN
			WRITE (6,*) 'Increase MAXOUT'
			CALL EXIT
		ENDIF
		OUTNAM(NOUT)='O3      '
		OUTTYP(NOUT)=-1
		OUTLBL(NOUT)='O3 (day1) '
		DO 7 J=1,NRCT
		OUTNAM(NOUT+J)='D(O3-NO)'
		OUTTYP(NOUT+J)=J
		IF (J.LT.10) THEN
			WRITE (OUTLBL(NOUT+J),'(I1,''-D(O3-NO)'')') J
		ELSE
			WRITE (OUTLBL(NOUT+J),'(I2,''-D(O3-NO)'')') J
		ENDIF
    7		CONTINUE
		NOUT=NOUT+NRCT
	ELSEIF (OUTLBL(NOUT)(1:5).EQ.'O3DAT') THEN
		IF (OUTLBL(NOUT)(6:6).EQ.' ') THEN
			NRCT=6
		ELSEIF (OUTLBL(NOUT)(7:7).EQ.' ') THEN
			READ (OUTLBL(NOUT)(6:6),'(I1)',ERR=1015) NRCT
		ELSE
			READ (OUTLBL(NOUT)(6:7),'(I2)',ERR=1015) NRCT
		ENDIF
		GOTO 1016
 1015		NRCT=6
 1016		IF (NRCT.LE.0) NRCT=6
		IF (NOUT+NRCT.GT.MAXOUT) THEN
			WRITE (6,*) 'Increase MAXOUT'
			CALL EXIT
		ENDIF
		DO 1017 J=1,NRCT
		OUTNAM(NOUT+J-1)='O3      '
		OUTTYP(NOUT+J-1)=J
 1017		WRITE (OUTLBL(NOUT+J-1),'('' O3-'',I2,4X)') J
		NOUT=NOUT+NRCT-1
	ELSEIF (OUTLBL(NOUT)(1:6).EQ.'TITLE '.OR.
     &	 OUTLBL(NOUT)(1:6).EQ.'title ') THEN
		USETIT=.TRUE.
		NOUT=NOUT-1
		GOTO 6
	ELSEIF (LLBL.GT.2) THEN
		IF (OUTLBL(NOUT)(LLBL-1:LLBL).EQ.'/I') THEN
			OUTNAM(NOUT)=OUTLBL(NOUT)
			OUTNAM(NOUT)=OUTLBL(NOUT)(1:LLBL-2)
			OUTTYP(NOUT)=-300
		ELSEIF (OUTLBL(NOUT)(LLBL-1:LLBL).EQ.'/F') THEN
			OUTNAM(NOUT)=OUTLBL(NOUT)
			OUTNAM(NOUT)=OUTLBL(NOUT)(1:LLBL-2)
			OUTTYP(NOUT)=-200
		ELSEIF (OUTLBL(NOUT)(LLBL-1:LLBL).EQ.'/A') THEN
			OUTNAM(NOUT)=OUTLBL(NOUT)
			OUTNAM(NOUT)=OUTLBL(NOUT)(1:LLBL-2)
			OUTTYP(NOUT)=-400
			USEAVG=.TRUE.
		ELSEIF (OUTLBL(NOUT)(LLBL-1:LLBL).EQ.'/D') THEN
			OUTNAM(NOUT)=OUTLBL(NOUT)
			OUTNAM(NOUT)=OUTLBL(NOUT)(1:LLBL-2)
			OUTTYP(NOUT)=-500
			OUTSAV(NOUT)=0.
		ELSEIF (OUTLBL(NOUT)(LLBL-1:LLBL-1).EQ.'/') THEN
			READ (OUTLBL(NOUT)(LLBL:LLBL),'(Z1)',ERR=820)
     &			 OUTTYP(NOUT)
			OUTTYP(NOUT)=-OUTTYP(NOUT)
			OUTNAM(NOUT)=OUTLBL(NOUT)(1:LLBL-2)
		ELSEIF (OUTLBL(NOUT)(LLBL-1:LLBL-1).EQ.'-') THEN
			READ (OUTLBL(NOUT)(LLBL:LLBL),'(Z1)',ERR=820)
     &			 OUTTYP(NOUT)
			OUTNAM(NOUT)=OUTLBL(NOUT)(1:LLBL-2)
		ELSE
			OUTNAM(NOUT)=OUTLBL(NOUT)(1:MIN0(LLBL,8))
			OUTTYP(NOUT)=0
		ENDIF
	ELSEIF (NOUT.GT.1) THEN
		J=INTVAL(OUTLBL(NOUT))
		IF (J.GT.0) THEN
			NM=NOUT-1
			NM0=NM-1
			NOUT=NM0+J
			IF (NOUT.GT.MAXOUT) STOP 'INCREASE MAXOUT'
			OUTTYP(NM)=1
			IF (J.GT.1) THEN
				DO 1201 JJ=2,J
				IF (JJ.LT.10) THEN
					WRITE (OUTLBL(NM0+JJ),'(I1)') JJ
				ELSE
					WRITE (OUTLBL(NM0+JJ),'(I2)') JJ
				ENDIF
				OUTNAM(NM0+JJ)=OUTNAM(NM)
 1201				OUTTYP(NM0+JJ)=JJ
			ENDIF
			GOTO 6
		ELSE
 			OUTNAM(NOUT)=OUTLBL(NOUT)(1:LLBL)
 			OUTTYP(NOUT)=0
		ENDIF
	ELSE
		OUTNAM(NOUT)=OUTLBL(NOUT)(1:LLBL)
		OUTTYP(NOUT)=0
	ENDIF
	IF (I.LT.MAXOUT.AND.NOUT.LT.MAXOUT) THEN
		I=I+1
		NOUT=NOUT+1
		GOTO 5
	ENDIF
    6	CONTINUE
C
C	GET CALC UIC
C
	CALUIC='.\'
	OPEN (UNIT=1,FILE='MODELING.PRM',STATUS='UNKNOWN')
   10	READ (1,1,END=11) INLIN
    1	FORMAT (A)
	IF (INLIN(1:4).EQ.'CAL=') THEN
		CALUIC=INLIN(5:)
	ENDIF
	GOTO 10
   11	CLOSE (UNIT=1)
C
C	APPEND MODELSET NAME TO CALC UIC
C
	LCALUC=LNBLNK(CALUIC)
	CALUIC=CALUIC(1:LCALUC)//MODEL(1:LMODEL)//'\'
	LCALUC=LCALUC+LMODEL+1
C
C	OPEN INPUT FILE FOR RUN ID'S
C	OPEN AND INITIALIZE OUTPUT FILE
C
	OPEN (UNIT=1,FILE=INFILE,STATUS='OLD',ERR=800)
C
  90	APND=OUTFIL(LOUTFL-1:LOUTFL).EQ.'/A'
	IF (APND) THEN
		OUTFIL=OUTFIL(1:LOUTFL-2)
		OPEN (UNIT=2,FILE=OUTFIL,STATUS='UNKNOWN',ACCESS='APPEND')
		WRITE (2,*)
	ELSE
		OPEN (UNIT=2,FILE=OUTFIL,STATUS='UNKNOWN')
	ENDIF
	CALL TMARK(INLIN)
	WRITE (2,14) MODEL(1:LMODEL),INLIN(1:16),
     &	 (OUTLBL(I)(1:LNBLNK(OUTLBL(I))),I=1,NOUT)
  14	FORMAT ('Model = ',A,'.  File created ',A//'RunID,Msg',
     &   99(',',A))
C
C	READ NEXT RUN
C
  100	READ (1,1,END=900) INLIN
	IF (INLIN(1:1).EQ.'!') GOTO 100
	IF (INLIN(1:1).EQ.' ') THEN
		WRITE (2,*)
		GOTO 100
	ELSEIF (INLIN(1:7).EQ.'INTRUN ') THEN
		CALL PARSE0 (2,INLIN,80)
		CALL PARSE1 (2,RUNID,LRUNID,8,INLIN)
	ELSE
		CALL PARSE0 (1,INLIN,80)
		CALL PARSE1 (1,RUNID,LRUNID,8,INLIN)
	ENDIF
C
C	OPEN CALC FILE
C
	FILNAM=CALUIC(1:LCALUC)//RUNID(1:LRUNID)//'.CDA'
	OPEN (UNIT=3,FILE=FILNAM,STATUS='OLD',ERR=113)
	GOTO 114
  113	WRITE (6,*) 'File = ',FILNAM(1:LCALUC+LRUNID+4),
     &	 ' does not exist.'
	WRITE (2,'(A)') RUNID(1:LRUNID)//',NoCSV'
	GOTO 100
  114	CONTINUE
C
C	READ HEADERS
C
  122	READ (3,'(2X,I5,45X,A)',ERR=832) NCHS,TITLE
	IF (NCHS.GT.MAXCCH) THEN
		WRITE (6,*) 'Too many channels (',NCHS,') for calc ',
     &		 RUNID(1:LRUNID)
		WRITE (6,*) 'INCREASE MAXCCH'
		CALL EXIT
	ENDIF
	READ (3,'(8A11)') (NAME(I),I=1,NCHS)
C
C	DETERMINE IF UNC RUN
C
	IT0=0
	IDT=60
	DO 1321 I=1,12
	IF (RUNID(1:2).EQ.UNCCHR(I)) THEN
		IT0=380
		IDT=100
		GOTO 1322
	ENDIF
 1321	CONTINUE
 1322	CONTINUE
C
C	LOCATE CHANNELS	OF INTEREST
C
	DO 130 I=1,NOUT
	DO 132 J=1,NCHS
	IF (NAME(J)(1:8).EQ.OUTNAM(I)) THEN
		LOCDAT(I)=J
		GOTO 131
	ENDIF
  132	LOCDAT(I)=0
  131	CONTINUE
	USED(I)=.FALSE.
	OUTDT0(I)=NODATA
  130	OUTDAT(I)=NODATA
C
C	READ FIRST RECORD
C
	NT=0
	READ (3,2111,ERR=148,END=148) TIM,(CX(I),I=1,NCHS)
 2111	FORMAT (F10.2/(1PE10.3,7E11.3))
	IF (TIM.LT.-1.0E+10) GOTO 148
	TIM=0.
	TIM0=0.
	GOTO 141
C
C	READ NEXT RECORD
C
  140	READ (3,2111,ERR=148,END=148) TIM,(CX(I),I=1,NCHS)
	IF (TIM.LT.-1.0E+10) GOTO 148
C
  141	NT=NT+1
	DO 142 I=1,NOUT
	IF (USED(I)) GOTO 142
	IF (LOCDAT(I).NE.0) THEN
		F=CX(LOCDAT(I))
		IF (OUTTYP(I).EQ.0) THEN
			IF (F.GT.OUTDAT(I)) OUTDAT(I)=F
		ELSEIF (OUTTYP(I).EQ.-200) THEN
			OUTDAT(I)=F
		ELSEIF (OUTTYP(I).EQ.-300) THEN
			IF (NT.EQ.1.) OUTDAT(I)=F
		ELSEIF (OUTTYP(I).EQ.-400) THEN
			IF (NT.EQ.1) THEN
				OUTDAT(I)=F
			ELSE
				OUTDAT(I)=OUTDAT(I)+F
			ENDIF
		ELSEIF (OUTTYP(I).EQ.-500) THEN
			IF (NT.EQ.1) THEN
				OUTSAV(I)=F
				OUTDAT(I)=0.
			ELSE
				OUTDAT(I)=OUTDAT(I)+
     &				 0.5*(TIM-TIM0)*(F+OUTSAV(I))
				OUTSAV(I)=F
			ENDIF
		ELSEIF (OUTTYP(I).LT.0) THEN
			IF (TIM.GE.1440.*FLOAT(-OUTTYP(I))) THEN
				USED(I)=.TRUE.
			ELSE
				IF (F.GT.OUTDAT(I)) OUTDAT(I)=F
			ENDIF
		ELSE
			TCHK=FLOAT((IT0+(IDT*OUTTYP(I))))
			IF (TIM.GE.TCHK) THEN
				USED(I)=.TRUE.
				IF (TIM.EQ.TCHK) THEN
				    IF (OUTLBL(I)(1:4).EQ.'D/DT') THEN
					OUTDAT(I)=1000.*F/TIM
				    ELSE
					OUTDAT(I)=F
				    ENDIF
				ELSEIF (OUTDT0(I).NE.NODATA) THEN
				    F=YINTERP(TCHK,OUTTM0(I),OUTDT0(I),
     &				     TIM,F)
				    IF (OUTLBL(I)(1:4).EQ.'D/DT') THEN
					OUTDAT(I)=1000.*F/TIM
				    ELSE
					OUTDAT(I)=F
				    ENDIF
				ENDIF
			ENDIF
			OUTTM0(I)=TIM
			OUTDT0(I)=F
		ENDIF
	ENDIF
  142	CONTINUE
	TIM0=TIM
	GOTO 140
  148	CLOSE (UNIT=3)
C
C	FINAL PROCESSING
C
	IF (USEAVG.AND.NT.GT.1) THEN
		F=1./FLOAT(NT)
		DO 143 I=1,NOUT
		IF (USED(I)) GOTO 143
		IF (OUTTYP(I).EQ.-400) OUTDAT(I)=F*OUTDAT(I)
  143		CONTINUE
	ENDIF
C
C	FORMAT DATA
C
	OUTLIN=RUNID(1:LRUNID)//','
	DO 150 I=1,NOUT
	IF (OUTDAT(I).EQ.NODATA) THEN
		OUTLIN=OUTLIN//','
	ELSE
		CALL FMTOU4(OUTBUF,OUTDAT(I))
		OUTLIN=OUTLIN(1:LNBLNK(OUTLIN))//','//OUTBUF
	ENDIF
  150	CONTINUE
C
C	OUTPUT DATA
C
	IF (USETIT) THEN
		WRITE (2,1) OUTLIN(1:LNBLNK(OUTLIN))//','//TITLE(1:LNBLNK(TITLE))
	ELSE
		WRITE (2,1) OUTLIN(1:LNBLNK(OUTLIN))
	ENDIF
	GOTO 100
C
C	DONE
C
  900	CLOSE (UNIT=1)
	CLOSE (UNIT=2)
	IF (APND) THEN
		WRITE (6,*) 'Appended to file = ',OUTFIL(1:LOUTFL)
	ELSE
		WRITE (6,*) 'File = ',OUTFIL(1:LOUTFL),' created.'
	ENDIF
	CALL EXIT
C
C	ERRORS
C
  800	WRITE (6,*) 'File = ',INFILE(1:LINFIL),' does not exist'
	GOTO 890
  820	WRITE (6,*) 'Unrecongnized option: ',OUTLBL(I)(1:J)
	GOTO 890
  832	WRITE (6,*) 'ERROR IN READING LABEL'
	GOTO 839
  834	WRITE (6,*) 'ERROR IN READING NAMES'
  839	WRITE (6,*) 'Calc file = ',FILNAM(1:LNBLNK(FILNAM)),
     &	 '; Calc ID = ',RUNID(1:LRUNID)
	WRITE (2,'(A)') RUNID(1:LRUNID),',BadCSV'
	GOTO 100
  890	CALL EXIT
	END
C
	FUNCTION INTVAL(CHARIN)
	CHARACTER*10 CHARIN
	LB=LNBLNK(CHARIN)
	IF (LB.EQ.1) THEN
		READ (CHARIN,'(I1)',ERR=9) INTVAL
	ELSEIF (LB.EQ.2) THEN
		READ (CHARIN,'(I2)',ERR=9) INTVAL
	ELSE
		INTVAL=0
	ENDIF
	RETURN
    9	INTVAL=0
	RETURN
	END
