	PROGRAM DMSRCT
C
C	SUMMARIZES REACTIVITIES FOR DETAILED MODEL SPECIES.
C	PROCESSES MIXTURES USING DMS REACTIVITY DATA
C	GETS SCENID FROM COMMAND LINE
C	GETS REACTIVITY DATA FROM SCENID.CLC
C	GETS FR-KOH'S FROM SCENID.BAS
C	GETS DMS LIST, NC'S, ETC. FROM [DMSFIL]
C	GETS [DMSFIL] FROM MODELING.PRM
C	USES .LPC FILE SPECIFIED BY RCTLPC= INPUT IN MODELING.PRM
C	GETS [MECUIC] FROM MODELING.PRM
C	GETS [RCTUIC] FROM MODELING.PRM
C	GETS [CMPUIC] FROM MODELING.PRM
C	GETS MECHANISTIC PARAMETERS AND "LUMPED MOLECULE" ASSIGNMENTS
C	FROM LUMPING CONTROL FILES.
C
C	P1 = SCENID
C	[P2] = OPTION.  
C	[P3] = SECOND OPTION
C		OPTIONS IMPLEMENTED:
C		"NOP":  PARAMETER REACTIVITIES NOT USED.  ONLY DMS IN
C			.CLC FILE OUTPUST.
C		"DOSE":  .RCT AND .CLC FILES IN DOSRCT= AND DOSCLC=
C			 DIRECTORIES
C		"USE=type outname":  READ .RCD FILE TO GET REACTIVITY DATA
C			FOR MEASUREMENT TYPE.  IF MULTIPLIED BY A FACTOR,
C			FACTOR GIVEN IN MODELING.PRM AS "FAC=type fac"
C			outname is output file name, which can't be scenid.
C		"OUT=output scenid": Use different name for output .RCT file
C		"NOADJ": Ignore "adjusted product" reactivities. Must give .RCT
C			file name to use (use with OUT= or USE=)
C			non-blank character at 101 in .CLC file or non-zero mwt
C			in .CLD file used to indicate "adjusted product" mechanism.
C		"NOCMP": Force use of explicltly calculated mixtures
C
C	OUTPUTS KR'S, MR'S AND REACTIVITIES IN [RCTUIC]SCENID.RCT
C	DOES NOT OUTPUT DMS'S WITH NO DATA.
C
C	(BOTH EXPLICIT AND -- FOR ALKAROS -- CALCULATED)
C
C
C	FOLLOWING ARE TYPES EXPECTED IN .CLD FILES:
C
	PARAMETER (NTYP=5,INDIOH=3)
	CHARACTER TYPLIS(NTYP)*8
	DATA TYPLIS /'O3max   ','IntO3   ','IntOH   ','PANmax  ',
     &	 'H2O2max '/
	LOGICAL USECOR(NTYP),CHANGE,FOUND
	DATA USECOR /.FALSE.   ,.FALSE.   ,.FALSE.   ,.FALSE.
     &	 ,.FALSE./
C
C
C	DATA READ FROM LUMPING CONTROL FILE
C
	INCLUDE 'LUMPSPEC.FOR'
C
C	DMS DATA FROM DMS.PRM
C
	INTEGER*2 NDMS,DMSNC(MAXDMS)
	CHARACTER*8 DMSNAM(MAXDMS)
	REAL*4 DMSMW(MAXDMS)
	LOGICAL ISMIX(MAXDMS)
C
C	DMS REACTIVITY DATA
C
	LOGICAL*1 EMRDFD(MAXDMS),CMRDFD(MAXDMS)
	REAL*4 EXPLMR(MAXDMS),CALCMR(MAXDMS),EXPLIR(MAXDMS)
C
C	MECHANISTIC PARAMETERS
C
	PARAMETER (MAXPMK=3)
	CHARACTER PRMKID(MAXPMK)*4,PRMTYP(MXAAPM)*1
	CHARACTER PRMOUT(MXAAPM,MAXPMK)*8
	REAL*4 PRMMR(MXAAPM,MAXPMK),PRMKOH(MAXPMK)
C	DATA PRMKOH/3.0E+3,3.0E+4,1.0E+5/ LOGS USED
	DATA PRMKOH/8.0064,10.309,11.513/
	DATA PRMKID/'.3.0','.30.','.100'/
C
C	USED FOR CALCULATING FRACTION REACTED FOR OH REACTIONS
C
	PARAMETER (MAXIOH=8)
	REAL*4 IOHKOH(MAXIOH),IOHI(MAXIOH)
C
C	WORK ARRAYS
C
	CHARACTER INLIN*132,FILNAM*80,SCENID*8,CLCUIC*60,
     &	 BASUIC*60,RCTUIC*60,DMSFIL*60,USENAM*8,OUTNAM*32,NAMEIN*8
	CHARACTER LPCFIL*40,CLCCHK*8,RCTCHK*8,FMT*8,NAME2*8
	INTEGER NMIX,MIXIND(MAXDMS)
	LOGICAL USECMP
	REAL MIXWT(MAXDMS)
C
	PARAMETER (MAXT=120)
	REAL CBUF1(MAXT),CBUF2(MAXT),UMIN
C
	REAL*4 NODATA,USEFAC,MAXMR
	PARAMETER (NODATA=-9.99E+9)
	LOGICAL NOPRM,USECLD,ERRIND,DATAIN,NOBASE,USECHM,USEOUT,NOADJ
	CHARACTER CMPUIC*60
C
C
C	GET SCENID FROM COMMAND LINE
C
	CALL GETARG (1,SCENID)
	IF (SCENID(1:1).EQ.' ') THEN
		WRITE (6,*) 'Use:  DMSRCT scenid [option]'
		WRITE (6,*) '(option = "PRM":  Parameters used.)'
		WRITE (6,*) '(option = "NOCMP": Force use of explici',
     &		 'tly calculated mixtures'
		WRITE (6,*) '(option = "USE=type outname":  Use reac',
     &		 'tivity relative to type, output to'
		WRITE (6,*) '          file = "outname.RCT".  E.g., ',
     &		 '"type" could be IntOH or PANmax.'
		CALL EXIT (2)
	ENDIF
	LSCNID=LNBLNK(SCENID)
	CALL GETARG (2,FILNAM)
C
	CLCCHK='CLC='
	LCLCCK=4
	RCTCHK='RCT='
	LRCTCK=4
	NOPRM=.FALSE.
	USENAM=' '
	LUSENM=1
	USECLD=.FALSE.
	USECHM=.FALSE.
	USEOUT=.FALSE.
	NOADJ=.FALSE.
	USECMP=.TRUE.
C
	L=0
    2	IF (FILNAM(1:3).EQ.'NOP') THEN
		NOPRM=.TRUE.
	ELSEIF (FILNAM(1:5).EQ.'DOSE ') THEN
		CLCCHK='DOSCLC='
		LCLCCK=7
		RCTCHK='DOSRCT='
		LRCTCK=7
	ELSEIF (FILNAM(1:4).EQ.'USE='.AND.FILNAM(5:5).NE.' ') THEN
		USENAM=FILNAM(5:)
		LUSENM=LNBLNK(USENAM)
C
		IF (USENAM(1:3).EQ.'8HR') THEN
			IUSE=-1
			USECLD=.TRUE.
			USENAM='8-Hr Avg'
		ELSEIF (USENAM(1:1).EQ.'.'.OR.USENAM(1:2).EQ.'0.') THEN
			IUSE=0
			UMIN=REALV(USENAM,LUSENM,ERRIND)
			IF (ERRIND) GOTO 901
			USECLD=.TRUE.
			IF (LUSENM.LE.5) THEN
				NAMEIN='O3>'//USENAM(1:5)
				USENAM=NAMEIN
			ENDIF
		ELSEIF (USENAM.EQ.'CHAM-IOH') THEN
			USECHM=.TRUE.
			USENAM=TYPLIS(INDIOH)
			IUSE=INDIOH
		ELSE
			DO 3 I=1,NTYP
			IF (USENAM.EQ.TYPLIS(I)) THEN
				IUSE=I
				USECLD=.TRUE.
				GOTO 4
			ENDIF
    3			CONTINUE
			GOTO 901
    4			CONTINUE
		ENDIF
C
		IF (.NOT.USEOUT) THEN
			CALL PARSE1 (3+L,OUTNAM,LOUTNM,32,INLIN)
			IF (OUTNAM(1:1).EQ.' ') THEN
				WRITE (6,*) 'Must give distinct output file',
     &			 ' name with USE option'
				CALL EXIT (2)
			ENDIF
			USEOUT=.TRUE.
			L=L+1
		ENDIF
	ELSEIF(FILNAM(1:4).EQ.'OUT=') THEN
		OUTNAM=FILNAM(5:)
		LOUTNM=LNBLNK(OUTNAM)
		USEOUT=.TRUE.
	ELSEIF (FILNAM(1:5).EQ.'NOADJ') THEN
		NOADJ=.TRUE.
	ELSEIF (FILNAM(1:1).EQ.' ') THEN
		L=1
	ELSEIF (FILNAM(1:5).EQ.'NOCMP') THEN
		USECMP=.FALSE.
	ELSE
		WRITE (6,*) 'Unrecognized option: ',FILNAM(1:J)
		CALL EXIT (2)
	ENDIF
	IF (L.EQ.0) THEN
		L=1
		CALL PARSE1 (3,FILNAM,J,40,INLIN)
		GOTO 2
	ENDIF
	IF (NOADJ) THEN
		IF (.NOT.USEOUT) THEN
			WRITE (6,*) 'Must give distinct output file',
     &			 ' name with NOADJ option'
			CALL EXIT (2)
c		ELSEIF (USECLD) THEN
c			WRITE (6,*) 'Use of NOADJ with CLD file input is not',
c     &		 ' currently supported.'
c			CALL EXIT (2)
		ENDIF
	ENDIF
C
C	GET [MECUIC], ETC. FROM MODELING.PRM
C
	MECUIC=' '
	CLCUIC=' '
	LCLCUC=0
	BASUIC=' '
	LBASUC=0
	LPCFIL=' '
	LLPCFL=0
	RCTUIC=' '
	LRCTUC=0
	CMPUIC=' '
	LMIXUC=0
	DMSFIL='DMS.PRM'
	USEFAC=1.0
	LDMSFL=7
C
	OPEN (UNIT=1,FILE='MODELING.PRM',STATUS='UNKNOWN')
   10	READ (1,1,END=12) INLIN
  1	FORMAT (A)
	L=LNBLNK(INLIN)
	IF (INLIN(1:5).EQ.'MECH=') THEN
		IF (L.GT.0) MECUIC=INLIN(6:L)
	ELSEIF (INLIN(1:LCLCCK).EQ.CLCCHK(1:LCLCCK)) THEN
		LCLCUC=L-LCLCCK
		IF (L.GT.0) CLCUIC=INLIN(LCLCCK+1:L)
	ELSEIF (INLIN(1:4).EQ.'BAS='.OR.INLIN(1:4).EQ.'CLC=') THEN
		LBASUC=L-4
		IF (L.GT.0) BASUIC=INLIN(5:L)
	ELSEIF (INLIN(1:7).EQ.'RCTLPC=') THEN
		LLPCFL=L-7
		IF (L.GT.7) THEN
			LPCFIL=INLIN(8:L)
		ELSE
			LPCFIL=' '
		ENDIF
	ELSEIF (INLIN(1:LRCTCK).EQ.RCTCHK) THEN
		LRCTUC=L-LRCTCK
		IF (L.GT.LRCTCK) THEN
			RCTUIC=INLIN(LRCTCK+1:L)
		ELSE
			RCTUIC=' '
		ENDIF
	ELSEIF (INLIN(1:4).EQ.'DMS='.OR.INLIN(1:4).EQ.'VOC=') THEN
		LDMSFL=L-4
		IF (L.GT.4) THEN
			DMSFIL=INLIN(5:L)
		ELSE
			DMSFIL=' '
		ENDIF
	ELSEIF (USECLD.OR.USECHM) THEN
		IF (INLIN(1:4+LUSENM).EQ.'FAC='//USENAM(1:LUSENM)) THEN
			CALL PARSE0 (2,INLIN,80)
			CALL PARSR2 (2,USEFAC,1.0,ERRIND,INLIN)
			IF (ERRIND.OR.USEFAC.EQ.0.0) THEN
				WRITE (6,*) 'Bad line in MODELING.PRM ',
     &				 '= ',INLIN(1:LNBLNK(INLIN))
				CALL EXIT (2)
			ENDIF
		ENDIF
	ELSEIF (INLIN(1:4).EQ.'CMP=') THEN
		LCMPUC=L-4
		IF (L.GT.0) THEN
			CMPUIC=INLIN(5:L)
		ELSE
			CMPUIC=' '
		ENDIF
	ENDIF
	GOTO 10
   12	CLOSE (UNIT=1)
C
C	DEFAULT BASUIC IS CLCUIC
C
	IF (LBASUC.EQ.0.AND.LCLCUC.NE.0) THEN
		BASUIC=CLCUIC
		LBASUC=LCLCUC
	ENDIF
C
C
C	READ DMS DATA FROM DMS.PRM
C
	OPEN (UNIT=1,FILE=DMSFIL(1:LDMSFL),STATUS='OLD',ERR=902)
C
   20	READ (1,1) INLIN
	IF (INLIN(1:1).NE.'.') GOTO 20
C
	NDMS=0
	NMIX=0
   22	READ (1,1,END=28) INLIN
	IF (INLIN(1:1).EQ.'!'.OR.
     &	 (INLIN(1:1).EQ.' '.OR.INLIN(1:1).EQ.'	')) GOTO 22
	NDMS=NDMS+1
	IF (NDMS.GT.MAXDMS) STOP 'INCREASE MAXDMS'
	READ (INLIN,'(A8,2X,I4,1X,F8.2,12X,A4)') DMSNAM(NDMS),DMSNC(NDMS),
     &	 DMSMW(NDMS),NAMEIN
	IF (DMSNC(NDMS).EQ.0.OR.DMSMW(NDMS).EQ.0.0) THEN
		NDMS=NDMS-1
		GOTO 22
	ENDIF
	EMRDFD(NDMS)=.FALSE.
	CMRDFD(NDMS)=.FALSE.
	IF (USECMP.AND.NAMEIN(1:4).EQ.'Mix ') THEN
		ISMIX(NDMS)=.TRUE.
		IF (DMSNC(NDMS).EQ.1) THEN
			NMIX=NMIX+1
			MIXIND(NMIX)=NDMS
		ENDIF
	ELSE
		ISMIX(NDMS)=.FALSE.
	ENDIF
	GOTO 22
C
   28	CLOSE (UNIT=1)
	NDMS0=NDMS
C
C
C	READ .BAS AND GET INTOH'S AT EACH K.
C	BYPASS IF PARMS NOT USED.
C
	IF (NOPRM) GOTO 39
C
	NIOH=0
	LFIL=LBASUC+LSCNID
	IF (LBASUC.NE.0) THEN
		FILNAM=BASUIC(1:LBASUC)
		FILNAM(LBASUC+1:LFIL)=SCENID(1:LSCNID)
	ELSE
		FILNAM=SCENID(1:LSCNID)
	ENDIF
	LFIL=LFIL+4
	FILNAM(LFIL-3:LFIL)='.BAS'
	OPEN (UNIT=2,FILE=FILNAM,STATUS='OLD',ERR=39)
C
  35	READ (2,1,END=37) INLIN
	IF (INLIN(1:6).EQ.'FR-KOH') THEN
		IF (NIOH.EQ.MAXIOH) THEN
			WRITE (6,*) 'TOO MANY FR-KOH INPUTS IN ',
     &			 '.BAS FILE'
			GOTO 910
		ELSEIF (NIOH.GT.0) THEN
			IF (IOHKOH(NIOH).LE.IOHKOH(NIOH-1)) THEN
				WRITE (6,*) 'FR-KOH INPUTS IN .BAS',
     &				 ' FILE OUT OF ORDER.'
				GOTO 910
			ENDIF
		ENDIF
		NIOH=NIOH+1
		READ (INLIN,'(6X,E10.2,F9.5)',ERR=910) IOHKOH(NIOH),
     &		 IOHI(NIOH)
		IF (IOHKOH(NIOH).LE.0.0.OR.IOHI(NIOH).GT.1.0) GOTO 910
		IF (IOHI(NIOH).EQ.1.0) THEN
			IOHI(NIOH)=-1.0
		ELSE
			IOHI(NIOH)=-ALOG(1.0-IOHI(NIOH))/IOHKOH(NIOH)
		ENDIF
	ENDIF
	GOTO 35
  37	CLOSE (UNIT=2)
	IF (NIOH.EQ.0) THEN
		WRITE (6,*) 'FR-KOH not defined in ',FILNAM(1:LFIL)
		GOTO 990
	ENDIF
C
   39	CONTINUE
C
C
C	OPEN SCENID.CLC FILE.  (OPENED HERE TO BE SURE ALL INPUT
C	FILES EXIST BEFORE TAKING THE TIME TO READ THE .LPC FILE)
C
	LFIL=LCLCUC+LSCNID
	IF (LCLCUC.NE.0) THEN
		FILNAM=CLCUIC(1:LCLCUC)
		FILNAM(LCLCUC+1:LFIL)=SCENID(1:LSCNID)
	ELSE
		FILNAM=SCENID(1:LSCNID)
	ENDIF
	LFIL=LFIL+4
	IF (USECLD) THEN
		FILNAM(LFIL-3:LFIL)='.CLD'
	ELSE
		FILNAM(LFIL-3:LFIL)='.CLC'
	ENDIF
	OPEN (UNIT=2,FILE=FILNAM,STATUS='OLD',ERR=900)
	DATAIN=.FALSE.
CN
C
C	READ .LPC FILE TO GET MECHANISTIC PARAMETER DATA.
C	BYPASS IF PARMS NOT USED.
C	(DON'T COMPUTE T-DEPENDENT K'S)
C
	IF (NOPRM) THEN
		NAPRM=0
		GOTO 49
	ELSEIF (LLPCFL.EQ.0) THEN
		NOPRM=.TRUE.
		NAPRM=0
		GOTO 49
	ENDIF
C
	FILNAM=LPCFIL(1:LLPCFL)
	LFIL=LLPCFL+4
	FILNAM(LLPCFL+1:LFIL)='.LPC'
	OPEN (UNIT=1,FILE=FILNAM,STATUS='OLD',ERR=900)
C
	THIGH=0.0
	TLOW=0.0
	CALL RDLUMP (-1,3,0)
C
C	INITIALIZE PARM TYPE ID'S, AND PARM REACTIVITIES
C
	NAPRM=0
	DO 32 I=1,NAAPRM
	IF (AAPRKI(I)) THEN
		IF (NAPRM.EQ.0) NAPRM=I-1
		GOTO 32
	ENDIF
	PRMTYP(I)=' '
	DO 33 J=1,MAXPMK
   33	PRMMR(I,J)=NODATA
   32	CONTINUE
	IF (NAPRM.EQ.0) NAPRM=NAAPRM
C
	MAXMR=0.0
C
C
C	DEFINE REACTIVITIES FOR "INERT", "NROG", AND "LOST"
C	SPECIES, IF ON DMS LIST.
C
	DO 34 I=1,NDMS
	IF (DMSNAM(I).EQ.'INERT   '.OR.DMSNAM(I).EQ.'NROG    '
     &	 .OR.DMSNAM(I).EQ.'LOST     ') THEN
		EXPLIR(I)=0.0
		EXPLMR(I)=0.0
		EMRDFD(I)=.TRUE.
	ENDIF
  34	CONTINUE
C
  49	CONTINUE
C
C
C	READ SCENID.CLC AND GET REACTIVITIES FOR DMS AND PARMS. 
C	IGNORE ENTRIES FOR SPECIES WHICH ARE NOT DMS'S.
C
	NOBASE=.TRUE.
	CORFAC=1.0
 40	READ (2,1,END=48) INLIN
	IF (INLIN(1:1).EQ.'!') GOTO 40
	IF (INLIN(1:1).EQ.' ') GOTO 40
	IF (USECLD) THEN
		IF (INLIN(1:5).EQ.'BASE ') THEN
			IF (.NOT.NOBASE) WRITE (6,*) 'Warning: more ',
     &			 'than one BASE input in .CLD file.'
			NOBASE=.FALSE.
			IF (IUSE.EQ.-1) THEN			
				READ (INLIN,'(9X,I3,8X,E12.5)',ERR=910) NT,
     &				 X
				IF (NT.LE.0) GOTO 910
				IF (NT.GT.MAXT) THEN
					WRITE (6,*) 'INCREASE MAXT'
					GOTO 910
				ENDIF
				READ (2,4001,END=48,ERR=910)
     &				 (CBUF1(1),I=1,NT)
				INLIN(10:10)='*'
				READ (2,4001,END=48,ERR=910)
     &				 (CBUF1(I),I=1,NT)
 4001				FORMAT (8X,16E12.5)
				IF (X.EQ.0.0) THEN
					CORFAC=1.0
				ELSE
					CORFAC=X
				ENDIF
				N8=MIN0(8,NT)
				N8M=N8-1
				F8=1.0/FLOAT(N8)
				BASDAT=0.0
				I8=1
				DO 4101 I=1,NT-N8M
				SUM=0.0
				DO 4102 J=I,I+N8M
 4102				SUM=SUM+CBUF1(J)
				IF (SUM.GT.BASDAT) THEN
					BASDAT=SUM
					I8=I
				ENDIF
 4101				CONTINUE
				BASDAT=BASDAT*F8
				N8=I8+N8M
			ELSEIF (IUSE.EQ.0) THEN
				READ (INLIN,'(9X,I3)',ERR=910) NT
				IF (NT.LE.0) GOTO 910
				IF (NT.GT.MAXT) THEN
					WRITE (6,*) 'INCREASE MAXT'
					GOTO 910
				ENDIF
				READ (2,4001,END=48,ERR=910)
     &				 (CBUF1(1),I=1,NT)
				INLIN(10:10)='*'
				READ (2,4001,END=48,ERR=910)
     &				 (CBUF1(I),I=1,NT)
				BASDAT=0.0
				DO 4002 I=1,NT
				IF (CBUF1(I).GT.UMIN) BASDAT=BASDAT+
     &				 CBUF1(I)
 4002				CONTINUE
			ELSE
				READ (INLIN,'(20X,8E12.5)',ERR=910) X,
     &				 (BASDAT,I=1,IUSE)
				IF (USECOR(IUSE)) THEN
					CORFAC=X
					IF (CORFAC.EQ.0.0) CORFAC=1.0
				ENDIF
				GOTO 40
			ENDIF
		ELSEIF (NOBASE) THEN
			GOTO 40
		ELSE
			READ (INLIN,'(8X,2E12.5)',ERR=910) ADDED,XKR
			IF (IUSE.EQ.-1) THEN
				INLIN(10:10)='*'
				READ (2,4001,END=48,ERR=910) (CBUF2(I),
     &				 I=1,NT),TNC,TMW
c		Non-zero MWT used to indicate a an "adjusted" input into
c		for .CLD processing
				IF (NOADJ.AND.TMW.NE.0.0) GOTO 40
				TSTDAT=0.0
				DO 4103 I=I8,N8
 4103				TSTDAT=TSTDAT+CBUF2(I)
				TSTDAT=TSTDAT*F8
			ELSEIF (IUSE.EQ.0) THEN
				INLIN(10:10)='*'
				READ (2,4001,END=48,ERR=910) (CBUF2(I),
     &				 I=1,NT),TNC,TMW
				TSTDAT=0.0
				DO 4003 I=1,NT
				IF (CBUF1(I).GT.UMIN) TSTDAT=TSTDAT+
     &				 CBUF2(I)
 4003				CONTINUE
			ELSE
				READ (INLIN,'(32X,9E12.5)',ERR=910) 
     &				 (TSTDAT,I=1,IUSE)
				READ (2,4001,END=48,ERR=910) (CBUF2(I),
     &				 I=1,NT),TNC,TMW
			ENDIF
			IF (XKR.EQ.0.0) GOTO 40
			XIR=(TSTDAT-BASDAT)/(ADDED*CORFAC)
			XMR=(XIR/XKR)*USEFAC
		ENDIF
	ELSE							!CLC INPUT
		IF (INLIN(1:4).EQ.'BASE') GOTO 40
		IF (NOADJ.AND.INLIN(101:101).NE.' ') THEN
			WRITE (6,*) INLIN(101:LNBLNK(INLIN(101:)))
			GOTO 40
		ENDIF
		IF (USECHM) THEN
			READ (INLIN,'(62X,E11.3,F7.4,F8.4)',ERR=910) 
     &			 ADDED,REACTD,XMR
			TNC=0.0
			TMW=0.0
			IF (REACTD.EQ.0.0.OR.ADDED.EQ.0.0) GOTO 40
			XIR=XMR*(REACTD/ADDED)
		ELSE
			READ (INLIN,'(28X,E11.3,F9.4,40X,F4.0,F7.2)',
     &			 ERR=910) XIR,XMR,TNC,TMW
		ENDIF
	ENDIF
	NAMEIN=INLIN(1:8)
C
C	IF IT IS A DMS, ADD MECH RCT TO LIST.  
C
	DO 42 I=1,NDMS
	IF (NAMEIN.EQ.DMSNAM(I)) THEN
		IF (ISMIX(I)) GOTO 40
		EXPLIR(I)=XIR
		EXPLMR(I)=XMR
		EMRDFD(I)=.TRUE.
		DATAIN=.TRUE.
		IF (ABS(XMR).GT.MAXMR) MAXMR=ABS(XMR)/FLOAT(DMSNC(I))
		IF (NDMS.GT.NDMS0.AND.TMW.NE.0.0.AND.TNC.NE.0.0) THEN
			DMSNC(I)=IFIX(TNC+0.001)	! UPDATE NC, MWT IF NAME NOT IN DMS.PRM
			DMSMW(I)=TMW
		ENDIF
		GOTO 40
	ENDIF
  42	CONTINUE
C
C	NOT RECOGNIZED AS DMS.  SEE IF IT IS A NON-STANDARD DMS NAME USED
C	IN A SUBSTITUTE STATEMENT.  IF SO, USE IT TO DEFINE REACTIVITY 
C	OF SUBSTITUTING NAME, IF IT IS A DMS.  
C
	DO 45 J=1,NSUB
	IF (NAMEIN.EQ.SUBNAM(J)) THEN
		DO 451 I=1,NDMS
		IF (DMSNAM(I).EQ.SUBOUT(J)) THEN
			IF (ISMIX(I)) GOTO 40
			EXPLIR(I)=XIR
			EXPLMR(I)=XMR
			EXPLIR(I)=EXPLIR(I)*SUBFAC(J)
			EXPLMR(I)=EXPLMR(I)*SUBFAC(J)
			EMRDFD(I)=.TRUE.
			DATAIN=.TRUE.
			IF (ABS(XMR).GT.MAXMR) MAXMR=ABS(XMR)
     &			 /FLOAT(DMSNC(I))
			GOTO 40
		ENDIF
  451		CONTINUE
		GOTO 40
	ENDIF
   45	CONTINUE
C
C	ADD TO DMS LIST IF IT HAS MWT AND NC DEFINED
C
	IF (TMW.GT.0.0.AND.TNC.GT.0.0) THEN
		IF (NDMS.GT.MAXDMS) STOP 'INCREASE MAXDMS'
		NDMS=NDMS+1
		DMSNAM(NDMS)=NAMEIN
		DMSNC(NDMS)=IFIX(TNC+0.001)
		DMSMW(NDMS)=TMW
		EMRDFD(NDMS)=.TRUE.
		CMRDFD(NDMS)=.FALSE.
		EXPLIR(NDMS)=XIR
		EXPLMR(NDMS)=XMR
		DATAIN=.TRUE.
		IF (ABS(XMR).GT.MAXMR) MAXMR=ABS(XMR)/FLOAT(DMSNC(I))
		GOTO 40
	ENDIF
C
C	NOT A DMS.  IF IT IS A PARM, ADD IT TO LIST.  FORMAT = R.pp.kid
C	OR P.pp.kid ASSUMED, WHERE pp IS PARM ID, AND kid='3.0' FOR KOH
C	= 3E+3, OR '30.' FOR KOH=3E+4.
C
	IF (NAMEIN(1:2).NE.'R.'.AND.NAMEIN(1:2).NE.'P.') GOTO 40
	DO 43 I=1,MAXPMK
	IF (NAMEIN(5:8).EQ.PRMKID(I)) THEN
		IND=I
		GOTO 431
	ENDIF
   43	CONTINUE
	GOTO 40
C
  431	IF (NOPRM) THEN
		IF (NAPRM.NE.0) THEN
			DO 4311 I=1,NAPRM
			IF (NAMEIN(3:4).EQ.AAPNAM(I)
     &			 .AND.NAMEIN(1:1).EQ.PRMTYP(I)) THEN
				PRMMR(I,IND)=XMR
				GOTO 40
			ENDIF
 4311			CONTINUE
		ENDIF
		IF (NAPRM.EQ.MXAAPM) STOP 'INCREASE MXAAPM'
		NAPRM=NAPRM+1
		AAPNAM(NAPRM)=NAMEIN(3:4)
		PRMTYP(NAPRM)=NAMEIN(1:1)
		AAPRKI(NAPRM)=.FALSE.
		DO 4312 I=1,MAXPMK
		IF (I.NE.IND) THEN
			PRMMR(NAPRM,I)=NODATA
		ELSE
			PRMMR(NAPRM,IND)=XMR
		ENDIF
 4312		CONTINUE
		GOTO 40
	ELSE
		DO 44 I=1,NAAPRM
		IF (AAPRKI(I)) GOTO 44
		IF (NAMEIN(3:4).EQ.AAPNAM(I)) THEN
			IF (I.GT.NAPRM) NAPRM=I
			PRMMR(I,IND)=XMR
			IF (ABS(XMR).GT.MAXMR) MAXMR=ABS(XMR)
			DATAIN=.TRUE.
			IF (PRMTYP(I).EQ.' ') THEN
				PRMTYP(I)=NAMEIN(1:1)
			ELSEIF (PRMTYP(I).NE.NAMEIN(1:1)) THEN
				WRITE (6,*) 'MORE THAN ONE TYPE ',
     &				 'FOR PARM =',AAPNAM(I)
			ENDIF
			GOTO 40
		ENDIF
   44		CONTINUE
	ENDIF
C
C	IGNORE UNRECOGNIZED NAMES
C
	GOTO 40
C
C	DONE READING REACTIVITIES
C
   48	CLOSE (UNIT=2)
	IF (.NOT.DATAIN) THEN
		WRITE (6,*) 'No useable data read'
		IF (USECLD.AND.NOBASE) WRITE (6,*) 'No BASE input ',
     &		 'found.'
		CALL EXIT (1)
	ENDIF
C
C	OUTPUT FORMAT
C
	IF (MAXMR.EQ.0.0) THEN
		WRITE (6,*) 'All MR''s zero.'
		CALL EXIT (1)
	ELSEIF (MAXMR.LT.0.001) THEN
		FMT='(1PE8.1)'
	ELSEIF (MAXMR.LT.0.1) THEN
		FMT='(F8.5)  '
	ELSEIF (MAXMR.LT.9.99) THEN
		FMT='(F8.4)  '
	ELSEIF (MAXMR.LT.99.9) THEN
		FMT='(F8.3)  '
	ELSEIF (MAXMR.LT.999.) THEN
		FMT='(F8.2)  '
	ELSEIF (MAXMR.LT.9999.) THEN
		FMT='(F8.1)  '
	ELSEIF (MAXMR.LT.99999.) THEN
		FMT='(F8.0)  '
	ELSE
		FMT='(1PE8.1)'
	ENDIF
C
C	FILL IN BLANK PARM VALUES
C	BYPASS IF PARMS NOT USED.
C
	DO 480 I=1,NAPRM
	IF (AAPRKI(I)) GOTO 480
C
	DO 481 J=1,MAXPMK
	IF (PRMMR(I,J).EQ.NODATA) THEN
		PRMOUT(I,J)='   Undef'
	ELSE
		WRITE (PRMOUT(I,J),FMT) PRMMR(I,J)
	ENDIF
  481	CONTINUE
  480	CONTINUE
C
	IF (NOPRM) GOTO 489
C
	DO 4801 I=1,NAPRM
	IF (PRMMR(I,1).EQ.NODATA) THEN
		DO 482 J=2,MAXPMK
		IF (PRMMR(I,J).NE.NODATA) THEN
			DO 483 K=1,J-1
  483			PRMMR(I,K)=PRMMR(I,J)
			IF (J.EQ.MAXPMK) GOTO 4801
			GOTO 485
		ENDIF
  482		CONTINUE
		DO 484 J=1,MAXPMK
  484		PRMMR(I,J)=0.0
		GOTO 4801
	ENDIF
  485	IF (PRMMR(I,MAXPMK).EQ.NODATA) THEN
		DO 4821 J=MAXPMK-1,1,-1
		IF (PRMMR(I,J).NE.NODATA) THEN
			DO 4831 K=J+1,MAXPMK
 4831			PRMMR(I,K)=PRMMR(I,J)
			IF (J.EQ.1) GOTO 4801
			GOTO 4851
		ENDIF
 4821		CONTINUE
		STOP 'PGM ERR AT 4821'
	ENDIF
C
C	** NOTE:  FOLLOWING VALID ONLY FOR MAXPMK=3
C
 4851	IF (PRMMR(I,2).EQ.NODATA) PRMMR(I,2)=
     &	 YINTERP(PRMKOH(2),PRMKOH(1),PRMMR(I,1),PRMKOH(3),PRMMR(I,3))
C
 4801	CONTINUE
C
C
C	CALCULATE MECHANISTIC REACTIVITIES FOR ALL "ALKARO" SPECIES
C	WHOSE PARAMETERS WERE READ.
C
	DO 100 IAA=1,NAA
	DO 101 I=1,NDMS
	IF (AANAM(IAA).EQ.DMSNAM(I)) THEN
		IDMS=I
		GOTO 102
	ENDIF
  101	CONTINUE
	GOTO 100
C
C	MAKE SURE IT IS NOT AN ALKENE
C
  102	DO 104 I=1,NAAPRM
	IF (AAPRKI(I).AND.AAPARM(I,IAA).NE.0.0.AND.AAPNAM(I).NE.'*1'
     &	 .AND.AAPNAM(I).NE.'*2') GOTO 100
  104	CONTINUE
C
C	THIS IS AN ALKARO.  ESTIMATE ITS MR FROM PARM REACTIVITIES
C
	SUM=0.0
	DO 56 I=1,NAPRM
	IF (AAPARM(I,IAA).EQ.0.0) GOTO 56
	X=ALOG(AAKOH(IAA))
	IF (X.LE.PRMKOH(2)) THEN
C		** VALID ONLY FOR MAXPMK=3 **
		SUM=SUM+(AAPARM(I,IAA)*YINTERP(X,PRMKOH(1),PRMMR(I,1),
     &		 PRMKOH(2),PRMMR(I,2)) )
	ELSE
		SUM=SUM+(AAPARM(I,IAA)*YINTERP(X,PRMKOH(2),PRMMR(I,2),
     &		 PRMKOH(3),PRMMR(I,3)) )
	ENDIF
   56	CONTINUE
	CALCMR(IDMS)=SUM
	CMRDFD(IDMS)=.TRUE.
C
C	IF IT'S REACTIVITY HASN'T BEEN EXPLICITLY INPUT, ESTIMATE
C	KINETIC REACTIVITY USING FR-KOH'S, AND PUT IN "EXPLIR" SLOT.
C
	IF (.NOT.EMRDFD(IDMS)) THEN
		IF (AAKOH(IAA).LE.IOHKOH(1)) THEN
			EXPLIR(IDMS)=1.0-EXP(-IOHI(1)*AAKOH(IAA))
		ELSEIF(AAKOH(IAA).GE.IOHKOH(NIOH)) THEN
			IF (IOHI(NIOH).LT.0.0) THEN
				EXPLIR(IDMS)=1.0
			ELSE
				EXPLIR(IDMS)=
     &				 1.0-EXP(-IOHI(NIOH)*AAKOH(IAA))
			ENDIF
		ELSE
			DO 58 I=2,NIOH
			IF (AAKOH(IAA).LT.IOHKOH(I)) THEN
				IF (IOHI(I-1).LT.0.0) THEN
					EXPLIR(IDMS)=1.0
					GOTO 100
				ENDIF
				X1=1.0-EXP(-IOHI(I-1)*AAKOH(IAA))
				IF (IOHI(I).LT.0.0) THEN
					X2=1.0
				ELSE
					X2=1.0-EXP(-IOHI(I)*AAKOH(IAA))
				ENDIF
				EXPLIR(IDMS)=YINTERP(AAKOH(IAA),
     &				 IOHKOH(I-1),X1,IOHKOH(I),X2)
				GOTO 100
			ENDIF
   58			CONTINUE
			STOP 'DMSRCT LOGIC ERR AT 58'
		ENDIF
	ENDIF
C
  100	CONTINUE
C
C
C	LOOP THRU DMS WITH STILL-UNDEFINED REACTIVITIES (NOT EXPLICITLY
C	INPUT OR ESTIMATED AS AN ALKARO), AND SEE IF IT CAN BE DEFINED
C	THRU "LUMPED MOLECULE" SUBSTITUTIONS.
C
C	THIS IS DONE ITERATIVELY, TO ALLOW FOR SUBSTITUTIONS OF SUBSTITUTIONS.
C	201 IS RETURN POINT.
C
  201	CHANGE=.FALSE.
C
	DO 200 IDMS=1,NDMS
	IF (CMRDFD(IDMS).OR.EMRDFD(IDMS)) GOTO 200
	NAMEIN=DMSNAM(IDMS)
	FOUND=.FALSE.
C
	DO 202 J=1,NSUB
	IF (NAMEIN.EQ.SUBNAM(J)) THEN
		DO 212 I=1,NDMS
		IF (DMSNAM(I).EQ.SUBOUT(J)) THEN
			IF (CMRDFD(I)) THEN
				CMRDFD(IDMS)=.TRUE.
				CALCMR(IDMS)=SUBFAC(J)*CALCMR(I)
				EXPLIR(IDMS)=EXPLIR(I)
				CHANGE=.TRUE.
				FOUND=.TRUE.
			ENDIF
			IF (EMRDFD(I)) THEN
				EMRDFD(IDMS)=.TRUE.
				EXPLIR(IDMS)=SUBFAC(J)*EXPLIR(I)
				EXPLMR(IDMS)=SUBFAC(J)*EXPLMR(I)
				CHANGE=.TRUE.
				FOUND=.TRUE.
			ENDIF
			IF (FOUND) GOTO 200
			GOTO 2102
		ENDIF
  212		CONTINUE
	ENDIF
  202	CONTINUE
 2102	CONTINUE
C
C	IF IT'S STILL NOT FOUND, LOOK "BACKWARDS" AND SEE IF A CALCULATION
C	WAS DONE FOR AN ALIAS OF THIS DMS.
C
	DO 2021 J=1,NSUB
	IF (NAMEIN.EQ.SUBOUT(J)) THEN
		DO 2121 I=1,NDMS
		IF (SUBFAC(J).NE.1.0) GOTO 2121
		IF (DMSNAM(I).EQ.SUBNAM(J)) THEN
			IF (CMRDFD(I)) THEN
				CMRDFD(IDMS)=.TRUE.
				CALCMR(IDMS)=CALCMR(I)
				EXPLIR(IDMS)=EXPLIR(I)
				CHANGE=.TRUE.
				FOUND=.TRUE.
			ENDIF
			IF (EMRDFD(I)) THEN
				EMRDFD(IDMS)=.TRUE.
				EXPLIR(IDMS)=EXPLIR(I)
				EXPLMR(IDMS)=EXPLMR(I)
				CHANGE=.TRUE.
				FOUND=.TRUE.
			ENDIF
			IF (FOUND) GOTO 200
			GOTO 2221
		ENDIF
 2121		CONTINUE
	ENDIF
 2021	CONTINUE
 2221	CONTINUE
C
C	SEE IF THIS IS DEFINED AS A MIXTURE OF OTHER DMS'S
C	(MR AND KR ARE NOT DEFINED IN THIS CASE)
C	DELETE MIXTURE IF A COMPONENT IS NOT A DMS
C
	DO 300 IMIX=1,NMIXS
	IF (NAMEIN.EQ.MIXNAM(IMIX)) THEN
		XF=0.0
		XKR=0.0
		XIR=0.0
		DO 301 IC=MIXI1(IMIX),MIXI1(IMIX)+NMIXI(IMIX)-1
		NAME2=MIXCMP(IC)
		DO 302 I=1,NDMS
		IF (NAME2.EQ.DMSNAM(I)) THEN
			IF (EMRDFD(I)) THEN
				XIR=XIR+(MIXFAC(IC)*EXPLIR(I))
				IF (EXPLMR(I).EQ.0.0) THEN
					XF=-9.9E+9
				ELSE
					XF=XF+MIXFAC(IC)
					XKR=XKR+(MIXFAC(IC)*EXPLIR(I)
     &					 *USEFAC/EXPLMR(I))
				ENDIF
				GOTO 301
			ELSEIF (CMRDFD(I)) THEN
				XIR=XIR+(MIXFAC(IC)*
     &				 (CALCMR(I)*EXPLIR(I)/USEFAC))
				IF (CALCMR(I).EQ.0.0) THEN
					XF=-9.9E+9
				ELSE
					XF=XF+MIXFAC(IC)
					XKR=XKR+(MIXFAC(IC)*EXPLIR(I))
				ENDIF
				GOTO 301
			ELSE
				GOTO 200
			ENDIF
		ENDIF
  302		CONTINUE
		MIXNAM(IMIX)=' '	! CONTAINS A NON-DMS.  DELETE MIX.
		GOTO 200
  301		CONTINUE
C	     -	CONTROL REACHES HERE ONLY IF REACTIVITIES OF ALL COMPONENTS
C	     -	WERE SUCCESSFULLY DEFINED.
		EMRDFD(IDMS)=.TRUE.
		EXPLIR(IDMS)=XIR
		IF (ABS(XF-1.0).GT.1.0E-5.OR.XKR.EQ.0.0) THEN
			EXPLMR(IDMS)=0.0
		ELSE
			EXPLMR(IDMS)=XIR*USEFAC/XKR
		ENDIF
		CHANGE=.TRUE.
	ENDIF
  300	CONTINUE
C
  200	CONTINUE
C
	IF (CHANGE) GOTO 201
C
C	CONTROL RESUMES HERE IF NO LPC INPUT USED.
  489	CONTINUE
C
C	OPEN OUTPUT FILE SUMMARIZING RESULTS, AND OUTPUT PARAMETER
C	REACTIVITIES
C
	IF (USECHM) USECLD=.TRUE.
	IF (USEOUT) THEN
		IF (RCTUIC(1:1).EQ.' ') THEN
			FILNAM=OUTNAM(1:LOUTNM)//'.RCT'
		ELSE
			FILNAM=RCTUIC(1:LRCTUC)//OUTNAM(1:LOUTNM)//
     &			 '.RCT'
		ENDIF
		LFIL=LRCTUC+LOUTNM+4
	ELSE
		IF (RCTUIC(1:1).EQ.' ') THEN
			FILNAM=SCENID(1:LSCNID)//'.RCT'
		ELSE
			FILNAM=RCTUIC(1:LRCTUC)//SCENID(1:LSCNID)//
     &			 '.RCT'
		ENDIF
		LFIL=LRCTUC+LSCNID+4
	ENDIF
	OPEN (UNIT=1,FILE=FILNAM,STATUS='UNKNOWN')
C
C	WRITE SCENID AND PARM VALUES USED. THEN INITIALIZE REST OF
C	OUTPUT
C
	IF (USECLD) WRITE (1,1061) USENAM,USEFAC,OUTNAM(1:LOUTNM)
 1061	FORMAT (A8,' Reactivity,  MR Factor =',1PE7.0,',  File = ',A)
	WRITE (1,*) 'ScenID = ',SCENID(1:LSCNID)
	IF (CORFAC.NE.1.0) WRITE (1,'(''CorFac = '',1PE12.3)') CORFAC
	IF (NAPRM.NE.0) THEN
		WRITE (1,61) (PRMKID(I)(2:4),I=1,MAXPMK)
   61		FORMAT (/'  Mechanistic Parameter Reactivities:'//
     &           '    Typ  ID  ',5('   P(',A3,')',:))
		WRITE (1,*)
		DO 78 I=1,NAPRM
		IF (.NOT.AAPRKI(I)) WRITE (1,71) PRMTYP(I),AAPNAM(I),
     &		 (PRMOUT(I,J),J=1,MAXPMK)
   71		FORMAT (5X,A1,3X,A2,1X,5(1X,A8))
   78		CONTINUE
	ENDIF
C
C	OUTPUT DMS REACTIVITIES (THAT HAVE BEEN DEFINED)
C
	IF (NOPRM) THEN
		WRITE (1,751) 
	ELSE
		WRITE (1,75) 
	ENDIF
   75	FORMAT (/'Reactivity Data:'//
     &   'DMSname       KR       MR/C     IR/C     IR/G',
     &   '    MRparm   Error'/',')
  751	FORMAT (/'Reactivity Data:'//
     &   'DMSname       KR       MR/C     IR/C     IR/G'/',')
   62	FORMAT (A8,F10.4,1X,A8,1P2E10.2,2X,A8,1X,A8)
  621	FORMAT (A8,F10.4,1X,A8,F10.5,1PE10.2,2X,A8,1X,A8)
C
	DO 400 I=1,NDMS
	FNC=FLOAT(DMSNC(I))
C
	IF (ISMIX(I)) GOTO 400
	IF (EMRDFD(I)) THEN
		EXPLMR(I)=EXPLMR(I)/FNC
		WRCT=48.0*EXPLIR(I)/DMSMW(I)
		EXPLIR(I)=EXPLIR(I)/FNC
		IF (EXPLMR(I).EQ.0.0) THEN
			X=0.0
		ELSE
			X=EXPLIR(I)/EXPLMR(I)
			IF (USECLD) X=X*USEFAC
		ENDIF
		WRITE (PRMOUT(1,1),FMT) EXPLMR(I)
		IF (CMRDFD(I)) THEN
			CALCMR(I)=CALCMR(I)/FNC
			WRITE (PRMOUT(1,2),FMT) CALCMR(I)
			WRITE (PRMOUT(1,3),FMT) CALCMR(I)-EXPLMR(I)
			IF (ABS(EXPLIR(I)).LT.0.01) THEN
				WRITE (1,62) DMSNAM(I),X,PRMOUT(1,1),
     &				 EXPLIR(I),WRCT,PRMOUT(1,2),PRMOUT(1,3)
			ELSE
				WRITE (1,621) DMSNAM(I),X,PRMOUT(1,1),
     &				 EXPLIR(I),WRCT,PRMOUT(1,2),PRMOUT(1,3)
			ENDIF
		ELSEIF (ABS(EXPLIR(I)).LT.0.01) THEN
			WRITE (1,62) DMSNAM(I),X,PRMOUT(1,1),EXPLIR(I),
     &			 WRCT
		ELSE
			WRITE (1,621) DMSNAM(I),X,PRMOUT(1,1),EXPLIR(I),
     &			 WRCT
		ENDIF
	ELSEIF (CMRDFD(I)) THEN
		WRCT=48.0*EXPLIR(I)*CALCMR(I)/DMSMW(I)
		CALCMR(I)=CALCMR(I)/FNC
		WRITE (PRMOUT(1,2),FMT) CALCMR(I)
		WRITE (1,62) DMSNAM(I),EXPLIR(I),PRMOUT(1,2),
     &		 CALCMR(I)*EXPLIR(I)/USEFAC,WRCT,PRMOUT(1,2)
	ENDIF
  400	CONTINUE
C
C	OUTPUT MIXTURES, IF ANY
C
	IF (NMIX.GT.0) THEN
		DO 490 IX=1,NMIX
		I=MIXIND(IX)
		INLIN=DMSNAM(I)
		L=LNBLNK(INLIN(1:8))
		IF (LCMPUC.EQ.0) THEN
			INLIN(L+1:L+4)='.CMP'
			L=L+4
		ELSE
			INLIN=CMPUIC(1:LCMPUC)//INLIN(1:L)//'.CMP'
			L=L+LCMPUC+4
		ENDIF
		INQUIRE(FILE=INLIN(1:L),EXIST=ERRIND)
		IF (.NOT.ERRIND) THEN
			WRITE (6,*) 'File='//INLIN(1:L)//' does not exist'
			GOTO 499
		ENDIF
		OPEN (UNIT=2,FILE=INLIN(1:L),STATUS='OLD')
		DO 493 J=1,NDMS
  493		MIXWT(J)=0.0
		TOTNC=0.0
		TOTRCT=0.0
C
  491		READ (2,1,END=498) INLIN
		IF (INLIN(1:1).EQ.'!') GOTO 491
		CALL PARSE0 (2,INLIN,80)
		CALL PARSE1 (1,NAMEIN,L,8,INLIN)
		CALL PARSER (2,XF,ERRIND,INLIN)
		IF (ERRIND) THEN
C			WRITE (6,*) 'Error reading data for '//DMSNAM(I)
C			WRITE (6,*) 'Bad line: '//INLIN
			GOTO 499
		ENDIF
		IF (XF.EQ.0.0) GOTO 491
		DO 492 J=1,NDMS
		IF (NAMEIN.EQ.DMSNAM(J)) THEN
			IF (EMRDFD(J).OR.CMRDFD(J)) THEN
				MIXWT(J)=XF
				XNC=FLOAT(DMSNC(J))
				XIR=EXPLIR(J)*XNC
				TOTNC=TOTNC+(XF*XNC)
				TOTRCT=TOTRCT+(XF*XIR)
				GOTO 491
			ELSE
C				WRITE (6,*) 'Cannot define IR for '//DMSNAM(I)//
C     &				 ' because IR for '//NAMEIN//' is not defined'
				GOTO 499
			ENDIF
		ENDIF
  492		CONTINUE
C		WRITE (6,*) 'Cannot define IR for '//DMSNAM(I)//
C     &		 ' because '//NAMEIN//' is not a DMS.'
		GOTO 499
  498		CONTINUE
		IF (TOTNC.NE.0.0) THEN
			XIR=TOTRCT*FLOAT(DMSNC(I))/TOTNC
			IF (ABS(XIR).LT.0.01) THEN
				WRITE (1,'(A8,19X,1PE10.2)') DMSNAM(I),XIR
			ELSE
				WRITE (1,'(A8,19X,F10.5)') DMSNAM(I),XIR
			ENDIF
		ENDIF
  499		CLOSE (UNIT=2)
  490		CONTINUE
	ENDIF

C
C	DONE
C
	CLOSE (UNIT=1)
	WRITE (6,*) 'Done.  File = ',FILNAM(1:LFIL),' created.'
	CALL EXIT (0)
C
C	ERRORS
C	
 900	WRITE (6,*) 'File = ',FILNAM(1:LFIL),' does not exist.'
	GOTO 990
 901	WRITE (6,*) 'Unrecognized data type = ',USENAM(1:LUSENM)
	WRITE (6,'(1X,''Recognized types: ".nnn" or''/(10(1X,A8)))') 
     &	 TYPLIS
	GOTO 990
 902	WRITE (6,*) 'File = ',DMSFIL(1:LDMSFL),' does not exist.'
	GOTO 990
 910	WRITE (6,*) 'Error reading data in file = ',FILNAM(1:LFIL)
	WRITE (6,*) 'Bad record = ',INLIN(1:LNBLNK(INLIN))
 990	CALL EXIT (1)
	END
