	SUBROUTINE LDSAR (IUNIT,SARKOD,ERRIND)
C
C	LOADS SAROAD.PRM DATA INTO MEMORY.  LIKE LDSAR, BUT SAROAD.FILE
C	ASSUMPED TO BE ALREADY OPEN, AND SARTYPE ALREADY DEFINED.
C
C	ARGUMENT:
C		IUNIT = UNIT NO. TO USE.  ASSUMED OPEN; CLOSED
C			AGAIN WHEN DONE
C		SARKOD = SAROAD TYPE CODE.
C		ERRIND = ERROR CODE. SET TO .TRUE. IF ERROR, .FALSE.
C			IF OK.
C
	INTEGER IUNIT
	INTEGER*4 SARI,LSARI
	CHARACTER*4 SARKOD
	LOGICAL ERRIND
C
C
C	GENERAL SPECIFICATIONS
C
	INCLUDE 'LUMPSPEC.FOR'
C
C	SPECIFICATIONS FOR SAROAD.PRM DATA
C
	INCLUDE 'SARSPEC.FOR'
C
C	LOCAL SPECIFICATIONS
C
	CHARACTER INLIN*80,NAMEIN*8
C
C	GETS LOCATION OF SAROAD ASSIGNMENT DATA SET FROM "SAR="
C	PARAMETER IN MODELING.PRM.  IF NOT FOUND, USES 'SY:SAROAD.PRM'
C
C	READS "MERGED" VERSION OF SAROAD.PRM.  GETS TYPE CODE FROM
C	"SARTYPE=" PARAMETER IN MODELING.PRM.  IF NOT FOUND, USES DEFAULT
C	INDICATED BELOW.  1 = "EPA", 2 = "ARB".
C
	INTEGER SARTYP
C
C	DEFAULT SAROAD TYPE IS "NONE".
C
	SARTYP=0
C
C
C	READ SAROAD.PRM DATA INTO MEMORY
C
    8	READ (IUNIT,'(A1)') INLIN(1:1)
	IF (INLIN(1:1).NE.'.') GOTO 8
C
	NSP=0
	LMIX=0
	LMIXM=0
C
	LLMIX=0
	LLMIXM=0
	SARI=0
C
   10	READ (IUNIT,'(A80)',END=90) INLIN
	IF (INLIN(1:1).EQ.'!') GOTO 10
	IF (INLIN(1:6).EQ.'      ') GOTO 10
C
C	DETERMINE SARTYP (IF NOT YET KNOWN).
C
	IF (INLIN(2:6).EQ.'     ') THEN
		IF (SARTYP.NE.0) GOTO 10
		IF (INLIN(9:12).NE.SARKOD) GOTO 10
		READ (INLIN,'(I1)',ERR=800) SARTYP
		GOTO 10
	ENDIF
C
C	INPUT NEXT ASSIGNMENT.  
C	IGNORE SAROAD NO'S WITH NON-MATCHING TYPE OR NO ASSIGNMENTS
C
	READ (INLIN,'(I1,I5,53X,A8)',ERR=800) INDTYP,SARI,NAMEIN
	IF ((NAMEIN(1:1).EQ.' ').OR.(INDTYP.NE.0.AND.INDTYP.NE.
     &	 SARTYP).OR.SARI.EQ.0) GOTO 10
C
C	DELETE LAST ONE IF THIS HAS SAME SAR NO (AS WOULD BE THE CASE
C	IF THIS HAD NON-ZERO SARTYPE CODE, AND LAST ONE WAS ZERO.)
C
	IF (SARI.EQ.LSARI) THEN
		LMIX=LLMIX
		LMIXM=LLMIXM
	ELSE
		IF (NSP.EQ.MAXSPE) GOTO 810
		LLMIX=LMIX
		LLMIXM=LMIXM
		LSARI=SARI
		NSP=NSP+1
		SAR(NSP)=SARI
	ENDIF
	READ (INLIN,'(38X,I3,F8.2)',ERR=800) SARNC(NSP),SARMW(NSP)
C
C	PROCESS THIS ONE
C
	IF (NAMEIN(1:1).NE.'+') THEN
C
		IF (NAMEIN.NE.'INERT   '.OR.SARNC(NSP).EQ.1) THEN
C
C			SINGLE DMS ASSIGNMENT.
C
			LMIX=LMIX+1
			IF (LMIX.GT.MAXCLS) GOTO 820
			IMIX(NSP)=LMIX
			NMIX(NSP)=LMIX
			SPCLAS(LMIX)=NAMEIN
			LVL(LMIX)=1.0
		ELSE
C
C			ASSIGNS TO MORE THAN ONE "INERT".  TREAT
C			LIKE MIXTURE
C
			LMIXM=LMIXM+1
			IF (LMIXM.GT.MAXCLM) GOTO 822
			IMIX(NSP)=-LMIXM
			NMIX(NSP)=LMIXM
			SPCLSM(LMIXM)=NAMEIN
			NCMIX(LMIXM)=1
			MWMIX(LMIXM)=SARMW(NSP)/FLOAT(SARNC(NSP))
			WLVL(LMIXM)=FLOAT(SARNC(NSP))/SARMW(NSP)
		ENDIF
C
	ELSEIF (SARMW(NSP).NE.0.0) THEN
C
C		MULTIPLE ISOMER DMS ASSIGNMENT
C
		READ (NAMEIN,'(1X,I3,4X)',ERR=800) N
		IMIX(NSP)=LMIX+1
		LMIX=LMIX+N
		IF (LMIX.GT.MAXCLS) GOTO 820
		NMIX(NSP)=LMIX
		READ (IUNIT,13,ERR=800) (LVL(I),SPCLAS(I),I=IMIX(NSP),
     &		 LMIX)
   13		FORMAT (6X,F7.4,1X,A8,F9.4,1X,A8,F9.4,1X,A8,F9.4,1X,A8)
C
	ELSE
C
C		NON-ISOMERIC MIXTURE DMS ASSIGNMENT.
C
		READ (NAMEIN,'(1X,I3,4X)',ERR=800) N
		IMIX(NSP)=-(LMIXM+1)
		LMIXM=LMIXM+N
		IF (LMIXM.GT.MAXCLM) GOTO 822
		NMIX(NSP)=LMIXM
		READ (IUNIT,14,ERR=800) (SPCLSM(I),WLVL(I),NCMIX(I),
     &		 MWMIX(I),I=-IMIX(NSP),LMIXM)
   14		FORMAT (8X,A8,E12.5,I4,F8.2)
C
	ENDIF
	GOTO 10
C
C
   90	CLOSE (UNIT=IUNIT)
C	WRITE (6,92) NSP
C   92	FORMAT (' Assignments for',I4,' SAROAD species read.')
C
C
	ERRIND=.FALSE.
	RETURN
C
C	ERROR
C
  800	WRITE (6,802) NSP
  802	FORMAT (' Error reading SAROAD assignment data.  NSP=',I4)
	IF (NSP.NE.0) WRITE (6,803) 'Current',SAR(NSP)
	IF (NSP.NE.1) WRITE (6,803) 'Last',SAR(NSP-1)
  803	FORMAT (1X,' SAROAD no. =',I10)
	GOTO 899
  810	WRITE (6,*) 'Too many SAROAD species in SAROAD assignment',
     &	 ' file.'
	WRITE (6,*) 'Increase MAXSPE in SARSPEC.FOR'
	GOTO 899
  820	WRITE (6,*) 'Too many DMS used in SAROAD assignment file.'
	WRITE (6,*) 'Increase MAXCLS in SARSPEC.FOR'
  822	WRITE (6,*) 'Too many mixture DMS used in SAROAD assignment ',
     &	 'file.'
	WRITE (6,*) 'Increase MAXCLM in SARSPEC.FOR'
C
  899	ERRIND=.TRUE.
	RETURN
	END
