C	RDALKP.FTN
C
C	READS MODEL SPECIES AND KINETIC AND MECHANISTIC PARAMETERS IN THE
C	FORMAT CREATED BY THE "ALKCONV" PROGRAM
C
	SUBROUTINE RDALKP(FUNIT)
C
C	ARGUMENT:  FILE UNIT FOR INPUT
C
	INTEGER FUNIT
C
	INCLUDE 'LUMPSPEC.FOR'
C
C
        PARAMETER (MAXT=3)
C
	INTEGER PRMLOC(MXAAPM)
	REAL*4 ALKPRM(MXAAPM,MAXT),TEMPS(MAXT)
	CHARACTER ALKPBF(MXAAPM)*2,INLIN*80
	LOGICAL VARYT
C
C
C	INITIALIZE TEMPERATURE-DEPENDENT VARIABLES
C
        CTEMP=4.40373E+17/TEMPR
	VARYT=(THIGH.NE.0.0.AND.TLOW.NE.0.0)
C
C	FIRST 2 PARMS RESERVED FOR KOH AT TLOW AND THIGH, RESPECTIVELY
C
	IF (VARYT) THEN
		IF (NAAPRM.EQ.0) THEN
			NAAPRM=2
			AAPNAM(1)='*1'
			AAPNAM(2)='*2'
			AAPRKI(1)=.TRUE.
			AAPRKI(2)=.TRUE.
		ENDIF
	ENDIF		
C
C	READ THE TEMPERATURES FOR WHICH PARMS GIVEN
C
        READ (FUNIT,'(5X,I1,F9.2,2F10.2)',ERR=3184) NTEMPS,TEMPS
	IF (NTEMPS.GT.3) NTEMPS=3
C
C	IF 3 T'S SPECIFIED, THEY MUST AGREE WITH THIGH AND TLOW.
C
	IF (VARYT.AND.NTEMPS.GT.1) THEN
		IF (TLOW.NE.TEMPS(1).OR.THIGH.NE.TEMPS(NTEMPS)) THEN
			WRITE (ICRT,*) 'T''s in alkane parm file',
     &			 ' disagree with THIGH and/or TLOW.'
			GOTO 3184
		ENDIF
	ENDIF
C
C       GET THE INFO NEEDED TO EXTRAPOLATE THE TEMPERATURE-DEPENDENT
C       PARMS TO TEMP=TEMPR
C
        IF (TEMPR.LT.TEMPS(1)) THEN
                GOTO 3186
        ELSEIF (NTEMPS.EQ.1) THEN
                IF (TEMPS(1).NE.TEMPR) GOTO 3186
        ELSE
                IF (TEMPR.LE.TEMPS(2)) THEN
                        I1=1
                        I2=2
                ELSEIF (NTEMPS.EQ.2) THEN
                        GOTO 3186
                ELSEIF (TEMPR.LE.TEMPS(3)) THEN
                        IF (TEMPS(1).GE.TEMPS(2)) THEN
                                GOTO 3187
                        ELSEIF (TEMPS(2).GE.TEMPS(3)) THEN
                                GOTO 3187
                        ELSE
                                I1=2
                                I2=3
                        ENDIF
                ELSE
                        GOTO 3186
                ENDIF
C
                F2=TEMPS(I2)-TEMPS(I1)
                F1=(TEMPS(I2)-TEMPR)/F2
                F2=(TEMPR-TEMPS(I1))/F2
        ENDIF
C
        READ (FUNIT,3002,ERR=3184) NPALK,(ALKPBF(I),I=1,NPALK)
 3002   FORMAT (I2,1X,25(A2,1X))
C
C	COMBINE NEW PARMS WITH OLD ONES, IF ANY.  ARRAY PRMLOC
C	GIVES INDEX FOR PARM NO.
C
	NOLD=NAAPRM
	DO 3010 I=1,NPALK
	IF (NOLD.GT.0) THEN
		DO 3012 J=1,NOLD
		IF (ALKPBF(I).EQ.AAPNAM(J)) THEN
			PRMLOC(I)=J
			GOTO 3010
		ENDIF
 3012		CONTINUE
	ENDIF
C
C	ADD NEW PARM, AND SET ITS VALUE TO ZERO FOR MODEL
C	SPECIES ALREADY ON LIST
C
	IF (NAAPRM.EQ.MXAAPM) STOP 'INREASE MXAAPM IN LUMPSPEC'
	NAAPRM=NAAPRM+1
	AAPNAM(NAAPRM)=ALKPBF(I)
	AAPRKI(NAAPRM)=.FALSE.
	PRMLOC(I)=NAAPRM
C
	IF (NAA.GT.0) THEN
		DO 3014 J=1,NAA
 3014		AAPARM(NAAPRM,J)=0.0
	ENDIF
 3010	CONTINUE
C	
C
C       READ ALKANE NAME, #C'S, PROCESSING CODE, KOH
C               (#C'S, PROCESSING CODE NOT USED)
C
 3100   NAA=NAA+1
 3101	READ (FUNIT,'(A)',END=3190) INLIN
	IF (INLIN(1:1).EQ.'!') GOTO 3101
        READ (INLIN,'(A8,8X,2I3,T31,3F10.0)',ERR=3184) AANAM(NAA),
     &	 I,I,(ALKPRM(I,1),I=1,NTEMPS)
        IF (NAA.GT.MAXAA) STOP 'TOO MANY MODEL SPECIES'
C
C	CALC KOH AND PUT IN ARRAY
C
        IF (NTEMPS.EQ.1) THEN
                AAKOH(NAA)=CTEMP*ALKPRM(1,1)
		IF (VARYT) THEN
			AAPARM(1,NAA)=ALKPRM(1,1)
			AAPARM(2,NAA)=ALKPRM(1,1)
		ENDIF
        ELSE
                AAKOH(NAA)=CTEMP*((F1*ALKPRM(I1,1))+(F2*ALKPRM(I2,1)))
		IF (VARYT) THEN
			AAPARM(1,NAA)=ALKPRM(1,1)
			AAPARM(2,NAA)=ALKPRM(NTEMPS,1)
		ENDIF
        ENDIF
C
C	INITIALIZE PARMS TO ZERO, THEN READ IN VALUES OF THOSE ON
C	PRMLOC LIST, AND PUT IN PLACE IN AAPARM ARRAY
C
	DO 3102 I=1,NAAPRM
 3102	AAPARM(I,NAA)=0.0
C
	DO 3110 I=1,NTEMPS
 3110	READ (FUNIT,'(8F10.5)',ERR=3184) (ALKPRM(J,I),
     &	 J=1,NPALK)
C
	IF (NTEMPS.EQ.1) THEN
		DO 3114 I=1,NPALK
 3114		AAPARM(PRMLOC(I),NAA)=ALKPRM(I,1)
	ELSE
		DO 3120 I=1,NPALK
 3120           AAPARM(PRMLOC(I),NAA)=(F1*ALKPRM(I,I1))
     &		 +(F2*ALKPRM(I,I2))
	ENDIF
C
        GOTO 3100
C
C	ERRORS
C
 3184   WRITE (ICRT,3183)
 3183   FORMAT (' ERROR IN READING ALKANE PARMS')
        GOTO 3188
 3186   WRITE (ICRT,3185) TEMPR
 3185   FORMAT (' TEMPERATURE GIVEN OUT OF RANGE OF THOSE IN THE'
     &   ,' ALKANE PARM DATA SET.  TEMPR=',F6.2)
        GOTO 3188
 3187   WRITE (ICRT,3182)
 3182   FORMAT ('BAD TEMPERATURE ORDER IN THE ALKANE DATA SET.')
 3188   STOP 'ABORT IN RDALKP'
C
C	END OF INPUT
C
 3190   NAA=NAA-1
        CLOSE (UNIT=FUNIT)
	RETURN
	END	
