	PROGRAM DMSRCT
C
C	SUMMARIZES REACTIVITIES FOR MODEL SPECIES FROM CALCULATIONS FOR
C	A FIXED-PARAMETER MECHANISM.
C	GETS SCENID FROM COMMAND LINE
C	GETS REACTIVITY DATA FROM SCENID.CLC
C	GETS FR-KOH'S FROM SCENID.BAS
C	GETS DMS LIST, NC'S, ETC. FROM [DMSFIL]
C	GETS [DMSFIL] FROM MODELING.PRM
C	USES .LCC FILE SPECIFIED BY LCC= INPUT IN MODELING.PRM
C	GETS [MECUIC] FROM MODELING.PRM
C	GETS [RCTUIC] FROM MODELING.PRM
C	GETS MODEL SPECIES ASSIGNMENTS FROM LUMPGEN-TYPE LUMPING CONTROL FILES.
C
C	P1 = SCENID
C	[P2] = OPTION.  
C	[P3] = SECOND OPTION
C		OPTIONS IMPLEMENTED:
C		"DOSE":  .RCT AND .CLC FILES IN DOSRCT= AND DOSCLC=
C			 DIRECTORIES
C		"USE=type outname":  READ .RCD FILE TO GET REACTIVITY DATA
C			FOR MEASUREMENT TYPE.  IF MULTIPLIED BY A FACTOR,
C			FACTOR GIVEN IN MODELING.PRM AS "FAC=type fac"
C			outname is output file name, which can't be scenid.
C
C
C	OUTPUTS KR'S, MR'S AND REACTIVITIES IN [RCTUIC]SCENID.RCT
C	DOES NOT OUTPUT DMS'S WITH NO DATA.
C
C	DATA READ FROM LUMPING CONTROL FILE
C
	INCLUDE 'LUMPSPEC.FOR'
C
C	DMS DATA FROM DMS.PRM
C
	INTEGER DMSNC(MAXDMS)
	REAL DMSMW(MAXDMS)
C
C	LMS REACTIVITY DATA
C
	LOGICAL RDFD(MAXSPE)
	REAL SPEMR(MAXSPE),SPEIR(MAXSPE),SPEKR(MAXSPE)
C
C
C	FOLLOWING ARE TYPES EXPECTED IN .CLD FILES:
C
	PARAMETER (NTYP=5,INDIOH=3)
	CHARACTER TYPLIS(NTYP)*8
	DATA TYPLIS /'O3max   ','IntO3   ','IntOH   ','PANmax  ',
     &	 'H2O2max '/
	LOGICAL USECOR(NTYP)
	DATA USECOR /.FALSE.   ,.FALSE.   ,.FALSE.   ,.FALSE.
     &	 ,.FALSE./
C
C	WORK ARRAYS
C
	CHARACTER INLIN*80,FILNAM*80,SCENID*8,CLCUIC*60,USENAM*8,
     &	 OUTNAM*32,RCTUIC*60,DMSFIL*60,FMT*8
	CHARACTER LCCFIL*40,CLCCHK*8,RCTCHK*8
	LOGICAL USECLD,USECHM,NOBASE,ERRIND
C
C	NOCLC INDICATES READ FROM FILE GIVING IR'S ONLY.
C
	LOGICAL NOCLC
C
	REAL NODATA,USEFAC,MAXMR
	PARAMETER (NODATA=-9.99E+9)
C
C
C	GET SCENID FROM COMMAND LINE
C
	CALL GETARG (1,SCENID)
	IF (SCENID(1:1).EQ.' ') THEN
		WRITE (6,*) 'Use:  DMSRCT scenid [option]'
		WRITE (6,*) '(option = "DOSE"  calculate DOSE rct''y)'
		CALL EXIT (2)
	ENDIF
	LSCNID=LNBLNK(SCENID)
	CALL GETARG (2,FILNAM)
C
	CLCCHK='CLC='
	LCLCCK=4
	RCTCHK='RCT='
	LRCTCK=4
	USENAM=' '
	LUSENM=1
	USECLD=.FALSE.
	USECHM=.FALSE.
C
	I=0
    2	IF (FILNAM(1:5).EQ.'DOSE ') THEN
		CLCCHK='DOSCLC='
		LCLCCK=7
		RCTCHK='DOSRCT='
		LRCTCK=7
	ELSEIF (FILNAM(1:4).EQ.'USE='.AND.FILNAM(5:5).NE.' ') THEN
		USENAM=FILNAM(5:)
		LUSENM=LNBLNK(USENAM)
C
		IF (USENAM.EQ.'CHAM-IOH') THEN
			USECHM=.TRUE.
			USENAM=TYPLIS(INDIOH)
			IUSE=INDIOH
			GOTO 4
		ENDIF
		DO 3 I=1,NTYP
		IF (USENAM.EQ.TYPLIS(I)) THEN
			IUSE=I
			USECLD=.TRUE.
			GOTO 4
		ENDIF
    3		CONTINUE
		WRITE (6,*) 'Unrecognized data type = ',USENAM(1:LUSENM)
		WRITE (6,'(1X,''Recognized types:''/(10(1X,A8)))') 
     &		 TYPLIS
		CALL EXIT (2)
    4		CONTINUE
C
		CALL GETARG (3+L,OUTNAM)
		IF (OUTNAM(1:1).EQ.' ') THEN
			WRITE (6,*) 'Must give distinct output file',
     &			 ' name with USE option'
			CALL EXIT (2)
		ENDIF
		LOUTNM=LNBLNK(OUTNAM)
		L=L+1
	ELSEIF (FILNAM(1:1).EQ.' ') THEN
		I=1
	ELSE
		WRITE (6,*) 'Unrecognized option: ',
     &		 FILNAM(1:LNBLNK(FILNAM))
		CALL EXIT (2)
	ENDIF
	IF (I.EQ.0) THEN
		I=1
		CALL GETARG (3,FILNAM)
		GOTO 2
	ENDIF
C
C	GET [MECUIC] FROM MODELING.PRM
C
	MECUIC=' '
	CLCUIC=' '
	LCLCUC=0
	LCCFIL=' '
	LLCCFL=0
	RCTUIC=' '
	LRCTUC=0
	DMSFIL='DMS.PRM'
	LDMSFL=7
	USEFAC=1.0
C
	OPEN (UNIT=1,FILE='MODELING.PRM',STATUS='UNKNOWN')
   10	READ (1,*,END=12) INLIN
	L=LNBLNK(INLIN)
	IF (INLIN(1:5).EQ.'MECH=') THEN
		IF (L.GT.0) MECUIC=INLIN(6:L)
	ELSEIF (INLIN(1:LCLCCK).EQ.CLCCHK) THEN
		LCLCUC=L-LCLCCK
		IF (L.GT.0) CLCUIC=INLIN(LCLCCK+1:L)
	ELSEIF (INLIN(1:4).EQ.'LCC=') THEN
		LLCCFL=L-4
		IF (L.GT.4) THEN
			LCCFIL=INLIN(5:L)
		ELSE
			LCCFIL=' '
		ENDIF
	ELSEIF (INLIN(1:LRCTCK).EQ.RCTCHK) THEN
		LRCTUC=L-LRCTCK
		IF (L.GT.LRCTCK) THEN
			RCTUIC=INLIN(LRCTCK+1:L)
		ELSE
			RCTUIC=' '
		ENDIF
	ELSEIF (INLIN(1:4).EQ.'DMS='.OR.INLIN(1:4).EQ.'VOC=') THEN
		LDMSFL=L-4
		IF (L.GT.4) THEN
			DMSFIL=INLIN(5:L)
		ELSE
			DMSFIL=' '
		ENDIF
	ELSEIF (USECLD.OR.USECHM) THEN
		IF (INLIN(1:4+LUSENM).EQ.'FAC='//USENAM(1:LUSENM)) THEN
			CALL PARSE0 (2,INLIN,80)
			CALL PARSR2 (2,USEFAC,1.0,ERRIND,INLIN)
			IF (ERRIND.OR.USEFAC.EQ.0.0) THEN
				WRITE (6,*) 'Bad line in MODELING.PRM ',
     &				 '= ',INLIN(1:LNBLNK(INLIN))
				CALL EXIT (2)
			ENDIF
		ENDIF
	ENDIF
	GOTO 10
   12	CLOSE (UNIT=1)
C
C
C	OPEN SCENID.CLC FILE.  (OPENED HERE TO BE SURE ALL INPUT
C	FILES EXIST BEFORE TAKING THE TIME TO READ THE .LCC FILE)
C
	LFIL=LCLCUC+LSCNID
	IF (LCLCUC.NE.0) THEN
		FILNAM=CLCUIC(1:LCLCUC)
		FILNAM(LCLCUC+1:LFIL)=SCENID(1:LSCNID)
	ELSE
		FILNAM=SCENID(1:LSCNID)
	ENDIF
	LFIL=LFIL+4
	IF (USECLD) THEN
		FILNAM(LFIL-3:LFIL)='.CLD'
	ELSE
		FILNAM(LFIL-3:LFIL)='.CLC'
	ENDIF
	OPEN (UNIT=2,FILE=FILNAM,STATUS='OLD',ERR=900)
C
C
C	READ .LCC FILE TO GET LUMPED MODEL ASSIGNMENTS.
C
	INLIN=FILNAM
	I=LFIL
	FILNAM=LCCFIL(1:LLCCFL)
	LFIL=LLCCFL+4
	FILNAM(LLCCFL+1:LFIL)='.LCC'
	OPEN (UNIT=1,FILE=FILNAM,STATUS='OLD',ERR=900)
	FILNAM=INLIN
	LFIL=I
C
	CALL RDLUMP (-1,3,0)
C
C
C	INITIAL DMS'S AS NO C'S.
C
	DO 21 I=1,NDMS
   21	DMSNC(I)=0
C
C	READ DMS NC'S AND DMS MW'S FROM DMS.PRM.  ONLY USE DMS'S IN
C	.LCC FILE.
C
	OPEN (UNIT=1,FILE=DMSFIL(1:LDMSFL),STATUS='OLD',ERR=902)
C
   20	READ (1,'(A)') INLIN
	IF (INLIN(1:1).NE.'.') GOTO 20
C
   22	READ (1,'(A)',END=28) INLIN
	IF (INLIN(1:1).EQ.'!'.OR.
     &	 (INLIN(1:1).EQ.' '.OR.INLIN(1:1).EQ.'	')) GOTO 22
	DO 26 I=1,NDMS
	IF (DMSNAM(I).EQ.INLIN(1:8)) THEN
		READ (INLIN,'(10X,I4,1X,F8.2)') DMSNC(I),DMSMW(I)
		IF (DMSMW(I).EQ.0.0) DMSNC(I)=0
		GOTO 22
	ENDIF
   26	CONTINUE
	GOTO 22
C
   28	CLOSE (UNIT=1)
C
C
C	INITIALIZE REACTIVITIES OF CONDENSED MODEL SPECIES AS UNDEFINED
C	DEFINE REACTIVITIES FOR "INERT", 
C
	DO 32 I=1,NSPE
	IF (SPENAM(I).EQ.'INERT   '.OR.SPENAM(I).EQ.'NROG    '
     &	 .OR.SPENAM(I).EQ.'NR      '.OR.SPENAM(I).EQ.'LOST    ') THEN
		SPEMR(I)=0.0
		SPEIR(I)=0.0
		RDFD(I)=.TRUE.
	ELSE
		RDFD(I)=.FALSE.
	ENDIF
   32	CONTINUE
C
C
C	READ SCENID.CLC AND GET REACTIVITIES FOR LUMPED MODEL SPECIES.
C	IGNORE IF NOT A RECOGNIZED LMS.
C
	MAXMR=0.0
	NOBASE=.TRUE.
	CORFAC=1.0
	NOCLC=.FALSE.
 40	READ (2,'(A)',END=48) INLIN
	IF (INLIN(1:1).EQ.'!') GOTO 40
	IF (INLIN(1:1).EQ.' ') GOTO 40
	IF (INLIN(1:1).EQ.'.') THEN
		NOCLC=.TRUE.
		GOTO 40
	ENDIF
	IF (INLIN(1:4).EQ.'BASE') THEN
		IF (USECLD) THEN
			IF (.NOT.NOBASE) WRITE (6,*) 'Warning: more ',
     &			 'than one BASE input in .CLD file.'
			NOBASE=.FALSE.
			READ (INLIN,'(20X,8E12.5)',ERR=910) X,
     &			 (BASDAT,I=1,IUSE)
			IF (USECOR(IUSE)) THEN
				CORFAC=X
				IF (CORFAC.EQ.0.0) CORFAC=1.0
			ENDIF
		ENDIF
	ELSEIF (USECLD.AND.NOBASE) THEN
		GOTO 40
	ELSE
C
C		IF IT IS A LMS, ADD MECH RCT TO LIST.  
C
		DO 42 I=1,NSPE
		IF (INLIN(1:8).EQ.SPENAM(I)) THEN
			IF (USECLD) THEN
				READ (INLIN,'(8X,9E12.5)',ERR=910) 
     &				 ADDED,XKR,(TSTDAT,J=1,IUSE)
				IF (XKR.EQ.0.0) GOTO 40
				XIR=(TSTDAT-BASDAT)/(ADDED*CORFAC)
				XMR=(XIR/XKR)*USEFAC
			ELSEIF (USECHM) THEN
				READ (INLIN,'(62X,E11.3,F7.4,F8.4)'
     &				 ,ERR=910) ADDED,REACTD,XMR
				IF (REACTD.EQ.0.0.OR.ADDED.EQ.0.0)
     &				 GOTO 40
				XIR=XMR*(REACTD/ADDED)
			ELSEIF (NOCLC) THEN
				CALL PARSE0 (2,INLIN,80)
				CALL PARSER (2,XIR,ERRIND,INLIN)
				IF (ERRIND) GOTO 910
				XMR=XIR
			ELSE
				READ (INLIN,'(28X,E11.3,F9.4)',ERR=910)
     &				 XIR,XMR
			ENDIF
			SPEIR(I)=XIR
			SPEMR(I)=XMR
			IF (ABS(XMR).GT.MAXMR) MAXMR=ABS(XMR)
			RDFD(I)=.TRUE.
		ENDIF
  42		CONTINUE
	ENDIF
	GOTO 40
C
C	DONE READING REACTIVITIES
C
   48	CLOSE (UNIT=2)
C
C
C	OUTPUT FORMAT
C
	IF (MAXMR.EQ.0.0) THEN
		WRITE (6,*) 'All MR''s zero.'
		CALL EXIT (1)
	ELSEIF (MAXMR.LT.0.0001.OR.MAXMR.GT.100000.) THEN
		FMT='(1PE8.1)'
	ELSEIF (MAXMR.LT.0.001) THEN
		FMT='(F8.6)  '
	ELSEIF (MAXMR.LT.0.01) THEN
		FMT='(F8.6)  '
	ELSEIF (MAXMR.LT.0.1) THEN
		FMT='(F8.5)  '
	ELSEIF (MAXMR.LT.1.0) THEN
		FMT='(F8.4)  '
	ELSEIF (MAXMR.LT.10.) THEN
		FMT='(F8.3)  '
	ELSEIF (MAXMR.LT.100.) THEN
		FMT='(F8.2)  '
	ELSEIF (MAXMR.LT.1000.) THEN
		FMT='(F8.1)  '
	ELSE
		FMT='(F8.0)  '
	ENDIF
C
C
C	OPEN OUTPUT FILE SUMMARIZING RESULTS
C
	IF (USECHM) USECLD=.TRUE.
	IF (USECLD) THEN
		IF (RCTUIC(1:1).EQ.' ') THEN
			FILNAM=OUTNAM(1:LOUTNM)//'.RCT'
		ELSE
			FILNAM=RCTUIC(1:LRCTUC)//OUTNAM(1:LOUTNM)//
     &			 '.RCT'
		ENDIF
		LFIL=LRCTUC+LOUTNM+4
	ELSE
		IF (RCTUIC(1:1).EQ.' ') THEN
			FILNAM=SCENID(1:LSCNID)//'.RCT'
		ELSE
			FILNAM=RCTUIC(1:LRCTUC)//SCENID(1:LSCNID)//
     &			 '.RCT'
		ENDIF
		LFIL=LRCTUC+LSCNID+4
	ENDIF
	OPEN (UNIT=1,FILE=FILNAM,STATUS='UNKNOWN')
C
C	WRITE SCENID AND PARM VALUES USED. THEN INITIALIZE REST OF
C	OUTPUT
C
	IF (USECLD) WRITE (1,1061) USENAM,USEFAC,OUTNAM(1:LOUTNM)
 1061	FORMAT (A8,' Reactivity,  MR Factor =',1PE7.0,',  File = ',A)
	WRITE (1,'(A)') 'ScenID = '//SCENID(1:LSCNID)
	IF (CORFAC.NE.1.0) WRITE (1,'(''CorFac = '',1PE12.3)') CORFAC
C
C	OUTPUT LMS REACTIVITIES.  WHILE YOU'RE AT IT, CALCULATE
C	KR'S FOR LMS.S
C
	IF (NOCLC) THEN
		WRITE (1,5101)
 5101		FORMAT (/'      Lumped Model Species Reactivities:'
     &           //'      LMSname       IR/M'/)
	ELSE
		WRITE (1,51)
   51		FORMAT (/'      Lumped Model Species Reactivities:'
     &           //'      LMSname       KR       MR/M      IR/M'/)
	ENDIF
	DO 50 I=1,NSPE
	IF (RDFD(I)) THEN
		IF (NOCLC) THEN
			WRITE (1,5201) SPENAM(I),SPEIR(I)
 5201			FORMAT (6X,A8,F11.5)
		ELSE
			IF (SPEMR(I).EQ.0.0) THEN
				SPEKR(I)=0.0
			ELSE
				SPEKR(I)=SPEIR(I)/SPEMR(I)
			ENDIF
			WRITE (INLIN(1:8),FMT) SPEMR(I)
			WRITE (1,52) SPENAM(I),SPEKR(I),INLIN(1:8),
     &			 SPEIR(I)
   52			FORMAT (6X,A8,F10.4,1X,A8,1PE10.2)
		ENDIF
	ENDIF
   50	CONTINUE
C
C	OUTPUT DMS REACTIVITIES (THAT CAN BE DEFINED)
C
	IF (NOCLC) THEN
		WRITE (1,7501)
 7501		FORMAT (/'Reactivity Data:'//'DMSname      IR/G'/'.C')
 6201		FORMAT (A8,F10.5)
	ELSE
		WRITE (1,75)
   75		FORMAT (/'Reactivity Data:'//
     &           'DMSname       KR       MR/C     IR/C     IR/G'/',')
   62		FORMAT (A8,F10.4,1X,A8,1P2E10.2)
	ENDIF
C
	DO 300 IDMS=1,NDMS
	IF (DMSNC(IDMS).NE.0.AND.IAST(IDMS).LT.IAST(IDMS+1)) THEN
		SKR=0.0
		SIR=0.0
		TOTMOL=0.0
		DO 310 I=IAST(IDMS),IAST(IDMS+1)-1
		J=DMSSPE(I)
		X=DMSSPF(I)
		IF (X.EQ.0.0) GOTO 310
		IF (.NOT.RDFD(J)) GOTO 300
		SKR=SKR+(SPEKR(J)*X)
		SIR=SIR+(SPEIR(J)*X)
		TOTMOL=TOTMOL+X
  310		CONTINUE
		FNC=FLOAT(DMSNC(IDMS))
		SIRC=SIR/FNC
		IF (NOCLC) THEN
			WRITE (1,6201) DMSNAM(IDMS),SIRC
		ELSE
			IF (SKR.EQ.0.0) THEN
				SMR=0.0
			ELSEIF (TOTMOL.LE.0.0) THEN
				SKR=0.0
				SMR=0.0
			ELSE
				SKR=SKR/TOTMOL
				SMR=SIRC/SKR
			ENDIF
			WRITE (INLIN(1:8),FMT) SMR
			WRITE (1,62) DMSNAM(IDMS),SKR,INLIN(1:8),SIRC,
     &			 SIR*48.0/DMSMW(IDMS)
		ENDIF
	ENDIF
  300	CONTINUE
	IF (NOCLC) THEN
		WRITE (1,6201) 'INERT   ',0.0
	ELSE
		WRITE (1,62) 'INERT   ',0.0,'        ',0.0,0.0
	ENDIF
C
C	DONE
C
	CLOSE (UNIT=1)
	WRITE (6,*) 'Done.  File = ',FILNAM(1:LFIL),' created.'
	CALL EXIT (0)
C
C	ERRORS
C	
 900	WRITE (6,*) 'File = ',FILNAM(1:LFIL),' does not exist.'
	GOTO 990
 902	WRITE (6,*) 'File = ',DMSFIL(1:LDMSFL),' does not exist.'
	GOTO 990
 910	WRITE (6,*) 'Error reading data in file = ',FILNAM(1:LFIL)
	WRITE (6,*) 'Bad line = ',INLIN(1:LNBLNK(INLIN))
 990	CALL EXIT (1)
	END
