C	GENLUMP.FOR
C
C	READS IN CONTROL PARAMETERS DEFINING MODEL SPECIES AND HOW
C	THEY ARE LUMPED.  FOR GENERAL LUMPINT.
C
C	ARGUMENTS:
C		IN1	UNIT NO. TO READ LUMPING CONTROL FILE.  IF
C			NEGATIVE, IT IS ALREADY OPEN, OTHERWISE, PGM
C			ASKS FOR NAME OF FILE.   CLOSED WHEN DONE.]
C		IUNIT2	UNIT NO.  AVAILABLE FOR USE.  MUST BE CLOSED
C			INITIALLY, CLOSED WHEN DONE
C		IKODE	USED TO CONTROL INITIALIZATION:
C			IKODE=<0:  TEMPR, PREFIX TO BE READ FROM LPC
C				   FILE.  (PREPEMIT MODE)
C			IKODE=1:   TEMPR, PREFIX ASSUMED TO BE ALREADY
C				   INITIALIZED, BUT CAN BE CHANGED BY LPC
C				   FILE
C			IKODE=>2:  TEMPR, PREFIX ASSUMED TO BE DEFINED, AND
C				   CANNOT BE CHANGED BY LPC FILE (LUMPINT
C				   MODE)
C
	SUBROUTINE RDLUMP (IN1,IUNIT2,IKODE)
C
C
	INTEGER IN1,IUNIT1,IUNIT2
C
C	COMMON SPECIFICATIONS
C
	INCLUDE 'LUMPSPEC.FOR'
C
C
C	LOCAL SPECIFICATIONS:
C
	LOGICAL ERRIND,ADDNEW
	CHARACTER FILNAM*80,INLIN*255,LPCFIL*40,NAMEIN*8
C
C
	LMECUC=LNBLNK(MECUIC)
C
C	INITIALIZE OUTPUT FORMAT VARIABLES
C
	IF (IKODE.LE.0) THEN
		LPRE=0
		LPRECH=' '
	ENDIF
	INTFMT=.FALSE.
	SHORT=.TRUE.
	ADDNEW=.TRUE.
C
C	INITIALIZE ASSIGNMENT PARAMETERS.
C
	NSPE=0
	NSPESV=0
C
	NDMS=0
	IAST(1)=1
C
	NSUB=0
C
C
C	GET PARM FILE NAME, OPEN IT, AND PROCESS PARMS
C	FORMAT OF PARM FILE:  INPUT RECORDS CAN BE IN ANY ORDER,
C	COMMANDS ARE "TEMP", "PARM", "GROUP", AND "REPLACE".
C
	IF (IN1.LT.0) THEN
		IUNIT1=-IN1
	ELSE
		IUNIT1=IN1
 100		WRITE (ICRT,102)
 102		FORMAT (' File name for control parms (<CR> to end): ')
		READ (IKEY,'(A)',END=9900) LPCFIL
		OPEN (UNIT=IUNIT1,FILE=LPCFIL,STATUS='OLD',ERR=100)
	ENDIF
C
C	PROCESS LUMPING CONTROL INPUT
C
 110	READ (IUNIT1,'(A)',END=180) INLIN
	IF (INLIN(1:1).EQ.'!') GOTO 110
	IF (INLIN(1:1).EQ.' ') GOTO 110
C
C	THE FOLLOWING ARE NOT USED FOR GENERAL LUMPING.
C
	IF (INLIN(1:4).EQ.'TEMP') THEN
		GOTO 110
	ELSEIF (INLIN(1:6).EQ.'INTOH') THEN
		GOTO 110
	ELSEIF (INLIN(1:4).EQ.'PARM') THEN
		GOTO 110
	ELSEIF (INLIN(1:5).EQ.'GROUP') THEN
		GOTO 110
	ELSEIF (INLIN(1:7).EQ.'NOSHORT') THEN
		GOTO 110
C
C	FOLLOWING COMMANDS ARE USED, COMMON TO LUMPINT.
C
C	FORMATTING OPTIONS.
C
	ELSEIF (INLIN(1:6).EQ.'INTFMT') THEN
C
C		INTFMT		OUTPUT FORMATTED SO IT CAN BE READ
C				BY SAPRC INT PROGRAM (NOT USED FOR
C				AIRSHED MODEL PREPARATIONS)
C
		INTFMT=.TRUE.
C
C
	ELSEIF (INLIN(1:6).EQ.'PREFIX') THEN
C
C		PREFIX prefix	4-CHAR (MAX) PREFIX FOR OUTPUT MODEL
C				SPECIES NAMES.  (FOR USE WITH SAPRC
C				INT PROGRAM ONLY.  NOT FOR AIRSHED
C				MODEL PREPARATIONS.)
C
		IF (IKODE.LE.1) THEN
			IF (INLIN(8:8).EQ.' ') THEN
				GOTO 9100
			ELSEIF (INLIN(9:9).EQ.' ') THEN
				LPRE=1
			ELSEIF (INLIN(10:10).EQ.' ') THEN
				LPRE=2
			ELSEIF (INLIN(11:11).EQ.' ') THEN
				LPRE=3
			ELSE
				LPRE=4
			ENDIF
			LPRECH=INLIN(8:11)
		ENDIF
C
C
C	COMMON LUMPING OPTIONS
C
	ELSEIF (INLIN(1:7).EQ.'REPLACE') THEN
C
C		REPLACE filename	filename = NAME OF FILE TO READ
C					MODEL SPECIES REPLACEMENT OR "LUMPED
C					MOLECULE" INFORMATION.  IF filename
C					IS BLANK, READS THIS INFO FROM THIS
C					FILE UNTIL 'END' RECORD ENCOUNTERED.
C
		IF (INLIN(9:9).EQ.' ') THEN
			IUNIT=IUNIT1
			FILNAM=LPCFIL
		ELSE
			IF (MECUIC(1:1).EQ.' ') THEN
				FILNAM=INLIN(9:)
			ELSE
				FILNAM=MECUIC(1:LMECUC)//INLIN(9:)
			ENDIF
			OPEN (UNIT=IUNIT2,FILE=FILNAM,STATUS='OLD',
     &			 ERR=9200)
			IUNIT=IUNIT2
		ENDIF
C
  130		READ (IUNIT,'(A)',END=138) INLIN
		IF (INLIN(1:1).EQ.'!'.OR.INLIN(1:1).EQ.' ') GOTO 130
		IF (INLIN(1:4).EQ.'END ') THEN
			IF (IUNIT.NE.UNIT1) CLOSE (UNIT=IUNIT2)
			GOTO 110
		ENDIF
		IF (NSUB.EQ.MAXSUB) STOP 'TOO MANY SUBSTITUTIONS'
		NSUB=NSUB+1
		CALL PARSE0 (3,INLIN,80)
		CALL PARSE1 (1,SUBNAM(NSUB),I,8,INLIN)
		CALL PARSE1 (2,SUBOUT(NSUB),I,8,INLIN)
		CALL PARSER (3,SUBFAC(NSUB),ERRIND,INLIN)
		IF (SUBNAM(NSUB).EQ.SUBOUT(NSUB)) THEN
			NSUB=NSUB-1
			GOTO 130
		ENDIF
		IF (SUBFAC(NSUB).EQ.0.0) SUBFAC(NSUB)=1.0
C
C		SEE IF SUBSTITUTING NAME IS ITSELF SUBSTITUTED BY
C		PREVIOUS INPUT
C
		IF (NSUB.EQ.1) GOTO 130
		DO 132 I=1,NSUB-1
		IF (SUBOUT(NSUB).EQ.SUBNAM(I)) THEN
			SUBOUT(NSUB)=SUBOUT(I)
			SUBFAC(NSUB)=SUBFAC(NSUB)*SUBFAC(I)
			IF (SUBNAM(NSUB).EQ.SUBOUT(NSUB)) THEN
				NSUB=NSUB-1
				GOTO 130
			ENDIF
			GOTO 134
		ENDIF
  132		CONTINUE
C
C		SEE IF THIS SUBSTITUTION MODIFIES A PREVOUS ONE
C
  134		DO 136 I=1,NSUB-1
		IF (SUBNAM(NSUB).EQ.SUBOUT(I)) THEN
			SUBOUT(I)=SUBOUT(NSUB)
			IF (SUBNAM(I).EQ.SUBOUT(I)) THEN
				SUBNAM(I)=SUBNAM(NSUB)
				SUBOUT(I)=SUBOUT(NSUB)
				SUBFAC(I)=SUBFAC(I)*SUBFAC(NSUB)
				NSUB=NSUB-1
				GOTO 130
			ENDIF
		ENDIF
  136		CONTINUE
		GOTO 130
C
  138		IF (IUNIT.EQ.IUNIT1) GOTO 180
		CLOSE (UNIT=IUNIT)
C
C
C	GET NAMES OF LUMPED SPECIES.  NOTE THAT IF THIS OPTION IS USED,
C	ADDNEW IS SET TO "F" TO INDICATE THAT NEW SPECIES CANNOT BE
C	ADDED EXCEPT THROUGH "SPECIES" COMMAND
C
	ELSEIF (INLIN(1:7).EQ.'SPECIES') THEN
C
C		SPECIES filename	filename = NAME OF FILE TO READ
C					LIST OF EXPLICIT MODEL SPECIES.  IF
C					FILE NAME IS BLANK, READS THIS 
C					INFO FROM THIS FILE UNTIL 'END'
C					RECORD ENCOUNTERED.
C
		ADDNEW=.FALSE.
C
		IF (INLIN(9:9).EQ.' ') THEN
			FILNAM=LPCFIL
			IUNIT=IUNIT1
		ELSE
			IF (MECUIC(1:1).EQ.' ') THEN
				FILNAM=INLIN(9:)
			ELSE
				FILNAM=MECUIC(1:LMECUC)//INLIN(9:)
			ENDIF
			OPEN (UNIT=IUNIT2,FILE=FILNAM,STATUS='OLD',
     &			 ERR=9200)
			IUNIT=IUNIT2
		ENDIF
C
  200		READ (IUNIT,'(A)',END=208) INLIN
		IF (INLIN(1:1).EQ.'!'.OR.INLIN(1:1).EQ.' ') GOTO 200
		IF (INLIN(1:4).EQ.'END ') THEN
			NSPESV=NSPE
			IF (IUNIT.NE.UNIT1) CLOSE (UNIT=IUNIT2)
			GOTO 110
		ENDIF
		CALL PARSE0 (1,INLIN,80)
		CALL PARSE1 (1,NAMEIN,I,8,INLIN)
C
		IF (NSPE.NE.0) THEN
			DO 202 I=1,NSPE
			IF (NAMEIN.EQ.SPENAM(I)) GOTO 200
  202			CONTINUE
		ENDIF
		IF (NSPE.EQ.MAXSPE) GOTO 9500
		NSPE=NSPE+1
		SPENAM(NSPE)=NAMEIN
		GOTO 200
C
  208		NSPESV=NSPE
		IF (IUNIT.EQ.IUNIT1) GOTO 180
		CLOSE (UNIT=IUNIT)
C
C
C	LUMPED SPECIES ASSIGNMENTS.
C
	ELSEIF (INLIN(1:6).EQ.'ASSIGN') THEN
C
C		ASSIGN filename		filename = NAME OF FILE TO READ
C					ASSIGNMENTS OF DMS SPECIES TO 
C					EXPLICIT MODEL SPECIES.  IF filename
C					IS BLANK, READS THIS INFO FROM THIS
C					FILE UNTIL 'END' RECORD ENCOUNTERED.
C
C		EACH LINE CAN HAVE UP TO 16 ASSIGNMENTS + AMOUNTS.
C
		IF (INLIN(8:8).EQ.' ') THEN
			FILNAM=LPCFIL
			IUNIT=IUNIT1
		ELSE
			IF (MECUIC(1:1).EQ.' ') THEN
				FILNAM=INLIN(9:)
			ELSE
				FILNAM=MECUIC(1:LMECUC)//INLIN(9:)
			ENDIF
			OPEN (UNIT=IUNIT2,FILE=FILNAM,STATUS='OLD',
     &			 ERR=9200)
			IUNIT=IUNIT2
		ENDIF
C
  400		READ (IUNIT,'(A)',END=420) INLIN
		IF (INLIN(1:1).EQ.'!') GOTO 400
		IF (INLIN(1:1).EQ.' ') GOTO 400
		IF (INLIN(1:4).EQ.'END ') THEN
			IF (IUNIT.NE.UNIT1) CLOSE (UNIT=IUNIT2)
			GOTO 110
		ENDIF
		IF (NDMS.EQ.MAXDMS) THEN
			WRITE (ICRT,*) 'SPECIES "',INLIN(1:8),'" AND ',
     &			 'THOSE FOLLOWING IGNORED.  INCRESE MAXDMS.'
			GOTO 420
		ENDIF
		NDMS=NDMS+1
		DMSNAM(NDMS)=INLIN(1:8)
		N1=NDMS+1
		I1=IAST(NDMS)
C
		CALL PARSE0 (17,INLIN,200)
		F=1.0
		DO 410 I=1,16
		CALL PARSE1 (I+1,NAMEIN,L,8,INLIN)
		IF (NAMEIN(1:1).EQ.' ') GOTO 412
		IF (NAMEIN(1:1).EQ.'#') THEN
			CALL PARSER (I+1,F,ERRIND,INLIN)
			IF (ERRIND) GOTO 9400
		ELSE
			IF (I1.GT.MAXAST) THEN
				WRITE (ICRT,*) 'TOO MANY ASSIGNMENTS.',
     &				 '  INCREASE MAXAST.'
				GOTO 9900
			ENDIF
C
C			FIND MODEL SPECIES USED
C
			DO 414 J=1,NSPE
			IF (NAMEIN.EQ.SPENAM(J)) THEN
				ISPE=J
				GOTO 416
			ENDIF
  414			CONTINUE
			IF (NSPE.EQ.MAXSPE) GOTO 9500
C
C			SPECIES NOT FOUND.  ADD NEW SPECIES.
C
			IF (NSPE.EQ.MAXSPE) GOTO 9500
			NSPE=NSPE+1
			IF (ADDNEW) NSPESV=NSPESV+1
			SPENAM(NSPE)=NAMEIN
			ISPE=NSPE
C
 416			DMSSPE(I1)=ISPE
			DMSSPF(I1)=F
			I1=I1+1
			F=1.0
		ENDIF
  410		CONTINUE
C
  412		IAST(N1)=I1
		GOTO 400
C
  420		IF (IUNIT.EQ.IUNIT1) GOTO 180
		CLOSE (UNIT=IUNIT)
	ELSE
C
C		UNRECOGNIZED LUMPING CONTROL COMMAND
C
		GOTO 9100
	ENDIF
C
C	LOOP BACK FOR NEXT LUMPING CONTROL COMMAND
C
	GOTO 110
C
C	END OF LUMPING CONTROL INPUT
C
  180	CLOSE (UNIT=IUNIT1)
	IF (IN1.GT.0) WRITE (ICRT,182) NSUB,NDMS
  182	FORMAT (' Parameters for',I4,' substitutions and',
     &   I4,' model species read.')
C
	RETURN
C
C
C	ERRORS
C
 9100	WRITE (ICRT,*) 'ERROR READING DATA FROM LUMPING CONTROL FILE:'
	WRITE (ICRT,'(1X,A)') INLIN
	GOTO 9900
C
 9200	WRITE (ICRT,*) 'ERROR OPENING LUMPING PARM FILE = ',
     &	 FILNAM(1:LNBLNK(FILNAM))
	GOTO 9900
C
 9400	WRITE (ICRT,*) 'BAD DATA IN ASSIGN INPUT'
	WRITE (ICRT,*) 'BAD RECORD = ',INLIN(1:LNBLNK(INLIN))
	GOTO 9900
C
 9500	WRITE (ICRT,*) 'TOO MANY LUMPED MODEL SPECIES.  INCREASE ',
     &	 'MAXSPE'
C
C	DONE
C
 9900	WRITE (ICRT,*) 'PROGRAM ABORTED.'
	CALL EXIT (2)
	END
C
C
C 
	SUBROUTINE GENLMP (OUTU)
C
C	LUMPING SUBROUTINE TO LUMPING.  READS COMPOSITION DATA USING
C	INBUF, OUTPUTS LUMPED COMPOSITIONS AND PARAMETERS
C	TO UNIT = OUTU (OPEN).  
C
C	RECOGNIZED PARAMETERS (IGNORED)
C
C		NORENAME	SUPPRESSES .NAME OUTPUT
C		NOPARM		SUPPRESSES PARAMETER VALUE OUTPUT
C
C	THIS VERSION PASSES THROUGH UNRECOGNIZED INPUT
C
C	INPUT TERMINATED BY <EOF> AND RECORDS STARTING WITH '.'.
C
C
C	LUMPED ASSIGNMENT SPECIFICATIONS
C
	INCLUDE 'LUMPSPEC.FOR'
C
C
C	LUMPED SPECIES CONCENCENTRATIONS
C
	REAL SPELVL(MAXSPE)
C
C	LOCAL SPECIFICATIONS.
C
	INTEGER OUTU
	LOGICAL ERRIND
	CHARACTER INLIN*80,NAMEIN*8
C
C	
C	INITIALIZE 
C
	DO 2 I=1,NSPE
    2	SPELVL(I)=0.0
C
	NUNK=0
C
C
C	READ AND DECODE NEXT INPUT LINE.  IF IT CAN'T BE DECODED,
C	LOOP TO 180 TO OUTPUT LINE W/O CHANGE
C
	FAC=1.0
C  
  100	CALL INBUF ('LUMP: ',6)
	IF (IORET.EQ.2) GOTO 300
	IF (IOB160(1:1).EQ.'.') THEN
		GOTO 300
	ELSEIF (IOB160(1:1).EQ.' ') THEN
		GOTO 180
C
C	IGNORED PARAMETERS.
C
	ELSEIF (IOB160(1:8).EQ.'NORENAME') THEN
		GOTO 100
	ELSEIF (IOB160(1:6).EQ.'NOLUMP') THEN
		GOTO 100
	ELSEIF (IOB160(1:6).EQ.'NOPARM') THEN
		GOTO 100
	ENDIF
C
C	GETS HERE IF NO SPECIAL COMMAND INPUT.
C	ASSUMED TO BE A NAME AND A VALUE
C
C	SPECIAL NAME:  #FAC value:	MULTIPLY ALL SUBSEQUENT VALUES BY
C					FACTOR INPUT.
C
	INLIN=IOB160(1:32)
C
	CALL PARSE0 (2,INLIN,80)
	NAMEIN='        '
	CALL PARSE1 (1,NAMEIN,L,8,INLIN)
	CALL PARSER (2,F,ERRIND,INLIN)
	IF (ERRIND) GOTO 180
C
C	#FAC f	FACTOR TO MULTIPLY ALL VALUES BY f
C
	IF (NAMEIN(1:4).EQ.'#FAC') THEN
		FAC=F
		GOTO 100
	ELSE
		F=F*FAC
	ENDIF
C
C	SPECIES INPUT ASSUMED.  IGNORE SPECIES WITH ZERO LEVELS
C
	IF (F.EQ.0.0) GOTO 100

C
C	FIRST REPLACE BY SUBSTITUTIONS, IF ANY.  
C
	DO 212 I=1,NSUB
	IF (NAMEIN.EQ.SUBNAM(I)) THEN
		NAMEIN=SUBOUT(I)
		F=F*SUBFAC(I)
	ENDIF
  212	CONTINUE
C
C
C	CHECK TO SEE IF LUMPED SPECIES
C
	DO 220 I=1,NSPE
	IF (NAMEIN.EQ.SPENAM(I)) THEN
		SPELVL(I)=SPELVL(I)+F
		GOTO 100
	ENDIF
  220	CONTINUE
C
C
C	CHECK TO SEE IF THIS RECOGNIZED DMS.  DO SPECIES LUMPING IF SO.
C
  238	DO 239 IDMS=1,NDMS
	IF (NAMEIN.EQ.DMSNAM(IDMS)) THEN
		IF (IAST(IDMS).GE.IAST(IDMS+1)) GOTO 100
		DO 236 I=IAST(IDMS),IAST(IDMS+1)-1
  236		SPELVL(DMSSPE(I))=SPELVL(DMSSPE(I))+(F*DMSSPF(I))
		GOTO 100
	ENDIF
  239	CONTINUE
C
C
C	NOT A RECOGNIZED SPECIES.  ADD IT TO LIST OF UNKNOWN SPECIES.
C
  240	IF (NUNK.GT.0) THEN
		DO 244 I=1,NUNK
		IF (NAMEIN.EQ.UNKNAM(I)) THEN
			UNKLVL(I)=UNKLVL(I)+F
			GOTO 100
		ENDIF
  244		CONTINUE
	ENDIF
C
C	ADD NEW NON-LUMPED SPECIES.
C
	IF (NUNK.EQ.MAXUNK) THEN
		WRITE (ICRT,*) 'Too many unrecognized species.  Bad',
     &		 ' input file or MAXUNK too small.'
  245		CALL INBUF ('BYPASS: ',8)
		IF (IORET.EQ.2) GOTO 300
		IF (IOB160(1:1).EQ.'.') GOTO 300
		GOTO 245
	ENDIF
	NUNK=NUNK+1
	UNKNAM(NUNK)=NAMEIN
	UNKLVL(NUNK)=F
	GOTO 100
C
C
C	CONTROL REACHES HERE IF INPUT LINE CAN'T BE DECODED.
C	OUTPUT IT AS IS AND LOOP BACK FOR MORE.
C
  180	WRITE (OUTU,'(A)') IOB160(1:LENSTR(IOB160,80))
	GOTO 100
C
C
C	END OF COMPOSITON INPUT PROCESSING.  DO LUMPING AND OUTPUT
C	RESULTS 
C
C
C	OUTPUT MODEL SPECIES THEN UNRECOGNIZED SPECIES.
C
  300	DO 310 I=1,NSPESV
	IF (SPELVL(I).NE.0.0) THEN
		IF (LPRE.EQ.0) THEN
			WRITE (OUTU,'(A8,1PE12.4)') SPENAM(I),
     &			 SPELVL(I)
		ELSE
			J=8-LPRE
			WRITE (OUTU,'(A,A,1PE12.4)') LPRECH(1:LPRE),
     &			 SPENAM(I)(1:J),SPELVL(I)
		ENDIF
	ENDIF
  310	CONTINUE
C
	IF (NSPESV.LT.NSPE) THEN
		DO 312 I=NSPESV+1,NSPE
		IF (SPELVL(I).NE.0.0) WRITE (OUTU,
     &		 '(''! '',A8,1PE12.4)') SPENAM(I),SPELVL(I)
  312		CONTINUE
	ENDIF
C
	IF (NUNK.GT.0) THEN
		IF (LPRE.EQ.0) THEN
			WRITE (OUTU,'(A8,1PE12.4)') (UNKNAM(I),
     &			 UNKLVL(I),I=1,NUNK)
		ELSE
			J=8-LPRE
			WRITE (OUTU,'(A,A,1PE12.4)') (LPRECH(1:LPRE),
     &			 UNKNAM(I)(1:J),UNKLVL(I),I=1,NUNK)
		ENDIF
	ENDIF
C
C
C	DONE 
C
C
	RETURN
	END
