C	LUMPSPEC.FTN
C
C	SPECIFICATIONS FOR CARBON BOND 4 LUMPING HC PROGRAM.  
C
C
C	VARIABLES USED TO CONTROL OUTPUT FORMAT
C
C	LPRECH	PREFIX FOR MODEL SPECIES NAMES
C	LPRE	LENGTH OF PREFIX
C	INTFMT	OUTPUT TO BE FORMATTED SO IT CAN BE USED AS
C		INPUT INTO SAPRC INT PROGRAM.
C	SHORT	PREVENTS INTLUMP FROM CONDENSING GROUPS
C
	CHARACTER*4 LPRECH
	INTEGER LPRE
	LOGICAL INTFMT,SHORT
C
C
C	MODEL SPECIES USED FOR LUMPING.  ASSIGNED USING "SPECIES"
C	COMMAND.
C
	PARAMETER (MAXSPE=500)
C
	INTEGER NSPE,NSPESV
	CHARACTER*8 SPENAM(MAXSPE)
C
C
C	MISC.
C
C	MECUIC	LOCATION OF "INCLUDE" FILES (FROM MODELING.PRM OR .PRM FILE)
C	PRMCNV	PARAMETER CONVERSION PROGRAM, IF USED.
C	SPARE1	SPARE CHARACTER STRINGS
C	SPARE2
C
	CHARACTER*60 MECUIC,PRMCNV,SPARE1,SPARE2
C
C	------------------------------------------------------------
C	SPECIFICATIONS FOR DETAILED MODEL SPECIES
C	------------------------------------------------------------
C
C	MAXDMS	MAXIMUM NO. DETAILED MODEL SPECIES
C	MAXAST	MAX. NO ASSIGNMENTS.
C	NDMS	NO. DETAILED MODEL SPECIES
C	IAST	ASSIGNMENT NO'S.
C	DMSNAM	SPECIES NAMES
C	DMSSPE	MODEL SPECIES ASSIGNMENTS
C	DMSSPF	AMOUNT OF MODEL SPECIES.
C	
C
	PARAMETER (MAXDMS=2000)
	PARAMETER (MAXAST=3*MAXDMS,MAXDM1=MAXDMS+1)
	INTEGER NDMS
	CHARACTER*8 DMSNAM(MAXDMS)
	INTEGER IAST(MAXDM1),DMSSPE(MAXAST)
	REAL DMSSPF(MAXAST)
C
C	SPECIFICATIONS FOR PRE-SUBSTITUTED SPECIES MODEL SPECIES
C
C	MAXSUB	MAX. NO SUBSTITUTIONS
C	NSUB	TOTAL NO. OF SUBSTITUTIONS.
C	SUBNAM	NAMES TO BE SUBSTITUTED
C	SUBOUT	NAMES REPLACING SUBSTITUTED NAMES
C	SUBFAC	FACTOR TO CHANGE LEVEL WHEN SUBSTITUTING
C
	PARAMETER (MAXSUB=1000)
	INTEGER NSUB
	CHARACTER*8 SUBNAM(MAXSUB),SUBOUT(MAXSUB)
	REAL SUBFAC(MAXSUB)
C
C
C	UNRECOGNIZED SPECIES.
C
C	MAXUNK	MAXINUM NUMBER OF SUCH GROUPS
C	NUNK	NO OF GROUPS
C	UNKNAM	NAME OF GROUP
C	UNKLVL	NO. MOLES IN GROUP
C
	PARAMETER (MAXUNK=1000)
	INTEGER NUNK
	CHARACTER*8 UNKNAM(MAXUNK)
	REAL UNKLVL(MAXUNK)
C
C
C	------------------------------------------------------------
C	COMMON BLOCKS FOR LUMPING DATA.
C	------------------------------------------------------------
C
	LOGICAL NOLPC
C
	COMMON /LMPDAT/ NSPE,NSPESV,LPRE,NDMS,IAST,DMSSPE,DMSSPF,NSUB,
     &	 SUBFAC,NUNK,UNKLVL,INTFMT,SHORT,NOLPC
	COMMON /LMPCHR/ SPENAM,LPRECH,DMSNAM,SUBNAM,SUBOUT,UNKNAM,
     &	 MECUIC,PRMCNV,SPARE1,SPARE2
C
C	------------------------------------------------------------
C	STANDARD FILE UNIT SPECIFICATIONS
C	------------------------------------------------------------
C
	INTEGER ICRT,IKEY,UNIT1,UNIT2,UNIT3,UNIT4
	PARAMETER (ICRT=6,IKEY=5)
	PARAMETER (UNIT1=1,UNIT2=2,UNIT3=3,UNIT4=4)
C
C	
C	------------------------------------------------------------
C	INPUT/OUTPUT BUFFERS (USED TO COMMUNICATE WITH INBUF)
C	------------------------------------------------------------
C
       LOGICAL    SHOW, NOKEY
       INTEGER    IN, IOLEN, IORET, LOUTBF
       CHARACTER*1  BYT16(16), BYT160(160)
       CHARACTER    IOB160*160, IOBF16*16, OUTBUF*132
C
       COMMON /IOBUF/ IN,IOLEN,IORET,MAXUNT,NOKEY,SHOW,LOUTBF
       COMMON /IOBFCH/ BYT16,IOB160,OUTBUF
       EQUIVALENCE (IOB160,BYT160),  (BYT16,IOBF16)
C
