C       PREP.FOR     MAIN PREP PROGRAM
C
	PROGRAM PREP
C
C      INPUT FILES ARE:  [loguic]input-name.PRP
C                        [loguic]*.RXO
C                                  these * names come from input-name.PRP
C                        [phfuic]*.PHF
C                                  these * names come from the *.RXO files
C
C      OUTPUT FILES ARE: [loguic]input-name.OUT
C                        [moduic]input-name.MOD
C                        [moduic]input-name.FOR
C
C -----------------------------------------------------------------------
C
	INCLUDE 'PSPECS.FOR'
	LOGICAL NOBTCH
C
C	NOBTCH USED TO INDICATE NOT RUN BY COMMAND FILE.  NOBTCH=F FOR PC
C	ONLY.
C
C	CHECK SPECS
C
	IF (MAXMAX.LT.MAXRXN.OR.MAXMAX.LT.MAXCO.OR.MAXMAX.LT.MAXNS)
     &	 STOP 'INCREASE MAXMAX'
C
C
C	GET UIC'S FOR .MOD AND .SDR FILES
C
	OPEN (UNIT=UNIT1,FILE='MODELING.PRM',STATUS='UNKNOWN',ERR=140)
C-
	MODUIC=' '
	PHFUIC=' '
	LOGUIC=' '
	TMPUIC=' '
        IOBF16=' '
        IOB160=' '
  130	READ (UNIT1,131,END=139) IOBF16,IOB160
  131	FORMAT (A4,A40)
	IF (IOBF16(1:4).EQ.'MOD=') THEN
   	 MODUIC=IOB160
	ELSEIF (IOBF16(1:4).EQ.'PHF=') THEN
 	 PHFUIC=IOB160
	ELSEIF (IOBF16(1:4).EQ.'LOG=') THEN
	 LOGUIC=IOB160
	ELSEIF (IOBF16(1:4).EQ.'TMP=') THEN
	 TMPUIC=IOB160
	ENDIF
	GOTO 130
C
 139	CLOSE (UNIT=UNIT1)
C
 140   CALL INITIN(4)
       NERR=0
       MODFIL=' '
       YESPRP=.TRUE.
       NOPRP=.FALSE.
C      FOR 'DUMMY' PREP SET YESPRP=.FALSE., NOPRP=.TRUE.
C
C      GET FILE NAMES.  INPUT FROM name.IN UNLESS TI: OR BLANK
C      INITIALLY SPECIFIED.  OUTPUT TO name.OUT FOR PRINTOUT,
C      AND TO [CHAMBER.CARTER.VIRPI.MODELS]name.MOD FOR MODELS.
C          OPEN MODEL FILE TO SEE IF OK, THEN CLOSE & DELETE.
C      (IF TASK IS INSTALLED, THEN INPUT/OUTPUT FILES' NAME TAKEN
C      FROM MCR COMMAND LINE.)
C
	CALL GETARG (1,IOB160)

	CALL PARSE0 (2,IOB160,80)
	CALL PARSE1 (1,MODFIL,LMODFL,16,IOB160)
	IF (MODFIL(1:1).NE.' ') THEN
		NOBTCH=.FALSE.
		GOTO 107
	ENDIF
C-
  100  WRITE (ICRT,101)
  101  FORMAT ('PRP input file = ',$)
       READ (IKEY,'(A)',END=9999) MODFIL
       NOBTCH=.TRUE.
  107  IF (MODFIL(1:1).EQ.' ') CALL EREXIT
CD      WRITE (ICRT,108) MODFIL
CD 108  FORMAT (' MODFIL= ',A16)
C  -     OPEN INPUT FILE
       IOB160=' '
       CALL FILNAM (LENAM,IOB160,LOGUIC,MODFIL,'.PRP ')
       CALL FILEIN
       IF (IORET.EQ.1) THEN
             IF (NOBTCH) THEN
                 WRITE (ICRT,*) 'ERROR IN FILEIN'
                 GOTO 100
             ELSE
		 WRITE (ICRT,*) '"'//IOB160(1:LNBLNK(IOB160))//'"'
		 WRITE (ICRT,*) IORET
                 WRITE (ICRT,*) 'CAN''T OPEN INPUT FILE.  ABORTED.'
                 CALL EREXIT
             ENDIF
       ENDIF
C
C      GET TITLE
C
  110  CALL INBUF ('TITLE  :',8)
       IF (IORET.EQ.2) GOTO 999
       TITLE(17:80)=IOB160
       CALL TMARK(TITLE(1:16))
C
C     SET PARMS TO DEFAULT
C
       ASMPRT=.FALSE.
       AIRSHD=.FALSE.
       VARYHV=.FALSE.
       SAVPHF=.FALSE.
       MF=0
       TEMPR=298.12
       TREF=300.0
       NPHOTK=0
       IRET=0
       NCOC1=MAXVCD+1
C
C	AIRSHED MODEL FORMATS:
C	FORM2=T FOR AIRSHED MODEL.  DILUTION IGNORED, EKMA-LIKE "AIRSHD"
C	OPTIONS TURNED OFF, 'RDMOD' FORMAT .MOD FILE, DIFFERENT .FOR
C	FILE FORMAT, MW'S, ETC. SAVED.
C
C	FORM3=T TO HAVE FORMATION AND LOSS RATES SEPARATELY CALCULATED.
C
	FORM2=.FALSE.
	FORM3=0
C
       IOB160=' '
       CALL FILNAM (LENAM,IOB160,LOGUIC,MODFIL,'.PRO ')
C-VBS
C.       OPEN (UNIT=OUT,NAME=IOB160,TYPE='NEW',RECORDSIZE=133,ERR=100)
C-I
       OPEN (UNIT=OUT,FILE=IOB160,STATUS='UNKNOWN',ERR=100)
C-
C      WRITE HEADER (FILE OUTPUT ONLY)
C
       WRITE (OUT,121) TITLE(1:16),TITLE(17:80)
  121  FORMAT ('1',130('*')//1X,29X,'S A P R C   M O D E L   P R E P',
     &  ' A R A T I O N   P R O G R A M'//1X,52X,A16//1X,28X,A64/
     &  /1X,130('*')//' PARAMETERS SPECIFIED:'/' ')
C
C      READ IN PARMS.  '.' IN FIRST LINE MEANS END OF PARM
C      INPUT, REST OF COMMANDS GO TO RDRXN
C
  200  CALL INBUF ('PARM.  :',8)
       IF (IORET.EQ.2) GOTO 999
       IF (IOB160(1:1).EQ.'.') GOTO 1000
       IF (IOB160(1:4).EQ.'    ') GOTO 1000
       OUTBUF=' '
       WRITE (OUTBUF,202) IOB160
  202  FORMAT (5X,A80)
       LOUTBF=LENSTR(IOB160,80)+5
C
       IF (IOB160(1:5).EQ.'DEBUG') THEN
		ASMPRT=.TRUE.
       ELSEIF (IOB160(1:4).EQ.'TEMP') THEN
		CALL ALIN16 (2,IOB160)
		READ (IOB160(17:80),221,ERR=800) X
  221		FORMAT (G16.0)
		IF (X.LE.0.0) GOTO 800
		TEMPR=X
        ELSEIF (IOB160(1:4).EQ.'TREF') THEN
                CALL ALIN16 (2,IOB160)
		READ (IOB160(17:80),221,ERR=800) X
		IF (X.LE.0.0) GOTO 800
		TREF=X
	ELSEIF (IOB160(1:6).EQ.'MAXVCO') THEN
		CALL ALIN16 (2,IOB160)
		READ (IOB160(17:80),'(I16)',ERR=800) I
		IF (I.GT.MAXCOV) THEN
			WRITE (ICRT,*) 'MAXIMUM ALLOWABLE MAXVCO =',
     &			 MAXCOV
			GOTO 800
		ELSEIF (I.LE.0) THEN
			I=MAXCOV
		ENDIF
		NCOC1=I+1
	ELSEIF (IOB160(1:7).EQ.'AIRSHED') THEN
		AIRSHD=.TRUE.
		VARYHV=.TRUE.
	ELSEIF (IOB160(1:6).EQ.'VARYHV') THEN
		VARYHV=.TRUE.
	ELSEIF (IOB160(1:7).EQ.'SAVEPHF') THEN
		SAVPHF=.TRUE.
	ELSEIF (IOB160(1:9).EQ.'FORMAT=FL') THEN
C			SEPARATE CALC OF FORM AND LOSS RATES, BUT ALL ELSE
C			LIKE NORMAL FORMAT
			FORM3=1
C			FORM2=.FALSE.	! ALREADY SET AT FALSE
	ELSEIF (IOB160(1:7).EQ.'FORMAT=') THEN
C			FORCE FORM2 ** NOT SUPPORTED BY STANDARD SAPRC INT PRM **
		IF (IOB160(8:8).EQ.'2') THEN
			FORM3=0
		ELSEIF (IOB160(8:8).EQ.'3') THEN
			FORM3=1
C			SEPARATE CALC OF FORM AND LOSS RATES, REAL
		ELSEIF (IOB160(8:8).EQ.'B') THEN
C			RAM'S "BOX MODEL" FORMAT
C			SEPARATE CALC OF FORM AND LOSS RATES, REAL*8
			FORM3=2
		ELSE
			GOTO 800
		ENDIF
		FORM2=.TRUE.
		AIRSHD=.FALSE.
		VARYHV=.FALSE.
	ELSE
		GOTO 800
	ENDIF
C
C
	WRITE (OUT,701) OUTBUF
  701	FORMAT (' ',A131)
	GOTO 200
C
C      ERROR
C
  800  WRITE (OUTBUF(LOUTBF+1: ),801)
  801  FORMAT ('     <--ERROR.  IGNORED.')
       WRITE (OUT,701) OUTBUF
       NERR=NERR+1
       IF (OUT.NE.6) WRITE (ICRT,802) IOB160(1:32)
  802  FORMAT (' ERROR.  UNRECOGNIZED PARM.  LINE = ',A32)
       GOTO 200
C
C  -                   READ REACTION LIST
 1000  WRITE (OUT,1001)
 1001  FORMAT (/' REACTIONS INPUT:',62X,'A',8X,'EA',6X,'B'/79X,
     &   '(IN PPM-MIN UNITS)')
	CALL RDRXN
	IF (NERR.GT.0) THEN
		YESPRP=.FALSE.
		NOPRP=.TRUE.
	ENDIF
	CALL REORDR
	IF (YESPRP) THEN
		CALL PNHRXN
C		           			! PRODUCE CODE
                IF (NERR.GT.0) THEN
                       YESPRP=.FALSE.
                       NOPRP=.TRUE.
                ENDIF
	ENDIF
	CALL LISTSC
C	           				! LIST REACTANTS AND COEF'S
	CALL SAVERX
C	            				! SAVE CODE OR LIST PHOT FILES
C  -                   DONE.  CLOSE FILES
  999	IF (OUT.NE.ICRT) WRITE (OUT,9003)
 9003	FORMAT (/1X,130('*')//46X,'E N D   P R E P   O U T P U T'/
     &	 /1X,130('*'))
	CLOSE (UNIT=OUT)
	IF (OUT.NE.ICRT) THEN
		IF (YESPRP) THEN
			IF (NOBTCH) WRITE (ICRT,9000) MODFIL
 9000			FORMAT (' MODEL = ''',A16,''' PREPARED.')
		ELSE
			WRITE (ICRT,9001) MODFIL
 9001			FORMAT (' MODEL = ''',A16,''' PROCESSED.')
		ENDIF
	ENDIF
 9999	IF (NERR.GT.0) THEN
                WRITE (ICRT,9002) NERR
 9002	        FORMAT (' ',I4,' ERRORS OCCURED')
 	        CALL EREXIT
        ELSE
                CALL OKEXIT
        ENDIF
	END
	SUBROUTINE EREXIT
	CALL EXIT (1)
	END
	SUBROUTINE OKEXIT
	CALL EXIT (0)
	END
