	PROGRAM MROPT
C
C	FINDS MIR AND MOR POINTS BY VARYING NOX, AND FITTING TO
C	FUNCTION.
C
C	RUNS INT
C
C	THIS VERSION -- ONLY VARIES NOX
C
	PARAMETER (MAXCAL=50)
	REAL ROG,NOX(MAXCAL),O3MAX(MAXCAL),ROGIR(MAXCAL),NOXIR(MAXCAL),
     &	 AVGN,PRM(5),UPRM(5)
	LOGICAL TEST,TSTPGM,ABORT
	COMMON /O3RCOM/ NCAL,IMAXO,IMAXR,IBASE,INDCAL,LOGU,ICAL,TEST,
     &	 NINT,ROG,NOX,O3MAX,ROGIR,NOXIR,DELROG,CORR,AVGN,PRM,UPRM
C
	CHARACTER CMDLIN*80,REASON*30,CLCUIC*60
	COMMON /CMDCOM/ CMDLIN,REASON,CLCUIC
C
	REAL BENDIF(MAXCAL)
C
	CHARACTER INLIN*80,SCNID*8,LOGFIL*40,SPLFIL*40,INBUF*44
C
	NINT=0
	ABORT=.FALSE.
C
C	OPTIMIZATION PARAMETERS
C
	DELROG=0.02
C
C	READ SCENARIO ID
C
C
	CALL GETARG (1,SCNID)
	IF (SCNID(1:1).EQ.' ') GOTO 800
	LSCNID=LNBLNK(SCNID)
	TEST=LSCNID.EQ.4.AND.SCNID(1:4).EQ.'TEST'
C
C	DECODE OPTIONS
C
	TSTPGM=.FALSE.
	LOGFIL=' '
	SPLFIL=' '
C
	J=2
    1	CALL GETARG (J,INBUF)
	IF (INBUF(1:5).EQ.'NOLOG') THEN
		LOGFIL(1:1)='*'
	ELSEIF (INBUF(1:4).EQ.'LOG=') THEN
		LOGFIL=INBUF(5:)
	ELSEIF (INBUF(1:4).EQ.'SPL=') THEN
		SPLFIL=INBUF(5:)
	ELSEIF (INBUF(1:7).EQ.'TESTPGM') THEN
		TSTPGM=.TRUE.
	ELSEIF (INBUF(1:1).EQ.' ') THEN
		GOTO 2
	ELSE
		GOTO 800
	ENDIF
	J=J+1
	IF (J.LE.4) GOTO 1
    2	CONTINUE
C
C	OPEN LOG FILE (IF APPLICABLE)
C
	IF (LOGFIL(1:1).EQ.'*') THEN
		LOGU=0
	ELSE
		LOGU=8
		IF (LOGFIL(1:1).EQ.' ') THEN
			LOGFIL=SCNID
			OPEN (UNIT=LOGU,FILE=SCNID(1:LSCNID)//'.LOG',
     &			 STATUS='UNKNOWN')
		ELSE
			OPEN (UNIT=LOGU,FILE=LOGFIL(1:LNBLNK(LOGFIL))//
     &			 '.LOG',ACCESS='APPEND',STATUS='UNKNOWN')
		ENDIF
		CALL TMARK (INBUF)
		WRITE (LOGU,1111) 'Start ScenID = '//SCNID//
     &		 ',  time = '//INBUF(1:16)
	ENDIF
 1111	FORMAT (A)
C
C
C	INITIALIZE (READ AND OPEN .BAS FILE ON UNIT 7, READY FOR APPEND)
C	BASE HC, NOX, O3MAX
C
	IF (TEST) THEN
		CALL TSTINI (SCNID,LSCNID,7,ROG,NOX(1),O3MAX(1),CORR,I)
	ELSE
		CALL MROINI (SCNID,LSCNID,7,ROG,NOX(1),O3MAX(1),CORR,I)
	ENDIF
	IF (I.NE.0) GOTO 810
C
C
C	CALCULATE BASE IR(ROG)
C
	IMAXO=1
	IMAXR=1
	IBASE=1
	F=NOX(1)
	NOX(1)=0.0
	REASON='Initial base calc'
	CALL O3RCAL (F,ABORT)
	IF (ABORT) GOTO 199
	WRITE (7,'(''IR(ROG)'',F12.6)') ROGIR(IBASE)
C
C	INITIAL CALCULATIONS:  VARY NOx BY FACTOR OF 1.5 FROM BASE
C
C
	REASON='Initial NOx decrease by 1.5'
	CALL O3RCAL (NOX(1)/1.5,ABORT)
	IF (ABORT) GOTO 199
	REASON='Initial NOx increase by 1.5'
	CALL O3RCAL (NOX(1)*1.5,ABORT)
	IF (ABORT) GOTO 199
C
C	IF JUST TESTING PROGRAM, QUIT AT THIS POINT
C
	IF (TSTPGM) THEN
		DO 99 I=1,NCAL
		NOXIR(I)=0.0
   99		BENDIF(I)=0.0
		GOTO 100
	ENDIF
C
C	IF MAX O3 POINT IS HIGHEST NOX, DO NEXT CALC WITH HIGHER NOX
C
   10	IF (IMAXO.EQ.1) THEN
		REASON='MaxO3 is highest NOx'
		CALL O3RCAL (1.7*NOX(1),ABORT)
		IF (ABORT) GOTO 199
		GOTO 10
	ENDIF
C	
C	IF MAX REACT POINT IS HIGEST NOX, DO NEXT CALC WITH SOMEWHAT HIGHER
C	NOX
C
   11	IF (IMAXR.EQ.1) THEN
		REASON='MaxRCT is highest NOx'
		CALL O3RCAL (1.3*NOX(1),ABORT)
		IF (ABORT) GOTO 199
		GOTO 11
	ENDIF
C
C	IF MAX O3 POINT IS LOWEST NOX, DO NEXT CALC WITH YET LOWER NOX
C
   12	IF (IMAXO.EQ.NCAL) THEN
		REASON='MaxO3 is lowest NOx'
		CALL O3RCAL (NOX(NCAL)/1.5,ABORT)
		IF (ABORT) GOTO 199
	ENDIF
C
C	FIGURE MAXIMUM SPACING BASED ON 7 CALCULATIONS,
C
	SFAC=(NOX(1)/NOX(NCAL))**0.14
	SPAC=(NOX(1)-NOX(NCAL))/7.
	SFAC2=SQRT(SFAC)
	SPAC2=SPAC/2
C
   20	DO 22 I=2,NCAL
	I1=I-1
	IF (NOX(I1)/NOX(I).GT.SFAC) THEN
		REASON='Normal factor spacing'
		CALL O3RCAL (SQRT(NOX(I1)*NOX(I)),ABORT)
		IF (ABORT) GOTO 199
		GOTO 20
	ELSEIF (NOX(I1)-NOX(I).GT.SPAC) THEN
		REASON='Normal difference spacing'
		CALL O3RCAL (0.5*(NOX(I1)+NOX(I)),ABORT)
		IF (ABORT) GOTO 199
		GOTO 20
	ENDIF
	IF (I.EQ.IMAXR.OR.I.EQ.IMAXO.OR.I1.EQ.IMAXR.OR.I1.EQ.IMAXO) THEN
		IF (NOX(I1)/NOX(I).GT.SFAC2) THEN
			REASON='Closer factor spacing'
			CALL O3RCAL (SQRT(NOX(I1)*NOX(I)),ABORT)
			IF (ABORT) GOTO 199
			GOTO 20
		ELSEIF (NOX(I1)-NOX(I).GT.SPAC2) THEN
			REASON='Closer difference spacing'
			CALL O3RCAL (0.5*(NOX(I1)+NOX(I)),ABORT)
			IF (ABORT) GOTO 199
			GOTO 20
		ENDIF
	ENDIF
   22	CONTINUE
C
C	FIND EXACT O3MAX AND MIR POINTS
C
	CALL FITMAX (IMAXO,SPAC2,SFAC2,ABORT)
	IF (ABORT) GOTO 199
	CALL FITMAX (IMAXR,SPAC2,SFAC2,ABORT)
	IF (ABORT) GOTO 199
C
C	DELETE POINTS WHICH ARE WITHIN 1.5% OF O3MAX OR MIR POINTS
C
	X1=NOX(IMAXR)*0.985
	X2=NOX(IMAXR)*1.015
	X3=NOX(IMAXO)*0.985
	X4=NOX(IMAXO)*1.015
	DO 2501 I=1,NCAL
	IF (I.NE.IMAXR.AND.I.NE.IMAXO) THEN
		XX=NOX(I)
		IF ((XX.GT.X1.AND.XX.LT.X2).OR.(XX.GT.X3.AND.XX.LT.X4))
     &		 NOX(I)=0.0
	ENDIF
 2501	CONTINUE
	J1=0
	DO 2502 I=1,NCAL
	IF (NOX(I).NE.0.0) THEN
		J1=J1+1
		IF (J1.NE.I) THEN
			NOX(J1)=NOX(I)
			O3MAX(J1)=O3MAX(I)
			ROGIR(J1)=ROGIR(I)
			IF (IMAXR.EQ.I) IMAXR=J1
			IF (IMAXO.EQ.I) IMAXO=J1
			IF (IBASE.EQ.I) IBASE=J1
		ENDIF
	ENDIF
 2502	CONTINUE
	NCAL=J1
C
C	BY NOW, THERE SHOULD BE ENOUGH POINTS TO DO REGRESSIONS TO
C	GET NOX REACTIVITIES.
C
   25	CALL DIFFY5 (NCAL,NOX,O3MAX,NOXIR,I)
	IBMIN=0
	DO 30 I=1,NCAL
	NOXIR(I)=CORR*NOXIR(I)
	BENDIF(I)=(NOXIR(I)*NOX(I))-(ROGIR(I)*ROG)
	IF (NOXIR(I).GT.0.0.AND.BENDIF(I).LT.0.0) IBMIN=I
   30	CONTINUE
	IF (IBMIN.EQ.0) THEN
		WRITE (6,*) 'Can''t find equal benefit point.'
		GOTO 100
	ENDIF
C
C	LOOP BACK IF EQUAL BENEFIT POINT IS TO CLOSE TO LOWEST NOX
C
	IF (IBMIN.GT.NCAL-2) THEN
		REASON='Low NOx too close to e.b. pt.'
		CALL O3RCAL (NOX(NCAL)/SFAC,ABORT)
		IF (ABORT) GOTO 199
		GOTO 25
	ENDIF
C
C	DO REGRESSION ON FOUR POINTS AROUND BENEFIT CROSSOVER 
C	TO FIND BETTER APPROX TO THAT POINT.
C
	I=IBMIN-1
	IF (LOGU.NE.0) THEN
		WRITE (LOGU,6001) (NOX(J),J=I,I+3)
		WRITE (LOGU,6002) (BENDIF(J),J=I,I+3)
	ENDIF
 6001	FORMAT (/'Find BENDIF ',5F12.4)
 6002	FORMAT (12X,5F12.4)
	CALL QFITC(4,NOX(I),BENDIF(I),AVGN,PRM,UPRM,3)
	F=(PRM(2)*PRM(2))-(4.*PRM(1)*PRM(3))
	IF (F.LT.0.0) THEN
		WRITE (6,*) 'Regression to find equal benefit point',
     &		 ' has no roots.'
		IBMIN=0
		GOTO 100
	ENDIF
	F=SQRT(F)
	ENOX=AVGN-((PRM(2)+F)/(2.*PRM(3)))
	IF (ENOX.GT.NOX(IBMIN).OR.ENOX.LT.NOX(IBMIN+1)) THEN
		ENOX=AVGN-((PRM(2)-F)/(2.*PRM(3)))
		IF (ENOX.GT.NOX(IBMIN).OR.ENOX.LT.NOX(IBMIN+1)) THEN
			WRITE (6,*) 'Estimate of equal benefit p',
     &			 'oint not in range.'
			IBMIN=0
			GOTO 100
		ENDIF
	ENDIF
C
C	ADD NEW "BEST FIT" POINT
C
	REASON='Add equal benefit point'
	CALL O3RCAL (ENOX,ABORT)
	IF (ABORT) GOTO 199
	IBMIN=ICAL
	CALL DIFFY5 (NCAL,NOX,O3MAX,NOXIR,I)
	DO 50 I=1,NCAL
	NOXIR(I)=CORR*NOXIR(I)
   50	BENDIF(I)=(NOXIR(I)*NOX(I))-(ROGIR(I)*ROG)
C
C	DELETE POINTS WHICH ARE WITHIN 1.5% OF EQUAL BENEFIT POINT
C
	J1=1
	X1=NOX(IBMIN)*0.985
	X2=NOX(IBMIN)*1.015
	DO 2511 I=1,NCAL
	IF (I.NE.IMAXR.AND.I.NE.IMAXO.AND.I.NE.IBMIN) THEN
		XX=NOX(I)
		IF (XX.GT.X1.AND.XX.LT.X2) THEN
			NOX(I)=0.0
			J1=0
		ENDIF
	ENDIF
 2511	CONTINUE
	IF (J1.EQ.0) THEN
		DO 2512 I=1,NCAL
		IF (NOX(I).NE.0.0) THEN
			J1=J1+1
			IF (J1.NE.I) THEN
				NOX(J1)=NOX(I)
				O3MAX(J1)=O3MAX(I)
				ROGIR(J1)=ROGIR(I)
				IF (IMAXR.EQ.I) IMAXR=J1
				IF (IMAXO.EQ.I) IMAXO=J1
				IF (IBASE.EQ.I) IBASE=J1
				IF (IBMIN.EQ.I) IBMIN=J1
			ENDIF
		ENDIF
 2512		CONTINUE
		NCAL=J1
	ENDIF
C
C	ABORT ENTRY POINT
C
	GOTO 100
  199	CONTINUE
C
C	OUTPUT RESULTS TO .BAS FILE (OPEN ON UNIT 7)
C
  100	WRITE (7,'(''IR(NOX)'',F12.6)') NOXIR(IBASE)
	WRITE (7,1111) '!             E.NOX       O3MAX     '//
     &	 'IR(ROG)     IR(NOX)   BD.NOX-HC'
	J=100
	DO 31 I=1,NCAL
	IF (I.EQ.IMAXR) THEN
		INLIN='NOx-MIR'
	ELSEIF (I.EQ.IMAXO) THEN
		INLIN='NOx-MOR'
	ELSEIF (I.EQ.IBMIN) THEN
		INLIN='NOx-LIM'
	ELSE
		J=J+1
		WRITE (INLIN,'(''NOx'',I3,1X)') J
		INLIN(4:4)='-'
	ENDIF
   31	WRITE (7,32) INLIN(1:7),NOX(I),O3MAX(I),ROGIR(I),NOXIR(I),
     &	 BENDIF(I)
   32	FORMAT (A7,5F12.6)
	CLOSE (UNIT=7)
C
	IF (TEST) THEN
		WRITE (6,*) 'Test results in TEST.TMP'
	ELSE
		WRITE (6,*) 'NOx variation results added to file = '
     &		 ,SCNID(1:LSCNID),'.BAS.'
	ENDIF
	IF (LOGU.NE.0) THEN
		CALL TMARK (INBUF)
		WRITE (LOGU,1111) 'End ScenID   = '//SCNID//
     &		 ',  time = '//INBUF(1:16)
		IF (ABORT) WRITE (LOGU,1111) 'ABORTED'
		WRITE (LOGU,1111)
		CLOSE (UNIT=LOGU)
		WRITE (6,*) 'Process logged in file = ',
     &		 LOGFIL(1:LNBLNK(LOGFIL)),'.LOG.'
	ENDIF
	IF (ABORT) THEN
		WRITE (6,*) 'ABORTED'
		CALL EXIT (2)
	ENDIF
C
C	OUTPUT SPL FILE FOR RESULTS
C
	O3MMAX=0.0
	RIRMAX=0.0
	RIRMIN=0.0
	XIRMAX=0.0
	XIRMIN=0.0
	DO 110 I=1,NCAL
	ROGIR(I)=ROGIR(I)*ROG
	NOXIR(I)=NOXIR(I)*NOX(I)
	IF (O3MAX(I).GT.O3MMAX) O3MMAX=O3MAX(I)
	IF (ROGIR(I).GT.RIRMAX) RIRMAX=ROGIR(I)
	IF (ROGIR(I).LT.RIRMIN) RIRMIN=ROGIR(I)
	IF (NOXIR(I).GT.XIRMAX) XIRMAX=NOXIR(I)
	IF (NOXIR(I).LT.XIRMIN) XIRMIN=NOXIR(I)
  110	CONTINUE
	RIRFAC=AMAX1(RIRMAX,ABS(RIRMIN))
	XIRFAC=AMAX1(XIRMAX,ABS(XIRMIN))
	IF (RIRFAC.NE.0.0) THEN
		RIRFAC=1.0/RIRFAC
	ELSE
		RIRFAC=1.0
	ENDIF
	IF (XIRFAC.NE.0.0) THEN
		XIRFAC=1.0/XIRFAC
	ELSE
		XIRFAC=1.0
	ENDIF
	IF (O3MMAX.EQ.0.0) O3MMAX=1.0
	DO 111 I=1,NCAL
	O3MAX(I)=O3MAX(I)/O3MMAX
	ROGIR(I)=ROGIR(I)*RIRFAC
  111	NOXIR(I)=NOXIR(I)*XIRFAC
	YMAX=1.0
	YMIN=AMIN1(RIRMIN*RIRFAC,XIRMIN*XIRFAC)
C
	IF (SPLFIL(1:1).EQ.' ') THEN
		OPEN (UNIT=1,FILE=SCNID(1:LSCNID)//'.SPL',
     &		 STATUS='UNKNOWN')
		WRITE (6,*) 'File = ',SCNID(1:LSCNID),'.SPL created.'
	ELSE
		LSPLFL=LNBLNK(SPLFIL)
		OPEN (UNIT=1,FILE=SPLFIL(1:LSPLFL)//'.SPL',
     &		 STATUS='UNKNOWN',ACCESS='APPEND')
		WRITE (6,*) 'Added to file = ',SPLFIL(1:LSPLFL),'.SPL.'
	ENDIF
	WRITE (1,1111) '* '//SCNID(1:LSCNID)
	WRITE (1,1111) 'XLABEL NOx Emissions'
	WRITE (1,1111) 'YLABEL Fraction of Maximum'
	WRITE (1,1111) 'LAB 2'
	WRITE (1,112) 'XMAX',NOX(1)*1.001,'XMIN',NOX(NCAL)*0.999,
     &	 'YMAX',YMAX,'YMIN',YMIN
	WRITE (1,115) NOX(IBASE),O3MAX(IBASE),NOX(IBASE),ROGIR(IBASE),
     &	 NOX(IBASE),NOXIR(IBASE)
  115	FORMAT (/'A Base Case'/(2F12.6))
  112	FORMAT (A4,F12.6)
	WRITE (1,114) O3MMAX,(NOX(I),O3MAX(I),I=1,NCAL)
  114	FORMAT (/'1 O3max (',F5.3,')'/(2F12.6))
	WRITE (1,116) '2 ROG',1./RIRFAC,(NOX(I),ROGIR(I),I=1,NCAL)
	WRITE (1,116) '5 NOX',1./XIRFAC,(NOX(I),NOXIR(I),I=1,NCAL)
  116	FORMAT (/A,' Effect (',F6.2,')'/(2F12.6))
	IF (IMAXR.NE.0) WRITE (1,117) NOX(IMAXR),YMIN,NOX(IMAXR),YMAX
	IF (IMAXO.NE.0) WRITE (1,117) NOX(IMAXO),YMIN,NOX(IMAXO),YMAX
	WRITE (1,117) NOX(1),0.0,NOX(NCAL),0.0
	IF (IBMIN.NE.0) WRITE (1,117) NOX(IBMIN),YMIN,NOX(IBMIN),YMAX
  117	FORMAT (/'3'/(2F12.6))
	CLOSE (UNIT=1)
C
	CALL EXIT (0)
C
C	ERRORS
C
  800	WRITE (6,*) 'Use:  MROPT SCNID [NOLOG] [LOG=logfile] ',
     &	 '[SPL=splfile]'
	WRITE (6,*) 'Where "SCNID" is a base case scenario',
     &	 ' already run (.BAS file exists).'
	CALL EXIT (1)
  810	WRITE (6,*) 'aborted.'
	CALL EXIT (2)
	END
C
C ----------------------------------------------------------------------
C 
	SUBROUTINE FITMAX (IND,SPAC,SFAC,ABORT)
C
C	FINDS MAXO3 (IND=INDMAX(1)) OR MAXIR (IND=INDMAX(2)) POINT
C
	PARAMETER (MAXCAL=50)
	REAL ROG,NOX(MAXCAL),O3ORIR(MAXCAL,2),NOXIR(MAXCAL),
     &	 AVGN,PRM(5),UPRM(5)
	LOGICAL TEST,ABORT
	COMMON /O3RCOM/ NCAL,INDMAX(2),IBASE,INDCAL,LOGU,ICAL,TEST,
     &	 NINT,ROG,NOX,O3ORIR,NOXIR,DELROG,CORR,AVGN,PRM,UPRM
C
	CHARACTER CMDLIN*80,REASON*30,CLCUIC*60
	COMMON /CMDCOM/ CMDLIN,REASON,CLCUIC
C
	CHARACTER*6 MAXLBL(2)
	DATA MAXLBL /'O3max ','MaxRct'/
C
C
	IF (IND.EQ.INDMAX(1)) THEN
		IIND=1
	ELSEIF (IND.EQ.INDMAX(2)) THEN
		IIND=2
	ELSE
		WRITE (6,*) 'PROGRAM ERROR; BAD FITMAX IND'
		ABORT=.TRUE.
		RETURN
	ENDIF
C
C	AT LEAST 2 POINTS SHOULD BE ABOVE AND BELOW MAXO3 AND MAXRCT
C	POINTS
C
   25	IF (IND.LE.2) THEN
		REASON='FitMax: need higher points'
		CALL O3RCAL (NOX(1)+SPAC,ABORT)
		IF (ABORT) GOTO 199
		IND=INDMAX(IIND)
		GOTO 25
	ENDIF
   26	IF (IND.GE.NCAL-1) THEN
		REASON='FitMax: need lower points'
		CALL O3RCAL (NOX(NCAL)/SFAC,ABORT)
		IF (ABORT) GOTO 199
		IND=INDMAX(IIND)
		GOTO 26
	ENDIF
C
C	GET "EXACT" MAX BY DOING FIT ON 5 POINTS AROUND CURRENT MAX
C
	I=IND-2
	IF (LOGU.NE.0) THEN
		WRITE (LOGU,6001) MAXLBL(IIND),1,(NOX(J),J=I,I+4)
		WRITE (LOGU,6002) (O3ORIR(J,IIND),J=I,I+4)
	ENDIF
 6001	FORMAT (/A6,' Try',I2,5F12.4)
 6002	FORMAT (12X,5F12.4)
	CALL QFITC(5,NOX(I),O3ORIR(I,IIND),AVGN,PRM,UPRM,4)
	F=(PRM(3)*PRM(3))-(3.*PRM(4)*PRM(2))
	IF (F.LT.0.0) THEN
		WRITE (6,*) 'Program error:  ',MAXLBL(IIND),
     &		 ' regression has no real roots.'
		ABORT=.TRUE.
		GOTO 199
	ELSE
		F=SQRT(F)
		ONOX=AVGN+PRM(3)-F
		IF (ONOX.GT.NOX(I).OR.ONOX.LT.NOX(IND+2)) THEN
			ONOX=AVGN+PRM(3)+F
			IF (ONOX.GT.NOX(I).OR.ONOX.LT.NOX(IND+2)) THEN
				WRITE (6,*) 'Program error:  ',
     &				 MAXLBL(IIND),' regression has no',
     &				 ' roots in range.'
C				ABORT=.TRUE.
C				GOTO 199
			ENDIF
		ENDIF
	ENDIF
C
C	DO CALCULATION FOR "EXACT" POINT
C
	REASON='FitMax: first estimate'
	CALL O3RCAL (ONOX,ABORT)
	IF (ABORT) GOTO 199
	IND=INDMAX(IIND)
C
C	NOW DO REGRESSION ON THE 4 POINTS THAT ARE CLOSEST TO NEW (OR OLD) MAX
C
	KOUNT=0
C
  100	KOUNT=KOUNT+1
	IF (O3ORIR(IND-2,IIND).GT.O3ORIR(IND+2,IIND)) THEN
		I=IND-2
	ELSE
		I=IND-1
	ENDIF
	IF (LOGU.NE.0) THEN
		WRITE (LOGU,6001) MAXLBL(IIND),KOUNT+1,(NOX(J),J=I,I+3)
		WRITE (LOGU,6002) (O3ORIR(J,IIND),J=I,I+3)
	ENDIF
	CALL QFITC(4,NOX(I),O3ORIR(I,IIND),AVGN,PRM,UPRM,3)
	ONOX=AVGN-(0.5*PRM(2)/PRM(3))
	WRITE (REASON,'(''FitMax: estimate'',I2)') KOUNT+1
	CALL O3RCAL (ONOX,ABORT)
	IF (ABORT) GOTO 199
	IND=INDMAX(IIND)
C
C	DO IT ONCE MORE
C
	IF (KOUNT.LT.2) GOTO 100
C
	IF (ONOX.NE.NOX(IND)) THEN
		IF (KOUNT.LT.3) GOTO 100
		WRITE (6,*) 'Warning:  ',MAXLBL(IIND),
     &		 ' point found by regression doesn''t have the ',
     &		 'largest value.'
		DO 42 I=1,NCAL
		IF (NOX(I).EQ.ONOX) THEN
			INDMAX(IIND)=I
			RETURN
		ENDIF
   42		CONTINUE
		STOP 'PGM ERROR IN O3RCAL:  NO NOX SET TO ONOX'
	ENDIF
	ABORT=.FALSE.
	RETURN
 199	ABORT=.TRUE.
	RETURN
	END
C ----------------------------------------------------------------------
C 
	SUBROUTINE O3RCAL(FNOX,ABORT)
C
C	CALLS O3CALC TO DETERMINE O3MAX, THEN TO DETERMINE IR (ROG)
C
	PARAMETER (MAXCAL=50)
	REAL ROG,NOX(MAXCAL),O3MAX(MAXCAL),ROGIR(MAXCAL),NOXIR(MAXCAL),
     &	 AVGN,PRM(5),UPRM(5)
	LOGICAL TEST,ABORT
	COMMON /O3RCOM/ NCAL,IMAXO,IMAXR,IBASE,INDCAL,LOGU,ICAL,TEST,
     &	 NINT,ROG,NOX,O3MAX,ROGIR,NOXIR,DELROG,CORR,AVGN,PRM,UPRM
C
	CHARACTER CMDLIN*80,REASON*30,CLCUIC*60
	COMMON /CMDCOM/ CMDLIN,REASON,CLCUIC
C
C
	IF (NCAL.EQ.MAXCAL) THEN
		WRITE (6,*) 'INCREASE MAXCAL'
		ABORT=.TRUE.
		RETURN
	ELSE
		ABORT=.FALSE.
	ENDIF
C
C	DETERMINE ORDERING OF THIS NOX (DECENDING ORDER)
C
	DO 1 I=1,NCAL
	IF (FNOX.EQ.NOX(I)) THEN
		WRITE (6,*) 'PROGRAM ERROR.  NOX SAME AS PREVIOUS'
		ABORT=.TRUE.
		RETURN
	ELSEIF (FNOX.GT.NOX(I)) THEN
		DO 11 J=NCAL,I,-1
		J1=J+1
		NOX(J1)=NOX(J)
		O3MAX(J1)=O3MAX(J)
   11		ROGIR(J1)=ROGIR(J)
		IF (IMAXR.GE.I) IMAXR=IMAXR+1
		IF (IMAXO.GE.I) IMAXO=IMAXO+1
		IF (IBASE.GE.I) IBASE=IBASE+1
		ICAL=I
		GOTO 2
	ENDIF
    1	CONTINUE
	ICAL=NCAL+1
C
    2	NCAL=NCAL+1
	NOX(ICAL)=FNOX
C
	IF (TEST) THEN
		INDCAL=0
C
C	O3.TMP
C	 Order:    5
C	 AvgX:        2.328    
C	 Parms:      0.2202     -1.2771E-02 -2.6911E-02  3.0362E-03  1.1650E-03
C	 uPARMS:     8.5203E-04  9.8799E-04  1.2853E-03  3.7060E-04  3.3532E-04
C
		F=FNOX-2.328
		O3MAX(ICAL)=0.2202-(1.2771E-02*F)-(2.6911E-02*F*F)
     &		 +(3.0362E-03*(F**3))+(1.1650E-03*(F**4))
C
C	ROG.TMP
C	 Order:    5
C	 AvgX:        2.328    
C	 Parms:      0.3979      0.4005      0.1081     -5.6636E-02 -3.2117E-02
C	 uPARMS:     1.7849E-02  2.0697E-02  2.6926E-02  7.7637E-03  7.0245E-03
C
		ROGIR(ICAL)=0.3979+(0.4005*F)+(0.1081*F*F)-
     &		 (5.6636E-02*(F**3))-(3.2117E-02*(F**4))
C
C		WRITE (6,*) REASON(1:LNBLNK(REASON))
C
	ELSE
		CALL O3CALC (ROG,FNOX,O3MAX(ICAL),INDCAL,NINT)
		IF (INDCAL.NE.0) GOTO 810
C
		CALL O3CALC (ROG*(1.+DELROG),FNOX,DELO3,INDCAL,NINT)
		IF (INDCAL.NE.0) GOTO 810
		ROGIR(ICAL)=CORR*(DELO3-O3MAX(ICAL))/(DELROG*ROG)
	ENDIF
C
	IF (ROGIR(ICAL).GT.ROGIR(IMAXR)) IMAXR=ICAL
	IF (O3MAX(ICAL).GT.O3MAX(IMAXO)) IMAXO=ICAL
C
	IF (LOGU.NE.0) WRITE (LOGU,'(3F12.6,I5,1X,A)') 
     &	 NOX(ICAL),O3MAX(ICAL),ROGIR(ICAL),NINT/2,REASON
C
	RETURN
C
  810	WRITE (6,*) 'aborted.'
	ABORT=.TRUE.
	RETURN
C
	END
C ----------------------------------------------------------------------
C 
	SUBROUTINE TSTINI (SCNID,LSCNID,IUNIT,ROG,NOX,O3MAX,CORR,IND)
C
C	CREATES .INT AND COMMAND FILE FOR SIMULATIONS, RETURNS ROG AND NOX
C
C	SCNID,LSCNID	= SCENARIO ID (INPUT)
C	IUNIT		= UNIT TO USE.  .BAS FILE OPENED AND LEFT OPEN
C	ROG,NOX		= ROG AND NOX READ FROM REACTCAL.IN FROM REACTCAL
C	O3MAX		= O3MAX READ FROM REACTCAL.IN FROM REACTCAL
C	CORR		= CORRECTION FACTOR FOR IR CALC.
C	IND 		= RETURN CODDE.  0 = SUCCESS.
C
	CHARACTER SCNID*8
	INTEGER LSCNID,IUNIT,IND
	REAL ROG,NOX,O3MAX
C
	ROG=15.6810
	NOX=2.3680
	O3MAX=0.219812
	SCNID='TEST'
	LSCNID=4
	CORR=67.0017
	IND=0
	OPEN (UNIT=7,FILE='TEST.TMP',STATUS='UNKNOWN')
	IUNIT=7
	RETURN
	END
C ----------------------------------------------------------------------
C 
	SUBROUTINE MROINI (SCNID,LSCNID,IUNIT,ROG,NOX,O3MAX,CORR,IND)
C
C	CREATES .INT AND COMMAND FILE FOR SIMULATIONS, RETURNS ROG AND NOX
C
C	SCNID,LSCNID	= SCENARIO ID (INPUT)
C	IUNIT		= UNIT TO USE.  .BAS FILE OPENED AND LEFT OPEN
C	ROG,NOX		= ROG AND NOX READ FROM REACTCAL.IN FROM REACTCAL
C	O3MAX		= O3MAX READ FROM REACTCAL.IN FROM REACTCAL
C	CORR		= CORRECTION FACTOR FOR IR CALC.
C	IND 		= RETURN CODDE.  0 = SUCCESS.
C
	CHARACTER SCNID*8
	INTEGER LSCNID,IUNIT,IND
	REAL ROG,NOX,O3MAX
C
	CHARACTER CMDLIN*80,REASON*30,CLCUIC*60
	COMMON /CMDCOM/ CMDLIN,REASON,CLCUIC
C
	CHARACTER MODUIC*60,STDMOD*8,INLIN*80
	LOGICAL ANS
C
C	GET PARMS FROM MODELING.PRM
C
	CLCUIC=' '
	MODUIC=' '
	STDMOD='AIRLMP'
C
	OPEN (UNIT=IUNIT,FILE='MODELING.PRM',STATUS='UNKNOWN')
   10	READ (IUNIT,1,END=12) INLIN
    1	FORMAT (A)
	IF (INLIN(1:4).EQ.'MOD=') THEN
		MODUIC=INLIN(5:)
	ELSEIF (INLIN(1:4).EQ.'CLC=') THEN
		CLCUIC=INLIN(5:)
	ELSEIF (INLIN(1:6).EQ.'MOD-S=') THEN
		STDMOD=INLIN(7:)
	ENDIF
	GOTO 10
   12	CLOSE (UNIT=IUNIT)
C
C	RUN REACTCAL FOR SCENARIO.  IF SUCCESSFUL, "REACTCAL.IN" 
C	WILL CONTAIN INFO ABOUT SCENARIO.
C
	OPEN (UNIT=IUNIT,FILE='REACTCAL.IN',STATUS='UNKNOWN')
	CLOSE (UNIT=IUNIT,STATUS='DELETE')

	CMDLIN='REACTCAL '//SCNID(1:LSCNID)//' +'
	CALL SYSTEM (CMDLIN)
C
	OPEN (UNIT=IUNIT,FILE='REACTCAL.IN',STATUS='OLD',ERR=800)
	READ (IUNIT,1,END=810) INLIN
	READ (INLIN,'(18X,4E14.7)',ERR=820) ROG,NOX,O3MAX,CORR
	IF (CORR.EQ.0.0) GOTO 820
	CORR=1./CORR
C
C	MAKE SURE MODEL.EXE FILE EXISTS, AND CREATE COMMAND LINE TO
C	RUN INT.
C
	LCMD=LNBLNK(MODUIC)
	L=LNBLNK(STDMOD)
	CMDLIN=MODUIC(1:MAX0(LCMD,1))
	CMDLIN(LCMD+1:)=STDMOD(1:L)//'.EXE'
	INQUIRE (FILE=CMDLIN,EXIST=ANS)
	IF (.NOT.ANS) THEN
		WRITE (6,*) 'File = ',CMDLIN(1:LCMD+L),
     &		 '.EXE does not exist'
		IND=2
		RETURN
	ENDIF
	CMDLIN(LCMD+1:)=STDMOD(1:L)//' '//SCNID(1:LSCNID)//' X MAX O3'
	LCMD=LCMD+L+LSCNID+9
C
C	OPEN .BAS FILE TO APPEND RESULTS.
C
	LC=LNBLNK(CLCUIC)
	INLIN=CLCUIC(1:MAX0(1,LC))
	INLIN(LC+1:)=SCNID(1:LSCNID)//'.BAS'
	OPEN (UNIT=IUNIT,FILE=INLIN,STATUS='OLD',ACCESS='APPEND',
     &	 ERR=830)
C
C	SUCCESSFUL CONCLUSION
C
	IND=0
	RETURN
C
C	ERRORS
C
  800	WRITE (6,*) 'REACTCAL failed.  No REACTCAL.IN produced.'
	IND=1
	RETURN
  810	WRITE (6,*) 'REACTCAL failed.  REACTCAL.IN is empty.'
	IND=1
	RETURN
  820	WRITE (6,*) 'REACTCAL failed.  Unexpected data in REACTCAL.IN:'
	WRITE (6,*) '"',INLIN(1:LNBLNK(INLIN)),'"'
	IND=1
	RETURN
  830	WRITE (6,*) 'File = ',INLIN(1:LC+LSCNID),'.BAS does not exist.'
	IND=3
	RETURN
	END
C ----------------------------------------------------------------------
C 
	SUBROUTINE O3CALC (ROG,NOX,O3MAX,IND,NINT)
C
C	RUNS INT TO DETERMINE O3MAX.  USES COMMAND LINE ALREADY
C	CREATED.  RESULT EXPECTED IN STATUS.TMP
C
C	ROG, NOX (INPUT):	ROG AND NOX FOR CALC
C	O3	(OUTPUT):	RESULTING O3 MAX
C	IND	(OUTPUT):	RESULT CODE.  0 = OK
C
	REAL ROG,NOX,O3MAX
C
	CHARACTER CMDLIN*80,REASON*30,CLCUIC*60
	COMMON /CMDCOM/ CMDLIN,REASON,CLCUIC
C
	CHARACTER INLIN*80
C
C	PUT ROG AND NOX IN REACTCAL.IN
C
	OPEN (UNIT=1,FILE='REACTCAL.IN',STATUS='UNKNOWN')
	WRITE (1,'(''TOT.HC '',1PE14.6)') ROG
	WRITE (1,'(''TOT.NOX'',1PE14.6)') NOX
	CLOSE (UNIT=1)
C
C	RESULT CREATED IN STATUS.TMP IF SUCCESSFUL
C
	OPEN (UNIT=1,FILE='STATUS.TMP',STATUS='UNKNOWN')
	CLOSE (UNIT=1,STATUS='DELETE')
C
	CALL SYSTEM (CMDLIN)
C
	OPEN (UNIT=1,FILE='STATUS.TMP',STATUS='OLD',ERR=800)
	READ (1,'(A)',END=810) INLIN
	IF (INLIN(1:6).NE.'INT OK') GOTO 820
	READ (1,'(A)',END=820) INLIN
	IF (INLIN(1:6).NE.'MAX O3') GOTO 820
	READ (INLIN,'(20X,E16.7)',ERR=820) O3MAX
	CLOSE (UNIT=1)
C
	NINT=NINT+1
	WRITE (6,20) ROG,NOX,O3MAX,NINT,REASON(1:LNBLNK(REASON))
  20	FORMAT (' ROG=',F7.3,', NOx=',F7.3,', O3max =',F7.4,I4,1X,A)
	IND=0
	RETURN
C
C	ERROR
C
  800	WRITE (6,*) 'INT failed.  No STATUS.TMP file.'
	IND=2
	RETURN
  810	WRITE (6,*) 'INT failed.  Empty STATUS.TMP file.'
	IND=2
  820	WRITE (6,*) 'INT failed.  STATUS.TMP file contains "',
     &	 INLIN(1:LNBLNK(INLIN)),'"'
	IND=2
	RETURN
	END
C ----------------------------------------------------------------------
C 
	SUBROUTINE QFITC (NPT,X,Y,XAVG,PARM,UPARM,NPARM)
C
C	QUADRATIC FIT USING X-XAVG.
C
C	ENTRY PQFITC (NPT,X,Y,UY)	TO COMPUTED PREDICTED Y'S AND
C					THEIR UNCERTAINTIES.
C	ARGUMENTS:
C
C	Y       VECTOR OF VALUES TO BE FIT
C	X       ARRAY OF 'INDEPENDENT' VARIABLES
C	NPT     NUMBER OF DATA PTS (FIXED AT NCN)
C	NPARM	NO. PARAMETERS (2 FOR LINE, 3 FOR QUAD)
C
C	XAVG	AVERAGE OF X.
C	PARM    VECTOR OF REGRESSION COEFS
C	UPARM   VECTOR OF UNCERTAINTIES (STD ERR) OF REGRESSION COEF (OUTPUT)
C
C	USED BY PREGRS
C
C	X	X VALUES FOR PREDICTED Y'S
C	Y	PREDICTED Y'S
C	UY	UNCERTAINTY OF PREDICTED Y'S
C
	PARAMETER (MAXPRM=5)
	REAL Y(NPT),X(NPT),PARM(MAXPRM),UPARM(MAXPRM),UY(NPT)
C
	PARAMETER (MPRMSQ=MAXPRM*MAXPRM)
	REAL SUMXY(MAXPRM),SUM(MAXPRM),PRMSAV(MAXPRM),XASAV
	REAL SUMSQ(MPRMSQ),MS
C
	DATA MPARM/0/,MPT/0/
C
	IF (NPARM.GT.MAXPRM) STOP 'INCREASE MAXPRM IN SUBS\QFIT.FOR'
C	IF (NPT.GT.MAXNPT) STOP 'INCREASE MAXNPT IN SUBS\QFIT.FOR'
C
	IF (NPT.LE.0) THEN
		RETURN
	ELSEIF (NPT.EQ.1) THEN
		PARM(1)=Y(1)
		UPARM(1)=0.0
		MPARM=1
		GOTO 800
	ELSEIF (NPT-1.LT.NPARM) THEN
		MPARM=NPT-1
	ELSE
		MPARM=NPARM
	ENDIF
	MPT=NPT
C
C	COMPUTE X AVG
	XAVG=0.0
	DO 1 I=1,NPT
    1	XAVG=XAVG+X(I)
	XAVG=XAVG/FLOAT(NPT)
	XASAV=XAVG
C
C	SPECIAL TREATMENT IF SIMPLE AVERAGE
C
	IF (MPARM.EQ.1) THEN
		SY=0.0
		SYY=0.0
		DO 2 I=1,NPT
		SY=SY+Y(I)
    2		SYY=SYY+(Y(I)*Y(I))
		SY=SY/FLOAT(NPT)
		SYY=SQRT((SYY-(FLOAT(NPT)*SY*SY))/FLOAT(NPT-1))
		PARM(1)=SY
		UPARM(1)=SYY
		GOTO 800
	ENDIF
C
C	NPTM1=NPT-1
C 
C	initialize
C
	SUMY=0.
	SUMYY=0.
	IJ=1
	DO 40 I=1,MPARM
          SUM(I)=0.
          SUMXY(I)=0.
          DO 20 J=1,MPARM
              SUMSQ(IJ)=0.
              IJ=IJ+1
   20     CONTINUE
   40 CONTINUE
 
C     sum sumsq
      DO 100 I=1,NPT
          SUMY=SUMY+Y(I)
          SUMYY=SUMYY+Y(I)*Y(I)
C
          DO 80 J=1,MPARM
	      IF (J.EQ.1) THEN
		  XIJ=1.0
	      ELSE
	          XIJ=(X(I)-XAVG)**(J-1)
	      ENDIF
              SUM(J)=SUM(J)+XIJ
              SUMXY(J)=SUMXY(J)+XIJ*Y(I)
              DO 60 L=J,MPARM
                  JL=(J-1)*MPARM+L
                  LJ=(L-1)*MPARM+J
		  IF (L.EQ.1) THEN
		      XIL=1.0
		  ELSE
		      XIL=(X(I)-XAVG)**(L-1)
		  ENDIF
                  SUMSQ(JL)=SUMSQ(JL)+(XIJ*XIL)
                  SUMSQ(LJ)=SUMSQ(JL)
   60         CONTINUE
   80     CONTINUE
  100 CONTINUE
 
C     DO 140 I=1,MPARM
C         SXY(I)=SUMXY(I)-SUM(I)*SUMY/NPT
C         DO 120 J=I,MPARM
C             IJ=(I-1)*MPARM+J
C             S(I,J)=SUMSQ(IJ)-SUM(I)*SUM(J)/NPT
C 120     CONTINUE
C         STD(I)=SQRT(S(I,I)/NPTM1)
C         XBAR(I)=SUM(I)/NPT
C 140 CONTINUE
C      YBAR=SUMY/NPT
C      SYY=SUMYY-SUMY*SUMY/NPT
C      STDY=SQRT(SYY/NPTM1)
 
      CALL VERTX(MPARM,SUMSQ)
 
      DO 200 I=1,MPARM
      PARM(I)=0.
          DO 180 J=1,MPARM
              IJ=(I-1)*MPARM+J
              PARM(I)=PARM(I)+SUMXY(J)*SUMSQ(IJ)
  180     CONTINUE
  200 CONTINUE
 
C sum of residuals
	SUMRES=0.
	DO 300 I=1,NPT
	YPRED=PARM(1)
	DO 220 J=2,MPARM
  220	YPRED=YPRED+PARM(J)*((X(I)-XAVG)**(J-1))
	SUMRES=SUMRES+(Y(I)-YPRED)**2
  300	CONTINUE
	MS=SUMRES/(NPT-MPARM)
C	RSQ=1.-(SUMRES/SUMYY)
C	IF (OUTU.NE.0) WRITE (OUTU,*) 'RSQ=',RSQ
 
C	IF (OUTU.NE.0) WRITE (OUTU,311)
C  311	FORMAT (/21X,'COEF',T33,'STD ERR',T45,'MEAN',T57,'STD DEV')
 
	DO 310 I=1,MPARM
	II=(I-1)*MPARM+I
	XX=SUMSQ(II)*MS
	IF (XX.LT.0.0) XX=0.0
	UPARM(I)=SQRT(XX)
	PRMSAV(I)=PARM(I)
C	IF (OUTU.NE.0) WRITE (OUTU,'('' VAR'',I6,T18,1P4G12.3)')
C     &	 I,PARM(I),UPARM(I),XBAR(I),STD(I)
  310	CONTINUE
C 
C
C	SET MPARM-NPARM PARMS TO ZERO
C
  800	IF (NPARM.LE.MPARM) RETURN
	DO 801 I=MPARM+1,NPARM
	PARM(I)=0.0
  801	UPARM(I)=0.0
	RETURN
C
C
C	ENTRY TO COMPUTE PREDICTED VALUE AND ITS UNCERTAINTY.
C
	ENTRY PQFITC (NPT,X,Y,UY)
	IF (NPT.LE.0) RETURN
	IF (MPARM.EQ.0) RETURN
	IF (MPT.LE.0) RETURN
C
	IF (MPARM.EQ.1) THEN
		DO 30 I=1,NPT
		Y(I)=SY
   30		UY(I)=SYY
		RETURN
	ENDIF

	YUNC0=1.0+(1.0/FLOAT(MPT))+SUMSQ(1)
C
	DO 400 I=1,NPT
	YPRED=PRMSAV(1)
	YUNC=YUNC0
	DO 410 J=2,MPARM
	XIJ=(X(I)-XASAV)**(J-1)
	YPRED=YPRED+(PRMSAV(J)*XIJ)
	YUNC=YUNC+(SUMSQ((J-1)*MPARM+J)*XIJ*XIJ)
	IF (J.LT.MPARM) THEN
		DO 420 L=J+1,MPARM
  420		YUNC=YUNC+(2.0*SUMSQ((J-1)*MPARM+L)*XIJ*
     &		 ((X(I)-XASAV)**(L-1)))
	ENDIF
  410	CONTINUE
	Y(I)=YPRED
  400	UY(I)=SQRT(YUNC*MS)
	RETURN
	END
C ----------------------------------------------------------------------
C 
	SUBROUTINE DIFFY5 (NPT,X,Y,DY,IND)
C
C	DIFFERENTIATS A FUNCTION BY FITTING EACH SET OF 5 POINTS TO
C	A CUBIC FIT.  MUST BE AT LEAST 5 POINTS
C
C	NPT = NO. POINTS
C	X,Y,DX = ARRAYS FOR INPUT AND OUTPUT
C	IND = RETURN CODE.  0 = OK. 1 = ERROR
C
	INTEGER NPT,IND
	REAL X(NPT),Y(NPT),DY(NPT)
C
	REAL PRM(5),UPRM(5),XAVG
	DYDX(XX)=PRM(2)+(2.*PRM(3)*XX)+(3.*PRM(4)*XX*XX)
C
	IF (NPT.LT.5) THEN
		IND=1
		RETURN
	ENDIF
C
C	DIFFERENTIATE FIRST 3 POINTS
C
	DO 10 I=3,NPT-2
	CALL QFITC (5,X(I-2),Y(I-2),XAVG,PRM,UPRM,4)
	IF (I.EQ.3) THEN
		XI=X(1)-XAVG
		DY(1)=DYDX(XI)
		XI=X(2)-XAVG
		DY(2)=DYDX(XI)
	ELSEIF (I.EQ.NPT-2) THEN
		XI=X(NPT-1)-XAVG
		DY(NPT-1)=DYDX(XI)
		XI=X(NPT)-XAVG
		DY(NPT)=DYDX(XI)
	ENDIF
	XI=X(I)-XAVG
   10	DY(I)=DYDX(XI)
C
	IND=0
	RETURN
	END
