C	PROCESS SCENARIO PARAMETERS.  FILE HAS 3 SUBROUTINES:
C
C		SUBROUTINE SPINIT	INITIALIZE
C		SUBROUTINE RDSOPT 	DECODE
C		SUBROUTINE SOPOUT 	OUTPUT
C
C ----------------------------------------------------------------------
	SUBROUTINE SPINIT
C
C	INITIALIZES SCENARIO PARAMETERS
C
	INCLUDE 'SCENSPEC.FOR'
C
	DECCAL=.FALSE.
	O3KODE=0
	RNOX=.FALSE.
	SCNTYP=' '
	LSCNTP=0
	TSTINP=' '
	LTSTIN=0
	BHCID=' '
	LBHCID=0
	AHCID=' '
	LAHCID=0
	MOLRCT=1.0
	HCLVL=0.0
	NOXLVL=0.0
	NOXRAT=0.0
	AHCLVL=0.0
	AO3LVL=0.0
	ANOXLV=0.0
	PZFILE=' '
	HV=-1.0
	CNCOR=1.0
	EPS=1.E-6
	NINF=0
C
	RETURN
	END
C
C ----------------------------------------------------------------------
	SUBROUTINE RDSOPT (SCNOPT,LSCNOP,IPARSE,INLIN)
C	DECODES SCENARIO PARAMETER INPUT.  
C
C	(SUBROUTINE SOPOUT, BELOW, OUTPUTS PARAMETER VALUES)
C
C	SCNOPT = SCEN PARM NAME
C	LSCNOP = LENGTH OF NAME
C	IPARSE = "WORD" NO IN PARSED (PARSE0) LINE IN STRING INLIN
C	PARSED STRING
C
	CHARACTER SCNOPT*8,INLIN*80
	INTEGER LSCNOP,IPARSE
C
C	SCENARIO PARAMETERS
C
	INCLUDE 'SCENSPEC.FOR'
C
C
	LOGICAL ANS
C
C
C	ALL COMMANDS ARE AT LEAST 2 CHARS LOND
C
	IF (LSCNOP.LT.2) GOTO 800
C
	IF (SCNOPT(1:1).EQ.'*') THEN
		IF (NINF.EQ.MAXINF) THEN
			WRITE (6,*) 'Scenario information data ',
     &			 'on "',SCNOPT(2:LSCNOP),' ignored.'
			WRITE (6,*) 'Increase MAXINF in RDSOPT.FOR.'
		ELSE
			NINF=NINF+1
			INFDSC(NINF)=SCNOPT(2:8)
			CALL PARSE1 (IPARSE,INFDAT(NINF),I,8,INLIN)
		ENDIF
	ELSEIF (SCNOPT.EQ.'DECCAL') THEN
		DECCAL=.TRUE.
	ELSEIF (SCNOPT.EQ.'NODECCAL') THEN
		DECCAL=.FALSE.
	ELSEIF (SCNOPT.EQ.'O3-NO') THEN
		O3KODE=1
	ELSEIF (SCNOPT.EQ.'O3') THEN
		O3KODE=0
	ELSEIF (SCNOPT.EQ.'DOSE') THEN
		O3KODE=2
	ELSEIF (SCNOPT.EQ.'SCNTYPE') THEN
		CALL PARSE1 (IPARSE,SCNTYP,LSCNTP,8,INLIN)
	ELSEIF (SCNOPT.EQ.'TESTINP') THEN
		CALL PARSE1 (IPARSE,TSTINP,LTSTIN,8,INLIN)
	ELSEIF (SCNOPT.EQ.'BASEHC') THEN
		CALL PARSE1 (IPARSE,BHCID,LBHCID,8,INLIN)
C		- BASEHC=AIR OR NONE SAME AS BLANK
		IF (BHCID.EQ.'AIR'.OR.BHCID.EQ.'NONE') THEN
			BHCID=' '
			LBHCID=0
		ENDIF
	ELSEIF (SCNOPT.EQ.'E.HC') THEN
		CALL PARSER (IPARSE,HCLVL,ANS,INLIN)
		IF (ANS) GOTO 810
	ELSEIF (SCNOPT.EQ.'E.NOX') THEN
		RNOX=.FALSE.
		CALL PARSER (IPARSE,NOXLVL,ANS,INLIN)
		IF (ANS) GOTO 810
	ELSEIF (SCNOPT.EQ.'HC/NOX') THEN
		RNOX=.TRUE.
		CALL PARSER (IPARSE,NOXRAT,ANS,INLIN)
		IF (ANS) GOTO 810
	ELSEIF (SCNOPT.EQ.'MOLRCT') THEN
		CALL PARSER (IPARSE,MOLRCT,ANS,INLIN)
		IF (ANS) GOTO 810
	ELSEIF (SCNOPT.EQ.'C/N-COR') THEN
		CALL PARSER (IPARSE,CNCOR,ANS,INLIN)
		IF (ANS) GOTO 810
		IF (CNCOR.EQ.0.0) CNCOR=1.0
	ELSEIF (SCNOPT.EQ.'ALOFTHC') THEN
		CALL PARSE1 (IPARSE,AHCID,LAHCID,8,INLIN)
C		- ALOFTHC=AIR OR NONE SAME AS BLANK
		IF (AHCID.EQ.'AIR'.OR.AHCID.EQ.'NONE') THEN
			AHCID=' '
			LAHCID=0
		ENDIF
	ELSEIF (SCNOPT.EQ.'ALO.HC') THEN
		CALL PARSER (IPARSE,AHCLVL,ANS,INLIN)
		IF (ANS) GOTO 810
	ELSEIF (SCNOPT.EQ.'ALO.O3') THEN
		CALL PARSER (IPARSE,AO3LVL,ANS,INLIN)
		IF (ANS) GOTO 810
	ELSEIF (SCNOPT.EQ.'ALO.NOX') THEN
		CALL PARSER (IPARSE,ANOXLV,ANS,INLIN)
		IF (ANS) GOTO 810
	ELSEIF (SCNOPT.EQ.'P(Z)') THEN
		CALL PARSE1 (IPARSE,PZFILE,I,8,INLIN)
	ELSEIF (SCNOPT.EQ.'HV') THEN
		CALL PARSER (IPARSE,HV,ANS,INLIN)
		IF (ANS) GOTO 810
	ELSEIF (SCNOPT.EQ.'EPS') THEN
		CALL PARSER (IPARSE,EPS,ANS,INLIN)
		IF (ANS) GOTO 810
		IF (EPS.LE.0.0) EPS=1.E-6
	ELSEIF (SCNOPT.EQ.'CHGMIN') THEN
		CALL PARSER (IPARSE,CHGMIN,ANS,INLIN)
		IF (ANS) GOTO 810
	ELSEIF (SCNOPT.EQ.'CHGMAX') THEN
		CALL PARSER (IPARSE,CHGMAX,ANS,INLIN)
		IF (ANS) GOTO 810
	ELSEIF (SCNOPT.EQ.'CHGOK') THEN
		CALL PARSER (IPARSE,CHGOK,ANS,INLIN)
		IF (ANS) GOTO 810
	ELSEIF (SCNOPT.EQ.'MAXRCT') THEN
		CALL PARSER (IPARSE,MAXRCT,ANS,INLIN)
		IF (ANS) GOTO 810
	ELSEIF (SCNOPT.EQ.'MAXITR') THEN
		CALL PARSEI (IPARSE,MAXITR,ANS,INLIN)
		IF (ANS) GOTO 810
	ELSE
		GOTO 800
	ENDIF
C
	RETURN
C
C
  800	WRITE (6,*) 'UNRECOGNIZED OPTION ("',SCNOPT(1:LSCNOP),
     &	 '") IN SCENARIO.PRM IGNORED.'
	RETURN
C
  810	WRITE (6,*) 'ERROR DECODING OPTION ("',SCNOPT(1:LSCNOP),
     &	 '") IN SCENARIO.PRM.  IGNORED.'
	RETURN
	END
C
C ----------------------------------------------------------------------
	SUBROUTINE SOPOUT (IUNIT,SCNID,ITC)
C
C	OUTPUTS ALL CURRENT SCENARIO PARAMETERS TO UNIT=IUNIT.
C	SCNID = SCENARIO ID
C	ITC = .TRUE. IF THIS IS CALLED BY ITCREACT
C
	INTEGER IUNIT
	CHARACTER SCNID*8
	LOGICAL ITC
C
C	SCENARIO.PRM PARAMETERS
C
	INCLUDE 'SCENSPEC.FOR'
C
C
	IF (IUNIT.EQ.0) RETURN
C
	WRITE (IUNIT,100) SCNID,SCNTYP,BHCID,HCLVL,NOXLVL,AHCID,
     &	 AHCLVL,ANOXLV,AO3LVL,NOXRAT,CNCOR,MOLRCT,EPS
  100	FORMAT ('SCEN',4X,A8/'SCNTYPE',1X,A8/'BASEHC',2X,A8/
     &  'E.HC',F12.4/'E.NOX',F11.4/'ALOFTHC',1X,A8/'ALO.HC',F10.4/
     &  'ALO.NOX',F9.4/'ALO.O3',F10.4/'HC/NOX',F10.4/
     &  'C/N-COR',F9.4/'MOLRCT',F10.5/'EPS',1PE13.1)
	IF (TSTINP(1:1).NE.' ') WRITE (IUNIT,1) 'TESTINP '//TSTINP
    1	FORMAT (A)
	IF (O3KODE.EQ.1) THEN
		WRITE (IUNIT,1) 'O3-NO'
	ELSEIF (O3KODE.EQ.0) THEN
		WRITE (IUNIT,1) 'O3'
	ELSE
		WRITE (IUNIT,'(''O3KODE'',I10)') O3KODE
	ENDIF
	IF (DECCAL) THEN
		WRITE (IUNIT,1) 'DECCAL'
	ELSE
		WRITE (IUNIT,1) 'NODECCAL'
	ENDIF
	IF (PZFILE.NE.' ') WRITE (IUNIT,1) 'P(Z)    '//
     &	 PZFILE(1:LNBLNK(PZFILE))
	IF (HV.GE.0.0) WRITE (IUNIT,'(''HV'',F14.4)') HV
	IF (ITC) WRITE (IUNIT,101) CHGMIN,CHGMAX,CHGOK,MAXRCT,MAXITR
  101	FORMAT ('CHGMIN',F10.4/'CHGMAX',F10.4/'CHGOK',F11.4/
     &   'MAXRCT',F10.4/'MAXITR',I10)
	WRITE (IUNIT,1) 'ENDPARMS'
	IF (NINF.GT.0) WRITE (IUNIT,102) (INFDSC(I),INFDAT(I),I=1,NINF)
  102	FORMAT (A7,1X,A8)
	RETURN
	END
