	PROGRAM REACTTAB
C
C	CALCULATES REACTIVITIES FOR SPECIES FOR SCENARIOS/SCALES
C	LISTED IN INPUT FILES.
C
C	IF NO PARAMETERS, GETS INPUT FROM USER PROMPTS.
C
C	P1 = DMS OR CMP FILE NAME, OR "F=filename" FOR INPUT FILE
C	     LISTING DMS OR CMP NAMES
C	P2 = SCENARIOS OR SCALES TO USE, OR "F=filename" FOR FILE
C	     GIVING SCENARIO LIST
C	P3 = OUTPUT FILE (DEFAULT=CON)
C	P4 = "M" OR "MA" FOR PER-MASS, "C" FOR PER-CARBON REACTIVITIES,
C	     "MOL" FOR PER-MOLE REACTIVITIES,
C	     "KR" FOR KINETIC REACTIVITIES, "MR" FOR MECHANISTIC
C	     REACTIVITIES.  "PC" FOR O3MAX, PER-CARBON, "PM" FOR O3MAX,
C	     PER MASS.
C	     (DEFAULT = "C")
C	P5 = STANDARD VOC OR MIXTURE FOR RELATIVE REACTIVITIES
C	     (DEFAULT = NO STANDARD -- GIVE ABSOLUTE REACTIVITIES)
C
C	GETS DMS LIST, MW'S, NC'S, FROM FROM FILE LISTED 
C	IN 'DMS=' OR 'VOC=' INPUT IN MODELING.PRM.  (DEFAULT=DMS.PRM)
C
C	DMS ASSIGNMENT DATA
C
	INCLUDE 'DMSSPC.FOR'
C
C	REACTIVITY ASSIGNMENT DATA
C
	PARAMETER (MAXRSC=360,MAXCOL=40)
	INTEGER NRSC,RSCTYP(MAXRSC)
	CHARACTER RSCLIS(MAXRSC)*8,DMSLIS(MAXDMS)*8
	REAL DMSRCT(MAXDMS,MAXRSC)
C
	REAL STDRCT(MAXRSC)
	INTEGER DMSIND(MAXDMS)
	CHARACTER*1 DMSNOR(MAXDMS)
C
	LOGICAL ERRIND,GRAM,USEMR,USEKR,PROMPT,FILEIN,AUTONC,WARNUN,
     &	 USEMOL,SIGFIG,APPND,SCNCOL,CSV1,CSV2,CONOUT
	CHARACTER INLIN*80,CMPUIC*40,DMSFIL*80,OUTFIL*40,RSCFIL*80,
     &	 STDVOC*8,DMSI*8,OPTKOD*8,NAMEIN*8
C	DIMENSION OF OUTFMT SHOULD BE MAX(MAXRSC,MAXDMS)+1
	PARAMETER (MAXOUF=MAXDMS+1)
	CHARACTER OUTFMT(MAXOUF)*8
	CHARACTER*1 FF
C
	REAL NODATA
	PARAMETER (NODATA=-9.99E+9)
C
	FF=char(13)
C
C	GET DMS DATA.  (ALL "SIMPLE" DMS ARE NORMALIZED)
C
	CALL LDDMS (I)
	IF (I.NE.0) GOTO 990
C
	DO 11 I=1,NDMS
  11	DMSNOR(I)=' '
C
C
C	GET CMP AND RCT FILE UICS FROM MODELING.PRM
C
	OPEN (UNIT=1,FILE='MODELING.PRM',STATUS='UNKNOWN')
C
	CMPUIC=' '
	LCMPUC=0
C
	AUTONC=.FALSE.
	WARNUN=.TRUE.
C
  10	READ (1,1,END=12) INLIN
    1	FORMAT (A)
	IF (INLIN(1:4).EQ.'CMP=') THEN
		CMPUIC=INLIN(5:)
		LCMPUC=LNBLNK(CMPUIC)
	ELSEIF (INLIN(1:13).EQ.'REACTTAB=NORM') THEN
		AUTONC=.TRUE.
	ELSEIF (INLIN(1:15).EQ.'REACTTAB=NONORM') THEN
		AUTONC=.FALSE.
		WARNUN=.FALSE.
	ELSEIF (INLIN(1:10).EQ.'REACTTAB= ')THEN
		AUTONC=.FALSE.
		WARNUN=.TRUE.
	ENDIF
	GOTO 10
C
   12	CLOSE (UNIT=1)
C
C
C	INITIALIZE COMMAND LINE INTERPRETATION
C
	CALL GETARG (1,DMSFIL)
	LDMSFL=LNBLNK(DMSFIL)
C
  101	IF (DMSFIL(1:1).EQ.'?') THEN
		GOTO 900
	ELSEIF (DMSFIL(1:1).EQ.' ') THEN
C	** PROMPT DOESN'T WORK FOR G77 VERSION ***
C		GOTO 900
C	*****
		PROMPT=.TRUE.
		WRITE (6,102) 
  102		FORMAT (' Give option code:'
     &           /'  (default) = Output per-carbon, O3 formed ',
     &                          'reactivities;'
     &           /'     M  = Output per-gram, O3 formed, reactivities;'
     &           /'    MOL = Output per-mole, O3 formed, reactivities;'
     &           /'     MR = Output mechanistic reactivities;'
     &           /'     K  = Output kinetic reactivities;'
     &           /'     PC  = Output per-carbon, O3 max., reactivities;'
     &           /'     PM  = Output per-gram, O3 max., reactivities.'
     &           /'   +code = Output in CSV format.'
     &           /'   *code = Output in 4 sig. figs.'
     &           //' Code: ',$)
		READ (5,1,END=990) OPTKOD
C
	ELSE
C
		PROMPT=.FALSE.
		CALL GETARG (2,RSCFIL)
		LRSCFL=LNBLNK(RSCFIL)
		IF (RSCFIL(1:1).EQ.' ') GOTO 900
C
		CALL GETARG (3,OUTFIL)
		LOUTFL=LNBLNK(OUTFIL)
		IF (OUTFIL(1:1).EQ.' '.OR.OUTFIL(1:2).EQ.'X ') THEN
			CSV1=.FALSE.
			APPND=.FALSE.
			CONOUT=.TRUE.
		ELSE
			IF (LOUTFL.LE.2) THEN
				APPND=.FALSE.
			ELSEIF (OUTFIL(LOUTFL-1:LOUTFL).EQ.'/A'.OR.
     &				 OUTFIL(LOUTFL-1:LOUTFL).EQ.'/a') THEN
				LOUTFL=LOUTFL-2
				APPND=.TRUE.
			ELSE
				APPND=.FALSE.
			ENDIF
			IF (LOUTFL.GT.4) THEN
				CSV1=(OUTFIL(LOUTFL-3:LOUTFL).EQ.'.CSV')
			ELSE
				CSV1=.FALSE.
			ENDIF
		ENDIF
C
		CALL GETARG (4,OPTKOD)
C
		STDVOC='        '
		CALL GETARG (5,STDVOC)
	ENDIF
C
C	GET OPTIONS
C
C
	CSV2=.FALSE.
	IF (CSV1) THEN
		SIGFIG=.TRUE.
		OPTKOD=OPTKOD(2:)
	ELSEIF (OPTKOD(1:1).EQ.'*') THEN
		SIGFIG=.TRUE.
		OPTKOD=OPTKOD(2:)
	ELSEIF (OPTKOD(1:1).EQ.'+') THEN
		SIGFIG=.TRUE.
		OPTKOD=OPTKOD(2:)
		CSV1=.TRUE.
	ELSE
		SIGFIG=.FALSE.
	ENDIF
	IF (OPTKOD(1:1).EQ.'C'.OR.OPTKOD(1:1).EQ.' ') THEN
		GRAM=.FALSE.
		USEKR=.FALSE.
		USEMR=.FALSE.
		USEMOL=.FALSE.
		IRKODE=0
	ELSEIF (OPTKOD(1:3).EQ.'MOL') THEN
		GRAM=.FALSE.
		USEKR=.FALSE.
		USEMR=.FALSE.
		USEMOL=.TRUE.
		IRKODE=0
	ELSEIF (OPTKOD(1:2).EQ.'M '.OR.OPTKOD(1:2).EQ.'MA') THEN
		GRAM=.TRUE.
		USEKR=.FALSE.
		USEMR=.FALSE.
		USEMOL=.FALSE.
		IRKODE=0
	ELSEIF (OPTKOD(1:2).EQ.'PC') THEN
		GRAM=.FALSE.
		USEKR=.FALSE.
		USEMR=.FALSE.
		USEMOL=.FALSE.
		IRKODE=3
	ELSEIF (OPTKOD(1:2).EQ.'PM') THEN
		GRAM=.TRUE.
		USEKR=.FALSE.
		USEMR=.FALSE.
		USEMOL=.FALSE.
		IRKODE=3
	ELSEIF (OPTKOD(1:2).EQ.'MR') THEN
		GRAM=.FALSE.
		USEKR=.FALSE.
		USEMR=.TRUE.
		USEMOL=.FALSE.
		IRKODE=2
	ELSEIF (OPTKOD(1:1).EQ.'K') THEN
		GRAM=.FALSE.
		USEKR=.TRUE.
		USEMR=.FALSE.
		USEMOL=.FALSE.
		IRKODE=1
	ELSEIF (PROMPT) THEN
		WRITE (6,*) 'Unrecognized code.'
		GOTO 101
	ELSE
		GOTO 900
	ENDIF
C
C	GET LIST OF SCENARIOS/SCALES.  LOAD DMS REACTIVITY DATA FOR
C	EACH.
C
  150	NRSC=0
	SCNCOL=.FALSE.
	IF (PROMPT) THEN
		WRITE (6,151)
  151		FORMAT (' Give scenario or reactivity scale (<CR>',
     &           ' when done).'/' Or "F=filename" to read scenario',
     &           ' list from a file.'/)
  152		WRITE (6,111) 'Scenario: '
  111		FORMAT (A,$)
		READ (5,1,END=990) RSCFIL
		IF (RSCFIL(1:1).EQ.' ') THEN
			IF (NRSC.EQ.0) GOTO 990
		ELSEIF (RSCFIL(1:4).EQ.'*COL') THEN
			SCNCOL=.TRUE.
			GOTO 152
		ELSEIF (RSCFIL(1:2).EQ.'F=') THEN
			LRSCFL=LNBLNK(RSCFIL)
			OPEN (UNIT=1,FILE=RSCFIL(3:LRSCFL),STATUS='OLD',
     &			 ERR=930)
  153			READ (1,1,END=158) INLIN
			IF (INLIN(1:1).EQ.' '.OR.INLIN(1:1).EQ.'!') GOTO
     &			 153
			IF (RSCFIL(1:4).EQ.'*COL') THEN
				SCNCOL=.TRUE.
				GOTO 153
			ENDIF
			NRSC=NRSC+1
			IF (NRSC.GT.MAXRSC) GOTO 920
			RSCLIS(NRSC)=INLIN(1:8)
			WRITE (6,*) 'Reading ',
     &			 RSCLIS(NRSC)(1:LNBLNK(RSCLIS(NRSC)))
			CALL LDRCT (RSCLIS(NRSC),DMSRCT(1,NRSC),IRKODE,
     &			 RSCTYP(NRSC))
			IF (RSCTYP(NRSC).LT.0) GOTO 990
			GOTO 153
  158			CLOSE (UNIT=1)
			IF (NRSC.EQ.0) THEN 
				WRITE (6,*) 'No scenarios/scales ',
     &				 'listed in file = ',RSCFIL(3:LRSCFL)
				GOTO 152
			ENDIF
		ELSE
			NRSC=NRSC+1
			RSCLIS(NRSC)=RSCFIL(1:8)
			CALL LDRCT (RSCLIS(NRSC),DMSRCT(1,NRSC),IRKODE
     &			 ,RSCTYP(NRSC))
			IF (RSCTYP(NRSC).LT.0) THEN
				NRSC=NRSC-1
				GOTO 152
			ELSEIF (NRSC.EQ.MAXRSC) THEN
				WRITE (6,*) 'No more scenarios can ',
     &				 'be input.'
			ELSE
				GOTO 152
			ENDIF
		ENDIF
C
	ELSEIF (RSCFIL(1:2).EQ.'F=') THEN
		OPEN (UNIT=1,FILE=RSCFIL(3:LRSCFL),STATUS='OLD',ERR=930)
  130		READ (1,1,END=133) INLIN
		IF (INLIN(1:1).EQ.' '.OR.INLIN(1:1).EQ.'!') GOTO 130
		IF (INLIN(1:4).EQ.'*COL') THEN
			SCNCOL=.TRUE.
			GOTO 130
		ENDIF
		NRSC=NRSC+1
		IF (NRSC.GT.MAXRSC) GOTO 920
		RSCLIS(NRSC)=INLIN(1:8)
C
		CALL LDRCT (RSCLIS(NRSC),DMSRCT(1,NRSC),IRKODE,
     &		 RSCTYP(NRSC))
		IF (RSCTYP(NRSC).LT.0) GOTO 990
		GOTO 130
C
  133		CLOSE (UNIT=1)
		IF (NRSC.EQ.0) THEN 
			WRITE (6,*) 'No scenarios/scales listed ',
     &			 'in file = ',RSCFIL(3:LRSCFL)
			GOTO 990
		ENDIF
	ELSE
		CALL PARSE0 (MAXRSC,RSCFIL,80)
		NRSC=0
		DO 140 IRSC=1,MAXRSC
		CALL PARSE1 (IRSC,NAMEIN,J,8,RSCFIL)
		IF (NAMEIN(1:1).EQ.' ') GOTO 142
		IF (NAMEIN(1:4).EQ.'*COL') THEN
			SCNCOL=.TRUE.
		ELSE
			NRSC=NRSC+1
			RSCLIS(NRSC)=NAMEIN
			CALL LDRCT (NAMEIN,DMSRCT(1,NRSC),IRKODE,
     &			 RSCTYP(NRSC))
			IF (RSCTYP(NRSC).LT.0) GOTO 990
		ENDIF
  140		CONTINUE
		NRSC=MAXRSC
  142		IF (NRSC.EQ.0) STOP 'RSC LIST PROGRAM ERROR'
	ENDIF
C
C	SCENARIOS INPUT.
C
C	MAXIMUM NO. DMS IS REDUCED TO MAXCOL IF MORE THAN MAXCOL
C	SCENARIOS.
C
	IF (CSV1) THEN
		MAXDMC=MAXDMS
	ELSEIF (NRSC.GT.MAXCOL) THEN
		MAXDMC=MAXCOL
	ELSE
		MAXDMC=MAXDMS
	ENDIF
C
C	GET STANDARD VOC NAME (FOR RELATIVE REACTIVITIES)
C	** LOOPS BACK TO HERE IF INTERACTIVE INPUT **
C
 1003	IF (PROMPT) THEN
		WRITE (6,1004)
 1004		FORMAT (' If relative reactivities desired, give ',
     &           'name of compound or mixture to use'
     &           /' as the standard.  (<CR> for absolute ',
     &           'reactivities.): ',$)
		READ (5,1,END=999) STDVOC
	ENDIF
	IF (STDVOC(1:1).EQ.' ') THEN
		NDMSL=0
		INDSTD=0
	ELSE
		NDMSL=1
		INDSTD=1
		IF (MAXDMC.LT.MAXDMS) MAXDMC=MAXDMC+1
		DMSLIS(1)=STDVOC
		GOTO 160
	ENDIF
C
C	GET LIST OF DMS
C
 1002	FILEIN=.FALSE.
	XTRIND=0
	IF (PROMPT) THEN
		WRITE (6,154)
  154		FORMAT (' Give species or mixture name (<CR> when',
     &           ' done).'/' Or "F=filename" to read species/mix',
     &           ' list from a file.'/)
	ELSEIF (DMSFIL(1:2).EQ.'F=') THEN
		OPEN (UNIT=1,FILE=DMSFIL(3:LDMSFL),STATUS='OLD',
     &		 ERR=910)
		FILEIN=.TRUE.
		IF (NDMSL.EQ.INDSTD) XTRIND=-1
	ELSE
		CALL PARSE0 (6,DMSFIL,80)
		DO 1541 I=1,6
		CALL PARSE1 (I,DMSLIS(I+INDSTD),J,8,DMSFIL)
		IF (DMSLIS(I+INDSTD)(1:1).EQ.' ') GOTO 1542
 1541		CONTINUE
		DMSLIS(7+INDSTD)=' '
 1542		CONTINUE
	ENDIF
C
C	READ NEXT DMS NAME
C
 1000	IF (FILEIN) THEN
  110		READ (1,1,END=170) INLIN
		IF (INLIN(1:1).EQ.'!') GOTO 110
		IF (INLIN(1:1).EQ.' ') THEN
			IF (XTRIND.LT.0) XTRIND=1
			GOTO 110
		ENDIF
		NDMSL=NDMSL+1
		IF (NDMSL.GT.MAXDMC) THEN
			IF (PROMPT) THEN
				WRITE (6,*) 'Too many species in file.',
     &				 '  ',INLIN(1:LNBLNK(INLIN)),
     &				 ' and those following ignored.'
				NDMSL=NDMSL-1
				GOTO 170
			ELSE
				WRITE (6,*) 'Too many species in file ',
     &				 '= ',	 DMSFIL(3:LDMSFL)
				GOTO 990
			ENDIF
		ENDIF
		DMSLIS(NDMSL)=INLIN(1:8)
C
	ELSEIF (PROMPT) THEN
		WRITE (6,111) 'Species/mix: '
		READ (5,1,END=999) INLIN
		IF (INLIN(1:1).EQ.' ') THEN
			IF (NDMSL.EQ.INDSTD) GOTO 999
			GOTO 170
		ELSEIF (INLIN(1:2).EQ.'F=') THEN
			OPEN (UNIT=1,FILE=INLIN(3:),STATUS='OLD',
     &			 ERR=915)
			FILEIN=.TRUE.
			IF (NDMSL.EQ.INDSTD) XTRIND=-1
			GOTO 1000
  915			WRITE (6,*) 'File = ',INLIN(3:LNBLNK(INLIN)),
     &			 ' does not exist.'
			GOTO 1000
		ENDIF
		IF (NDMSL.EQ.MAXDMC) THEN
			WRITE (6,*) 'No more species can be input.'
			GOTO 170
		ENDIF
		NDMSL=NDMSL+1
		DMSLIS(NDMSL)=INLIN(1:8)
	ELSE
		IF (NDMSL-INDSTD.EQ.6) GOTO 170
		NDMSL=NDMSL+1
		IF (DMSLIS(NDMSL)(1:1).EQ.' ') THEN
			NDMSL=NDMSL-1
			GOTO 170
		ENDIF
	ENDIF
C
C	SEE IF SPECIES DMSLIS(NDMSL) IS DEFINED, AND IF SO GET ITS
C	REACTIVITY
C
  160	DMSI=DMSLIS(NDMSL)
C
C	FIGURE RCT IF IT IS A DMS.  IF IT IS A "STANDARD" VOC
C	AND NOT NORMALIZED, NORMALIZE IT.
C
	DO 1010 I=1,NDMS
	IF (DMSI.EQ.DMSNAM(I)) THEN
		DMSIND(NDMSL)=I
		IF (NDMSL.EQ.INDSTD) THEN
			IF (DMSNOR(I).EQ.'*') THEN
				TOTNC=DMSNC(I)
				DO 1043 J=1,NRSC
				IF (DMSRCT(I,J).NE.NODATA)
     &				 DMSRCT(I,J)=DMSRCT(I,J)/TOTNC
 1043				CONTINUE
				DMSMW(I)=DMSMW(I)/TOTNC
				DMSNC(I)=1.0
				DMSNOR(I)=' '
			ENDIF
			GOTO 1002
		ELSE
			GOTO 1000
		ENDIF
	ENDIF
 1010	CONTINUE
C
C	NOT A DMS.  IT MUST BE A CMP FILE.
C	DO NOT CALCULATE MECHANISTIC REACTIVITIES FOR CMP FILES.
C
	IF (USEMR) THEN
		WRITE (6,*) 'Mechanistic reactivities are meaningless',
     &		 ' for mixtures.'
		GOTO 1090
	ENDIF
C
	LVOC=LNBLNK(DMSI)
	INLIN=CMPUIC(1:LCMPUC)
	INLIN(LCMPUC+1:LCMPUC+LVOC)=DMSI(1:LVOC)
	INLIN(LCMPUC+LVOC+1:LCMPUC+LVOC+4)='.CMP'
	OPEN (UNIT=2,FILE=INLIN,STATUS='OLD',ERR=1070)
C
	IF (NDMS.GT.MAXDMS) THEN
		WRITE (6,*) 'Too many species.  Increase MAXDMS',
     &		 ' in REACTTAB and LDDMS.'
		GOTO 990
	ELSEIF (NDMSL.GT.MAXDMC) THEN
		WRITE (6,*) 'Too many scenarios or species ',
     &		 'to tabulate.'
		GOTO 990
	ENDIF
	NDMS=NDMS+1
	DMSNAM(NDMS)=DMSI
	DMSIND(NDMSL)=NDMS
C
C	READ DATA IN CMPFILE
C
	TOTWT=0.0
	TOTNC=0.0
	DO 1020 J=1,NRSC
 1020	DMSRCT(NDMS,J)=0.0
C
 1030	READ (2,1,END=1040) INLIN
	IF (INLIN(1:1).EQ.' '.OR.INLIN(1:1).EQ.'!') GOTO 1030
	CALL PARSE0 (2,INLIN,80)
	DMSI='        '
	CALL PARSE1 (1,DMSI,I,8,INLIN)
	DO 1032 I=1,NDMS
	IF (DMSI.EQ.DMSNAM(I)) THEN
		CALL PARSER (2,X,ERRIND,INLIN)
		IF (ERRIND) GOTO 1084
		TOTWT=TOTWT+(X*DMSMW(I))
		TOTNC=TOTNC+(X*DMSNC(I))
		DO 1034 IRSC=1,NRSC
		IF (DMSRCT(I,IRSC).EQ.NODATA) THEN
			WRITE (6,*) DMSNAM(I),' Undefined for ',
     &			 RSCLIS(IRSC)
			DMSRCT(NDMS,IRSC)=NODATA
		ELSEIF (DMSRCT(NDMS,IRSC).NE.NODATA) THEN
			DMSRCT(NDMS,IRSC)=DMSRCT(NDMS,IRSC)
     &			 +(X*DMSNC(I)*DMSRCT(I,IRSC))
		ENDIF
 1034		CONTINUE
		GOTO 1030
	ENDIF
 1032	CONTINUE
	GOTO 1082
C
 1040	CLOSE (UNIT=2)
	IF (TOTNC.EQ.0.0) GOTO 1086
C
C	NORMALIZE REACTIVITIES (IF AUTO-NORMALIZE OPTION USED,
C	OR IF STANDARD VOC)
C
	IF (AUTONC.OR.INDSTD.EQ.NDMSL) THEN
		DO 1042 I=1,NRSC
		IF (DMSRCT(NDMS,I).NE.NODATA) THEN
			DMSRCT(NDMS,I)=DMSRCT(NDMS,I)/TOTNC
		ENDIF
 1042		CONTINUE
		DMSMW(NDMS)=TOTWT/TOTNC
		DMSNC(NDMS)=1.0
		DMSNOR(NDMS)=' '
	ELSE
		DMSMW(NDMS)=TOTWT
		DMSNC(NDMS)=TOTNC
		IF (ABS(TOTNC-1.0).GT.1.E-4) THEN
C@@
			IF (WARNUN) WRITE (6,1499)
     &			 DMSNAM(NDMS)(1:LNBLNK(DMSNAM(NDMS))),TOTNC
 1499			FORMAT (' Warning:  ',A,' is an unnormalized',
     &                   ' mixture.  No. C''s = ',F8.4,'.'/)
			DMSNOR(NDMS)='*'
		ELSE
			DMSNOR(NDMS)=' '
		ENDIF
	ENDIF
C
C	DONE WITH CMP FILE
C
	IF (NDMSL.EQ.INDSTD) GOTO 1002
	GOTO 1000
C
C	UNRECOGNIZED DMS OR INAPPROPRAITE USE OF .CMP FILE.
C
 1070	WRITE (6,*) 'Unrecognized VOC or CMP = ',DMSLIS(NDMSL)
	GOTO 1090
C
C	ERRORS READING CMP FILE
C
 1082	WRITE (6,*) 'Unrecognized VOC (',DMSI(1:LNBLNK(DMSI)),') in ',
     &	 DMSLIS(NDMSL)(1:LNBLNK(DMSLIS(NDMSL))),'.CMP.'
	GOTO 1090
 1084	WRITE (6,*) 'Bad data in .CMP file for ',DMSLIS(NDMSL)
	CLOSE (UNIT=2)
	GOTO 1090
 1086	WRITE (6,*) 'CMP file for ',DMSLIS(NDMSL),' has no carbons.'
	GOTO 1090
C
 1090	IF (NDMSL.EQ.INDSTD) THEN
		IF (PROMPT) GOTO 1003
		WRITE (6,*) 'Aborted because standard VOC or CMP is ',
     &		 'undefined.'
		GOTO 990
	ELSEIF (PROMPT) THEN
		NDMSL=NDMSL-1
		GOTO 1000
	ELSE
		DMSIND(NDMSL)=0
C**
		WRITE (6,*) 'PROGRAM CANNOT HANDLE THIS CONDITION',
     &		 ' BECAUSE OF IMPROPER TREATMENT OF DMSIND'
		GOTO 990
C		GOTO 1000
	ENDIF
C
C	END OF DMS INPUT
C
  170	IF (FILEIN) THEN
		IF (XTRIND.GT.0.AND.NRSC.LE.MAXCOL) THEN
			REWIND (UNIT=1)
		ELSE
			CLOSE (UNIT=1)
		ENDIF
		IF (NDMSL.EQ.INDSTD) THEN 
			WRITE (6,*) 'No VOCs listed in file = ',
     &			 DMSFIL(3:LDMSFL)
			GOTO 990
		ENDIF
	ELSEIF (NDMSL.EQ.INDSTD) THEN
		IF (.NOT.PROMPT) WRITE (6,*) 'No Species specified.'
		GOTO 990
	ENDIF
C
C
C	DEFINE STANDARD REACTIVITY ARRAY, IF APPLICABLE.
C
	IF (INDSTD.NE.0) THEN
		DO 1100 IDMS=1,NDMSL
		IF (IDMS.NE.INDSTD) GOTO 1100
		ID=DMSIND(IDMS)
		DMSI=DMSLIS(IDMS)
		ERRIND=.TRUE.
		DO 1110 IRSC=1,NRSC
C	      -	IF THE "SCENARIO" IS A STANDARD DEVIATION, STANDARD
C	      - "REACTIVITY" IS 1.  THUS, S.D. OF STANDARD IS IGNORED.
		IF (RSCTYP(IRSC).GT.0) THEN
			F=1.0
		ELSE
			F=DMSRCT(ID,IRSC)
		ENDIF
		IF (F.EQ.0.0) THEN
			WRITE (6,*) STDVOC,' has zero reactivity',
     &			 ' for ',RSCLIS(IRSC)
			STDRCT(IRSC)=NODATA
		ELSEIF (GRAM) THEN
			STDRCT(IRSC)=F*48.0*DMSNC(ID)
     &			 /DMSMW(ID)
			ERRIND=.FALSE.
		ELSEIF (USEMOL) THEN
			STDRCT(IRSC)=F*DMSNC(ID)
			ERRIND=.FALSE.
		ELSE
			STDRCT(IRSC)=F
			ERRIND=.FALSE.
		ENDIF
 1110		CONTINUE
		IF (ERRIND) THEN
			GOTO 990
		ENDIF
 1100		CONTINUE
	ENDIF
C
C
C	ALL REACTIVITIES DEFINED.  GIVEN IN PER-CARBON UNITS.
C
C	OPEN OUTPUT FILE.
C
	IF (PROMPT) THEN
		WRITE (6,410)
  410		FORMAT (/' Give output file (<CR> for terminal ',
     &           'output.): ',$)
		READ (5,1,END=990) OUTFIL
		IF (OUTFIL(1:1).NE.' ') THEN
			LOUTFL=LNBLNK(OUTFIL)
			IF (LOUTFL.GT.3) THEN
				IF (OUTFIL(LOUTFL-1:LOUTFL).EQ.'/A'.OR.
     &				 OUTFIL(LOUTFL-1:LOUTFL).EQ.'/a') THEN
					LOUTFL=LOUTFL-2
					APPND=.TRUE.
				ELSE
					APPND=.FALSE.
				ENDIF
			ELSE
				APPND=.FALSE.
			ENDIF
			CONOUT=.FALSE.
		ELSE
			APPND=.FALSE.
			CONOUT=.TRUE.
			LOUTFL=0
		ENDIF
	ENDIF
C
	IF (APPND) THEN
		INQUIRE (FILE=OUTFIL(1:LOUTFL),EXIST=APPND)
	ENDIF
	IF (APPND) THEN
		OPEN (UNIT=2,FILE=OUTFIL(1:LOUTFL),STATUS='UNKNOWN',
     &		 ACCESS='APPEND')
		WRITE (2,1) FF
		IOUT=2
	ELSEIF (CONOUT) THEN
		IOUT=6
	ELSE
		OPEN (UNIT=2,FILE=OUTFIL(1:LOUTFL),STATUS='UNKNOWN')
		IOUT=2
	ENDIF
C
	IF (USEKR) THEN
		INLIN='Kinetic'
		L=7
	ELSEIF (USEMR) THEN
		INLIN='Per-Carbon Mechanistic'
		L=L+22
	ELSEIF (GRAM) THEN
		IF (IRKODE.EQ.0) THEN
			INLIN='Per-gram Incremental'
			L=20
		ELSE
			INLIN='Per-gram, Peak O3'
			L=17
		ENDIF
	ELSEIF (USEMOL) THEN
		IF (IRKODE.EQ.0) THEN
			INLIN='Per-mole Incremental'
			L=20
		ELSE
			INLIN='Per-mole, Peak O3'
			L=17
		ENDIF
	ELSE
		IF (IRKODE.EQ.0) THEN
			INLIN='Per-Carbon Incremental'
			L=22
		ELSE
			INLIN='Per-Carbon, Peak O3'
			L=19
		ENDIF
	ENDIF
	IF (STDVOC(1:1).EQ.' ') THEN
		WRITE (IOUT,*) INLIN(1:L),' Reactivities.'
	ELSE
		WRITE (IOUT,*) INLIN(1:L),' Reactivities relative to ',
     &		 STDVOC(1:LNBLNK(STDVOC)),'.'
	ENDIF
	WRITE (IOUT,1)
C
C	IF NO. SCENARIOS GT MAX. NO COLUMNS, OUTPUT RESULTS WITH
C	DMS IN COLUMNS, SCENARIOS IN ROWS.
C
C	IF CSV FORMAT, DMS IN COLUMN UNLESS NUMBER OF SCENARIOS > # DMS
C
	IF (CSV1.AND.NRSC.LE.NDMSL) THEN
		CSV1=.FALSE.
		CSV2=.TRUE.
	ENDIF
C
	IF ((CSV1.OR.(NRSC.GT.MAXCOL.OR.SCNCOL)).AND.(.NOT.CSV2)) THEN
C
C		OUTPUT DMS IN COLUMNS
C
		IF ((NDMSL-INDSTD.EQ.2).AND.(.NOT.CSV1)) THEN
			NCOL=3
		ELSE
			NCOL=NDMSL-INDSTD
		ENDIF
		IF (CSV1) THEN
			WRITE (IOUT,1221) 'Scenario',(DMSLIS(I)
     &			 (1:LNBLNK(DMSLIS(I))),I=INDSTD+1,NDMSL)
 1221			FORMAT (A,255(',',A))
			DO 1222 I=INDSTD+1,NDMSL
			IF (DMSNOR(DMSIND(I)).NE.' ') THEN
				WRITE (IOUT,1221) ' ',(DMSNOR(DMSIND(J)),
     &				 J=INDSTD+1,NDMSL)
				GOTO 1223
			ENDIF
 1222			CONTINUE
			WRITE (IOUT,1)
 1223			CONTINUE
		ELSEIF (NDMSL-INDSTD.NE.2) THEN
			WRITE (IOUT,1201) 'Scenario    ',(' ',
     &			 DMSNOR(DMSIND(I)),DMSLIS(I),I=INDSTD+1,NDMSL)
			WRITE (IOUT,1)
		ELSE
			WRITE (IOUT,1201) 'Scenario     ',
     &			 DMSNOR(DMSIND(INDSTD+1)),DMSLIS(INDSTD+1),' ',
     &			 DMSNOR(DMSIND(INDSTD+2)),DMSLIS(INDSTD+2),
     &			 '  (Ratio)'
			WRITE (IOUT,1)
		ENDIF
C
C		OUTPUT REACTIVITY.  
C
		DO 1200 IRSC=1,NRSC
		IF (INDSTD.NE.0.AND.(STDRCT(IRSC).EQ.NODATA
     &		 .OR.STDRCT(IRSC).EQ.0.0)) GOTO 1200
C
		ERRIND=.FALSE.
		DO 1220 IDMS=1,NDMSL
		IF (IDMS.EQ.INDSTD) GOTO 1220
		ID=DMSIND(IDMS)
		I1=IDMS-INDSTD
		IF (ID.EQ.0) THEN
			OUTFMT(I1)='        '
			ERRIND=.TRUE.
		ELSEIF (DMSRCT(ID,IRSC).EQ.NODATA) THEN
			OUTFMT(I1)='        '
			ERRIND=.TRUE.
		ELSE
			IF (GRAM) THEN
				X=DMSRCT(ID,IRSC)*48.0*DMSNC(ID)/
     &				 DMSMW(ID)
			ELSEIF (USEMOL) THEN
				X=DMSRCT(ID,IRSC)*DMSNC(ID)
			ELSE
				X=DMSRCT(ID,IRSC)
			ENDIF
			IF (INDSTD.NE.0) X=X/STDRCT(IRSC)
			IF (SIGFIG) THEN
				CALL FMTOU4 (OUTFMT(I1),X)
			ELSE
				CALL FMTOUT (OUTFMT(I1),X)
			ENDIF
			IF (I1.EQ.1) X1=X
		ENDIF
 1220		CONTINUE
C
		IF ((NDMSL-INDSTD.EQ.2).AND.(.NOT.CSV1)) THEN
			IF (ERRIND) THEN
				OUTFMT(3)='        '
			ELSE
				IF (X.EQ.0.0) THEN
					OUTFMT(3)='        '
				ELSEIF (SIGFIG) THEN
					CALL FMTOU4 (OUTFMT(3),X1/X)
				ELSE
					CALL FMTOUT (OUTFMT(3),X1/X)
				ENDIF
			ENDIF
		ENDIF
C
		IF (CSV1) THEN
			WRITE (IOUT,1221) RSCLIS(IRSC),(OUTFMT(I),I=1,NCOL)
		ELSE
			WRITE (IOUT,1201) RSCLIS(IRSC),'  ',('  ',
     &			 OUTFMT(I),I=1,NCOL)
 1201			FORMAT (40A)
		ENDIF
C
 1200		CONTINUE
C
	ELSE
C
C		OUTPUT SCENARIOS IN COLUMNS
C
		IF ((NRSC.EQ.2).AND.(.NOT.CSV2)) THEN
			NCOL=3
		ELSE
			NCOL=NRSC
		ENDIF
		IF (CSV2) THEN
			WRITE (IOUT,1221) ',VOC or Mix',(RSCLIS(I),I=1,NRSC)
		ELSEIF (NRSC.NE.2) THEN
			WRITE (IOUT,1201) '(VOC-or-MIX)',('  ',RSCLIS(I),
     &			 I=1,NRSC)
		ELSE
			WRITE (IOUT,1201) '(VOC-or-MIX)  ',RSCLIS(1),'  ',
     &			 RSCLIS(2),'  (%-Diff.)'
		ENDIF
		WRITE (IOUT,1)
C
C		OUTPUT REACTIVITY.  
C
		DO 1300 IDMS=1,NDMSL
		IF (IDMS.EQ.INDSTD) GOTO 1300
		ID=DMSIND(IDMS)
		IF (ID.EQ.0) GOTO 1300
C
		DMSI=DMSLIS(IDMS)
C
		DO 1320 IRSC=1,NRSC
		IF (INDSTD.NE.0) THEN
			IF (STDRCT(IRSC).EQ.NODATA) THEN
				OUTFMT(IRSC)='        '
			ELSEIF (DMSRCT(ID,IRSC).EQ.NODATA) THEN
				OUTFMT(IRSC)='        '
			ELSEIF (STDRCT(IRSC).EQ.0.0) THEN
				OUTFMT(IRSC)='        '
			ELSE
				IF (GRAM) THEN
					X=DMSRCT(ID,IRSC)*48.0*DMSNC(ID)
     &				 	 /(DMSMW(ID)*STDRCT(IRSC))
				ELSEIF (USEMOL) THEN
					X=DMSRCT(ID,IRSC)*DMSNC(ID)
     &					 /STDRCT(IRSC)
				ELSE
					X=DMSRCT(ID,IRSC)/STDRCT(IRSC)
				ENDIF
				IF (SIGFIG) THEN
					CALL FMTOU4 (OUTFMT(IRSC),X)
				ELSE
					CALL FMTOUT (OUTFMT(IRSC),X)
				ENDIF
				IF (IRSC.EQ.1) X1=X
			ENDIF
		ELSEIF (DMSRCT(ID,IRSC).EQ.NODATA) THEN
			OUTFMT(IRSC)='        '
		ELSE
			IF (GRAM) THEN
				X=DMSRCT(ID,IRSC)*48.0*DMSNC(ID)/
     &				 DMSMW(ID)
			ELSEIF (USEMOL) THEN
				X=DMSRCT(ID,IRSC)*DMSNC(ID)
			ELSE
				X=DMSRCT(ID,IRSC)
			ENDIF
			IF (IRSC.EQ.1) X1=X
			IF (SIGFIG) THEN
				CALL FMTOU4 (OUTFMT(IRSC),X)
			ELSE
				CALL FMTOUT (OUTFMT(IRSC),X)
			ENDIF
		ENDIF
 1320		CONTINUE
C
		IF (NRSC.EQ.2.AND.NCOL.EQ.3) THEN
			IF (DMSRCT(ID,1).EQ.NODATA) THEN
				OUTFMT(3)='        '
			ELSEIF (DMSRCT(ID,2).EQ.NODATA) THEN
				OUTFMT(3)='        '
			ELSEIF (DMSRCT(ID,1).EQ.0.0) THEN
				OUTFMT(3)='        '
			ELSE
				WRITE (OUTFMT(3),'(2PF6.0,2X)') 
     &				 (X-X1)/X1
			ENDIF
		ENDIF
C
C		COPY "COMMENT" RECORDS FROM INPUT FILE, IF APPLICABLE
C
		IF (XTRIND.GT.0) THEN
 1340			READ (1,1) INLIN
			IF (INLIN(1:8).NE.DMSLIS(IDMS)) THEN
				IF (INLIN(1:1).NE.'!') WRITE (IOUT,*) 
     &				 INLIN(2:LNBLNK(INLIN))
				GOTO 1340
			ENDIF
		ENDIF
C
		IF (CSV2) THEN
			WRITE (IOUT,1221) DMSNOR(ID),DMSLIS(IDMS),
     &			 (OUTFMT(I),I=1,NCOL)
		ELSE
			WRITE (IOUT,1201) DMSNOR(ID),DMSLIS(IDMS),'  ',
     &			 ('  ',OUTFMT(I),I=1,NCOL)
		ENDIF
C
 1300		CONTINUE
C
		IF (XTRIND.GT.0) THEN
 1342			READ (1,1,END=1344) INLIN
			IF (INLIN(1:1).NE.'!') WRITE (IOUT,*) 
     &			 INLIN(2:LNBLNK(INLIN))
			GOTO 1342
 1344			CLOSE (UNIT=1)
		ENDIF
C
	ENDIF
C
C	OUTPUT FOOTNOTE IF SOME "DMS" ARE UNNORMALIZED
C
	ERRIND=.FALSE.
	DO 1301 I=INDSTD+1,NDMSL
	IF (DMSNOR(DMSIND(I)).EQ.'*') THEN
		WRITE (IOUT,*)
		WRITE (IOUT,*) '* = Unnormalized mixture.'
		GOTO 800
	ENDIF
 1301	CONTINUE
C
C	DONE
C
  800	CLOSE (UNIT=2)
	IF (OUTFIL(1:LOUTFL).NE.'CON') THEN
		IF (APPND) THEN
			WRITE (6,*) 'Done.  Appended to file = ',
     &			 OUTFIL(1:LOUTFL)
		ELSEIF (CONOUT) THEN
			WRITE (6,*)
		ELSE
			WRITE (6,*) 'Done.  File = ',
     &			 OUTFIL(1:LOUTFL),' created.'
		ENDIF
	ENDIF
	IF (PROMPT) GOTO 1003
	CALL EXIT (0)
C
C
C	ERRORS
C
  900	WRITE (6,*) 'Useage:  REACTTAB p1 p2 [p3 [*|+]p4 p5],  where:'
	WRITE (6,*) 'p1 = VOC or CMP file name, or "F=filename" for ',
     &	 'input file listing VOC or'
	WRITE (6,*) '     CMP names'
	WRITE (6,*) 'p2 = Scenarios or scales to use, or "F=filename',
     &	 '" for file giving scenario list'
	WRITE (6,*) 'p3 = Output file (default=CON), "file/A" = append,'
	WRITE (6,*) 'p4 = "M" for per-mass incremental reactivities, ',
     &	 '"MR" for mechanistic'
	WRITE (6,*) '     reactivities, "K" for kinetic reactivities.',
     &	 '  (Default = per-carbon'
	WRITE (6,*) '     incremental reactivities).'
	WRITE (6,*) '     "*" prefix means use more sig figs.'
	WRITE (6,*) '     "+" prefix means output in .CSV format.'
	WRITE (6,*) 'p5 = Standard VOC or mixture for relative react',
     &	 'ivities'
	WRITE (6,*) '     (Default = no standard-- give absolute rea',
     &	 'ctivities)'
C	********
	WRITE (6,*) 'Note: Interactive mode doesn''t work for'//
     &		 ' G77 version'
	WRITE (6,*) 'Use "REACTTB1" instead.'
	GOTO 990
C
  910	WRITE (6,*) 'File = ',DMSFIL(3:LDMSFL),' does not exist.'
	GOTO 990
C
  920	WRITE (6,*) 'Too many scenarios in ',RSCFIL(3:LRSCFL)
	GOTO 990
C
  930	WRITE (6,*) 'File = ',RSCFIL(3:LRSCFL),' does not exist.'
	IF (PROMPT) GOTO 150
	GOTO 990
C
  990	WRITE (6,*) 'Aborted.'
  999	WRITE (6,*) 'Done.'
	CALL EXIT (0)
	END
