	SUBROUTINE ARALIN (YOUT,NIN,XIN,YIN,NOUT,XOUT,IND,NODATA)
C
C	ARRAY INTERPOLATION.  FIND YOUT WHICH ALLIGNS (XIN,YIN)
C	WITH XOUT.  I.E.,
C	CALCULATES ARRAY YOUT WHICH HAS Y VALUES CORRESPONDING TO
C	X VALUES IN XOUT WHICH ARE INTERPOLATED FROM (X,Y) WHERE
C	X IN XIN AND Y IN YIN. 
C
C	IND = SUCCESS CODE:
C		0 = OK
C		1 = YOUT FOR XOUT < XIN(1) ASSIGNED YIN(1) OR NODATA
C		2 = YOUT FOR XOUT > XIN(NIN) ASSIGNED YIN(NIN) OR NODATA
C		3 = BOTH OF ABOVE
C	       -1 = ABORTED BECAUSE XIN NOT IN ASCENDING ORDER
C		    (EQUAL VALUES OK)
C	       -2 = ABORTED BECAUSE XOUT NOT IN ASCENDING ORDER
C		    (EQUAL VALUES NOT OK)
C	       -3 = ABORTED BECAUSE NIN OR NOUT LE 0
C
C	NODATA = CODE FOR "NO DATA" IF YOUT < XIN(1) OR > XIN(NIN)
C		    0. = USE XIN(1) OR XIN(NIN)
C		NOT 0. = USE FOR "NO DATA"
C
C	XIN AND XOUT MUST BE SORTED IN ASCENDING ORDER.
C	ARALIN DOESN'T CHECK FOR THIS.
C
	REAL XOUT(NOUT),YOUT(NOUT),XIN(NIN),YIN(NIN),NODATA
C
	IF (NIN.LE.0.OR.NOUT.LE.0) THEN
		IND=-3
		RETURN
	ENDIF
C
	IND=0
	IIN=1
	XOLAST=XOUT(1)-1.0
	XILAST=XIN(1)
C
	DO 100 IOUT=1,NOUT
	IF (XOUT(IOUT).LT.XOLAST) THEN
		IND=-2
		RETURN
	ELSEIF (XOUT(IOUT).EQ.XOLAST) THEN
		YOUT(IOUT)=YOUT(IOUT-1)
		GOTO 100
	ENDIF
	XOLAST=XOUT(IOUT)
C
  101	IF (XIN(IIN).EQ.XOUT(IOUT)) THEN
		YOUT(IOUT)=YIN(IIN)
  102		IF (IIN.EQ.NIN) THEN
			IF (IOUT.EQ.NOUT) RETURN
			IOUTL=IOUT+1
			GOTO 110
		ENDIF
		IIN=IIN+1
		IF (XIN(IIN).LT.XILAST) THEN
			IND=-1
			RETURN
		ENDIF
		XILAST=XIN(IIN)
		IF (XIN(IIN).EQ.XOUT(IOUT)) GOTO 102
	ELSEIF (XIN(IIN).GT.XOUT(IOUT)) THEN
		IF (IIN.EQ.1) THEN
			IF (NODATA.EQ.0.0) THEN
				YOUT(IOUT)=YIN(1)
			ELSE
				YOUT(IOUT)=NODATA
			ENDIF
			IND=1
C-D
		ELSEIF (XIN(IIN-1).GE.XOUT(IOUT)) THEN
			WRITE (6,*) 'LOGIC ERROR.  IIN,IOUT=',IIN,IOUT
C-
		ELSE
			D=XIN(IIN)-XIN(IIN-1)
			YOUT(IOUT)=(YIN(IIN)*(XOUT(IOUT)-XIN(IIN-1))/D)+
     &			 (YIN(IIN-1)*(XIN(IIN)-XOUT(IOUT))/D)
		ENDIF
C	ELSEIF (XIN(IIN).LT.XOUT(IOUT) THEN
	ELSE
		IF (IIN.EQ.NIN) THEN
			IOUTL=IOUT
			GOTO 110
		ENDIF
		IIN=IIN+1
		IF (XIN(IIN).LT.XILAST) THEN
			IND=-1
			RETURN
		ENDIF
		XILAST=XIN(IIN)
		GOTO 101
	ENDIF
  100	CONTINUE
C
C	DONE
C
	RETURN
C
C	CONTROL REACHES HERE IF XOUT(IOUT) > XIN(NIN)
C
  110	IF (IND.EQ.0) THEN
		IND=2
	ELSE
		IND=3
	ENDIF
	IF (NODATA.EQ.0.0) THEN
		DO 111 I=IOUTL,NOUT
  111		YOUT(I)=YIN(NIN)
	ELSE
		DO 112 I=IOUTL,NOUT
  112		YOUT(I)=NODATA
	ENDIF
	RETURN
	END
