	SUBROUTINE PARSE0 (NMAX,IB,IEND)
C	SUBROUTINE PARSE1 (NSUB,SUB,LSUB,LSUBMX,IB)
C	SUBROUTINE PARSE2 (NSUB,SUB,LSUB,LSUBMX,IB)
C	SUBROUTINE PARSEI (NSUB,INTVAL,ERRIND,IB)
C	SUBROUTINE PARSI4 (NSUB,INTVAL,ERRIND,IB)
C	SUBROUTINE PARSER (NSUB,REALVL,ERRIND,IB)
C	SUBROUTINE PARSI2 (NSUB,INTVAL,IDFLT,ERRIND,IB)
C	SUBROUTINE PARSR2 (NSUB,REALVL,RDFLT,ERRIND,IB)
C
C	PARSE INPUT LINE INTO "WORDS" OF VARIABLE LENGTH.  WORDS
C	SEPARATED BY BLANK OR COMMAS.  LENGTH OF STRING SET BY
C	PARAMETER "IEND".  LAST CHARACTER OF STRING IS RESERVED FOR
C	PROGRAM - MUST NOT CONTAIN DATA.  A "!" CHARACTER TERMINATES
C	STRING.  
C
C	-PARSE0 CALLED TO DO INITIAL PARSING (FINDING WHERE SUBSTRINGS
C	 START AND END
C	-PARSE1 CALLED TO DEFINE PARSED SUBSTRING.
C
C	QUOTES AROUND A STRING FORCE IT TO BE THE "WORD".
C
C	ARGUMENTS:  (PARSE0 -- ALL INPUT)
C
C	NMAX	MAXIMUM NUMBER OF WORDS.  DATA AFTER THIS IGNORED.
C	IB	BUFFER TO PARSE
C	IEND =	MAXIMUM LENGTH OF BUFFER.  BUFFER CAN HAVE ONLY IEND-1
C		CHARACTERS OF NON-BLANK DATA.  MUST NOT BE GREATER THAN
C		LENGTH OF IB, AND MUST BE LE 80.
C
C	COMMA ALWAYS SEPARATES WORDS.  DEFAULT IS FOR BLANK AND TAB
C	ALSO TO SEPARATE WORDS, WITH MORE THAN ONE TOGETHER IGNORED.
C
C	IF NMAX=-1, NON-DEFAULT CHARACTERS CAN BE USED TO SEPARATE
C	STRINGS.  IN THIS CASE.
C
C	IB	SET OF CHARACTERS TO REPLACE " " OR <TAB> (UP TO 8)
C	IEND	NO. CHARACTERS (MAX 8).  IF ZERO, NOTHING IS DONE.
C
C
C	ARGUMENTS:  (PARSE1)
C
C	NSUB	WORD NO. TO PARSE.
C	LSUB	LENGTH OF SUBSTRING (OUTPUT)
C	SUB	SUBSTRING (OUTPUT)
C	LSUBMX	MAXIMUM LENGTH OF SUBSTRING (MUST BE LE 80)
C	IB	MUST BE SAME AS IB IN CALL TO PARSE0
C
C	ARGUMENTS (PARSEI/PARSER)
C
C	NSUB	AS ABOVE 
C	INTVAL	INTEGER VALUE TO DECODE (OUTPUT FOR PARSEI)
C	REALVL	REAL VALUE TO DECODE (OUTPUT FOR PARSER)
C	ERRIND	SET TO .TRUE. IF ERROR, .FALSE. IF OK (OUTPUT)
C
C	ADDITIONAL ARGUMENT (PARSI2/PARSR2 ONLY)
C
C	IDFLT/RDFLT  DEFAULT VALUE IF BLANK FIELD.
C
C	PARSE LOCAL DATA
C
C	N	NUMBER OF "WORDS" PARSED.  
C	NMX	"NMAX" VALUE PASSED TO PROGRAM.
C	IS	ARRAY GIVING FIRST CHARACTER IN WORD
C	IE	ARRAY GIVING LAST CHARACTER IN WORD
C		(IF WORD IS BLANK, IS AND IE POINT TO CHAR NO. IEND,
C		 WHICH IS SET AT BLANK)
C
C
	INTEGER IEND,NMAX
	PARAMETER (MAXLEN=250)
	CHARACTER*250 IB
C
	PARAMETER (MAXNMX=26,MAXCHK=8)
	INTEGER N,IS(MAXNMX),IE(MAXNMX),NCHK,ISS(MAXNMX)
	CHARACTER*1 CHKCHR(MAXCHK)
	COMMON /PARSAV/ N,IS,IE,NMX,NCHK,IEN,ISS
	COMMON /PARCHR/ CHKCHR
C
	INTEGER IC
	CHARACTER*1 UQUOT,TAB
	LOGICAL CHARX,WORD,FIRST
	DATA FIRST/.TRUE./
	TAB=CHAR(9)
C
C
C
C	SET CHECK CHARACTERS IF APPLICABLE (IND,CHARS,NCHARS)
C	IND=-1:  ONLY CHARS INPUT ARE CHK CHARS.
C	IND=-2:  ADD COMMA TO CHK CHARS.  (NCHARS=0 RESETS)
C
	IF (IEND.LT.0) RETURN
	IF (NMAX.EQ.-1.OR.NMAX.EQ.-2) THEN
		FIRST=.FALSE.
		IF (NMAX.EQ.-2) THEN
			NCHK=MIN0(8,IEND+1)
			CHKCHR(1)=','
			IF (IEND.EQ.0) RETURN
			I1=1
		ELSEIF (IEND.LE.0) THEN
			RETURN
		ELSE
			NCHK=MIN0(8,IEND)
			I1=0
		ENDIF
		DO 2 I=1,NCHK-I1
    2		CHKCHR(I+I1)=IB(I:I)
		RETURN
	ELSEIF (FIRST.OR.NMAX.EQ.-3) THEN
		FIRST=.FALSE.
		CHKCHR(1)=','
		NCHK=1
		IF (NMAX.EQ.-3) RETURN
	ENDIF
C
C
	NMX=NMAX
	IEN=IEND
	IF (IEND.GT.MAXLEN) IEND=MAXLEN
	IF (NMX.GT.MAXNMX) NMX=MAXNMX
C
	IC=0
	N=0
	WORD=.FALSE.
C
   10	CHARX=.FALSE.
C
   20	IF (IC.EQ.IEND) GOTO 90
	IC=IC+1
C
	IF (IB(IC:IC).EQ.' '.OR.IB(IC:IC).EQ.TAB) THEN
		IF (CHARX) THEN
			WORD=.FALSE.
			GOTO 10
		ENDIF
		GOTO 20
	ENDIF
	DO 21 I=1,NCHK
	IF (IB(IC:IC).EQ.CHKCHR(I)) THEN
		IF (N.EQ.0) THEN
			N=1
			ISS(1)=IC
			IS(1)=IEND
			IE(1)=IEND
		ELSEIF (N.EQ.NMX) THEN
			GOTO 90
		ENDIF
		N=N+1
		WORD=.TRUE.
		ISS(N)=IC+1
		IS(N)=IEND
		IE(N)=IEND
		GOTO 10
	ENDIF
  21	CONTINUE
	IF (IB(IC:IC).EQ.'!') THEN
		GOTO 90
	ELSEIF (IB(IC:IC).EQ.''''.OR.IB(IC:IC).EQ.'"') THEN
		IF (WORD) THEN
			IF (IE(N).NE.IEND) THEN
				IF (N.EQ.NMX) GOTO 90
				N=N+1
			ENDIF
		ELSE
			IF (N.EQ.NMX) GOTO 90
			N=N+1
		ENDIF
		ISS(N)=IC+1
		IS(N)=IC+1
		IE(N)=IEND
		UQUOT=IB(IC:IC)
   32		IF (IC.EQ.IEND) THEN
			IF (IE(N).EQ.IEND) IS(N)=IEND
			GOTO 90
		ENDIF
		IC=IC+1
		IF (IB(IC:IC).EQ.UQUOT) THEN
			IF (IE(N).EQ.IEND) IS(N)=IEND
			WORD=.FALSE.
			GOTO 10
		ELSE
			IE(N)=IC
			GOTO 32
		ENDIF
	ELSE
		IF (WORD) THEN
			IE(N)=IC
			IF (IS(N).EQ.IEND) IS(N)=IC
		ELSE
			IF (N.EQ.NMX) GOTO 90
			N=N+1
			WORD=.TRUE.
			ISS(N)=IC
			IS(N)=IC
			IE(N)=IC
		ENDIF
		CHARX=.TRUE.
	ENDIF
C
	GOTO 20
C
   90	IF (N.EQ.NMX) RETURN
	DO 92 I=N+1,NMX
	ISS(I)=IEND
	IS(I)=IEND
   92	IE(I)=IEND
	RETURN
C
	END
C
C
	SUBROUTINE PARSE1 (NSUB,SUB,LSUB,LSUBMX,IB)
C
C	RETURNS SUBSTRING FROM PREVIOUSLY-PARSED STRING
C	PARSE0 MUST BE CALLED FIRST, OR RESULTS WILL BE GARBAGE.
C
C
	INTEGER LSUB,LSUBMX
	PARAMETER (MAXLEN=250)
	CHARACTER*250 IB,SUB
	CHARACTER*1 TAB
C
	PARAMETER (MAXNMX=26,MAXCHK=8)
	INTEGER N,IS(MAXNMX),IE(MAXNMX),NCHK,ISS(MAXNMX)
	CHARACTER*1 CHKCHR(MAXCHK)
	COMMON /PARSAV/ N,IS,IE,NMX,NCHK,IEN,ISS
	COMMON /PARCHR/ CHKCHR
	TAB=CHAR(9)
C
C	BLANK STRING OUTPUT IF BAD INPUT
C
	IF (NSUB.LE.0.OR.NSUB.GT.N) GOTO 800
	IF (IS(NSUB).GT.IE(NSUB)) GOTO 800
	IF (LSUBMX.LE.0) GOTO 800
C
C
	LSUB=IE(NSUB)-IS(NSUB)+1
	IF (LSUB.GT.LSUBMX) THEN
		LSUB=LSUBMX
		SUB(1:LSUBMX)=IB(IS(NSUB):IS(NSUB)+LSUB-1)
	ELSE
		SUB(1:LSUBMX)=IB(IS(NSUB):IE(NSUB))
	ENDIF
	IF (LSUB.EQ.1) THEN
		IF (SUB(1:1).EQ.' '.OR.SUB(1:1).EQ.TAB) GOTO 800
	ENDIF
	RETURN
C
C	BLANK STRING OUTPUT
C
  800	LSUB=0
	SUB(1:LSUBMX)=' '
	RETURN
	END
C
C
	SUBROUTINE PARSE2 (NSUB,SUB,LSUB,LSUBMX,IB)
C
C	RETURNS SUBSTRING FROM PREVIOUSLY-PARSED STRING
C	THIS VERSION PUTS REST OF BUFFER INTO OUTPUT STRING.
C	PARSE0 MUST BE CALLED FIRST, OR RESULTS WILL BE GARBAGE.
C
C
	INTEGER LSUB,LSUBMX
	PARAMETER (MAXLEN=250)
	CHARACTER*250 IB,SUB
	CHARACTER*1 TAB
C
	PARAMETER (MAXNMX=26,MAXCHK=8)
	INTEGER N,IS(MAXNMX),IE(MAXNMX),NCHK,ISS(MAXNMX)
	CHARACTER*1 CHKCHR(MAXCHK)
	COMMON /PARSAV/ N,IS,IE,NMX,NCHK,IEN,ISS
	COMMON /PARCHR/ CHKCHR
	TAB=CHAR(9)
C
C	BLANK STRING OUTPUT IF BAD INPUT
C
	IF (NSUB.LE.0.OR.NSUB.GT.N) GOTO 800
	IF (ISS(NSUB).GT.IE(NSUB)) GOTO 800
	IF (LSUBMX.LE.0) GOTO 800
C
C
	LSUB=IEN-ISS(NSUB)+1
	IF (LSUB.GT.LSUBMX) THEN
		LSUB=LSUBMX
		SUB(1:LSUBMX)=IB(ISS(NSUB):ISS(NSUB)+LSUB-1)
	ELSE
		SUB(1:LSUBMX)=IB(ISS(NSUB):IEN)
	ENDIF
	IF (LSUB.EQ.1) THEN
		IF (SUB(1:1).EQ.' '.OR.SUB(1:1).EQ.TAB) GOTO 800
	ENDIF
	LSUB=LNBLNK(SUB(1:LSUB))
	RETURN
C
C	BLANK STRING OUTPUT
C
  800	LSUB=0
	SUB(1:LSUBMX)=' '
	RETURN
	END
C
C
	SUBROUTINE PARSEI (NSUB,INTVAL,ERRIND,IB)
C
C	RETURNS DECODED INTEGER VALUE FROM PREVIOUSLY-PARSED STRING
C	PARSE0 MUST BE CALLED FIRST, OR RESULTS WILL BE GARBAGE.
C	ERRIND SET IF BLANK INPUT AS WELL AS BAD NUMBER.
C
	LOGICAL ERRIND
	INTEGER NSUB
	PARAMETER (MAXLEN=250)
	CHARACTER*250 IB
C
	PARAMETER (MAXNMX=26)
	INTEGER N,IS(MAXNMX),IE(MAXNMX),NCHK,ISS(MAXNMX)
	COMMON /PARSAV/ N,IS,IE,NMX,NCHK,IEN,ISS
C
C	ERROR VALUE OUTPUT IF BAD INPUT
C
	IF (NSUB.LE.0.OR.NSUB.GT.N) GOTO 800
C
C	IF FIRST CHAR IS A "#", IT IS IGNORED.
C
	IS1=IS(NSUB)
	IS2=IE(NSUB)
	IF (IB(IS1:IS1).EQ.'#') IS1=IS1+1
	IF (IS1.GT.IS2) GOTO 800
C
	INTVAL=INTV (IB(IS1:IS2),IS2-IS1+1,ERRIND)
	IF (ERRIND) INTVAL=0
	RETURN
C
  800	ERRIND=.TRUE.
	INTVAL=0
	RETURN
	END
C
C
	SUBROUTINE PARSI4 (NSUB,INTVAL,ERRIND,IB)
C
C	RETURNS DECODED INTEGER VALUE FROM PREVIOUSLY-PARSED STRING
C	PARSE0 MUST BE CALLED FIRST, OR RESULTS WILL BE GARBAGE.
C	ERRIND SET IF BLANK INPUT AS WELL AS BAD NUMBER.
C
	LOGICAL ERRIND
	INTEGER NSUB
	INTEGER*4 INTVAL
	PARAMETER (MAXLEN=250)
	CHARACTER*250 IB
C
	PARAMETER (MAXNMX=26)
	INTEGER N,IS(MAXNMX),IE(MAXNMX),NCHK,ISS(MAXNMX)
	COMMON /PARSAV/ N,IS,IE,NMX,NCHK,IEN,ISS
C
C	ERROR VALUE OUTPUT IF BAD INPUT
C
	IF (NSUB.LE.0.OR.NSUB.GT.N) GOTO 800
C
C	IF FIRST CHAR IS A "#", IT IS IGNORED.
C
	IS1=IS(NSUB)
	IS2=IE(NSUB)
	IF (IB(IS1:IS1).EQ.'#') IS1=IS1+1
	IF (IS1.GT.IS2) GOTO 800
C
	CALL INTV4 (INTVAL,IB(IS1:IS2),IS2-IS1+1,ERRIND)
	IF (ERRIND) INTVAL=0
	RETURN
C
  800	ERRIND=.TRUE.
	INTVAL=0
	RETURN
	END
C
C
	SUBROUTINE PARSER (NSUB,REALVL,ERRIND,IB)
C
C	RETURNS DECODED REAL VALUE FROM PREVIOUSLY-PARSED STRING
C	PARSE0 MUST BE CALLED FIRST, OR RESULTS WILL BE GARBAGE.
C	ERRIND SET IF BLANK INPUT AS WELL AS BAD NUMBER.
C
C
	LOGICAL ERRIND
	INTEGER NSUB
	PARAMETER (MAXLEN=250)
	CHARACTER*250 IB
	REAL REALVL
C
	PARAMETER (MAXNMX=26)
	INTEGER N,IS(MAXNMX),IE(MAXNMX),NCHK,ISS(MAXNMX)
	COMMON /PARSAV/ N,IS,IE,NMX,NCHK,IEN,ISS
C
C
C	ERROR VALUE OUTPUT IF BAD INPUT
C
	IF (NSUB.LE.0.OR.NSUB.GT.N) GOTO 800
C
C	IF FIRST CHAR IS A "#", IT IS IGNORED.
C
	IS1=IS(NSUB)
	IS2=IE(NSUB)
	IF (IB(IS1:IS1).EQ.'#') IS1=IS1+1
	IF (IS1.GT.IS2) GOTO 800
C
	REALVL=REALV(IB(IS1:IS2),IS2-IS1+1,ERRIND)
	IF (ERRIND) REALVL=0.0
	RETURN
C
  800	ERRIND=.TRUE.
	REALVL=0.0
	RETURN
	END
C
C
	SUBROUTINE PARSI2 (NSUB,INTVAL,IDFLT,ERRIND,IB)
C
C	RETURNS DECODED INTEGER VALUE FROM PREVIOUSLY-PARSED STRING
C	PARSE0 MUST BE CALLED FIRST, OR RESULTS WILL BE GARBAGE.
C	INTVAL SET TO IDFLT IF FIELD IS BLANK.  ERRIND SET IF BAD NUMBER.
C
C
	LOGICAL ERRIND
	INTEGER NSUB,INTVAL,IDFLT
	PARAMETER (MAXLEN=250)
	CHARACTER*250 IB
C
	PARAMETER (MAXNMX=26)
	INTEGER N,IS(MAXNMX),IE(MAXNMX),NCHK,ISS(MAXNMX)
	COMMON /PARSAV/ N,IS,IE,NMX,NCHK,IEN,ISS
C
C	ERROR VALUE OUTPUT IF BAD INPUT
C
	IF (NSUB.LE.0.OR.NSUB.GT.NMX) GOTO 800
C
	IS1=IS(NSUB)
	IS2=IE(NSUB)
C
C	IF BLANK FIELD, USE DEFAULT
C	IF FIRST CHAR IS A "#", IT IS IGNORED.
C
	IF (IB(IS1:IS1).EQ.'#') THEN
		IS1=IS1+1
	ELSEIF (IB(IS1:IS1).EQ.' ') THEN
		INTVAL=IDFLT
		ERRIND=.FALSE.
		RETURN
	ENDIF
	IF (IS1.GT.IS2) GOTO 800
C
	INTVAL=INTV (IB(IS1:IS2),IS2-IS1+1,ERRIND)
	IF (ERRIND) INTVAL=IDFLT
	RETURN
C
  800	ERRIND=.TRUE.
	INTVAL=IDFLT
	RETURN
	END
C
C
	SUBROUTINE PARSR2 (NSUB,REALVL,RDFLT,ERRIND,IB)
C
C	RETURNS DECODED REAL VALUE FROM PREVIOUSLY-PARSED STRING
C	PARSE0 MUST BE CALLED FIRST, OR RESULTS WILL BE GARBAGE.
C	REALVL SET TO RDFLT IF FIELD IS BLANK.  ERRIND SET IF BAD NUMBER.
C
C
	LOGICAL ERRIND
	INTEGER NSUB
	PARAMETER (MAXLEN=250)
	CHARACTER*250 IB
	REAL REALVL,RDFLT
C
	PARAMETER (MAXNMX=26)
	INTEGER N,IS(MAXNMX),IE(MAXNMX),NCHK,ISS(MAXNMX)
	COMMON /PARSAV/ N,IS,IE,NMX,NCHK,IEN,ISS
C
C
C	ERROR VALUE OUTPUT IF BAD INPUT
C
	IF (NSUB.LE.0.OR.NSUB.GT.NMX) GOTO 800
C
	IS1=IS(NSUB)
	IS2=IE(NSUB)
C
C	IF BLANK FIELD, USE DEFAULT
C	IF FIRST CHAR IS A "#", IT IS IGNORED.
C
	IF (IB(IS1:IS1).EQ.'#') THEN
		IS1=IS1+1
	ELSEIF (IB(IS1:IS1).EQ.' ') THEN
		REALVL=RDFLT
		ERRIND=.FALSE.
		RETURN
	ENDIF
	IF (IS1.GT.IS2) GOTO 800
C
	REALVL=REALV(IB(IS1:IS2),IS2-IS1+1,ERRIND)
	IF (ERRIND) REALVL=RDFLT
	RETURN
C
  800	ERRIND=.TRUE.
	REALVL=RDFLT
	RETURN
	END
