	PROGRAM RENORCMP
C
C	NORMALIZES CMP FILES.
C	P1 = INPUT .CMP FILE NAME
C	P2 = OUTPUT .CMP FILE NAME OR OR FULL OUTPUT FILE NAME
C	     IF "SUM" OPTION USED.  IF NOT GIVEN, INPUT FILE OVER-WRITES
C	     OUTPUT FILE, AND OLD FILE IS RENAMED [CMPUIC]P1.BAK
C	[P3] = NO. C'S TO NORMALIZE TO.  DEFAULT = 1.0
C	     OR "SUM" TO JUST SUM TOTAL C'S (NO OUTPUT)
C	     OR "NONORM" TO OUTPUT CONVERTED FILE W/O NORMALIZING.
C	[P4] = IF "M", NORMALIZES TO P3 GRAMS RATHER THAN P3 C'S.
C	       IF "PPB", MULTIPLIES OUTPUT BY 1000, AND USES Fx.2 FORMAT
C
C	IF "SUM" OPTION USED AND OUTPUT FILE NAMED, APPENDS RECORD
C	GIVING TOTAL C AND FILE NAME TO IT.
C
C	THIS VERSION ALLOWS MASS INPUT.  IF SO, "#MASS" RECORD MUST
C	APPEAR BEFORE ANY DMS INPUT.
C
C	THIS VERSION ALSO ALLOWS INPUT IN MOLES C.  IF SO, A "#C" RECORD
C	MUST APPEAR BEFORE ANY DMS INPUT.
C
C	GETS DMS NC DATA FROM FILE REFERENCED IN "DMS=" OR "VOC="
C	INPUT IN MODELING.PRM.  IF NO SUCH INPUT, USES
C	[MECUIC]DMS.PRM.
C	GETS [MECUIC] FROM "MECH=" INPUT IN MODELING.PRM
C
C	INPUT AND OUTPUT FILES TO [CMPUIC]name.CMP
C
C	DMS DATA FROM DMS.PRM
C
	PARAMETER (MAXDMS=2000)
	INTEGER NDMS
	CHARACTER*8 DMSNAM(MAXDMS)
	REAL DMSNC(MAXDMS),DMSMW(MAXDMS)
C
C	COMPOSITION DATA FROM INPUT FILE.  (NOTE THAT IF A COMPOUND IS
C	LISTED MORE THAN ONCE, IT IS SUMMED UP, NOT OVER-WRITTEN)
C
	REAL DMSLVL(MAXDMS)
C
C	LOCAL VARIABLES
C
	LOGICAL ERRIND,NEWCMP,BADDMS,GRAMS,MASSIN,NORM,CARBIN,PPBOUT
	REAL NORFAC
	CHARACTER MECUIC*40,INLIN*80,INFILE*40,OUTFIL*40,NAMEIN*8,
     &	 CMPUIC*40,FILNAM*80,DMSFIL*40,FMT*20
C
C
C	GET FILE NAMES FROM COMMAND LINE
C
	CALL GETARG (1,INFILE)
C
	IF (INFILE(1:1).EQ.'?'.OR.INFILE(1:2).EQ.'/?') THEN
	WRITE (6,*) 'NORMALIZES CMP FILES.'
	WRITE (6,*) 'P1 = INPUT .CMP FILE NAME'
	WRITE (6,*) 'P2 = OUTPUT .CMP FILE NAME OR OR FULL OUTPUT FIL;'
     &	  ,'E NAME'
	WRITE (6,*) '        IF "SUM" OPTION USED.  IF NOT GIVEN, INP;'
     &	  ,'UT FILE OVER-WRITES'
	WRITE (6,*) '        OUTPUT FILE, AND OLD FILE IS RENAMED [CM;'
     &	  ,'PUIC]P1.BAK'
	WRITE (6,*) '[P3] = NO. C''S TO NORMALIZE TO.  DEFAULT = 1.0'
	WRITE (6,*) '        OR "SUM" TO JUST SUM TOTAL C''S (NO OUTPU;'
     &	  ,'T)'
	WRITE (6,*) '        OR "NONORM" TO OUTPUT CONVERTED FILE W/O;'
     &	  ,' NORMALIZING.'
	WRITE (6,*) '[P4] = IF "M", NORMALIZES TO P3 GRAMS RATHER THA;'
     &	  ,'N P3 C''S.'
	WRITE (6,*) '        IF "PPB", MULTIPLIES OUTPUT BY 1000, AND;'
     &	  ,' USES Fx.2 FORMAT'
	WRITE (6,*) '        IF "SUM" OPTION USED AND OUTPUT FILE NAM;'
     &	  ,'ED, APPENDS RECORD'
	WRITE (6,*) '        GIVING TOTAL C AND FILE NAME TO IT.'
	WRITE (6,*)
	WRITE (6,*) 'OPTIONS IN FILE:'
	WRITE (6,*) '#MASS OR MASS ... MASS INPUT'
	WRITE (6,*)
	WRITE (6,*) '#C OR CARBON  ... CARBON INPUT'
	WRITE (6,*) 'GETS DMS NC DATA FROM FILE REFERENCED IN "DMS=" ;'
     &	  ,'OR "VOC="'
	WRITE (6,*) 'INPUT IN MODELING.PRM.  IF NO SUCH INPUT, USES [;'
     &	  ,'MECUIC]DMS.PRM.'
	WRITE (6,*) 'INPUT AND OUTPUT FILES TO [CMPUIC]name.CMP'
	CALL EXIT (0)
	ENDIF
C
	IF (INFILE(1:1).EQ.' ') GOTO 910
C
	LINFIL=LNBLNK(INFILE)
	CALL GETARG (2,OUTFIL)
	LOUTFL=LNBLNK(OUTFIL)
C
C	GET NORMALIZATION FROM COMMAND LINE
C
	GRAMS=.FALSE.
	PPBOUT=.FALSE.
C
	CALL GETARG (3,INLIN)
	IF (INLIN(1:4).EQ.'SUM ') THEN
		NEWCMP=.FALSE.
	ELSEIF (INLIN(1:7).EQ.'NONORM ') THEN
		NORM=.FALSE.
		NEWCMP=.TRUE.
	ELSE
		NORM=.TRUE.
		NEWCMP=.TRUE.
		IF (INLIN(1:1).EQ.' ') THEN
			NORFAC=1.0
		ELSE
			NORFAC=REALV (INLIN,12,ERRIND)
			IF (ERRIND.OR.NORFAC.LE.0.0) GOTO 910
		ENDIF
	ENDIF
C
	CALL GETARG (4,NAMEIN)
	IF (NAMEIN(1:2).EQ.'M ') THEN
		GRAMS=.TRUE.
	ELSEIF (NAMEIN(1:4).EQ.'PPB ') THEN
		PPBOUT=.TRUE.
	ELSEIF (NAMEIN(1:1).NE.' ') THEN
		WRITE (6,*) 'Unrecognized command line option "',
     &		 NAMEIN(1:LNBLNK(NAMEIN)),'".'
		GOTO 910
	ENDIF
C
C
C	GET [MECUIC] OR DMSFIL NAME AND [CMPUIC] FROM MODELING.PRM
C
	MECUIC=' '
	LMECUC=0
	DMSFIL=' '
	LDMSFL=0
	CMPUIC=' '
	LCMPUC=0
C
	OPEN (UNIT=1,FILE='MODELING.PRM',STATUS='UNKNOWN')
   10	READ (1,1,END=12) INLIN
	L=LNBLNK(INLIN)
	IF (INLIN(1:5).EQ.'MECH=') THEN
		LMECUC=L-5
		IF (L.GT.0) THEN
			MECUIC=INLIN(6:L)
		ELSE
			MECUIC=' '
		ENDIF
	ELSEIF (INLIN(1:4).EQ.'DMS='.OR.INLIN(1:4).EQ.'VOC=') THEN
		LDMSFL=L-4
		IF (L.GT.0) THEN
			DMSFIL=INLIN(5:L)
		ELSE
			DMSFIL=' '
		ENDIF
	ELSEIF (INLIN(1:4).EQ.'CMP=') THEN
		LCMPUC=L-4
		IF (L.GT.0) THEN
			CMPUIC=INLIN(5:L)
		ELSE
			CMPUIC=' '
		ENDIF
	ENDIF
	GOTO 10
   12	CLOSE (UNIT=1)
C
C
C	READ DMS DATA INTO MEMORY.
C
	IF (DMSFIL(1:1).EQ.' ') THEN
		IF (LMECUC.NE.0) THEN
			LDMSFL=LMECUC+7
			DMSFIL=MECUIC(1:LMECUC)
			DMSFIL(LMECUC+1:LDMSFL)='DMS.PRM'
		ELSE
			LDMSFL=7
			DMSFIL='DMS.PRM'
		ENDIF
	ENDIF
C
	FILNAM=DMSFIL(1:LDMSFL)
	LFIL=LDMSFL
	OPEN (UNIT=1,FILE=FILNAM,STATUS='OLD',ERR=900)
C
   20	READ (1,1) INLIN
	IF (INLIN(1:1).NE.'.') GOTO 20
C
	NDMS=0
C
   22	READ (1,1,END=28) INLIN
	IF (INLIN(1:1).EQ.'!'.OR.
     &	 (INLIN(1:1).EQ.' '.OR.INLIN(1:1).EQ.'	')) GOTO 22
C
	NDMS=NDMS+1
	IF (NDMS.GT.MAXDMS) STOP 'Dimension overrun.  Increase MAXDMS.'
	CALL PARSE0 (3,INLIN,80)
	DMSNAM(NDMS)='        '
	CALL PARSE1 (1,DMSNAM(NDMS),I,8,INLIN)
	CALL PARSEI (2,I,ERRIND,INLIN)
	IF (ERRIND) GOTO 920
	DMSNC(NDMS)=FLOAT(I)
	CALL PARSER (3,DMSMW(NDMS),ERRIND,INLIN)
	IF (ERRIND.OR.DMSMW(NDMS).LE.0.0) GOTO 920
	GOTO 22
  920	NDMS=NDMS-1
	GOTO 22
C
C
   28	CLOSE (UNIT=1)
C
C	OPEN INPUT FILE
C
	IF (LCMPUC.EQ.0) THEN
		FILNAM=INFILE(1:LINFIL)
		LFIL=LINFIL+4
	ELSE
		LFIL=LINFIL+LCMPUC+4
		FILNAM=CMPUIC(1:LCMPUC)
		FILNAM(LCMPUC+1:LFIL-4)=INFILE(1:LINFIL)
	ENDIF
	FILNAM(LFIL-3:LFIL)='.CMP'
C
	OPEN (UNIT=1,FILE=FILNAM,STATUS='OLD',ERR=900)
	INFILE=FILNAM
	LINFIL=LFIL
C
C	OPEN OUTPUT FILE, IF APPLICABLE.  IF NONE NAMED AND RENORMAL-
C	IZATION TO BE DONE, USE "RENORCMP.TMP" AS THE FILE NAME.
C
	IF (NEWCMP) THEN
		IF (OUTFIL(1:1).EQ.' ') THEN
			LFIL=LCMPUC+12
			FILNAM(LCMPUC+1:LFIL)='RENORCMP.TMP'
		ELSE
			LFIL=LOUTFL+LCMPUC+4
			FILNAM(LCMPUC+1:LFIL-4)=OUTFIL(1:LOUTFL)
			FILNAM(LFIL-3:)='.CMP'
			OUTFIL=FILNAM
			LOUTFL=LFIL
		ENDIF
		OPEN (UNIT=2,FILE=FILNAM,STATUS='UNKNOWN')
	ENDIF
C
C
C	READ DATA FROM INPUT FILE.  COPY COMMENTS TO NEW FILE,
C	IF APPLICABLE.  READ COMPOSITIONS INTO MEMORY.
C	ALSO SUM UP TOTAL MASS AND CARBONS.
C
	DO 5 I=1,NDMS
    5	DMSLVL(I)=0.0
	TOTWT=0.0
	TOTNC=0.0
	TOTMOL=0.0
C
	FAC=1.0
	MASSIN=.FALSE.
	CARBIN=.FALSE.
	BADDMS=.FALSE.
	NCMP=0
C
   2	READ (1,1,END=8) INLIN
   1	FORMAT (A)
	IF (INLIN(1:1).EQ.'!'.OR.INLIN(1:1).EQ.' ') THEN
		IF (NEWCMP) WRITE (2,1) INLIN(1:LNBLNK(INLIN))
		GOTO 2
	ENDIF
	CALL PARSE0 (2,INLIN,80)
	CALL PARSE1 (1,NAMEIN,L,8,INLIN)
C
	IF (NAMEIN(1:4).EQ.'#FAC'.OR.NAMEIN(1:4).EQ.'FAC') THEN
		CALL PARSER (2,FAC,ERRIND,INLIN)
		IF (ERRIND.OR.FAC.LE.0.0) THEN
			WRITE (6,*) 'Error reading factor in file = ',
     &			 INFILE(1:LINFIL),'.'
			WRITE (6,*) 'Bad record = "',INLIN(1:LNBLNK(INLIN)),'".'
			BADDMS=.TRUE.
			FAC=1.0
		ENDIF
		GOTO 2
C
	ELSEIF (NAMEIN(1:5).EQ.'#MASS'.OR.NAMEIN(1:5).EQ.'MASS ') THEN
		IF (NCMP.NE.0) THEN
			WRITE (6,*) 'Mixing mass and molar input',
     &			 ' is not allowed.'
			BADDMS=.TRUE.
		ENDIF
		MASSIN=.TRUE.
		GOTO 2
	ELSEIF (NAMEIN(1:2).EQ.'#C'.OR.NAMEIN(1:2).EQ.'C '.OR.
     &	 NAMEIN(1:7).EQ.'CARBON ') THEN
		IF (NCMP.NE.0) THEN
			WRITE (6,*) 'Mixing carbon and molar input',
     &			 ' is not allowed.'
			BADDMS=.TRUE.
		ENDIF
		CARBIN=.TRUE.
		GOTO 2
	ENDIF
	CALL PARSER (2,X,ERRIND,INLIN)
	IF (ERRIND) THEN
C		OK IF CONCENTRATION IS BLANK.
		CALL PARSE1 (2,NAMEIN,L,8,INLIN)
		IF (NAMEIN(1:1).EQ.' ') GOTO 2
		WRITE (6,*) 'Error reading composition data in file = ',
     &		 INFILE(1:LINFIL),'.'
		WRITE (6,*) 'Bad record = "',INLIN(1:LNBLNK(INLIN)),'".'
		BADDMS=.TRUE.
		GOTO 2
	ENDIF
	IF (X.EQ.0.0) GOTO 2
	X=X*FAC
C
C	FIND IF THIS IS ON LIST, AND SUM UP WT AND C'S.
C
	DO 6 I=1,NDMS
	IF (NAMEIN.EQ.DMSNAM(I)) THEN
		IF (DMSLVL(I).EQ.0.0) NCMP=NCMP+1
		IF (MASSIN) THEN
			TOTWT=TOTWT+X
			X=X/DMSMW(I)
		ELSEIF (CARBIN) THEN
			X=X/DMSNC(I)
			TOTWT=TOTWT+(X*DMSMW(I))
		ELSE
			TOTWT=TOTWT+(X*DMSMW(I))
		ENDIF
		DMSLVL(I)=DMSLVL(I)+X
		TOTNC=TOTNC+(X*DMSNC(I))
		TOTMOL=TOTMOL+X
		GOTO 2
	ENDIF
   6	CONTINUE
C
	WRITE (6,*) NAMEIN,' not found in ',DMSFIL(1:LDMSFL),'.'
	BADDMS=.TRUE.
	GOTO 2
C
C	DONE READING .CMP FILE
C
    8	CLOSE (UNIT=1)
	IF (TOTNC.EQ.0.0) THEN
		WRITE (6,*) 'No species or carbon in ',
     &		 INFILE(1:LINFIL),'.'
		GOTO 990
	ENDIF
C
	IF (BADDMS) GOTO 990
C
C
C	IF NEW COMPOSITION FILE BEING CREATED, WRITE NORMALIZED CONC'S
C	TO OUTPUT FILE
C
	IF (NEWCMP) THEN
		IF (NORM) THEN
			IF (GRAMS) THEN
				FAC=NORFAC/TOTWT
				WRITE (2,211) FAC
  211				FORMAT ('!'/'! Normalized by',
     &                           ' grams.  Factor = ',1PE12.3)
			ELSE
				FAC=NORFAC/TOTNC
				WRITE (2,212) FAC
  212				FORMAT ('!'/'! Normalized by',
     &                           ' carbons.  Factor = ',1PE12.3)
			ENDIF
			TOTNC=TOTNC*FAC
			TOTWT=TOTWT*FAC
			TOTMOL=TOTMOL*FAC
		ENDIF
C
		IF (MASSIN) THEN
			WRITE (2,
     &			 '(''!''/''! Converted from mass input'')')
		ELSEIF (CARBIN) THEN
			WRITE (2,
     &			 '(''!''/''! Converted from carbon input'')')
		ENDIF
C
		WRITE (INLIN,210) INFILE(LCMPUC+1:LINFIL-4),NCMP,
     &		 TOTNC,TOTWT
  210		FORMAT ('CMPfile = ',A,';  #VOCs =',I3,
     &           ';  Moles C = ',F7.4,';  Grams =',F7.3)
		WRITE (6,*) INLIN(1:LNBLNK(INLIN))
		WRITE (2,213) INLIN(1:LNBLNK(INLIN)),TOTMOL,TOTWT/TOTMOL
  213		FORMAT ('!'/'! ',A,';'/'! Moles =',F7.4,';  Avg Mwt ='
     &           ,F8.3/'!')
		IF (PPBOUT) THEN
			WRITE (2,*) '! Output multiplied by 1000'
			WRITE (2,*) '!'
			FMT='(A8,3PF12.2)'
		ELSE
			FMT='(A8,1PE12.4)'
		ENDIF
C
		IF (NORM) THEN
			DO 200 I=1,NDMS
			IF (DMSLVL(I).NE.0.0) WRITE (2,FMT)
     &			 DMSNAM(I),FAC*DMSLVL(I)
  200			CONTINUE
		ELSE
			DO 201 I=1,NDMS
			IF (DMSLVL(I).NE.0.0) WRITE (2,FMT)
     &			 DMSNAM(I),DMSLVL(I)
  201			CONTINUE
		ENDIF
C
		CLOSE (UNIT=2)
C
C		IF NO OUTPUT FILE SPECIFIED, RENAME OLD ONE TO
C		name.BAK, AND RENAME NEW ONE TO BE SAME AS OLD ONE.
C
		IF (OUTFIL(1:1).EQ.' ') THEN
			OUTFIL=INFILE
			LOUTFL=LINFIL
C
			INFILE(LINFIL-3:LINFIL)='.BAK'
			INQUIRE (FILE=INFILE(1:LINFIL),
     &			 EXIST=ERRIND)
			IF (ERRIND) THEN
				INLIN='DEL '
				INLIN(5:)=INFILE(1:LINFIL)
C				WRITE (6,*) 'CMD=',INLIN(1:LNBLNK(INLIN))
				CALL SYSTEM (INLIN)
			ENDIF
C
			INLIN(1:7)='RENAME '
			INLIN(8:LINFIL+8)=OUTFIL(1:LOUTFL)
			INLIN(LINFIL+9:)=' *.BAK'
C			WRITE (6,*) 'CMD=',INLIN(1:LNBLNK(INLIN))
			CALL SYSTEM (INLIN)
C
			INLIN(8:LFIL+7)=FILNAM(1:LFIL)
			INLIN(LFIL+8:LFIL+8)=' '
			INLIN(LFIL+9:LFIL+LINFIL-LCMPUC+9)=
     &			 OUTFIL(LCMPUC+1:LINFIL)
C			WRITE (6,*) 'CMD=',INLIN(1:LNBLNK(INLIN))
			CALL SYSTEM (INLIN)
C
			WRITE (6,202) OUTFIL(1:LOUTFL),' replaced',FAC
  202			FORMAT (' File = ',2A, '.  Factor = ',1PE11.4)
		ELSE
			WRITE (6,202) OUTFIL(1:LOUTFL),' created',FAC
		ENDIF
	ELSE
C
C	IF NO NEW CMP FILE, OPEN OUTPUT FILE AND APPEND INFO
C	TO IT.
C
		WRITE (INLIN,210) INFILE(LCMPUC+1:LINFIL-4),NCMP,
     &		 TOTNC,TOTWT
		WRITE (6,*) INLIN
		IF (OUTFIL(1:1).NE.' ') THEN
			OPEN (UNIT=1,FILE=OUTFIL(1:LOUTFL),
     &		 	 STATUS='UNKNOWN',ACCESS='APPEND')
			WRITE (1,*) INLIN(1:LNBLNK(INLIN))
			CLOSE (UNIT=1)
			WRITE (6,202) OUTFIL(1:LOUTFL),' updated.',FAC
		ENDIF
C
	ENDIF
C
C	DONE
C
	CALL EXIT (0)
C
C
C	ERRORS
C	
 900	WRITE (6,*) 'File = ',FILNAM(1:LNBLNK(FILNAM)),' does not exist.'
	GOTO 999
C
 910	WRITE (6,911) 
 911	FORMAT (' Useage:  "RENORCMP input-cmp-file output',
     &   '-cmp-file [factor-if-not-1.0]"'/'     or:  "RENORCMP ',
     &   'input-cmp-file [output-file] SUM"  to show total C only.')
	WRITE (6,*) 'Append "M" to normalize to grams.'
	WRITE (6,*) 'Append "PPB" to multiply output by 1000.'
	GOTO 999
C
 990	WRITE (6,*) 'Normalization aborted.'
	IF (NEWCMP) CLOSE (UNIT=2,STATUS='DELETE')
C
 999	CALL EXIT (1)
	END
